<?php
require_once ASD_APPLICATION_PATH . '/controllers/Abstract/Ajax.php';

class Asd_Controller_AdminAjaxController
    extends Asd_Controller_Abstract_Ajax
{
    public function getCategoriesAction()
    {
        if (!isset($_POST['params'])) {
            throw new Exception('Params not found');
        }
        if (!is_array($_POST['params'])) {
            throw new Exception('"params" is not array');
        }
        if (!isset($_POST['params']['options'])) {
            throw new Exception('Options not found');
        }
        if (!is_array($_POST['params']['options'])) {
            throw new Exception('"options" is not array');
        }

        $params = $_POST['params'];
        $options = $_POST['params']['options'];

        $parent = isset($params['parent'])? $params['parent'] : NULL;

        try {
            $items = Asd_Application::getModel('Amazon')
                ->setOptions($options)
                ->getCategories($parent);
        } catch (Asd_Model_Amazon_Exception $e) {
            $this->_throwError("Error getting categories: {$e->getMessage()}");
        }

        // Format array to save order
        $result = array();
        foreach ($items as $id=>$label) {
            $result[] = array(
                'id' => $id,
                'label' => $label,
            );
        }

        return $result;
    }
}