<?php
require_once ASD_APPLICATION_PATH . '/controllers/Abstract/Ajax.php';

class Asd_Controller_FrontendAjaxController
    extends Asd_Controller_Abstract_Ajax
{
    public function getCategoriesAction()
    {
        if (!isset($_POST['params'])) {
            throw new Exception('Params not found');
        }
        if (!is_array($_POST['params'])) {
            throw new Exception('"params" is not array');
        }
        $params = $_POST['params'];
        if (!isset($params['market'])) {
            throw new Exception('"market" not found');
        }

        if (isset($params['parent'])) {
            try {
                $items = Asd_Application::getModel('Amazon')
                    ->setOption('market', $params['market'])
                    ->getCategories($params['parent']);
            } catch (Asd_Model_Amazon_Exception $e) {
                $this->_throwError("Error getting categories: {$e->getMessage()}");
            }

            // Format array to save order
            $result = array();

            foreach ($items as $id=>$label) {
                $result[] = array(
                    'id' => $id,
                    'label' => $label,
                );
            }

        } else {
            if (!isset($_POST['block_params'])) {
                throw new Exception('"block_params" not found');
            }

            $blockParams = @unserialize(base64_decode($_POST['block_params']));
            if (!is_array($blockParams)) {
                throw new Exception('Could not read "block_params"');
            }
            $blockParams['market'] = $params['market'];

            $block = Asd_Application::getModel('Block_Toolbar')
                ->setParams($blockParams);

            try {
                $amazon = Asd_Application::getModel('Amazon')
                    ->setOption('market', $params['market']);
                $categories = $amazon->getCategories();
                $category = $block->getCategory();

                if ($category) {
                    $subcategories = $amazon->getCategories($category);
                    $subcategory = $block->getSubcategory();
                } else {
                    $subcategories = array();
                    $subcategory = NULL;
                }
            } catch (Asd_Model_Amazon_Exception $e) {
                $this->_throwError("Error getting categories: {$e->getMessage()}");
            }

            // Format array to save order
            $result = array(
                'categories' => array(),
            );

            foreach ($categories as $id=>$label) {
                $item = array(
                    'id' => $id,
                    'label' => $label,
                );
                if ($id == $category) {
                    $item['selected'] = TRUE;
                }
                $result['categories'][] = $item;
            }
            if ($subcategories) {
                $result['subcategories'] = array();
                foreach ($subcategories as $id=>$label) {
                    $item = array(
                        'id' => $id,
                        'label' => $label,
                    );
                    if ($id == $subcategory) {
                        $item['selected'] = TRUE;
                    }
                    $result['subcategories'][] = $item;
                }
            }
        }

        return $result;
    }

    public function searchAction()
    {
        if (!isset($_POST['params'])) {
            throw new Exception('Params not found');
        }
        $params = $_POST['params'];
        parse_str($params, $params);

        if (!isset($params['market'])) {
            throw new Exception('"market" not specifed');
        }

        $affiliateId = Asd_Application::getModel('Options')
            ->getValue("{$params['market']}_affiliate_id");
        if ('' != $affiliateId) {
            $params['affiliate_id'] = $affiliateId;
        }

        try {
            $this->_view->items = Asd_Application::getModel('Amazon_Search')
                ->search($params);
        } catch (Asd_Model_Amazon_Exception $e) {
            if (current_user_can('administrator')) {
                $this->_throwError($e->getMessage());
            }
            $this->_throwError("Sorry, there was error searching for products. Please notify site owner.");
        }
    }
}