/* DUPLICATOR MYSQL SCRIPT CREATED ON : December 18, 2014, 11:28 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `hash` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=326 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=1429 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(20) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=227 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `name` (`name`),
  KEY `slug` (`slug`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(64) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "https://wordpress.org/", "", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "Hi, this is a comment.\nTo delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "1", "", "", "0", "0");

/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "20141218_luxurybeautygifts", "5493633089ab97560141218232848", "20", "2014-12-18 23:28:59", "admin", "O:11:\"DUP_Package\":16:{s:2:\"ID\";i:1;s:4:\"Name\";s:26:\"20141218_luxurybeautygifts\";s:4:\"Hash\";s:29:\"5493633089ab97560141218232848\";s:8:\"NameHash\";s:56:\"20141218_luxurybeautygifts_5493633089ab97560141218232848\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:51:\"/home1/anton241/public_html/beauty/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://beauty.demobay.info/wp-snapshots/\";s:8:\"ScanFile\";s:66:\"20141218_luxurybeautygifts_5493633089ab97560141218232848_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";s:68:\"20141218_luxurybeautygifts_5493633089ab97560141218232848_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:34:\"/home1/anton241/public_html/beauty\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:26:\"20141218_luxurybeautygifts\";s:4:\"Hash\";s:29:\"5493633089ab97560141218232848\";s:8:\"NameHash\";s:56:\"20141218_luxurybeautygifts_5493633089ab97560141218232848\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:51:\"/home1/anton241/public_html/beauty/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://beauty.demobay.info/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";s:70:\"20141218_luxurybeautygifts_5493633089ab97560141218232848_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:69:\"20141218_luxurybeautygifts_5493633089ab97560141218232848_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:57;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://beauty.demobay.info/", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://beauty.demobay.info/", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Luxury Beauty Gifts", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "mail@yourmail.com", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "1", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%year%/%monthnum%/%day%/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:10:{i:0;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:1;s:33:\"ama_search_bar/ama_search_bar.php\";i:2;s:48:\"covertstorecontent/covertstorecontent-plugin.php\";i:3;s:25:\"duplicator/duplicator.php\";i:4;s:19:\"jetpack/jetpack.php\";i:5;s:37:\"super-socializer/super_socializer.php\";i:6;s:27:\"wp-super-cache/wp-cache.php\";i:7;s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";i:8;s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";i:9;s:26:\"youtube-widget/youtube.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("37", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("38", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("39", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("40", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("41", "template", "covertstorebuilder", "yes");
INSERT INTO `wp_options` VALUES("42", "stylesheet", "covertstorebuilder", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_whitelist", "", "yes");
INSERT INTO `wp_options` VALUES("44", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("45", "comment_registration", "1", "yes");
INSERT INTO `wp_options` VALUES("46", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("47", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("48", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("49", "db_version", "30133", "yes");
INSERT INTO `wp_options` VALUES("50", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("51", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("52", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("53", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("54", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("55", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("56", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("57", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("61", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("69", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("71", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments", "", "yes");
INSERT INTO `wp_options` VALUES("73", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("74", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("75", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("76", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("77", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("78", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_categories", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_text", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("81", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("82", "uninstall_plugins", "a:1:{s:27:\"wp-super-cache/wp-cache.php\";s:23:\"wpsupercache_deactivate\";}", "no");
INSERT INTO `wp_options` VALUES("83", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("84", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("88", "initial_db_version", "29630", "yes");
INSERT INTO `wp_options` VALUES("89", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("90", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("91", "widget_recent-posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("92", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "sidebars_widgets", "a:10:{s:19:\"wp_inactive_widgets\";a:0:{}s:23:\"sidebar-featured-widget\";a:2:{i:0;s:8:\"search-2\";i:1;s:20:\"youtube_responsive-2\";}s:19:\"sidebar-post-widget\";a:0:{}s:19:\"sidebar-page-widget\";a:0:{}s:22:\"sidebar-catpage-widget\";a:0:{}s:23:\"sidebar-wishlist-widget\";a:0:{}s:16:\"sidebar-footer-1\";a:0:{}s:16:\"sidebar-footer-2\";a:0:{}s:16:\"sidebar-footer-3\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("96", "cron", "a:15:{i:1418946064;a:1:{s:20:\"jetpack_clean_nonces\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1418947193;a:1:{s:14:\"mm_cron_hourly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1418947200;a:1:{s:11:\"wp_cache_gc\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1418948397;a:1:{s:34:\"imwb_covertstorecontent_cron_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1418950793;a:1:{s:18:\"mm_cron_twicedaily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1418950842;a:1:{s:31:\"imwb_zonpress_amazon_cron_event\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:11:\"every4hours\";s:4:\"args\";a:0:{}s:8:\"interval\";i:14400;}}}i:1418951994;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"584cde211e0960696b0b3f02604f2875\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:226;}}}}i:1418967156;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1418993993;a:1:{s:13:\"mm_cron_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1419010375;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1419011140;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1419074472;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1419512393;a:1:{s:14:\"mm_cron_weekly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1421542793;a:1:{s:15:\"mm_cron_monthly\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2635200;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("98", "_transient_random_seed", "9396ab395db9aace7441adb7c53960f6", "yes");
INSERT INTO `wp_options` VALUES("123", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("125", "ossdl_off_cdn_url", "http://beauty.demobay.info/", "yes");
INSERT INTO `wp_options` VALUES("126", "ossdl_off_include_dirs", "wp-content,wp-includes", "yes");
INSERT INTO `wp_options` VALUES("127", "ossdl_off_exclude", ".php", "yes");
INSERT INTO `wp_options` VALUES("128", "ossdl_cname", "", "yes");
INSERT INTO `wp_options` VALUES("129", "jetpack_activated", "1", "yes");
INSERT INTO `wp_options` VALUES("130", "jetpack_options", "a:2:{s:7:\"version\";s:16:\"3.1.1:1410889264\";s:11:\"old_version\";s:16:\"3.1.1:1410889264\";}", "yes");
INSERT INTO `wp_options` VALUES("135", "wpsupercache_start", "1410889364", "yes");
INSERT INTO `wp_options` VALUES("136", "wpsupercache_count", "0", "yes");
INSERT INTO `wp_options` VALUES("137", "supercache_stats", "a:3:{s:9:\"generated\";i:1410890650;s:10:\"supercache\";a:5:{s:7:\"expired\";i:0;s:12:\"expired_list\";a:0:{}s:6:\"cached\";i:0;s:11:\"cached_list\";a:0:{}s:2:\"ts\";i:1410890650;}s:7:\"wpcache\";a:3:{s:6:\"cached\";i:0;s:7:\"expired\";i:0;s:5:\"fsize\";s:3:\"0KB\";}}", "yes");
INSERT INTO `wp_options` VALUES("150", "jpstart_wizard_has_run", "1", "yes");
INSERT INTO `wp_options` VALUES("151", "_transient_timeout_mm_test", "1421326778", "no");
INSERT INTO `wp_options` VALUES("152", "_transient_mm_test", "a:2:{s:4:\"name\";s:18:\"spam-prevention-v1\";s:3:\"key\";s:32:\"a736d113a8bda8c8e934a9b2bd73b7b4\";}", "no");
INSERT INTO `wp_options` VALUES("153", "mm_previous_tests", "a:1:{i:0;s:18:\"spam-prevention-v1\";}", "yes");
INSERT INTO `wp_options` VALUES("154", "wpsupercache_gc_time", "1418907578", "yes");
INSERT INTO `wp_options` VALUES("160", "auto_core_update_notified", "a:4:{s:4:\"type\";s:6:\"manual\";s:5:\"email\";s:17:\"mail@yourmail.com\";s:7:\"version\";s:5:\"4.0.1\";s:9:\"timestamp\";i:1418907579;}", "yes");
INSERT INTO `wp_options` VALUES("162", "_transient_timeout_mm_spam_102b70fcd6933a86c6affddf206b822a", "1418993980", "no");
INSERT INTO `wp_options` VALUES("163", "_transient_mm_spam_102b70fcd6933a86c6affddf206b822a", "no", "no");
INSERT INTO `wp_options` VALUES("164", "jetpack_file_data", "a:1:{s:3:\"3.3\";a:46:{s:32:\"015407a5e088dca39cf9c7a6f611bd94\";a:10:{s:4:\"name\";s:20:\"Spelling and Grammar\";s:11:\"description\";s:89:\"Check your spelling, style, and grammar with the After the Deadline proofreading service.\";s:4:\"sort\";s:1:\"6\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"03dd5ab7f1171335d146548a0555cba7\";a:10:{s:4:\"name\";s:8:\"Carousel\";s:11:\"description\";s:63:\"Transform standard image galleries into full-screen slideshows.\";s:4:\"sort\";s:2:\"22\";s:10:\"introduced\";s:3:\"1.5\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:17:\"Photos and Videos\";}s:32:\"26a1110b98346c613673eb1cbd79e19b\";a:10:{s:4:\"name\";s:16:\"Jetpack Comments\";s:11:\"description\";s:79:\"Let readers comment with WordPress.com, Twitter, Facebook, or Google+ accounts.\";s:4:\"sort\";s:2:\"20\";s:10:\"introduced\";s:3:\"1.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"29e001bcce9c5bf35af9fd30bb5fde8f\";a:10:{s:4:\"name\";s:12:\"Contact Form\";s:11:\"description\";s:44:\"Insert a contact form anywhere on your site.\";s:4:\"sort\";s:2:\"15\";s:10:\"introduced\";s:3:\"1.3\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:5:\"Other\";}s:32:\"d0baafe35f10c662720acd87e667b952\";a:10:{s:4:\"name\";s:20:\"Custom Content Types\";s:11:\"description\";s:92:\"Organize and display different types of content on your site, separate from posts and pages.\";s:4:\"sort\";s:2:\"34\";s:10:\"introduced\";s:3:\"3.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"6e4d61a01861e502a21fc271a8414b62\";a:10:{s:4:\"name\";s:10:\"Custom CSS\";s:11:\"description\";s:57:\"Customize your site’s CSS without modifying your theme.\";s:4:\"sort\";s:1:\"2\";s:10:\"introduced\";s:3:\"1.7\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Appearance\";}s:32:\"5043643214ee49d948edc234b528b5ee\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"4f9ad03af5115ba5ad13dc5caac8b38d\";a:10:{s:4:\"name\";s:21:\"Enhanced Distribution\";s:11:\"description\";s:74:\"Share your public posts and comments to search engines and other services.\";s:4:\"sort\";s:1:\"5\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:6:\"Public\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"1b5f5a9dc3ed02903bff893f579ddc49\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"a4d0eaf28f17b61bc96b8cb5f6b259dc\";a:10:{s:4:\"name\";s:19:\"Gravatar Hovercards\";s:11:\"description\";s:58:\"Enable pop-up business cards over commenters’ Gravatars.\";s:4:\"sort\";s:2:\"11\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:18:\"Social, Appearance\";}s:32:\"6164a2ff8cea240d1574636ee0c5db00\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:8:\"2.0.3 ??\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";}s:32:\"a742228308375890577dffebba458a07\";a:10:{s:4:\"name\";s:15:\"Infinite Scroll\";s:11:\"description\";s:46:\"Add support for infinite scroll to your theme.\";s:4:\"sort\";s:2:\"26\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:10:\"Appearance\";}s:32:\"c390bd4d7239fee39faacb0e7c965703\";a:10:{s:4:\"name\";s:8:\"JSON API\";s:11:\"description\";s:69:\"Allow applications to securely access your content through the cloud.\";s:4:\"sort\";s:2:\"19\";s:10:\"introduced\";s:3:\"1.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:6:\"Public\";s:11:\"module_tags\";s:19:\"Writing, Developers\";}s:32:\"cc7e2341a1609a4171c94b58dfaa2ddc\";a:10:{s:4:\"name\";s:14:\"Beautiful Math\";s:11:\"description\";s:85:\"Use LaTeX markup language in posts and pages for complex equations and other geekery.\";s:4:\"sort\";s:2:\"12\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"6ee46f0a7ce9d22faa8a38b1ee6e9681\";a:10:{s:4:\"name\";s:5:\"Likes\";s:11:\"description\";s:70:\"Give visitors an easy way to show their appreciation for your content.\";s:4:\"sort\";s:2:\"23\";s:10:\"introduced\";s:3:\"2.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"4d12f65509409d83388c2dc66c1d63ee\";a:10:{s:4:\"name\";s:8:\"Markdown\";s:11:\"description\";s:51:\"Write posts or pages in plain-text Markdown syntax.\";s:4:\"sort\";s:2:\"31\";s:10:\"introduced\";s:3:\"2.8\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"95050b50560fb82666501cb8e792b55d\";a:10:{s:4:\"name\";s:12:\"Mobile Theme\";s:11:\"description\";s:64:\"Optimize your site with a mobile-friendly theme for smartphones.\";s:4:\"sort\";s:2:\"21\";s:10:\"introduced\";s:3:\"1.8\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:18:\"Appearance, Mobile\";}s:32:\"d3dd05bb3a4f8fb82088f65c8ecef44c\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"df91786663f70dffae3c414c6bfa1f67\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"ce2bbb5ff04cf746789b518445192e5b\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"28645e508e6d1bf1a0efdc7aae996343\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"ccbe6fecb17f940a1b7992a69c01f398\";a:10:{s:4:\"name\";s:7:\"Monitor\";s:11:\"description\";s:88:\"Receive notifications from Jetpack if your site goes offline — and when it it returns.\";s:4:\"sort\";s:2:\"28\";s:10:\"introduced\";s:3:\"2.6\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:0:\"\";}s:32:\"b2f25fb5353dc6ef1ed610c0ff170fa2\";a:10:{s:4:\"name\";s:13:\"Notifications\";s:11:\"description\";s:84:\"Receive notification of site activity via the admin toolbar and your Mobile devices.\";s:4:\"sort\";s:2:\"13\";s:10:\"introduced\";s:3:\"1.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:5:\"Other\";}s:32:\"3c88c74f93d3b274251e7772c559d849\";a:10:{s:4:\"name\";s:10:\"Omnisearch\";s:11:\"description\";s:66:\"Search your entire database from a single field in your Dashboard.\";s:4:\"sort\";s:2:\"16\";s:10:\"introduced\";s:3:\"2.3\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Developers\";}s:32:\"711c09ecbb4f544f35a6480924985f12\";a:10:{s:4:\"name\";s:6:\"Photon\";s:11:\"description\";s:66:\"Accelerate your site by loading images from the WordPress.com CDN.\";s:4:\"sort\";s:2:\"25\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:29:\"Photos and Videos, Appearance\";}s:32:\"73abf5efa55db3c52b7c7c46f2baeb87\";a:10:{s:4:\"name\";s:13:\"Post by Email\";s:11:\"description\";s:58:\"Publish posts by email, using any device and email client.\";s:4:\"sort\";s:2:\"14\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:7:\"Writing\";}s:32:\"e1bb4b3184bc9c8d827ecd21892f9500\";a:10:{s:4:\"name\";s:9:\"Publicize\";s:11:\"description\";s:55:\"Share new posts on social media networks automatically.\";s:4:\"sort\";s:2:\"10\";s:10:\"introduced\";s:3:\"2.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"ff1934b756208a87d30e3976dfd39341\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"4de95bb2474a96bca07bfec7a26d9639\";a:10:{s:4:\"name\";s:13:\"Related Posts\";s:11:\"description\";s:60:\"Display links to your related content under posts and pages.\";s:4:\"sort\";s:2:\"29\";s:10:\"introduced\";s:3:\"2.9\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:0:\"\";}s:32:\"285496f05c3b06389461282b14b8b680\";a:10:{s:4:\"name\";s:7:\"Sharing\";s:11:\"description\";s:81:\"Allow visitors to share your content on Facebook, Twitter, and more with a click.\";s:4:\"sort\";s:1:\"7\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:3:\"1.2\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"dbf0da82b47371a7b28428551caac6ad\";a:10:{s:4:\"name\";s:16:\"Shortcode Embeds\";s:11:\"description\";s:77:\"Embed content from YouTube, Vimeo, SlideShare, and more, no coding necessary.\";s:4:\"sort\";s:1:\"3\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:3:\"1.2\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:46:\"Photos and Videos, Social, Writing, Appearance\";}s:32:\"50a035f8adaa75f1805a763d04ed7708\";a:10:{s:4:\"name\";s:16:\"WP.me Shortlinks\";s:11:\"description\";s:56:\"Enable WP.me-powered shortlinks for all posts and pages.\";s:4:\"sort\";s:1:\"8\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"0252a54d78b0c0dba9edea97a1885096\";a:10:{s:4:\"name\";s:9:\"Site Icon\";s:11:\"description\";s:29:\"Add a site icon to your site.\";s:4:\"sort\";s:2:\"22\";s:10:\"introduced\";s:3:\"3.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:5:\"Other\";}s:32:\"44d6d961a988f4a62f4fb21dab62aa4b\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"5d0acfdad79daad9a078105f66834561\";a:10:{s:4:\"name\";s:22:\"Jetpack Single Sign On\";s:11:\"description\";s:62:\"Allow your users to log in using their WordPress.com accounts.\";s:4:\"sort\";s:2:\"30\";s:10:\"introduced\";s:3:\"2.6\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:10:\"Developers\";}s:32:\"fd9348ca9cb9ce3770bb0986ca5c3c38\";a:10:{s:4:\"name\";s:19:\"WordPress.com Stats\";s:11:\"description\";s:85:\"Monitor your stats with clear, concise reports and no additional load on your server.\";s:4:\"sort\";s:1:\"1\";s:10:\"introduced\";s:3:\"1.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:19:\"WordPress.com Stats\";}s:32:\"ba752592ce5acc67399a9e3ca96a9030\";a:10:{s:4:\"name\";s:13:\"Subscriptions\";s:11:\"description\";s:88:\"Allow users to subscribe to your posts and comments and receive notifications via email.\";s:4:\"sort\";s:1:\"9\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:6:\"Social\";}s:32:\"b597da46871b7d127a7318c786c6cc43\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"9368121657a53e417190a503690d47ef\";a:10:{s:4:\"name\";s:15:\"Tiled Galleries\";s:11:\"description\";s:73:\"Display your image galleries in a variety of sleek, graphic arrangements.\";s:4:\"sort\";s:2:\"24\";s:10:\"introduced\";s:3:\"2.1\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:2:\"No\";s:11:\"module_tags\";s:17:\"Photos and Videos\";}s:32:\"c51e3fd9308cad04f55de39481c90dfb\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}s:32:\"70fe6a34607f4c713e4f06a5341d3ef8\";a:10:{s:4:\"name\";s:10:\"VaultPress\";s:11:\"description\";s:85:\"Protect your site with automatic backups and security scans. (Subscription required.)\";s:4:\"sort\";s:2:\"32\";s:10:\"introduced\";s:5:\"0:1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:5:\"false\";s:4:\"free\";s:5:\"false\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";}s:32:\"b7b25636c7a738d0fb1a374497ae9935\";a:10:{s:4:\"name\";s:17:\"Site Verification\";s:11:\"description\";s:78:\"Verify your site or domain with Google Webmaster Tools, Pinterest, and others.\";s:4:\"sort\";s:2:\"33\";s:10:\"introduced\";s:3:\"3.0\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:0:\"\";}s:32:\"66e8f9ab1616354d4e17dc2fda77900e\";a:10:{s:4:\"name\";s:10:\"VideoPress\";s:11:\"description\";s:68:\"Upload and embed videos right on your site. (Subscription required.)\";s:4:\"sort\";s:2:\"27\";s:10:\"introduced\";s:3:\"2.5\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:5:\"false\";s:19:\"requires_connection\";s:3:\"Yes\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:17:\"Photos and Videos\";}s:32:\"bd37449642ed5aea292a84a365c8542e\";a:10:{s:4:\"name\";s:17:\"Widget Visibility\";s:11:\"description\";s:57:\"Specify which widgets appear on which pages of your site.\";s:4:\"sort\";s:2:\"17\";s:10:\"introduced\";s:3:\"2.4\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:10:\"Appearance\";}s:32:\"1cb02df7dad5e15600e91649b731dc77\";a:10:{s:4:\"name\";s:21:\"Extra Sidebar Widgets\";s:11:\"description\";s:79:\"Add images, Twitter streams, your site’s RSS links, and more to your sidebar.\";s:4:\"sort\";s:1:\"4\";s:10:\"introduced\";s:3:\"1.2\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:2:\"No\";s:13:\"auto_activate\";s:3:\"Yes\";s:11:\"module_tags\";s:18:\"Social, Appearance\";}s:32:\"0d51facffc0740b0d84ce97c2edbcb94\";a:10:{s:4:\"name\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:10:\"introduced\";s:0:\"\";s:7:\"changed\";s:0:\"\";s:10:\"deactivate\";s:0:\"\";s:4:\"free\";s:0:\"\";s:19:\"requires_connection\";s:0:\"\";s:13:\"auto_activate\";s:0:\"\";s:11:\"module_tags\";s:0:\"\";}}}", "yes");
INSERT INTO `wp_options` VALUES("165", "jetpack_available_modules", "a:1:{s:3:\"3.3\";a:34:{s:18:\"after-the-deadline\";s:3:\"1.1\";s:8:\"carousel\";s:3:\"1.5\";s:8:\"comments\";s:3:\"1.4\";s:12:\"contact-form\";s:3:\"1.3\";s:20:\"custom-content-types\";s:3:\"3.1\";s:10:\"custom-css\";s:3:\"1.7\";s:21:\"enhanced-distribution\";s:3:\"1.2\";s:19:\"gravatar-hovercards\";s:3:\"1.1\";s:15:\"infinite-scroll\";s:3:\"2.0\";s:8:\"json-api\";s:3:\"1.9\";s:5:\"latex\";s:3:\"1.1\";s:5:\"likes\";s:3:\"2.2\";s:8:\"markdown\";s:3:\"2.8\";s:9:\"minileven\";s:3:\"1.8\";s:7:\"monitor\";s:3:\"2.6\";s:5:\"notes\";s:3:\"1.9\";s:10:\"omnisearch\";s:3:\"2.3\";s:6:\"photon\";s:3:\"2.0\";s:13:\"post-by-email\";s:3:\"2.0\";s:9:\"publicize\";s:3:\"2.0\";s:13:\"related-posts\";s:3:\"2.9\";s:10:\"sharedaddy\";s:3:\"1.1\";s:10:\"shortcodes\";s:3:\"1.1\";s:10:\"shortlinks\";s:3:\"1.1\";s:9:\"site-icon\";s:3:\"3.2\";s:3:\"sso\";s:3:\"2.6\";s:5:\"stats\";s:3:\"1.1\";s:13:\"subscriptions\";s:3:\"1.2\";s:13:\"tiled-gallery\";s:3:\"2.1\";s:10:\"vaultpress\";s:5:\"0:1.2\";s:18:\"verification-tools\";s:3:\"3.0\";s:10:\"videopress\";s:3:\"2.5\";s:17:\"widget-visibility\";s:3:\"2.4\";s:7:\"widgets\";s:3:\"1.2\";}}", "yes");
INSERT INTO `wp_options` VALUES("166", "mm_master_aff", "hostgator", "yes");
INSERT INTO `wp_options` VALUES("167", "mm_install_date", "Dec 18, 2014", "yes");
INSERT INTO `wp_options` VALUES("176", "_site_transient_timeout_browser_2ecdbfd8102b573d256a595b708fbee8", "1419512394", "yes");
INSERT INTO `wp_options` VALUES("177", "_site_transient_browser_2ecdbfd8102b573d256a595b708fbee8", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:7:\"Firefox\";s:7:\"version\";s:4:\"34.0\";s:10:\"update_url\";s:23:\"http://www.firefox.com/\";s:7:\"img_src\";s:50:\"http://s.wordpress.org/images/browsers/firefox.png\";s:11:\"img_src_ssl\";s:49:\"https://wordpress.org/images/browsers/firefox.png\";s:15:\"current_version\";s:2:\"16\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("178", "mm_cron", "a:3:{s:5:\"daily\";a:1:{s:14:\"plugin_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:14:\"plugin_version\";s:2:\"el\";s:5:\"0.5.9\";}}s:6:\"weekly\";a:1:{s:10:\"wp_version\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:10:\"wp_version\";s:2:\"el\";s:3:\"4.0\";}}s:7:\"monthly\";a:3:{s:12:\"plugin_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:12:\"plugin_count\";s:2:\"el\";i:3;}s:11:\"theme_count\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:11:\"theme_count\";s:2:\"el\";i:3;}s:13:\"current_theme\";a:4:{s:1:\"t\";s:5:\"event\";s:2:\"ec\";s:9:\"scheduled\";s:2:\"ea\";s:13:\"current_theme\";s:2:\"el\";s:14:\"twentyfourteen\";}}}", "yes");
INSERT INTO `wp_options` VALUES("180", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1418950797", "no");
INSERT INTO `wp_options` VALUES("181", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Dec 2014 02:22:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=4.2-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 4.1 Release Candidate 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Dec 2014 02:22:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3411\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:429:\"The next release candidate for WordPress 4.1 is now available for testing. Seventy changes have gone in since the first release candidate. With no known issues left, we plan to release 4.1 tomorrow, December 18. To test, try the WordPress Beta Tester plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can download the release candidate here (zip). If you&#8217;d like to learn more about [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"John Blackbourn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1465:\"<p>The next release candidate for WordPress 4.1 is now available for testing.</p>\n<p><a href=\"https://core.trac.wordpress.org/log/trunk?rev=30961&amp;stop_rev=30827\">Seventy changes</a> have gone in since the <a href=\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate/\">first release candidate</a>. With no known issues left, we plan to release 4.1 tomorrow, December 18.</p>\n<p>To test, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"https://wordpress.org/wordpress-4.1-RC3.zip\">download the release candidate here</a> (zip). If you&#8217;d like to learn more about what&#8217;s new in WordPress 4.1, visit the updated About screen in your dashboard (<strong><img src=\"https://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a href=\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/\">the Beta 1 post</a>.</p>\n<p><strong>Plugin authors:</strong> Remember to test your plugins against 4.1, and if they&#8217;re compatible, make sure they are marked as tested up to 4.1. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"https://make.wordpress.org/core/tag/4-1-dev-notes/\">notes for developers for 4.1</a> as always.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 4.1 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Dec 2014 11:52:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:3:\"4.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3375\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:341:\"The release candidate for WordPress 4.1 is now available. We&#8217;ve made a lot of refinements over the last few weeks. RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.1 on Tuesday, December 16, but we need your [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"John Blackbourn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2301:\"<p>The release candidate for WordPress 4.1 is now available.</p>\n<p>We&#8217;ve made a lot of refinements over the last few weeks. RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.1 on Tuesday, December 16, but we need your help to get there. If you haven’t tested 4.1 yet, now is the time! (Please though, not on your live site unless you’re adventurous.)</p>\n<p><strong>Think you&#8217;ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you&#8217;ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 4.1 RC1, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.1-RC1.zip\">download the release candidate here</a> (zip). If you&#8217;d like to learn more about what&#8217;s new in WordPress 4.1, visit the About screen in your dashboard (<strong><img src=\"https://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) or check out the <a href=\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/\">beta announcement</a>.</p>\n<p><strong>Developers</strong>, please test your plugins and themes against WordPress 4.1 and update your plugin&#8217;s <em>Tested up to</em> version in the readme to 4.1 before next week. If you find compatibility problems, we never want to break things, so please be sure to post to the support forums so we can figure those out before the final release.</p>\n<p>Be sure to <a href=\"https://make.wordpress.org/core/\">follow along the core development blog</a>, where we&#8217;ll continue to post <a href=\"https://make.wordpress.org/core/tag/4-1-dev-notes/\">notes for developers</a> for 4.1. (For example: if you&#8217;ve written a child theme for Twenty Fifteen, some of the new pagination functions have been renamed for clarity.)</p>\n<p><em>Testing four point one</em><br />\n<em>Why are we up at this hour?</em><br />\n<em>Code is poetry</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 4.0.1 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/11/wordpress-4-0-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/11/wordpress-4-0-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Nov 2014 18:55:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3363\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:345:\"WordPress 4.0.1 is now available. This is a critical security release for all previous versions and we strongly encourage you to update your sites immediately. Sites that support automatic background updates will be updated to WordPress 4.0.1 within the next few hours. If you are still on WordPress 3.9.2, 3.8.4, or 3.7.4, you will be [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3395:\"<p>WordPress 4.0.1 is now available. This is a <strong>critical security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>Sites that support automatic background updates will be updated to WordPress 4.0.1 within the next few hours. If you are still on WordPress 3.9.2, 3.8.4, or 3.7.4, you will be updated to 3.9.3, 3.8.5, or 3.7.5 to keep everything secure. (We don’t support older versions, so please update to 4.0.1 for the latest and greatest.)</p>\n<p>WordPress versions 3.9.2 and earlier are affected by a critical cross-site scripting vulnerability, which could enable anonymous users to compromise a site. This was reported by <a href=\"http://klikki.fi/\">Jouko Pynnonen</a>. This issue does not affect version 4.0, but version 4.0.1 does address these eight security issues:</p>\n<ul>\n<li>Three cross-site scripting issues that a contributor or author could use to compromise a site. Discovered by <a href=\"http://joncave.co.uk/\">Jon Cave</a>, <a href=\"http://www.miqrogroove.com/\">Robert Chapin</a>, and <a href=\"https://johnblackbourn.com/\">John Blackbourn</a> of the WordPress security team.</li>\n<li>A cross-site request forgery that could be used to trick a user into changing their password.</li>\n<li>An issue that could lead to a denial of service when passwords are checked. Reported by <a href=\"http://www.behindthefirewalls.com/\">Javier Nieto Arevalo</a> and <a href=\"http://www.devconsole.info/\">Andres Rojas Guerrero</a>.</li>\n<li>Additional protections for server-side request forgery attacks when WordPress makes HTTP requests. Reported by Ben Bidner (vortfu).</li>\n<li>An extremely unlikely hash collision could allow a user&#8217;s account to be compromised, that also required that they haven&#8217;t logged in since 2008 (I wish I were kidding). Reported by <a href=\"http://david.dw-perspective.org.uk\">David Anderson</a>.</li>\n<li>WordPress now invalidates the links in a password reset email if the user remembers their password, logs in, and changes their email address. Reported separately by <a href=\"https://twitter.com/MomenBassel\">Momen Bassel</a>, <a href=\"http://c0dehouse.blogspot.in/\">Tanoy Bose</a>, and <a href=\"https://managewp.com/\">Bojan Slavković of ManageWP</a>.</li>\n</ul>\n<p>Version 4.0.1 also fixes 23 bugs with 4.0, and we&#8217;ve made two hardening changes, including better validation of EXIF data we are extracting from uploaded photos. Reported by <a href=\"http://www.securesolutions.no/\">Chris Andrè Dale</a>.</p>\n<p>We appreciated the <a href=\"https://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these issues directly to our security team. For more information, see the <a href=\"https://codex.wordpress.org/Version_4.0.1\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/log/branches/4.0?rev=30475&amp;stop_rev=29710\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.0.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click “Update Now”.</p>\n<p><em>Already testing WordPress 4.1? The second beta is now available (<a href=\"https://wordpress.org/wordpress-4.1-beta2.zip\">zip</a>) and it contains these security fixes. For more on 4.1, see <a href=\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/\">the beta 1 announcement post</a>.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/11/wordpress-4-0-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:48:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.1 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Nov 2014 22:35:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3352\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:346:\"Welcome, everyone, to WordPress 4.1 Beta 1! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.1, try the WordPress Beta Tester plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"John Blackbourn\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3409:\"<p>Welcome, everyone, to WordPress 4.1 Beta 1!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.1, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"//wordpress.org/wordpress-4.1-beta1.zip\">download the beta here</a> (zip).</p>\n<p>WordPress 4.1 is due for release next month, so we need your help with testing. Here are some highlights of what to test:</p>\n<ul>\n<li>Our beautiful new default theme, <a href=\"https://make.wordpress.org/core/2014/09/09/twenty-fifteen/\">Twenty Fifteen</a>. It&#8217;s a clean, mobile-first, blog-focused theme designed through simplicity.</li>\n<li>A new <a href=\"https://make.wordpress.org/core/2014/11/11/focus-v2-demo-video/\">distraction-free writing mode for the editor</a>. It&#8217;s enabled by default for beta, and we&#8217;d love feedback on it.</li>\n<li>The ability to automatically install new language packs right from the General Settings screen (available as long as your site&#8217;s filesystem is writable).</li>\n<li>A new inline formatting toolbar for images embedded into posts.</li>\n</ul>\n<p>There have been a lot of changes for developers to test as well:</p>\n<ul>\n<li><a href=\"https://make.wordpress.org/core/2014/10/20/update-on-query-improvements-in-4-1/\">Improvements to meta, date, comment, and taxonomy queries</a>, including complex (nested, multiple relation) queries; and querying comment types (<a href=\"https://core.trac.wordpress.org/ticket/12668\">#12668</a>).</li>\n<li>A single term shared across multiple taxonomies is now split into two when updated. For more, <a href=\"https://make.wordpress.org/core/2014/11/12/an-update-on-the-taxonomy-roadmap/\">see this post</a>, <a href=\"https://core.trac.wordpress.org/ticket/5809\">#5809</a>, and <a href=\"https://core.trac.wordpress.org/ticket/30335\">#30335</a>.</li>\n<li>A new and better way for <a href=\"https://make.wordpress.org/core/2014/10/29/title-tags-in-4-1/\">themes to handle title tags</a>.</li>\n<li>Several <a href=\"https://make.wordpress.org/core/2014/10/27/toward-a-complete-javascript-api-for-the-customizer/\">improvements to the Customizer API</a>, including contextual panels and sections, and JavaScript templates for controls.</li>\n</ul>\n<p>If you want a more in-depth view of what changes have made it into 4.1, <a href=\"https://make.wordpress.org/core/tag/week-in-core/\">check out the weekly review posts</a> on the main development blog.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=4.1\">everything we’ve fixed</a> so far.</p>\n<p>Happy testing!</p>\n<p><em>Twenty Fifteen theme</em><br />\n<em> The beautiful face which hides</em><br />\n<em> Many improvements</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/11/wordpress-4-1-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Watch WordCamp San Francisco Livestream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/10/wcsf-livestream/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/10/wcsf-livestream/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Oct 2014 20:18:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3341\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:381:\"WordCamp San Francisco is the official annual WordPress conference, gathering the community every year since 2006. This is the time when Matt Mullenweg addresses the community in his annual State of the Word presentation – a recap of  the year in WordPress and giving us a glimpse into its future. This year the speaker lineup is stellar. There will be talks by [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Nikolay Bachiyski\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1975:\"<p><a title=\"2014 edition\" href=\"http://2014.sf.wordcamp.org\">WordCamp San Francisco</a> is the official annual WordPress conference, gathering the community every year <a title=\"An old website for a WordPress long time ago\" href=\"http://2006.sf.wordcamp.org\">since 2006</a>. This is the time when Matt Mullenweg addresses the community in his annual <a href=\"http://wordpress.tv/?s=state+of+the+word\">State of the Word</a> presentation – a recap of  the year in WordPress and giving us a glimpse into its future.</p>\n<p>This year the speaker lineup is stellar. There will be talks by three of the lead WordPress developers: <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-andrew-nacin\">Andrew Nacin</a>, <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-helen-hou-sandi\">Helen Hou-Sandí</a>, and <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-mark-jaquith\">Mark Jaquith</a>. We’re also looking forward to speakers like <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-jenny-lawson\">Jenny Lawson</a>, also known as The Bloggess, and <a href=\"http://2014.sf.wordcamp.org/speaker/chris-lema/\">Chris Lema</a>. If you’re at all interested in the web, you will appreciate the appearance of <a href=\"http://2014.sf.wordcamp.org/speakers/#wcorg-speaker-jeff-veen\">Jeff Veen</a> – one of the creators of Google Analytics and co-founder of Typekit.</p>\n<p>Even though San Francisco is far far away for most of you, you can still be part of the fun and watch all presentations in real-time via livestream:</p>\n<p><a href=\"http://2014.sf.wordcamp.org/tickets/\">Get a livestream ticket and watch all talks from WordCamp San Francisco live</a></p>\n<p>If you hurry, you can get one of the special livestream tickets, including a WordCamp San Francisco 2104 t-shirt. You can find all the technical details and start times <a href=\"http://2014.sf.wordcamp.org/live-stream/\">at the WordCamp San Francisco website</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/10/wcsf-livestream/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 4.0 “Benny”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"https://wordpress.org/news/2014/09/benny/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://wordpress.org/news/2014/09/benny/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Sep 2014 17:05:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3296\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:370:\"Version 4.0 of WordPress, named “Benny” in honor of jazz clarinetist and bandleader Benny Goodman, is available for download or update in your WordPress dashboard. While 4.0 is just another number for us after 3.9 and before 4.1, we feel we&#8217;ve put a little extra polish into it. This release brings you a smoother writing and management experience [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23554:\"<p>Version 4.0 of WordPress, named “Benny” in honor of jazz clarinetist and bandleader <a href=\"http://en.wikipedia.org/wiki/Benny_Goodman\">Benny Goodman</a>, is available <a href=\"https://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. While 4.0 is just another number for us after 3.9 and before 4.1, we feel we&#8217;ve put a little extra polish into it. This release brings you a smoother writing and management experience we think you&#8217;ll enjoy.</p>\n<div id=\"v-bUdzKMro-1\" class=\"video-player\"><embed id=\"v-bUdzKMro-1-video\" src=\"https://v0.wordpress.com/player.swf?v=1.03&amp;guid=bUdzKMro&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" title=\"Introducing WordPress 4.0 &quot;Benny&quot;\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<hr />\n<h2 style=\"text-align: center\">Manage your media with style</h2>\n<p><img class=\"alignnone size-full wp-image-3316\" src=\"https://wordpress.org/news/files/2014/09/media.jpg\" alt=\"Media Library\" width=\"1000\" height=\"586\" />Explore your uploads in a beautiful, endless grid. A new details preview makes viewing and editing any amount of media in sequence a snap.</p>\n<hr />\n<h2 style=\"text-align: center\">Working with embeds has never been easier</h2>\n<div style=\"width: 632px; \" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-3296-1\" width=\"632\" height=\"445\" autoplay=\"1\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//s.w.org/images/core/4.0/embed.mp4?_=1\" /><source type=\"video/webm\" src=\"//s.w.org/images/core/4.0/embed.webm?_=1\" /><source type=\"video/ogg\" src=\"//s.w.org/images/core/4.0/embed.ogv?_=1\" /><a href=\"//s.w.org/images/core/4.0/embed.mp4\">//s.w.org/images/core/4.0/embed.mp4</a></video></div>\n<p>Paste in a YouTube URL on a new line, and watch it magically become an embedded video. Now try it with a tweet. Oh yeah — embedding has become a visual experience. The editor shows a true preview of your embedded content, saving you time and giving you confidence.</p>\n<p>We’ve expanded the services supported by default, too — you can embed videos from CollegeHumor, playlists from YouTube, and talks from TED. <a href=\"https://codex.wordpress.org/Embeds\">Check out all of the embeds</a> that WordPress supports.</p>\n<hr />\n<h2 style=\"text-align: center\">Focus on your content</h2>\n<div style=\"width: 632px; \" class=\"wp-video\"><video class=\"wp-video-shortcode\" id=\"video-3296-2\" width=\"632\" height=\"356\" autoplay=\"1\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//s.w.org/images/core/4.0/focus.mp4?_=2\" /><source type=\"video/webm\" src=\"//s.w.org/images/core/4.0/focus.webm?_=2\" /><source type=\"video/ogg\" src=\"//s.w.org/images/core/4.0/focus.ogv?_=2\" /><a href=\"//s.w.org/images/core/4.0/focus.mp4\">//s.w.org/images/core/4.0/focus.mp4</a></video></div>\n<p>Writing and editing is smoother and more immersive with an editor that expands to fit your content as you write, and keeps the formatting tools available at all times.</p>\n<hr />\n<h2 style=\"text-align: center\">Finding the right plugin</h2>\n<p><img class=\"aligncenter size-large wp-image-3309\" src=\"https://wordpress.org/news/files/2014/09/add-plugin1-1024x600.png\" alt=\"Add plugins\" width=\"692\" height=\"405\" /></p>\n<p>There are more than 30,000 free and open source plugins in the WordPress plugin directory. WordPress 4.0 makes it easier to find the right one for your needs, with new metrics, improved search, and a more visual browsing experience.</p>\n<hr />\n<h2 style=\"text-align: center\">The Ensemble</h2>\n<p>This release was led by <a href=\"http://helenhousandi.com\">Helen Hou-Sandí</a>, with the help of these fine individuals. There are 275 contributors with props in this release, a new high. Pull up some Benny Goodman on your music service of choice, as a bandleader or in one of his turns as a classical clarinetist, and check out some of their profiles:</p>\n<p><a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"https://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"https://profiles.wordpress.org/alexanderrohmann\">Alexander Rohmann</a>, <a href=\"https://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"https://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"https://profiles.wordpress.org/amit\">Amit Gupta</a>, <a href=\"https://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andrezrv\">Andres Villarreal</a>, <a href=\"https://profiles.wordpress.org/zamfeer\">Andrew Mowe</a>, <a href=\"https://profiles.wordpress.org/sumobi\">Andrew Munro (sumobi)</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"https://profiles.wordpress.org/arnee\">arnee</a>, <a href=\"https://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"https://profiles.wordpress.org/filosofo\">Austin Matzko</a>, <a href=\"https://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"https://profiles.wordpress.org/kau-boy\">Bernhard Kau</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/bramd\">Bram Duvigneau</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/krogsgard\">Brian Krogsgard</a>, <a href=\"https://profiles.wordpress.org/brianlayman\">Brian Layman</a>, <a href=\"https://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"https://profiles.wordpress.org/camdensegal\">Camden Segal</a>, <a href=\"https://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"https://profiles.wordpress.org/mackensen\">Charles Fulton</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/chrico\">ChriCo</a>, <a href=\"https://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"https://profiles.wordpress.org/chrisl27\">chrisl27</a>, <a href=\"https://profiles.wordpress.org/caxelsson\">Christian Axelsson</a>, <a href=\"https://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"https://profiles.wordpress.org/boda1982\">Christopher Spires</a>, <a href=\"https://profiles.wordpress.org/clifgriffin\">Clifton Griffin</a>, <a href=\"https://profiles.wordpress.org/jupiterwise\">Corey McKrill</a>, <a href=\"https://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"https://profiles.wordpress.org/extendwings\">Daisuke Takahashi</a>, <a href=\"https://profiles.wordpress.org/ghost1227\">Dan Griffiths</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"https://profiles.wordpress.org/danielhuesken\">Daniel Husken</a>, <a href=\"https://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"https://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"https://profiles.wordpress.org/dkotter\">Darin Kotter</a>, <a href=\"https://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"https://profiles.wordpress.org/dllh\">Daryl L. L. Houston (dllh)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/dlh\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dnaber-de\">David Naber</a>, <a href=\"https://profiles.wordpress.org/davidthemachine\">DavidTheMachine</a>, <a href=\"https://profiles.wordpress.org/debaat\">DeBAAT</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/donncha\">Donncha O Caoimh</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/dustyn\">Dustyn Doyle</a>, <a href=\"https://profiles.wordpress.org/eddiemoya\">Eddie Moya</a>, <a href=\"https://profiles.wordpress.org/oso96_2000\">Eduardo Reveles</a>, <a href=\"https://profiles.wordpress.org/edwin-at-studiojoyocom\">Edwin Siebel</a>, <a href=\"https://profiles.wordpress.org/ehg\">ehg</a>, <a href=\"https://profiles.wordpress.org/tmeister\">Enrique Chavez</a>, <a href=\"https://profiles.wordpress.org/erayalakese\">erayalakese</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"https://profiles.wordpress.org/ebinnion\">Eric Binnion</a>, <a href=\"https://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"https://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"https://profiles.wordpress.org/eherman24\">Evan Herman</a>, <a href=\"https://profiles.wordpress.org/fab1en\">Fabien Quatravaux</a>, <a href=\"https://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"https://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"https://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"https://profiles.wordpress.org/garhdez\">garhdez</a>, <a href=\"https://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"https://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/garza\">garza</a>, <a href=\"https://profiles.wordpress.org/gauravmittal1995\">gauravmittal1995</a>, <a href=\"https://profiles.wordpress.org/gavra\">Gavrisimo</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"https://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"https://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"https://profiles.wordpress.org/bordoni\">Gustavo Bordoni</a>, <a href=\"https://profiles.wordpress.org/harrym\">harrym</a>, <a href=\"https://profiles.wordpress.org/hebbet\">hebbet</a>, <a href=\"https://profiles.wordpress.org/hinnerk\">Hinnerk Altenburg</a>, <a href=\"https://profiles.wordpress.org/hlashbrooke\">Hugh Lashbrooke</a>, <a href=\"https://profiles.wordpress.org/iljoja\">iljoja</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/issuu\">issuu</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"https://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"https://profiles.wordpress.org/jacobdubail\">Jacob Dubail</a>, <a href=\"https://profiles.wordpress.org/janhenkg\">JanHenkG</a>, <a href=\"https://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/jwenerd\">Jared Wenerd</a>, <a href=\"https://profiles.wordpress.org/jaza613\">Jaza613</a>, <a href=\"https://profiles.wordpress.org/jeffstieler\">Jeff Stieler</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/slimndap\">Jeroen Schmit</a>, <a href=\"https://profiles.wordpress.org/jerrysarcastic\">Jerry Bates (jerrysarcastic)</a>, <a href=\"https://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"https://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"https://profiles.wordpress.org/jesper800\">Jesper van Engelen</a>, <a href=\"https://profiles.wordpress.org/engelen\">Jesper van Engelen</a>, <a href=\"https://profiles.wordpress.org/jessepollak\">Jesse Pollak</a>, <a href=\"https://profiles.wordpress.org/jgadbois\">jgadbois</a>, <a href=\"https://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnzanussi\">John Zanussi</a>, <a href=\"https://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"https://profiles.wordpress.org/jonnyauk\">jonnyauk</a>, <a href=\"https://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"https://profiles.wordpress.org/softmodeling\">Jordi Cabot</a>, <a href=\"https://profiles.wordpress.org/jjeaton\">Josh Eaton</a>, <a href=\"https://profiles.wordpress.org/tai\">JOTAKI Taisuke</a>, <a href=\"https://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"https://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"https://profiles.wordpress.org/jtsternberg\">Justin Sternberg</a>, <a href=\"https://profiles.wordpress.org/greenshady\">Justin Tadlock</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/ixkaito\">Kaito</a>, <a href=\"https://profiles.wordpress.org/kapeels\">kapeels</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/kevinlangleyjr\">Kevin Langley</a>, <a href=\"https://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"https://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"https://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"https://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"https://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"https://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"https://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"https://profiles.wordpress.org/lritter\">lritter</a>, <a href=\"https://profiles.wordpress.org/lukecarbis\">Luke Carbis</a>, <a href=\"https://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"https://profiles.wordpress.org/m_i_n\">m_i_n</a>, <a href=\"https://profiles.wordpress.org/funkatronic\">Manny Fleurmond</a>, <a href=\"https://profiles.wordpress.org/targz-1\">Manuel Schmalstieg</a>, <a href=\"https://profiles.wordpress.org/clorith\">Marius (Clorith)</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"https://profiles.wordpress.org/sivel\">Matt Martz</a>, <a href=\"https://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"https://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"https://profiles.wordpress.org/mattheweppelsheimer\">Matthew Eppelsheimer</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/meekyhwang\">meekyhwang</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/mdawaffe\">Michael Adams (mdawaffe)</a>, <a href=\"https://profiles.wordpress.org/michalzuber\">michalzuber</a>, <a href=\"https://profiles.wordpress.org/midxcat\">midxcat</a>, <a href=\"https://profiles.wordpress.org/mauteri\">Mike Auteri</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikejolley\">Mike Jolley</a>, <a href=\"https://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"https://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"https://profiles.wordpress.org/mnelson4\">Mike Nelson</a>, <a href=\"https://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikeyarce\">mikeyarce</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"https://profiles.wordpress.org/mrmist\">mrmist</a>, <a href=\"https://profiles.wordpress.org/m_uysl\">Mustafa Uysal</a>, <a href=\"https://profiles.wordpress.org/muvimotv\">MuViMoTV</a>, <a href=\"https://profiles.wordpress.org/nabil_kadimi\">nabil_kadimi</a>, <a href=\"https://profiles.wordpress.org/namibia\">Namibia</a>, <a href=\"https://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"https://profiles.wordpress.org/nd987\">nd987</a>, <a href=\"https://profiles.wordpress.org/neil_pie\">Neil Pie</a>, <a href=\"https://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"https://profiles.wordpress.org/schoenwaldnils\">Nils Schonwald</a>, <a href=\"https://profiles.wordpress.org/ninos-ego\">Ninos</a>, <a href=\"https://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"https://profiles.wordpress.org/compute\">Patrick Hesselberg</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/pdclark\">Paul Clark</a>, <a href=\"https://profiles.wordpress.org/paulschreiber\">Paul Schreiber</a>, <a href=\"https://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"https://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"https://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"https://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"https://profiles.wordpress.org/philipjohn\">Philip John</a>, <a href=\"https://profiles.wordpress.org/senlin\">Piet Bos</a>, <a href=\"https://profiles.wordpress.org/psoluch\">Piotr Soluch</a>, <a href=\"https://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"https://profiles.wordpress.org/purzlbaum\">purzlbaum</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rclations\">RC Lations</a>, <a href=\"https://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"https://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"https://profiles.wordpress.org/rob1n\">rob1n</a>, <a href=\"https://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"https://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"https://profiles.wordpress.org/harmr\">RobertHarm</a>, <a href=\"https://profiles.wordpress.org/rohan013\">Rohan Rawat</a>, <a href=\"https://profiles.wordpress.org/rhurling\">Rouven Hurling</a>, <a href=\"https://profiles.wordpress.org/ruudjoyo\">Ruud Laan</a>, <a href=\"https://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/sammybeats\">Sam Brodie</a>, <a href=\"https://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"https://profiles.wordpress.org/sathishn\">Sathish Nagarajan</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"https://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"https://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"https://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"https://profiles.wordpress.org/sergejmueller\">Sergej Muller</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/shanebp\">shanebp</a>, <a href=\"https://profiles.wordpress.org/sharonaustin\">Sharon Austin</a>, <a href=\"https://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"https://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"https://profiles.wordpress.org/simonp303\">simonp303</a>, <a href=\"https://profiles.wordpress.org/slobodanmanic\">Slobodan Manic</a>, <a href=\"https://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"https://profiles.wordpress.org/sphoid\">sphoid</a>, <a href=\"https://profiles.wordpress.org/stephdau\">Stephane Daury</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stompweb\">Steven Jones</a>, <a href=\"https://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"https://profiles.wordpress.org/5um17\">Sumit Singh</a>, <a href=\"https://profiles.wordpress.org/t4k1s\">t4k1s</a>, <a href=\"https://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"https://profiles.wordpress.org/taylorde\">Taylor Dewey</a>, <a href=\"https://profiles.wordpress.org/thomasvanderbeek\">Thomas van der Beek</a>, <a href=\"https://profiles.wordpress.org/tillkruess\">Till</a>, <a href=\"https://profiles.wordpress.org/codenameeli\">Tim \'Eli\' Dalbey</a>, <a href=\"https://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"https://profiles.wordpress.org/tjnowell\">Tom J Nowell</a>, <a href=\"https://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"https://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"https://profiles.wordpress.org/torresga\">torresga</a>, <a href=\"https://profiles.wordpress.org/liljimmi\">Tracy Levesque</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/treyhunner\">treyhunner</a>, <a href=\"https://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"https://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"https://profiles.wordpress.org/vlajos\">vlajos</a>, <a href=\"https://profiles.wordpress.org/voldemortensen\">voldemortensen</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/winterdev\">winterDev</a>, <a href=\"https://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"https://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"https://profiles.wordpress.org/katzwebdesign\">Zack Katz</a>, <a href=\"https://profiles.wordpress.org/tollmanz\">Zack Tollman</a>, and <a href=\"https://profiles.wordpress.org/zoerooney\">Zoe Rooney</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video, and Helen with <a href=\"http://adriansandi.com\">Adrián Sandí</a> for the music.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.1!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/news/2014/09/benny/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 4.0 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Aug 2014 12:20:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3287\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:321:\"The first release candidate for WordPress 4.0 is now available! In RC 1, we’ve made refinements to what we&#8217;ve been working on for this release. Check out the Beta 1 announcement post for more details on those features. We hope to ship WordPress 4.0 next week, but we need your help to get there. If you [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2134:\"<p>The first release candidate for WordPress 4.0 is now available!</p>\n<p>In RC 1, we’ve made refinements to what we&#8217;ve been working on for this release. Check out the <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">Beta 1 announcement post</a> for more details on those features. We hope to ship WordPress 4.0 <em>next week</em>, but we need your help to get there. If you haven’t tested 4.0 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 4.0 RC1, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 4.0, visit the awesome About screen in your dashboard (<strong><img src=\"https://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar).</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 4.0 and update your plugin&#8217;s <em>Tested up to</em> version in the readme to 4.0 before next week. If you find compatibility problems, please be sure to post any issues to the support forums so we can figure those out before the final release. You also may want to <a href=\"https://make.wordpress.org/core/2014/08/21/introducing-plugin-icons-in-the-plugin-installer/\">give your plugin an icon</a>, which we launched last week and will appear in the dashboard along with banners.</p>\n<p><em>It is almost time</em><br />\n<em> For the 4.0 release</em><br />\n<em> And its awesomeness</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"https://wordpress.org/news/2014/08/wordpress-4-0-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.0 Beta 4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 15 Aug 2014 05:06:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3280\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:353:\"The fourth and likely final beta for WordPress 4.0 is now available. We&#8217;ve made more than 250 changes in the past month, including: Further improvements to the editor scrolling experience, especially when it comes to the second column of boxes. Better handling of small screens in the media library modals. A separate bulk selection mode [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2003:\"<p>The fourth and likely final beta for WordPress 4.0 is now available. We&#8217;ve made <a href=\"https://core.trac.wordpress.org/log?rev=29496&amp;stop_rev=29229&amp;limit=300\">more than 250 changes</a> in the past month, including:</p>\n<ul>\n<li>Further improvements to the editor scrolling experience, especially when it comes to the second column of boxes.</li>\n<li>Better handling of small screens in the media library modals.</li>\n<li>A separate bulk selection mode for the media library grid view.</li>\n<li>Improvements to the installation language selector.</li>\n<li>Visual tweaks to plugin details and customizer panels.</li>\n</ul>\n<p><strong>We need your help</strong>. We’re still aiming for a release this month, which means the next week will be critical for identifying and squashing bugs. If you’re just joining us, please see <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">the Beta 1 announcement post</a> for what to look out for.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums, where friendly moderators are standing by. <b>Plugin developers</b><strong>,</strong> if you haven’t tested WordPress 4.0 yet, now is the time — and be sure to update the “tested up to” version for your plugins so they’re listed as compatible with 4.0.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.0, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-beta4.zip\">download the beta here</a> (zip).</p>\n<p><em>We are working hard</em><br />\n<em>To finish up 4.0<br />\n</em><em>Will you help us too?</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/08/wordpress-4-0-beta-4/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 3.9.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 06 Aug 2014 19:04:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3269\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:377:\"WordPress 3.9.2 is now available as a security release for all previous versions. We strongly encourage you to update your sites immediately. This release fixes a possible denial of service issue in PHP&#8217;s XML processing, reported by Nir Goldshlager of the Salesforce.com Product Security Team. It  was fixed by Michael Adams and Andrew Nacin of the WordPress [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2353:\"<p>WordPress 3.9.2 is now available as a security release for all previous versions. We strongly encourage you to update your sites immediately.</p>\n<p>This release fixes a possible denial of service issue in PHP&#8217;s XML processing, reported by <a href=\"https://twitter.com/nirgoldshlager\">Nir Goldshlager</a> of the Salesforce.com Product Security Team. It  was fixed by Michael Adams and Andrew Nacin of the WordPress security team and David Rothstein of the <a href=\"https://www.drupal.org/SA-CORE-2014-004\">Drupal security team</a>. This is the first time our two projects have coordinated joint security releases.</p>\n<p>WordPress 3.9.2 also contains other security changes:</p>\n<ul>\n<li>Fixes a possible but unlikely code execution when processing widgets (WordPress is not affected by default), discovered by <a href=\"http://www.buayacorp.com/\">Alex Concha</a> of the WordPress security team.</li>\n<li>Prevents information disclosure via XML entity attacks in the external GetID3 library, reported by <a href=\"http://onsec.ru/en/\">Ivan Novikov</a> of ONSec.</li>\n<li>Adds protections against brute attacks against CSRF tokens, reported by <a href=\"http://systemoverlord.com/\">David Tomaschik</a> of the Google Security Team.</li>\n<li>Contains some additional security hardening, like preventing cross-site scripting that could be triggered only by administrators.</li>\n</ul>\n<p>We appreciated responsible disclosure of these issues directly to our security team. For more information, see the <a href=\"https://codex.wordpress.org/Version_3.9.2\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/log/branches/3.9?stop_rev=29383&amp;rev=29411\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 3.9.2</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now&#8221;.</p>\n<p>Sites that support automatic background updates will be updated to WordPress 3.9.2 within 12 hours. (If you are still on WordPress 3.8.3 or 3.7.3, you will also be updated to 3.8.4 or 3.7.4. We don&#8217;t support older versions, so please update to 3.9.2 for the latest and greatest.)</p>\n<p>Already testing WordPress 4.0? The third beta is <a href=\"https://wordpress.org/wordpress-4.0-beta3.zip\">now available</a> (zip) and it contains these security fixes.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/08/wordpress-3-9-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.0 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Jul 2014 21:15:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3261\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:374:\"WordPress 4.0 Beta 2 is now available for download and testing. This is software still in development, so we don’t recommend that you run it on a production site. To get the beta, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). For more of what’s new in version 4.0, check out [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1745:\"<p>WordPress 4.0 Beta 2 is now available for download and testing. This is software still in development, so we don’t recommend that you run it on a production site. To get the beta, try the <a href=\"https://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.0-beta2.zip\">download the beta here</a> (zip).</p>\n<p>For more of what’s new in version 4.0, <a href=\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-1/\">check out the Beta 1 blog post</a>. Some of the changes in Beta 2 include:</p>\n<ul>\n<li>Further refinements for the the plugin installation and media library experiences.</li>\n<li>Updated TinyMCE, which now includes better indentation for lists and the restoration of the color picker.</li>\n<li>Cookies are now tied to a session internally, so if you have trouble logging in, <a href=\"https://core.trac.wordpress.org/ticket/20276\">#20276</a> may be the culprit.</li>\n<li>Various bug fixes (there were <a href=\"https://core.trac.wordpress.org/log?rev=29228&amp;stop_rev=29060&amp;limit=200\">nearly 170 changes</a> since last week).</li>\n</ul>\n<p>If you think you’ve found a bug, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a bug report, <a href=\"https://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=4.0\">everything we’ve fixed</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://wordpress.org/news/2014/07/wordpress-4-0-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 18 Dec 2014 12:59:57 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:37:\"https://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 18 Dec 2014 02:22:15 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20141124234515\";}", "no");
INSERT INTO `wp_options` VALUES("182", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1418950797", "no");
INSERT INTO `wp_options` VALUES("183", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1418907597", "no");
INSERT INTO `wp_options` VALUES("184", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1418950798", "no");
INSERT INTO `wp_options` VALUES("185", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Intergalactic: A Bold Free WordPress Theme from Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35880\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/intergalactic-a-bold-free-wordpress-theme-from-automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2904:\"<p>Despite a global <a href=\"http://rt.com/news/global-space-spending-shrinks-001/\" target=\"_blank\">decrease in public funding for space programs</a>, humans are still reaching for the last frontier through <a href=\"http://www.space.com/24848-science-fiction-space-movies-2014-countdown.html\" target=\"_blank\">film</a>, <a href=\"http://www.radiotimes.com/news/2012-10-24/nasas-voyager-probes-at-35-listen-to-the-music-of-the-planets\" target=\"_blank\">music</a>, and even design. Automattic&#8217;s latest free theme release on WordPress.org is a bold new take on the space motif.</p>\n<p><a href=\"https://wordpress.org/themes/intergalactic\" target=\"_blank\">Intergalactic</a> features strong typography with post titles overlaying full-width featured images. The one-column layout is well-suited to a personal blog and the theme has support for all the standard post formats.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/intergalactic-theme.jpg\" rel=\"prettyphoto[35880]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/intergalactic-theme.jpg?resize=660%2C928\" alt=\"intergalactic-theme\" class=\"aligncenter size-full wp-image-35903\" /></a></p>\n<p>Intergalactic also includes support for custom headers, custom backgrounds, and a social links menu. The theme keeps navigation out of sight via a high-contrast slideout menu. The sidebar is 530px wide with plenty of space for longer page titles and wider widgets.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/intergalactic-slide-out-menu.png\" rel=\"prettyphoto[35880]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/intergalactic-slide-out-menu.png?resize=1025%2C357\" alt=\"intergalactic-slide-out-menu\" class=\"aligncenter size-full wp-image-35916\" /></a></p>\n<p>The theme also has built-in styles for right-aligned, left-aligned, and centered pullquotes, which can be easily set in the text editor.</p>\n<pre class=\"brush: xml; light: true; title: ; notranslate\">&lt;blockquote class=\"alignleft\"&gt;\n   This is a left-aligned blockquote.\n&lt;/blockquote&gt;</pre>\n<p>Intergalactic&#8217;s bold design takes you back to the glory days when space photography was brand new and manned missions put explorers on the moon. It&#8217;s been more than 40 years since the Apollo 17 astronauts&#8217; last visit to the lunar surface in 1972, but the idea of space travel remains firmly stuck in the public imagination.</p>\n<p>If you need a new look for your blog and you&#8217;re ready to publish at the speed of light in 2015, the Intergalactic theme is a powerful motivator. Check out the <a href=\"http://intergalacticdemo.wordpress.com/\" target=\"_blank\">live demo</a> on WordPress.com to see it in action. Intergalactic is now available to <a href=\"https://wordpress.org/themes/intergalactic\" target=\"_blank\">download</a> for free from the WordPress.org Themes Directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Dec 2014 06:19:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: How to Take Control of The WordPress Heartbeat API\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35865\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wptavern.com/how-to-take-control-of-the-wordpress-heartbeat-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8187:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/HeartbeatControlFeaturedImage.png\" rel=\"prettyphoto[35865]\"><img class=\"size-full wp-image-35888\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/HeartbeatControlFeaturedImage.png?resize=638%2C271\" alt=\"Heartbeat Control Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/osseous/11865341393/\">osseous</a> &#8211; <a href=\"http://creativecommons.org/licenses/by/2.0/\">cc</a>\n<p>The WordPress <a title=\"http://codex.wordpress.org/Function_Reference/wp_heartbeat_settings\" href=\"http://codex.wordpress.org/Function_Reference/wp_heartbeat_settings\">Heartbeat API, introduced in WordPress 3.6, </a>simulates a pulse and is responsible for revision tracking, session management, and more. The pulse is around 98 Bytes in size, but it can cause performance issues in certain situations.</p>\n<p>If you&#8217;ve been notified by your webhost that your account is using too many resources and cite <code>POST /wp-admin/admin-ajax.php</code> as the cause, it&#8217;s likely due to the Heartbeat API.</p>\n<h2>How The Heartbeat API Works</h2>\n<p>Inmotion Hosting has an <a title=\"http://www.inmotionhosting.com/support/website/wordpress/heartbeat-ajax-php-usage#heartbeat-in-action\" href=\"http://www.inmotionhosting.com/support/website/wordpress/heartbeat-ajax-php-usage#heartbeat-in-action\">excellent article</a> that explains how the Heartbeat API works. If you monitor server requests while in the post editor, you&#8217;ll see <code>POST /wp-admin/admin-ajax.php \"http://example.com/wp-admin/index.php</code> appear every 15 seconds. This is the pulse generated by the API.</p>\n<p>The pulse makes sure you have a persistent connection to the web server and provides a way for developers to trigger events. For example, if the pulse takes 30 seconds or longer to process, WordPress displays a connection error and attempts to reconnect to the server.</p>\n<h2>The Problem</h2>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/PulseExecutionTime.png\" rel=\"prettyphoto[35865]\"><img class=\"size-full wp-image-35883\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/PulseExecutionTime.png?resize=221%2C183\" alt=\"Execution Time\" /></a>Execution Time\n<p>There are several situations in which a pulse is generated either automatically, or by a user. Most of the time pulses are harmless and don&#8217;t do anything.</p>\n<p>Each pulse (POST request) executes a PHP script equating to CPU time on the server. In an experiment, InMotion Hosting left the dashboard open for a half hour and noticed <strong>25</strong> PHP script executions that used <strong>5.77</strong> CPU seconds. The small amount of CPU time was used to do nothing.</p>\n<p>The problem is compounded by the fact that each user who has access to the backend of WordPress generates a pulse. As the number of users navigating the WordPress backend simultaneously increases, so does the number of pulses generated from the API.</p>\n<p>If a webhosting provider has strict limits on the number of processes or resources used, you could easily go over the limit.</p>\n<h2>How to Control The Heartbeat API</h2>\n<p><a title=\"https://wordpress.org/plugins/heartbeat-control/\" href=\"https://wordpress.org/plugins/heartbeat-control/\">Heartbeat Control</a>, developed by <a title=\"http://jeffmatson.net/\" href=\"http://jeffmatson.net/\">Jeff Matson</a>, is a new plugin that enables you to control the interval of pulses. After activating the plugin, you&#8217;ll find the settings located in <strong>Tools&gt;Heartbeat Control</strong>.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/HeartbeatControlSettings.png\" rel=\"prettyphoto[35865]\"><img class=\"wp-image-35885 size-full\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/HeartbeatControlSettings.png?resize=502%2C258\" alt=\"Heartbeat Control Settings\" /></a>Heartbeat Control Settings\n<p>You can choose to disable the API entirely, only on the dashboard page, or allow it only on the post editing screen. You can also choose the interval when pulses are sent. The choices range from 15-60 seconds with 5 second intervals in between.</p>\n<p>By changing the interval to 60 seconds, pulses are less likely to impact server performance. Several <a title=\"http://www.inmotionhosting.com/support/website/wordpress/heartbeat-ajax-php-usage#comments\" href=\"http://www.inmotionhosting.com/support/website/wordpress/heartbeat-ajax-php-usage#comments\">HostGator customers</a> who use the plugin report they no longer experience suspensions for using too many resources.</p>\n<h2>Why InMotion Hosting Doesn&#8217;t Throttle The API by Default</h2>\n<p>If increasing the pulse interval from 15 to 60 seconds increases server performance, why doesn&#8217;t InMotion Hosting throttle the API on every webhosting server?</p>\n<p>Matson, who works for InMotion Hosting, says a one size fits all approach doesn&#8217;t work. &#8220;The reason we don&#8217;t do that is because there are some users that require it at the default rate or an even higher frequency. When making server-wide changes, you have to be extremely careful that you do not impact a customer&#8217;s site.&#8221;</p>\n<p>Matson goes on to say that, &#8220;As a host, the number one goal is making customers happy and restricting the normal operation of a user&#8217;s site is unacceptable.&#8221;</p>\n<h2>How HostGator Almost Deleted WP Tavern</h2>\n<p>I sympathize with those who use HostGator as they have a strict <a title=\"http://support.hostgator.com/articles/pre-sales-policies/rules-terms-of-service/cpu-resource-restriction\" href=\"http://support.hostgator.com/articles/pre-sales-policies/rules-terms-of-service/cpu-resource-restriction\">CPU resource restriction</a>. If pulses from the Heartbeat API cause the CPU to become busy or cause a backup in processes, using 25% of the CPU longer than 90 seconds is easy to do.</p>\n<p>HostGator&#8217;s policy for using too many resources is to suspend the account. This makes it impossible to troubleshoot the problem. If you exceed the resource allotment more than five times, the site is removed from the server and your account is banned.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/HostGatorResourcePolicy.png\" rel=\"prettyphoto[35865]\"><img class=\"size-full wp-image-35886\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/HostGatorResourcePolicy.png?resize=503%2C107\" alt=\"HostGator Resource Policy\" /></a>HostGator Resource Policy\n<p>In late 2013, when WP Tavern used HostGator, I experienced first-hand what it&#8217;s like to have a website suspended. When I upgraded the Tavern to WordPress 3.6, which introduced the Heartbeat API, I <a title=\"http://wptavern.com/my-wordpress-is-denying-itself-service\" href=\"http://wptavern.com/my-wordpress-is-denying-itself-service\">started to experience problems</a>. The site would routinely lock up and when I viewed the processes tab in cPanel, it looked like a simple process repeated itself, leading to a denial of service.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2013/06/siteoffline.jpg\" rel=\"prettyphoto[35865]\"><img class=\"aligncenter size-full wp-image-7554\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2013/06/siteoffline.jpg?resize=741%2C644\" alt=\"Site Offline Errors\" /></a>I can&#8217;t confirm if the Heartbeat API was the culprit but it&#8217;s high on my list of suspicions. After suspending the Tavern twice, HostGator informed me that if the site was suspended again, it would be removed from the server without giving me a chance to back it up. Needless to say, I switched hosts immediately.</p>\n<h2>Don&#8217;t End Up in a Similar Situation</h2>\n<p>If you&#8217;re using a webhosting service with strict resource limits, consider installing Heartbeat Control to limit the number of pulses. Not only will it mean fewer calls to the server, but it may lead to a performance increase as well. Keep a close eye on the resources used and if you come close to maxing out, it&#8217;s a sign you need to upgrade to a better plan. Don&#8217;t end up in a position where you may lose your site!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Dec 2014 02:19:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: Atlanta WordPress Coders Guild: A New Meetup for Designers and Programmers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35847\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://wptavern.com/atlanta-wordpress-coders-guild-a-new-meetup-for-designers-and-programmers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7496:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/atlanta.jpg\" rel=\"prettyphoto[35847]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/atlanta.jpg?resize=1022%2C496\" alt=\"photo credit: FrenchKheldar - cc\" class=\"size-full wp-image-35874\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/frenchkheldar/3322197028/\">FrenchKheldar</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>The Atlanta metro area will soon be getting a new type of WordPress meetup, targeted towards programmers and designers. Local organizers <a href=\"http://mikeschinkel.com/\" target=\"_blank\">Mike Schinkel</a> and <a href=\"http://micahwood.me/\" target=\"_blank\">Micah Wood</a> announced the <a href=\"http://www.meetup.com/atlanta-wordpress-coders-guild/\" target=\"_blank\">Atlanta WordPress Coders Guild</a> on Meetup.com and have already attracted 55 members who identify themselves as coders.</p>\n<p>Due to the group&#8217;s unique requirements, it is not affiliated with the WordPress Foundation-sponsored <a href=\"https://make.wordpress.org/community/meetups/\" target=\"_blank\">community meetups</a>. In order to become a member, one must be interested in working with technologies such as PHP, MySQL, Apache, Javascript, jQuery, Git, Backbone, Vagrant, Gulp, Grunt, SASS, and of the WordPress API.</p>\n<p>&#8220;We are not affiliated with the WordPress Foundation&#8217;s Community Meetups initiative because we are not open to WordPress end-users,&#8221; Schinkel emphasizes in the meetup&#8217;s description. &#8220;We are instead a group for serious professionals with a goal of raising the bar for WordPress coder talent in the Southeast and to make it more viable for the major project funders to choose WordPress instead of closed source solutions.&#8221;</p>\n<p>Official community meetups have a requirement to have membership open to &#8220;all who wish to join, regardless of ability, skill, financial status or any other criteria.&#8221; Since the Atlanta WordPress Coders Guild isn&#8217;t open to all skill levels, it is running independently. The organizers plan to host workshops centered around best practices expected by clients who spend $100k+ on projects that demand a high level of performance and security.</p>\n<h3>Atlanta&#8217;s Fragmented WordPress Community</h3>\n<p>Schinkel has lived in the Atlanta area for several decades and has <a href=\"http://mikeschinkel.com/blog/25-best-practices-for-meetup-organizers/\" target=\"_blank\">organized professional meetups</a> for the past eight years. He&#8217;s an accidental connector who became acquainted with many people in the area and has a unique perspective on the Atlanta tech and WordPress communities.</p>\n<p>&#8220;We have a really strong tech community backed by education like Georgia Tech and ~10 Fortune 500 companies in the Atlanta area, and tons on technology meetups,&#8221; he said. &#8220;Lots of Java, .NET, Ruby, Javascript and PHP, and at least 10 large digital agencies with probably up to 1000 agencies if you count the small ones.&#8221;</p>\n<p>The startup community is also thriving in the area and Atlanta is experiencing growth across various sectors, including financial, health tech, IT security, and more. Unfortunately, this has not directly translated into a strong WordPress community.</p>\n<p>&#8220;The WordPress community, however, is fragmented because of metro Atlanta’s expansive geography, lack of any natural geographic boundaries and no single entity with the clout to really organize a cohesive community,&#8221; Schinkel explained. The area has 10 different meetups, many of which fail to attract more than a handful of members on a regular basis.</p>\n<p>The <a href=\"http://www.meetup.com/wordpress-atlanta/\" target=\"_blank\">Atlanta WordPress Users Group</a>, organized by Judi Knight, is the most successful with approximately 1600 members, but Schinkel says those are primarily people willing to travel to a meetup in town. Outer metro Atlanta residents are reluctant to attend.</p>\n<p>&#8220;Also, from the perspective of a professional WordPress PHP, MySQL and jQuery coder, those meetups are characterized by really novice end-users,&#8221; he said. &#8220;Rarely, if ever, is there any significant WordPress coding talent in attendance, and intermediate to advanced topics are never announced or covered.&#8221;</p>\n<h3>The Need for More Workshops Focused on Advanced Topics</h3>\n<p>Schinkel believes that the Atlanta WordPress community needs the opportunity to have more advanced workshops and developer-focused meetups. &#8220;As far as I can tell the existing successful WordPress meetups all focus on the needs of end-users,&#8221; he said. &#8220;That’s great, it is what in part has driven the success but WordPress, but it also means that there are no local meetups to help WordPress coders to grow their skills.&#8221;</p>\n<p>Schinkel used the term &#8220;coder&#8221; in the meetup name specifically to filter out those he would classify as developers.</p>\n<blockquote><p>Many people think of themselves as &#8216;WordPress Developers&#8217; when what they do is install WordPress; select, install and configure a theme; select, install and configure plugins; maybe tweak CSS; and add some page templates with a bit if loop and template tag coding. So we think of those people as &#8216;Site Builders&#8217; and think the term &#8216;developer&#8217; is too broadly adopted to have any communicable distinction in the context of WordPress people.</p></blockquote>\n<p>There are a myriad of meetups in Atlanta for WordPress end users who want to learn about using themes and plugins, but virtually no meetups for coders who want to expand their skills. This is why the organizers are spearheading a WordPress coders guild in Atlanta.</p>\n<p>&#8220;First and foremost we want to see more Atlanta agencies and internal terms in the larger Atlanta organizations choosing WordPress for their projects,&#8221; Schinkel said. &#8220;For that to happen there has to be a stronger talent base in Atlanta who are knowledgeable and experienced in WordPress best practices, at least as far as they relate to agency use of WordPress.&#8221;</p>\n<p>He anticipates that the group will probably have its first &#8220;get to know each other&#8221; meetup in January and then start workshops in February. With advanced topics in the spotlight every week, Schinkel hopes that agencies and internal teams that rarely come out to network will be more motivated to attend.</p>\n<p>&#8220;We want to create a stronger WP coder community than we currently have in Atlanta, and the one we currently have is really lacking,&#8221; he said. &#8220;Put it another way, Drupal has a far stronger developer community in Atlanta because of their Drupal meetup and yet Drupal has ~1/10th the marketshare of WordPress. Now that is really sad, don’t you think?&#8221;</p>\n<p>Schinkel and Wood have identified a common problem with many community meetups where the topics focus on end user education. While connecting with people of all skill levels is important, more advanced WordPress professionals often become less motivated to attend meetups that don&#8217;t include topics that challenge them and help them become better at their work. The <a href=\"http://www.meetup.com/atlanta-wordpress-coders-guild/\" target=\"_blank\">Atlanta WordPress Coders Guild</a> aims to solve this problem with an alternative, non-traditional WordPress meetup.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Dec 2014 23:34:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WPTavern: VVV-Dashboard Provides an Interface for Managing Varying Vagrant Vagrants Installations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35807\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"http://wptavern.com/vvv-dashboard-provides-an-interface-for-managing-varying-vagrant-vagrants-installations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3392:\"<p><a href=\"https://github.com/leogopal/VVV-Dashboard\" target=\"_blank\">VVV-Dashboard</a> is a new tool that provides an interface for managing your <a href=\"https://github.com/Varying-Vagrant-Vagrants/VVV\" target=\"_blank\">Varying Vagrant Vagrants</a> installations. Inspired by <a href=\"http://wptavern.com/variable-vvv-a-new-vvv-site-creation-wizard-for-wordpress\" target=\"_blank\">Variable VVV</a>, a script that makes it easy to create and delete sites, <a href=\"https://twitter.com/leogopal\" target=\"_blank\">Leo Gopal</a> made VVV-Dashboard to complement it.</p>\n<p>Gopal is a WordPress developer from Cape Town, South Africa. &#8220;I installed my first WordPress site seven years ago while in high school and started creating sites for clients ever since. Only recently, after Matt&#8217;s <a href=\"http://ma.tt/2014/09/five-for-the-future/\" target=\"_blank\">Five for the Future</a> speech, did I decide to come out and offer what I have to everyone, more freely,&#8221; he said. VVV-Dashboard is one of his first public contributions.</p>\n<p>The tool was designed to work with Variable VVV but can be used without it. &#8220;Because VVV is very terminal oriented, it&#8217;s easy to forget commands when you need them. For example, you might forget to &#8216;vagrant up &#8211;provision&#8217; when working with Variable VVV (and other site creators),&#8221; Gopal said. VVV-Dashboard adds a quick reference page inside your vvv.dev site for commands and includes a list of all your Vagrant installs.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/vvv-dashboard.png\" rel=\"prettyphoto[35807]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/vvv-dashboard.png?resize=1025%2C472\" alt=\"vvv-dashboard\" class=\"aligncenter size-full wp-image-35817\" /></a></p>\n<p>The title of the page displays how many VVV sites you have installed on your machine. Each site and its admin are linked, along with a <a href=\"http://www.xdebug.org/docs/profiler\" target=\"_blank\">profiler</a> button that offers a quick overview. In order for the profiler to work, you must have Xdebug turned on.</p>\n<p>Many developers end up with a long list of dev sites, and it can be difficult to remember what sites are active and where they are located. The VVV-Dashboard interface saves you time with a convenient list and might even inspire you to perform a cleanup of sites no longer in use.</p>\n<p>In the next few releases, Gopal plans to include more basic site info in the dashboard, such as whether or not WP_Debug is enabled, an indicator for if Xdebug is on/off, the current active theme, etc. Variable VVV recently added a blueprints feature, which allows you to set up different plugins, themes, mu-plugins, options, or constants that will be installed to a new site you create. Gopal plans to create a few blueprint examples and add them to VVV-Dashboard.</p>\n<p>VVV-Dashboard is licensed under the GPL V2. It adds a friendly layer between you and your VVV sites to make management more convenient and efficient. Check out the project on <a href=\"https://github.com/leogopal/VVV-Dashboard\" target=\"_blank\">GitHub</a> where you&#8217;ll find complete installation instructions. If you have any tips on how to improve the project, make sure to <a href=\"https://github.com/leogopal/VVV-Dashboard/issues/new\" target=\"_blank\">leave your feedback</a> for the developer.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Dec 2014 20:01:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: ManageWP Releases Plugin Discovery Tool\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35747\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wptavern.com/managewp-releases-plugin-discovery-tool\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5361:\"<p>The <a title=\"https://wordpress.org/plugins/\" href=\"https://wordpress.org/plugins/\">WordPress plugin directory</a> has nearly 35k plugins and discovering new ones that have been tested and downloaded a few thousand times is difficult. Users can browse the directory for newest, recently updated, most popular, and highest rated plugins. With the exception of the <a title=\"https://wordpress.org/plugins/browse/updated/\" href=\"https://wordpress.org/plugins/browse/updated/\">recently updated</a> category, there&#8217;s no way to discover plugins in the middle of the pack. A new <a title=\"https://managewp.org/plugins/best\" href=\"https://managewp.org/plugins/best\">plugin discovery tool</a> by ManageWP, attempts to solve the problem.</p>\n<h2>Algorithm Based</h2>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/ManageWPBestNewPlugins.png\" rel=\"prettyphoto[35747]\"><img class=\"size-full wp-image-35794\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/ManageWPBestNewPlugins.png?resize=925%2C663\" alt=\"Best New Plugins\" /></a>Best New Plugins Page\n<p>The front page of <a title=\"https://managewp.org/plugins/best\" href=\"https://managewp.org/plugins/best\">ManageWP.org/plugins</a> displays the best new plugins under 100k downloads. The plugins are determined using an algorithm that takes into account plugin quality and acceleration of growth. A plugin&#8217;s quality is determined using seven metrics:</p>\n<ul>\n<li>Last Updated</li>\n<li>WordPress Compatibility</li>\n<li>Support</li>\n<li>Rating</li>\n<li>Plugin Popularity</li>\n<li>Author Popularity</li>\n<li>Other plugins from the same author</li>\n</ul>\n<p>Using a combination of metrics, ManageWP is able to display a constantly evolving list of <a title=\"https://managewp.org/plugins/rising\" href=\"https://managewp.org/plugins/rising\"><em>rising stars</em></a>. Placing emphasis on a plugin&#8217;s compatibility with WordPress and when it was last updated might motivate plugin authors to keep these fields updated.</p>\n<h2>Comparing Plugins</h2>\n<p>If you&#8217;re curious to see how plugins compare to each other, check out the <a title=\"https://managewp.org/#comparePlugins\" href=\"https://managewp.org/#comparePlugins\">plugin comparison section</a> of the site. Simply choose two different plugins and hit the compare button. The comparison displays each plugin&#8217;s statistics with a download chart at the bottom. At the moment, you&#8217;re limited to comparing only two plugins at the same time, but there are plans to allow for more in the future.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/ManageWPPluginComparison.png\" rel=\"prettyphoto[35747]\"><img class=\"size-full wp-image-35793\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/ManageWPPluginComparison.png?resize=915%2C493\" alt=\"Plugin Comparisons\" /></a>Plugin Comparisons\n<h2>Plugin Awards</h2>\n<p>Awards are a quick way to determine how well a plugin is doing in specific categories. For example, <a title=\"https://managewp.org/plugins/details/wordpress-seo\" href=\"https://managewp.org/plugins/details/wordpress-seo\">WordPress SEO</a> by Team Yoast, has a number of awards for being the most downloaded and highest rated in multiple categories. I think it would be beneficial if this area was extended to highlight more ranks like top ten, top five, and number one.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/PluginAwards.png\" rel=\"prettyphoto[35747]\"><img class=\"size-full wp-image-35797\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/PluginAwards.png?resize=599%2C559\" alt=\"ManageWP Plugin Awards\" /></a>ManageWP Plugin Awards\n<h2>Future Improvements</h2>\n<p>ManageWP founder, Vladimir Prelovac, says he&#8217;s not finished with the site. In <a title=\"https://managewp.com/blog\" href=\"https://managewp.com/blog\">the announcement</a>, he shares a couple of ideas on what he&#8217;d like to see in the next iteration.</p>\n<ul>\n<li>Simpler plugin comparison, allow multiple plugins compared at once.</li>\n<li>Include <a href=\"https://wpvulndb.com/\">WP Vulnerability Database</a> security data to plugin details page and Plugin Quality score.</li>\n<li>Allow plugin authors to ‘claim’ their pages. This will allow all sorts of activity like adding the links to their premium support, answering Q&amp;A</li>\n<li>Open everything via an API so everyone can use the engine and its data</li>\n</ul>\n<p>The WP Vulnerability Database will be a nice enhancement, especially if you can see how many vulnerability reports a plugin has. Something to keep in mind is that ManageWP/Plugins is utilizing the <a title=\"http://codex.wordpress.org/WordPress.org_API\" href=\"http://codex.wordpress.org/WordPress.org_API\">WordPress.org Plugins API,</a> which limits the types of data it&#8217;s able to work with.</p>\n<h2>A Plugin Directory Without The Plugins</h2>\n<p>I love the idea behind <a title=\"https://managewp.org/plugins\" href=\"https://managewp.org/plugins\">ManageWP/Plugins</a> because it fills a void created by the plugin directory. It&#8217;s essentially a sub-section of the directory without the plugins. When I look for plugins to review, the directory leaves me little choice between one that&#8217;s popular or brand new. ManageWP/Plugins gives me an opportunity to discover them before they reach global popularity.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 17 Dec 2014 05:58:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"WPTavern: WordPress Accessibility Team Is Mobilizing to Make Accessibility Required for WordPress.org Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35570\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"http://wptavern.com/wordpress-accessibility-team-is-mobilizing-to-make-accessibility-required-for-wordpress-org-themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4365:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/guided-road.jpg\" rel=\"prettyphoto[35570]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/guided-road.jpg?resize=900%2C421\" alt=\"guided-road\" class=\"aligncenter size-full wp-image-22575\" /></a></p>\n<p>Throughout the first half of this month, the WordPress Accessibility team has been working together with the Theme Review Team to discuss the <a href=\"https://make.wordpress.org/accessibility/2014/12/04/theme-accessibility-meeting-notes/\" target=\"_blank\">possibility of requiring the accessibility-ready tag</a> for themes hosted on WordPress.org. The team will need to create an official proposal to submit to the Theme Review Team in order to make this happen.</p>\n<p>In preparation, the Accessibility team is increasing efforts to educate theme authors on accessibility best practices. Joe Dolson published a post with <a href=\"https://make.wordpress.org/themes/2014/12/15/three-easy-tips-for-accessible-theming/\" target=\"_blank\">tips for making WordPress themes accessible</a>, which includes basic instructions for making themes work with a keyboard, creating event triggers as accessible controls, and adding supporting text for images.</p>\n<p>The Accessibility team also created a <a href=\"https://github.com/wpaccessibility/\" target=\"_blank\">GitHub repository</a> for sharing WordPress-specific code examples for accessibility and plans to add resources in the near future. The theme handbook and reviewer&#8217;s handbook will potentially need to be reworked in order to account for the new guidelines. &#8220;The goal is for those documents to explicitly correlate to the theme accessibility guidelines, so that theme authors have specific guidance on what to do to meet those requirements,&#8221; Dolson said at a recent meeting.</p>\n<p>The Accessibility team hopes to announcing new guidelines for theme developers in April 2015, which would then be required as of November 2015. Once the guidelines are finalized for both required and recommended items, the Accessibility team will also need to train the Theme Review Team on reviewing for accessibility.</p>\n<p>For most traditional WordPress sites, the active theme is the face of the website, and accessibility-ready themes undoubtedly improve the experience of WordPress for users with disabilities. However, making accessibility required for themes is a long and difficult path. The possibility of the requirement already has opposition among Theme Review Team administrators.</p>\n<p>When we <a href=\"http://wptavern.com/wordpress-themes-directory-now-requires-all-themes-to-be-translation-ready\" target=\"_blank\">published</a> about WordPress.org&#8217;s newest requirement for themes to be translation-ready, several readers chimed in on the comments to advocate for accessibility to be required. Justin Tadlock, a TRT admin, <a href=\"http://wptavern.com/wordpress-themes-directory-now-requires-all-themes-to-be-translation-ready#comment-61697\" target=\"_blank\">replied</a>, &#8220;As an admin of TRT, full compliance with our current accessibility guidelines is something I’d fight to not make a requirement.</p>\n<p>&#8220;Unfortunately, making a theme accessible can sometimes mean not respecting a designer’s artistic vision. This is particularly an issue with color contrasts. Anything that would hinder design decisions like this is not something I would support. That’s beyond the scope of what TRT’s role is.&#8221;</p>\n<p>Even with more education for theme authors, additional guidelines pose another hurdle to overcome in the rigorous review process. Tadlock believes it would stifle submissions from new theme authors. &#8220;Requiring accessibility-ready themes would be such a huge barrier to entry for new theme authors that it would be detrimental to the system.&#8221;</p>\n<p>The Accessibility team is highly motivated to push for this new requirement and is currently working on a precise proposal that will be voted on by the Theme Review Team. &#8220;The important thing with the proposal is clarity,&#8221; Dolson said, recognizing that it could blocked if the two teams are unable to communicate effectively about the issues at stake. The decisions made in the first part of 2015 will determine the immediate future of theme accessibility in the WordPress.org Themes Directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Dec 2014 21:24:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"Post Status: Let’s WordSesh together\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"http://www.poststat.us/?p=7232\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://www.poststat.us/lets-wordsesh-together/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1513:\"<p><img class=\"aligncenter size-large wp-image-7233\" src=\"http://www.poststat.us/wp-content/uploads/2014/12/wordsesh-3-752x317.png\" alt=\"wordsesh-3\" width=\"627\" height=\"264\" /></p>\n<p>This weekend, <a href=\"http://wordsesh.org/\">WordSesh</a> 3 will begin. WordSesh is 24 straight hours of live streamed presentations and discussions from a variety of intelligent folks in the WordPress world.</p>\n<p>It starts at 0:00 UTC Saturday, which really means 7:00 p.m. Eastern time on Friday for those of us in America. It&#8217;ll run through Saturday evening.</p>\n<p>The <a href=\"http://wordsesh.org/#schedule\">lineup</a> for WordSesh is as good as any WordCamp, and the chat around the past events has been fantastic. Scott Basgaard and his team of volunteers do a great job.</p>\n<p>I&#8217;ll be on a WordPress news roundtable at the tail end of WordSesh. On Friday, I&#8217;m going to have some news that will help explain my radio silence of late, and will probably spice up the conversation I&#8217;m to have with Jeff Chandler (of WP Tavern), Dre Armeda and Brad Williams (of DradCast) and Doc Pop (of Torquemag). I hope you&#8217;ll watch.</p>\n<p>Check out all the information on the <a href=\"http://wordsesh.org/\">WordSesh</a> website, follow <a href=\"https://twitter.com/wordsesh\">@WordSesh</a> on Twitter, and RSVP if you&#8217;d like to attend. There are already over 600 people signed up. It&#8217;s completely free and community supported. I love this event and I&#8217;m glad to see it happen again.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Dec 2014 19:43:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"WPTavern: Jetpack 3.3 Introduces New Centralized Dashboard for Managing Multiple WordPress Sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35724\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"http://wptavern.com/jetpack-3-3-introduces-new-centralized-dashboard-for-managing-multiple-wordpress-sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3553:\"<p>Jetpack 3.3 is now available. The highlight of this release is the new centralized site dashboard feature that allows users to manage multiple Jetpack-connected WordPress sites and WordPress.com sites from one location in WordPress.com.</p>\n<p>The new dashboard is mobile friendly and includes the <a href=\"http://wptavern.com/jetpack-3-2-introduces-centralized-posting-from-wordpress-com\" target=\"_blank\">centralized posting feature that was introduced in Jetpack 3.2</a>. It also allows users to see all of their sites listed together and perform a number of housekeeping actions:</p>\n<ul>\n<li><strong>Plugin management:</strong> Turn plugins on or off with one click — per site or in bulk.</li>\n<li><strong>Initiate plugin updates:</strong> Update plugins for a single site or all sites in bulk.</li>\n<li><strong>Automatic updates:</strong> Turn on auto-updates for any plugin on a per-site basis or in bulk.</li>\n</ul>\n<p>Jetpack 3.3 is required in order to use the plugin management features, so you&#8217;ll need to update at least one of your sites to check it out. You also need to activate Jetpack&#8217;s JSON API feature and ensure that the &#8220;Allow remote actions&#8221; setting is enabled.</p>\n<p>To view all the plugins you have installed, visit <a href=\"https://wordpress.com/plugins\" target=\"_blank\">WordPress.com/Plugins</a>. When you click through a plugin, you&#8217;ll find a short description of it and a list of the sites where you have it installed.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/jetpack-plugin-management.jpg\" rel=\"prettyphoto[35724]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/jetpack-plugin-management.jpg?resize=980%2C482\" alt=\"jetpack-plugin-management\" class=\"aligncenter size-full wp-image-35735\" /></a></p>\n<p>WordPress.com&#8217;s one dashboard to rule them all is now in direct competition with services like <a href=\"https://managewp.com/\" target=\"_blank\">ManageWP</a>, <a href=\"https://wpremote.com/\" target=\"_blank\">WP Remote</a>, <a href=\"http://infinitewp.com/\" target=\"_blank\">InfiniteWP</a>, and several others that provide centralized site management.</p>\n<p>As WordPress has become an increasingly popular solution for building websites, developers are often responsible for more sites than they can safely keep track of for updates. Centralized dashboard management is critical for scaling maintenance capabilities. It comes as no surprise that WordPress.com is getting its hook into self-hosted sites by moving to support centralized site management via Jetpack.</p>\n<p>In addition to the new centralized dashboard, Jetpack 3.3 also brings many other enhancements to the plugin:</p>\n<ul>\n<li>Adds responsive video support to BuddyPress</li>\n<li>Custom Content Types: Added &#8216;order&#8217; and &#8216;orderby&#8217; options to portfolio shortcode</li>\n<li>Display notice when Jetpack Development Mode is on</li>\n<li>Compatibility with Twenty Fifteen</li>\n<li>Likes: Updated the code to accept arbitrary CPTs</li>\n<li>Related Posts: Allow filter by post_format</li>\n<li>Sharing: add new jetpack_sharing_counts filter for option to turn off sharing counts</li>\n<li>Sharing: Use the Site Logo Theme Tool and the Site Icon as fallbacks for image tags</li>\n</ul>\n<p>The 3.3 release also adds several filters that allow developers to further customize Jetpack&#8217;s behavior. Check out the <a href=\"https://wordpress.org/plugins/jetpack/changelog/\" target=\"_blank\">changelog</a> for the full list of enhancements and improvements.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 16 Dec 2014 18:24:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WPTavern: 100,000+ WordPress Sites Compromised Using the Slider Revolution Security Vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35668\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://wptavern.com/100000-wordpress-sites-compromised-using-the-slider-revolution-security-vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3280:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/07/security.jpg\" rel=\"prettyphoto[35668]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/07/security.jpg?resize=1024%2C487\" alt=\"photo credit: Ravages - cc\" class=\"size-full wp-image-27206\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/ravages/6731739485/\">Ravages</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>Over the weekend, the security team at Sucuri <a href=\"http://blog.sucuri.net/2014/12/soaksoak-malware-compromises-100000-wordpress-websites.html\" target=\"_blank\">discovered</a> that more than 100,000 WordPress sites have been hit with the SoakSoak.ru malware campaign. This campaign has resulted in more than 11,000 domains being blacklisted by Google.</p>\n<p>SoakSoak modifies the wp-includes/template-loader.php file in order to inject Javascript, which contains the malware, into every page on compromised sites. You can check to see if your site is affected by using Sucuri&#8217;s free <a href=\"http://sitecheck.sucuri.net/\" target=\"_blank\">SiteCheck scanner</a>.</p>\n<p>After researching the compromised sites, Sucuri found that SoakSoak&#8217;s vehicle of attack is the <a href=\"http://wptavern.com/critical-security-vulnerability-found-in-wordpress-slider-revolution-plugin-immediate-update-advised\" target=\"_blank\">critical security vulnerability that was discovered in the Slider Revolution plugin</a> and made public in September. At that time, Envato identified more than <a href=\"http://wptavern.com/1000-wordpress-themes-on-envato-market-potentially-affected-by-revolution-slider-security-vulnerability\" target=\"_blank\">1,000 themes sold through its marketplace that were potentially affected</a> by this particular vulnerability.</p>\n<p>The Slider Revolution issue, though silently patched in February, has been actively exploited since its disclosure. Many WordPress site administrators have not updated their copies of the Slider Revolution plugin to the patched version, leaving their sites open to compromise. Since the plugin is packaged with many themes sold through Themeforest, site owners are not always aware that they are vulnerable.</p>\n<p>According to the report from Sucuri, the SoakSoak attack first scans sites to locate the vulnerable file within the Slider Revolution plugin in order to gain access to the wp-config.php file. If successful, the intruder then attempts to upload a malicious theme to the site, followed by injecting the <a href=\"http://labs.sucuri.net/db/malware/backdoor-phpfilesman02\" target=\"_blank\">Filesman backdoor</a> into the website. The attacker then injects another backdoor in order to modify the swfobject.js file to inject malware that redirects visitors to soaksoak.ru.</p>\n<p>This malware attack is particularly difficult to clean up after. If your site has been compromised, you cannot simply remove the infected files. The backdoors will also need to be addressed, as well as the Slider Revolution vulnerabilities. Sucuri advises stopping malicious attacks through a firewall. If your site or one of your clients&#8217; sites is using the Slider Revolution plugin, it is imperative that you check to see if you are affected and update your site and plugins immediately.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Dec 2014 22:42:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Pippin Williamson on Building a Community Around Your Open Source Project\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35573\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://wptavern.com/pippin-williamson-on-building-a-community-around-your-open-source-project\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10938:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/pippin-williamson.jpg\" rel=\"prettyphoto[35573]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/pippin-williamson.jpg?resize=800%2C393\" alt=\"photo credit: inQbation\" class=\"size-full wp-image-35588\" /></a>photo credit: <a href=\"http://www.inqbation.com/photos-of-wordpress-wordcamp-miami-2014/\">inQbation</a>\n<p>When <a href=\"https://twitter.com/pippinsplugins\" target=\"_blank\">Pippin Williamson</a> launched <a href=\"https://easydigitaldownloads.com/\" target=\"_blank\">Easy Digital Downloads</a> in early 2012, he could not have predicted the success that the open source project is experiencing today. The core plugin is approaching half a million downloads and recently passed 100 <a href=\"https://github.com/easydigitaldownloads/Easy-Digital-Downloads/graphs/contributors\" target=\"_blank\">contributors</a> on GitHub. It provides the foundation for a profitable commercial marketplace of more than 190 extensions authored by the EDD community.</p>\n<h3>The Birth of Easy Digital Downloads</h3>\n<p>As is the case with many entrepreneurs, Williamson discovered one of his best ideas while solving one of his own problems. He had become an avid plugin developer long before EDD was in the picture. &#8220;I wanted a better way to sell WordPress plugins I was creating through my own site,&#8221; he said. &#8220;I had been using the Code Canyon marketplace from Envato for a while and had toyed with a few of the other e-commerce plugins, but I wanted something a bit different.&#8221; Williamson had no idea that EDD would soon become his full-time job.</p>\n<blockquote><p>When a project starts out that way, it&#8217;s really hard to guesstimate what the future holds for it. As I continued building on the plugin and making more generalized features that had a wider audience than just my site, it became apparent pretty quickly that others were looking for some of the same things. The project was started in March and by November of the same year, I really started to consider the prospect of it becoming a full-time job for me.</p></blockquote>\n<p>Williamson was inspired by Jigoshop&#8217;s and WooCommerce&#8217;s successes with the &#8220;extensions marketplace&#8221; business model. &#8220;As an outsider, it seemed as though the extensions model was working well for them, so I thought, &#8216;Why not?&#8217; It seemed like a good fit. Early on though I had no idea that we would reach more than 150 extensions in so short a time.&#8221;</p>\n<p>He built the first couple of extensions for himself, including the Stripe integration. &#8220;Those first extensions were really the ones that proved building a marketplace around EDD wasn&#8217;t an utterly insane idea. Mostly insane but plausible.&#8221;</p>\n<h3>Extensibility Has a Direct Correlation to Profitability</h3>\n<p>Easy Digital Downloads is well known for having a codebase that is easy to extend and friendly to developers. Williamson built this into the project out of principle from the early days of EDD, not knowing how vital extensibility would become further down the road.</p>\n<p>&#8220;It definitely started as a core philosophy but became a fundamental requirement as the project grew. EDD wouldn&#8217;t be even half as successful as it is now if it weren&#8217;t for the extensibility,&#8221; he said. &#8220;There are still severe pain points in terms of our extensibility, but they are being worked on for future releases. A commitment to always making the plugin more and more extensible is one of the things that has really helped us along the way.&#8221;</p>\n<p>Extensibility is the backbone of the EDD marketplace, and it&#8217;s paying off for Williamson and the project as a whole. On an average day, the core EDD plugin sees 400-1000 downloads. &#8220;The revenue of the project has grown consistently since first launching two and a half years ago,&#8221; Williamson said. &#8220;In its first year, we saw steady growth, but nothing amazing by any means. It was enough to tell me there was potential for much, much more.&#8221;</p>\n<p>In 2012, Williamson reports that the project pulled in $25,000 in extension sales, with one fifth of this paid out to third party developers for extension sales. Over the course of 2013, EDD grew its monthly revenue from ~$2,000 per month up to nearly $16,000 per month. Williamson finished that year with ~$190,000 in sales and paid out nearly $64,000 in commissions to third party developers.</p>\n<p>&#8220;And now, just as we are wrapping up 2014, we have seen more than $456,000 in sales and have generated more than $200,000 in commissions for third party developers,&#8221; Williamson said. &#8220;In 2015 these numbers are expected to grow, just as they have for the last two years. To say we&#8217;re excited for the future would be to put it lightly.&#8221;</p>\n<h3>Attracting and Keeping a Community of Contributors</h3>\n<p>Without EDD&#8217;s large community of contributors, the project&#8217;s success would have been severely limited. EDD seems to have an organic way of attracting and keeping contributors. Williamson attributes this to three key aspects of the community surrounding the project:</p>\n<ul>\n<li><strong>We work hard to always try and make new contributors few welcome.</strong> No one should ever be told (even indirectly) to go away when they are trying to give back to a project. By being open to criticism and suggestions from the community, and working to ensure the community feels encouraged to speak up, we have gained a lot of long-time contributors, simply because they didn&#8217;t feel like their suggestions were lost in a dark abyss of nothingness or intentionally ignored. When people feel welcomed, they tend to stick around.</li>\n<li><strong>Every suggestion gets an answer of some kind. Period.</strong> We strive to never leave a support ticket or github issue unanswered. Even if the answer is &#8220;no&#8221;, we still answer it. When people are ignored, they leave, so we never ignore anyone. Period.</li>\n<li><strong>We have actively asked people to help out on the project.</strong> There are tons of people out there ready, willing, and wanting to help; sometimes all it takes is an invitation.</li>\n</ul>\n<p>Williamson doesn&#8217;t think that any of these efforts are unique to EDD, but they have been the most important factors for growing and keeping a large contributor base. He aims to make sure every single contributor gets an answer to their suggestions, no matter how small the contribution or bug report. &#8220;If someone that is brand new to the project feels they have been ignored, how likely are they to ever come back? I think we see this a lot with WordPress core contributors,&#8221; he said.</p>\n<p>&#8220;There are hundreds of tickets on trac that have gone unanswered from new contributors, and I suspect a huge percentage of those people have decided to move on and not contribute since they felt ignored. <strong>It doesn&#8217;t matter if someone is actually ignored; it matters that they feel they were ignored.</strong>&#8221;</p>\n<p>In order to maintain a good follow-up process, Williamson has streamlined development of the core plugin through its GitHub repository. New contributors who want to get involved with extension or theme development also have access to a private Trello board where they can connect with other developers.</p>\n<h3>Advice for New Open Source Project Leaders</h3>\n<p>When reflecting on the early days of EDD, Williamson has a few regrets and encourages developers to think about the future when it comes to plugin architecture. &#8220;There is one major architectural change I would make, and that is the use of custom tables for storing data,&#8221; he said.</p>\n<p>&#8220;We opted out of using custom tables from day one, and that was a mistake. Not properly leveraging custom tables that had the exact database schema that we needed actually made it dramatically more work for us in the long run. We&#8217;ve had to jump through a lot of hoops to build advanced queries for solid store reporting.&#8221;</p>\n<p>This mistake has made it difficult to build EDD in a way that will scale the plugin up to a larger user base on larger websites, as needed. Williamson and contributors continue to find ways to deal with it but it is still costing the team a great deal more effort.</p>\n<p>On the community aspect of the project, he has a few simple tips for open source project leaders who want to attract a decent base of contributors.</p>\n<ul>\n<li>Be nice.</li>\n<li>Respond to everyone.</li>\n<li>Make it publicly known that you want contributions.</li>\n<li>Do what you can to make it easy (hint: asking people to email patches is not making it easy.)</li>\n<li>Be very open to criticism.</li>\n<li>Work hard to build an awesome product, as that alone will attract a certain number of interested in contributors.</li>\n</ul>\n<p>Holding to these principles has made Easy Digital Downloads a resounding success, as well as an inspirational example for WordPress plugin developers. Williamson hopes to expand operations to include a hosted version of the plugin, but doesn&#8217;t yet have a roadmap for how that will play out.</p>\n<p>&#8220;I would like to see a hosted version be available within the next year or two. We haven&#8217;t officially decided if we will offer one or if we will seek partnering with an agency or other group, but I&#8217;d love to see it come about,&#8221; he said. If he&#8217;s able to launch a hosted version, Williamson will have the opportunity to tap into a whole new demographic of customers, many of whom are likely not developers.</p>\n<p>&#8220;I&#8217;ve never run a hosted service before so it will be a whole new experience for me with a whole new set of challenges,&#8221; he said. Williamson counts the strong EDD community as one of his assets in pursuing this new venture:</p>\n<blockquote><p>One advantage that I feel we will have, however, is the rapid development pace that having a strong community of contributors affords us. As we iterate quickly on the self-hosted version, those same changes will be able to be applied to a hosted version. It will also be able to go in reverse: as we test out new features in a hosted version, we can apply those same changes upstream to the self-hosted version. Much like WordPress.org and WordPress.com.</p></blockquote>\n<p>With a large number of people building extensions for the project, and a regular stream of contributions and bug fixes, Williamson and EDD are uniquely prepared to support a hosted version. The success of <a href=\"https://easydigitaldownloads.com/\" target=\"_blank\">Easy Digital Downloads</a> demonstrates the value of building a strong community around your open source project. With the right cultivation and a healthy community, any quality project can become more profitable and prepared for the future.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Dec 2014 20:19:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: The Majority of Shark Tank Contestants Use WordPress and WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35540\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wptavern.com/the-majority-of-shark-tank-contestants-use-wordpress-and-woocommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2055:\"<p>Have you ever wondered what CMS and eCommerce system <a title=\"http://en.wikipedia.org/wiki/Shark_Tank\" href=\"http://en.wikipedia.org/wiki/Shark_Tank\">Shark Tank</a> contestants use? WP Engine used <a title=\"http://builtwith.com/\" href=\"http://builtwith.com/\">BuiltWith</a> and <a title=\"http://wpengine.com/2014/12/03/shark-tank-cms-infographic/\" href=\"http://wpengine.com/2014/12/03/shark-tank-cms-infographic/\">looked at the websites</a> of each contestant appearing on the show between seasons 1-5. They also manually investigated each site to determine some of the more complex setups. Factors WP Engine looked for include: if the site was still active, site-wide SSL implementation, and what kind of eCommerce solutions are being used. Here are a few highlights from the infographic.</p>\n<p>WordPress is the most popular platform, followed by Shopify and Magento. One of the most disappointing discoveries is that out of 341 websites, only 39 have SSL support. SSL is important because it provides a level of encryption between you and the server. It also protects customer information which is extremely important if you&#8217;re going to sell things online.</p>\n<p>For over a year, Magento was the eCommerce system of choice, but it&#8217;s now in second place. WooCommerce is now the most popular eCommerce system used by Shark Tank contestants. This makes sense since WordPress is the most popular platform and WooCommere is built to be used with WordPress.</p>\n<p>Check out the rest of the data in the image below and let us know if any of the data surprises you. The image is over 1mb in size so it might take a little while to load.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/WPEngine_SharkTank_Infographic-V2.png\" rel=\"prettyphoto[35540]\"><img class=\"wp-image-35639 size-full\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/WPEngine_SharkTank_Infographic-V2.png?resize=1025%2C7993\" alt=\"WPEngine Shark Tank Infographic\" /></a>Infographic Created By <a href=\"http://www.wpengine.com\">WP Engine</a>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Dec 2014 20:15:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Google Earth API to Retire December 12th, 2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35615\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wptavern.com/google-earth-api-to-retire-december-12th-2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2380:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/GoogleEarthAPIFeaturedImage.png\" rel=\"prettyphoto[35615]\"><img class=\"size-full wp-image-35621\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/GoogleEarthAPIFeaturedImage.png?resize=634%2C211\" alt=\"Google Earth API Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/21177199@N03/2567692977/\">Ludovico Cera</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>For over six years, the <a title=\"https://developers.google.com/earth/documentation/index\" href=\"https://developers.google.com/earth/documentation/index\">Google Earth API</a> has enabled countless developers to build 3D mapping applications in the browser. Those days are over as Google <a title=\"http://googlegeodevelopers.blogspot.com/2014/12/announcing-deprecation-of-google-earth.html\" href=\"http://googlegeodevelopers.blogspot.com/2014/12/announcing-deprecation-of-google-earth.html\">announced on its developer blog</a> that the API is deprecated and will officially retire December 12th, 2015.</p>\n<p>The Google Earth API is built on the <a href=\"http://en.wikipedia.org/wiki/NPAPI\">NPAPI plugin framework</a> which <a title=\"http://blog.chromium.org/2014/11/the-final-countdown-for-npapi.html\" href=\"http://blog.chromium.org/2014/11/the-final-countdown-for-npapi.html\">Chrome</a> and <a title=\"https://blog.mozilla.org/security/2014/02/28/update-on-plugin-activation/\" href=\"https://blog.mozilla.org/security/2014/02/28/update-on-plugin-activation/\">Firefox</a> no longer support due to security reasons. Over the past six years, the API has experienced dwindling support across multiple platforms, especially on mobile. It&#8217;s worth noting that Google Earth is not going away; only its API is being retired.</p>\n<p>A <a title=\"https://wordpress.org/plugins/search.php?q=google+earth\" href=\"https://wordpress.org/plugins/search.php?q=google+earth\">quick search</a> of the WordPress plugin directory for Google Earth shows at least three pages of results. However, several of the plugins look like they use Google Maps instead of Google Earth. If using an external API, most authors put the information in the plugin&#8217;s description. If you&#8217;re using a plugin that uses the API, please get in touch with the author and let them know it&#8217;s no longer supported.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 15 Dec 2014 18:33:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: BuddyPress, bbPress, and GlotPress Development Campaign is Now Fully Funded\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34940\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://wptavern.com/buddypress-bbpress-and-glotpress-development-campaign-is-now-fully-funded\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4263:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/11/jjj.jpg\" rel=\"prettyphoto[34940]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/11/jjj.jpg?resize=1025%2C499\" alt=\"jjj\" class=\"aligncenter size-full wp-image-33407\" /></a></p>\n<p>John James Jacoby&#8217;s crowd-funding <a href=\"https://www.indiegogo.com/projects/buddypress-bbpress-glotpress-development#home\" target=\"_blank\">campaign for development on WordPress&#8217; sister projects</a> is now closed and fully funded at $51,500. For the first six months of 2015, he will be working full-time to push the BuddyPress, bbPress, and GlotPress projects forward.</p>\n<p>Jacoby is essentially pioneering a new way of working as an open source developer funded by the community. There&#8217;s no prescription for how to tackle each project&#8217;s goals, but working remotely in the past has uniquely prepared him for this opportunity.</p>\n<p>&#8220;Previous experience working mostly independently and remotely certainly doesn&#8217;t hurt, particularly for things like consistent communication and maintaining momentum,&#8221; he said. &#8220;It will be nice to get back into the swing of posting public status updates and more strictly planning out my days and weeks again. I appreciate the freedom I&#8217;ve had since July, but being completely without structure can be risky, too.&#8221;</p>\n<p>Jacoby anticipates splitting his time equally between BuddyPress, bbPress, and GlotPress. &#8220;In my imagination, fairly evenly in priority order for a few of the long standing issues that have been prohibiting enhancements to WordPress.org, specifically for the Rosetta sites,&#8221; he said. &#8220;GlotPress will require a little more time for me to start being helpful, so I&#8217;ll likely try to focus on the BuddyPress and bbPress queue first.&#8221;</p>\n<p>What will a typical day look like for Jacoby when he starts working full-time on the sister projects? He plans to be involved in every aspect, from writing code to mentoring to adding codex contributions.</p>\n<blockquote><p>I think a typical day will look like a cup of coffee, reading Trac and Slack, providing feedback and mentorship, and shepherding as much activity as I can. That might mean committing patches and doing feature development, increasing unit test coverage and working on the codex, or helping with tools to enable others to contribute easier. There is no shortage of things to do, and I&#8217;ll be looking at ways to multiply my efforts to get the maximum value out of the time I have.</p></blockquote>\n<p>If the development project is successful, other developers may be inspired to create similar campaigns. Jacoby isn&#8217;t the only one with the capability to make a strong impact on these projects. He believes that there are many others who would be able to do that same.</p>\n<blockquote><p>I really hope people look at this campaign as something they can try, too. Stephen Edgar has been absolutely killing it all across .org, so removing that barrier for him is a priority of mine. Mathieu Viet keeps putting out comprehensive BuddyPress concepts that could make their way into core with just a bit more free time and focus. Ryan McCue already volunteers a huge amount of time; imagine if he was 100% focused. </p>\n<p>Matt Gross (currently at 10up) is such a fast learner and can really crank stuff out quickly. Alison Barrett (also currently at 10up) is the same way; crazy fast at learning and implementing new things. I&#8217;d love to work with either of them on the bb&#8217;s again. A few of these individuals may not require outside funding, but it&#8217;s an interesting idea to use it as an option to reduce an employer&#8217;s monetary burden.</p></blockquote>\n<p>Working full-time on open source community projects without distraction, while still paying the bills, is a rare opportunity that Jacoby intends to maximize. If all goes as planned, the first half of 2015 will bring about the removal of the projects&#8217; most pressing hindrances. The success of Jacoby&#8217;s campaign demonstrates that the WordPress community believes in the potential of BuddyPress, bbPress, and GlotPress enough to invest in a trustworthy developer to make dedicated improvements.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Dec 2014 22:01:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WPTavern: A Newbie’s Guide to bbPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35431\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wptavern.com/a-newbies-guide-to-bbpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7392:\"<p>If you&#8217;re brand new to <a title=\"http://bbpress.org/\" href=\"http://bbpress.org/\">bbPress</a>, you may not know about some of the ways it can be extended beyond being a simple forum. Additional functionality can be added with plugins, its output can be manipulated through CSS, and development is easy to keep up with. Even though bbPress has a <a title=\"https://codex.bbpress.org/getting-started-with-bbpress/\" href=\"https://codex.bbpress.org/getting-started-with-bbpress/\">getting started</a> guide available, I came up with my own mini guide. Here are some tips to get you started on building a bbPress forum.</p>\n<h2>Where to Find Plugins</h2>\n<p>bbPress is a plugin that was designed to be extended by other plugins. Once installed and configured, simply browse the plugin directory from the backend of WordPress and search for bbPress. There are at least 314 plugins that show up in the search results, not including the ones hosted on Github.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressPlugins.png\" rel=\"prettyphoto[35431]\"><img class=\"size-full wp-image-35455\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressPlugins.png?resize=1025%2C526\" alt=\"bbPress Plugins in The WordPress Plugin Directory\" /></a>bbPress Plugins in The WordPress Plugin Directory\n<p>Even though bbPress.org has a <a title=\"https://bbpress.org/plugins/\" href=\"https://bbpress.org/plugins/\">section dedicated to plugins</a>, it&#8217;s essentially an alternative to browsing the WordPress plugin directory. Instead of being able to view all of the plugins available, the pages only list bbPress specific plugins.</p>\n<p>Similar to WordPress, bbPress <a title=\"http://codex.bbpress.org/feature-plugins-tracking/\" href=\"http://codex.bbpress.org/feature-plugins-tracking/\">has a list of feature plugins</a> that may one day, be merged into core. The list contains plugins that offer features found in most forum software out of the box, so it&#8217;s a good place to start when adding features. Pay close attention to the <strong>Last Updated:</strong> information as I encountered a lot of plugins that haven&#8217;t been updated in over 2 years.</p>\n<h2>Altering The Look and Feel</h2>\n<p>bbPress comes with built-in theme support where all required elements such as front-end editing are included. If a WordPress theme doesn&#8217;t have support for the various elements that make up bbPress, you&#8217;ll still be able to use it. The built-in support makes it compatible with nearly every WordPress theme. However, I strongly encourage you to use a theme that is bbPress compatible as it almost always looks better than the default.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressCompatibleThemes.png\" rel=\"prettyphoto[35431]\"><img class=\"size-full wp-image-35467\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressCompatibleThemes.png?resize=1025%2C810\" alt=\"Free bbPress Compatible Themes\" /></a>Free bbPress Compatible Themes\n<p>A <a title=\"https://wordpress.org/themes/search.php?q=bbPress\" href=\"https://wordpress.org/themes/search.php?q=bbPress\">search of the theme directory</a> indicates four pages of free WordPress themes that are explicitly compatible with bbPress. If you&#8217;d simply like to override the default markup to give it a custom look, check out <a title=\"https://codex.bbpress.org/theme-compatibility/\" href=\"https://codex.bbpress.org/theme-compatibility/\">this Codex article</a>.</p>\n<h2>How to Keep up With Development</h2>\n<p>While WordPress releases three major versions a year, bbPress averages two a year. So far in 2014, there have been no major versions released. Compared to WordPress, bbPress development occurs at a slower pace due to a smaller number of people contributing and spending time on the project. Not only does this make it easy to keep up with changes, it increases the opportunity to influence the project.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressDevelopment.png\" rel=\"prettyphoto[35431]\"><img class=\"size-full wp-image-35469\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressDevelopment.png?resize=946%2C691\" alt=\"bbPress Development\" /></a>bbPress Development\n<p>bbPress uses <a title=\"https://bbpress.trac.wordpress.org/timeline\" href=\"https://bbpress.trac.wordpress.org/timeline\">Trac for development</a> where user&#8217;s can submit bug reports and patches. If you use <a title=\"https://slack.com/\" href=\"https://slack.com/\">Slack</a>, you can join the #bbPress channel where core developers and contributors hang out. This is a great way to get in touch with people and communicate in real-time.</p>\n<h2>Where to Get Support</h2>\n<p>The best way to get support is through the official <a title=\"https://bbpress.org/forums/\" href=\"https://bbpress.org/forums/\">bbPress forum</a>. While not as active as the WordPress support forum, there&#8217;s still a good amount of activity that takes place. It&#8217;s also monitored by all of the core developers.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressSupport.png\" rel=\"prettyphoto[35431]\"><img class=\"size-full wp-image-35517\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressSupport.png?resize=986%2C575\" alt=\"bbPress Support Forum\" /></a>bbPress Support Forum\n<p>The bbPress support forums follow the same rules and guidelines set forth by the WordPress support forums. There are two documents you should read to familiarize yourself to how it works. <a href=\"https://codex.wordpress.org/Using_the_Support_Forums\">Using the Support Forum</a> and the <a href=\"https://codex.wordpress.org/Forum_Welcome\">Forum Welcome message</a>.</p>\n<h2>bbPress Nomenclature</h2>\n<p>bbPress has a set of nomenclature that is different from forum software you may have used in the past. This small guide explains what each term means.</p>\n<ul>\n<li><strong>Forums</strong> – Are segments of the main forum similar to categories.</li>\n<li><strong>Topics</strong> – Topics are created within forums, they are the issues that are being discussed.</li>\n<li><strong>Replies</strong> – Replies are made to topics, this is the actual discussion.</li>\n<li><strong>Voices</strong> &#8211; Voices represent the number of individuals participating in a conversation</li>\n</ul>\n<h2>The Next Six Months</h2>\n<p>Although development has come to a crawl in recent months, it&#8217;s encouraging that John James Jacoby <a title=\"https://www.indiegogo.com/projects/buddypress-bbpress-glotpress-development\" href=\"https://www.indiegogo.com/projects/buddypress-bbpress-glotpress-development\">successfully reached his crowd funding goal</a> as bbPress will likely experience a surge in development and community based contributions over the next six months. Hopefully, the next six months are among the project&#8217;s brightest.</p>\n<h2>Codex Volunteer</h2>\n<p>The documentation and organization of documents on the bbPress.org website leaves a lot to be desired. Several links point to placeholders or the incorrect pages. I&#8217;m working with the team as a Codex volunteer to try to clean up the mess so others can benefit by finding the information they need.</p>\n<p>This guide is a Cliff’s Notes version of what&#8217;s available on bbPress.org. I hope it helps you as it did me when putting it together.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Dec 2014 20:32:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Variable VVV: A New VVV Site Creation Wizard for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35501\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/variable-vvv-a-new-vvv-site-creation-wizard-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4804:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/vagrant.png\" rel=\"prettyphoto[35501]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/04/vagrant.png?resize=1025%2C463\" alt=\"vagrant\" class=\"aligncenter size-full wp-image-21435\" /></a></p>\n<p><a href=\"http://bradparbs.com/\" target=\"_blank\">Brad Parbs</a> and his colleagues at <a href=\"http://webdevstudios.com/\" target=\"_blank\">WebDevStudios</a> have created a new tool for the thousands of developers out there who utilize <a href=\"https://github.com/Varying-Vagrant-Vagrants/VVV\" target=\"_blank\">Varying Vagrant Vagrants</a> for WordPress development. As Vagrant development environments are a daily staple of work life at WDS, the team needed a faster way for setting up new WordPress sites with VVV.</p>\n<p><a href=\"https://github.com/bradp/vv\" target=\"_blank\">Variable VVV</a> is their solution, a script that automates the creation and deletion of new WordPress sites using VVV. The script is based on Alison Barrett&#8217;s <a href=\"http://wptavern.com/vvv-site-wizard-automates-the-creation-and-deletion-of-wordpress-development-sites\" target=\"_blank\">VVV Site Wizard</a>.</p>\n<p>&#8220;The original site wizard hasn&#8217;t been updated in about half a year. I&#8217;ve designed this to be a drop-in replacement,&#8221; Parbs told the Tavern. &#8220;All the flags and commands from vvv-site-wizard function 100% the same, so you can just install this and start using it exactly the same.&#8221; Anyone who has used the VVV Site Wizard in the past will be comfortable using Variable VVV right away.</p>\n<p>The new script has a few additional features beyond the original VVV Site Wizard, including the following:</p>\n<ul>\n<li>The ability to pass vagrant command through to VVV</li>\n<li>An easier way to set your VVV installation path</li>\n<li>The ability to clone a git-repo as wp-content</li>\n<li>The ability to set more installation options</li>\n</ul>\n<p>While creating the script, Parbs went through the issues list at the vvv-site-wizard repository and fixed a number of issues. He sees Variable VVV as the spiritual successor to the original tool and has designed it to be a bit easier to use. He noted that it takes just 1/3 the time to type the commands and the command results have also been vastly improved. &#8220;One example is the <code>list</code> command to show you all sites. With vvv-site-wizard, it is a plain list of site names. <code>vv list</code> will show you a colorized output, along with URLs and marking VVV defaults,&#8221; Parbs explained.</p>\n<p>The WebDevStudios team has an extensive roadmap of features for future implementation. Parbs is most excited about the idea of &#8220;blueprints,&#8221; which would offer the ability to install themes and plugins while setting up a new site.</p>\n<blockquote><p>A blueprint would define a list of plugins, themes, mu-plugins, and various site options. When installing, you could grab that blueprint and it would set it all up. I&#8217;m planning on letting you grab from Github, WP.org, a zip file link, etc. I&#8217;ve <a href=\"https://github.com/bradp/vv/issues/5\" target=\"_blank\">outlined the idea</a> on GitHub. You&#8217;d setup multiple blueprints, and when you do an install, you could grab a blueprint and use that. For example, an &#8216;ecommerce&#8217; blueprint might install WooCommerce, some other plugins, and _s, or whatever you like.</p></blockquote>\n<p>As the VVV Site Wizard doesn&#8217;t seem to be maintained anymore, Parbs plans to keep Variable VVV going and has also outlined a number of other enhancements in the project&#8217;s <a href=\"https://github.com/bradp/vv/issues\" target=\"_blank\">issues queue</a>:</p>\n<ul>\n<li>Enable vv to auto-update itself</li>\n<li>Add deployment capability</li>\n<li>Delete site database during removal</li>\n<li>Add option to add dummy content when creating site</li>\n<li>Allow overriding of /htdocs install location</li>\n</ul>\n<p>Parbs plans to add anything that will make developers&#8217; lives easier at WebDevStudios, but he is also open to suggestions. &#8220;I&#8217;ve built the script to be extremely easy to add new functionality, so implementing features people request will be as easy as possible,&#8221; he said.</p>\n<p>The script is now ready for public use. &#8220;Over the past few days, a few people here at WebDevStudios have been beta-testing it, and its really solid,&#8221; Parbs said. <a href=\"https://github.com/bradp/vv\" target=\"_blank\">Variable VVV</a> is now publicly available on GitHub for anyone who wants to use it or contribute back to the project. If you test the script, make sure to leave your feedback and suggestions in the project&#8217;s issues list, as WebDevStudios plans to consistently maintain and extend the tool to make it better.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Dec 2014 19:47:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Idea Factory: A Frontend Submission and Voting System for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35416\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/idea-factory-a-frontend-submission-and-voting-system-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4173:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/idea-factory.jpg\" rel=\"prettyphoto[35416]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/idea-factory.jpg?resize=631%2C300\" alt=\"idea-factory\" class=\"aligncenter size-full wp-image-35420\" /></a></p>\n<p>One of the oldest and simplest ways of accessing public opinion is through an up/down voting system. When offered in a controlled setting where everyone has the chance to vote, the system causes the best ideas to float to the top.</p>\n<p><a href=\"https://wordpress.org/plugins/idea-factory/\" target=\"_blank\">Idea Factory</a> is a plugin designed to make it easy for WordPress administrators to set up a voting system where users can submit new ideas from the frontend. The plugin was created by <a href=\"http://nickhaskins.co/\" target=\"_blank\">Nick Haskins</a>, author of the <a href=\"https://wordpress.org/plugins/aesop-story-engine/\" target=\"_blank\">Aesop Story Engine</a>.</p>\n<p><strong>&#8220;Idea Factory was born out of necessity, and the frustration of the lack of plugins that did exactly what I wanted it to do,&#8221;</strong> Haskins wrote in the plugin&#8217;s description. His implementation is simple but built to be extensible, offering developers a number of <a href=\"https://github.com/bearded-avenger/idea-factory/wiki\" target=\"_blank\">filters, hooks, and actions</a>. Idea Factory features the following:</p>\n<ul>\n<li>AJAX powered front-end submission and voting</li>\n<li>Voting is limited to logged-in users</li>\n<li>1 vote allowed per user per idea</li>\n<li>Emails the admin with notification of a new submission</li>\n<li>Extensible with hooks and actions on events</li>\n<li>More ideas loaded with AJAX on front-end</li>\n<li>Mobile friendly</li>\n</ul>\n<p>Logged-in users can enter new ideas via a modal submission box. The plugin creates an Idea custom post type and data is stored in post_meta and user_meta tables.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/idea-submit.png\" rel=\"prettyphoto[35416]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/idea-submit.png?resize=900%2C783\" alt=\"idea-submit\" class=\"aligncenter size-full wp-image-35452\" /></a></p>\n<p>Ideas are displayed at yoursite.com/ideas. Users can only vote once on each idea before they are locked out. Up votes push ideas to the top and down votes send ideas further down the list.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/ideas.png\" rel=\"prettyphoto[35416]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/ideas.png?resize=1025%2C537\" alt=\"ideas\" class=\"aligncenter size-full wp-image-35432\" /></a></p>\n<p>The design is generic enough to drop nicely into any theme, but you can further customize it by copying the file from the plugin&#8217;s /template-ideas/ directory into your theme. Idea Factory&#8217;s settings also allow you to disable the core CSS file from loading so that you can take full control.</p>\n<p>Each idea and its description can be edited in the admin. If you have a highly active voting board, you may want to turn off email notifications for new submissions. The settings also include an option to hold all new ideas as drafts to be approved before publishing.</p>\n<p>After testing Idea Factory, I was impressed with how easy it was to set up and use. Both idea creation and voting are anonymous, but it might be nice to have an option to display users for each. However, one of the best things about Idea Factory is that it maintains a limited set of features in favor of keeping the plugin lean and extensible.</p>\n<p>An idea voting system can help community managers or developers get a better idea of where to invest their time and how to prioritize new features. It&#8217;s a quick way to take the temperature of your user base, because it allows them to freely express their ideas and participate in voting up the best ones. It&#8217;s also far less time-consuming than conducting a survey. Check out <a href=\"https://wordpress.org/plugins/idea-factory/\" target=\"_blank\">Idea Factory on WordPress.org</a> for a solid, simple way to bring new ideas to light.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 12 Dec 2014 07:03:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: WPWeekly Episode 174 – What Would it Take to Lose The Throne?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=35424&preview_id=35424\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"http://wptavern.com/wpweekly-episode-174-what-would-it-take-to-lose-the-throne\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3205:\"<p>In this episode of WordPress Weekly, <a href=\"http://marcuscouch.com/\" title=\"http://marcuscouch.com/\">Marcus Couch</a> and I discuss what it would take for WordPress to lose its dominant market share position. We both agree that WordPress isn&#8217;t going anywhere soon but it&#8217;s something to be mindful of.</p>\n<p>We share our thoughts on the recommended plugins tab coming in WordPress 4.1 and whether or not it will help users discover new plugins. Last but not least, we discuss Google&#8217;s attempt to simplify reCAPTCHAs by replacing distorted text with a check box.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/what-would-it-take-for-wordpress-to-lose-its-dominance\" title=\"http://wptavern.com/what-would-it-take-for-wordpress-to-lose-its-dominance\">What Would it Take For WordPress to Lose its Dominance?</a><br />\n<a href=\"http://wptavern.com/googles-new-recaptcha-api-replaces-distorted-text-with-a-checkbox\" title=\"http://wptavern.com/googles-new-recaptcha-api-replaces-distorted-text-with-a-checkbox\">Google’s New reCAPTCHA API Replaces Distorted Text with a Checkbox</a><br />\n<a href=\"http://wptavern.com/wordpress-4-1-to-introduce-plugin-recommendations\" title=\"http://wptavern.com/wordpress-4-1-to-introduce-plugin-recommendations\">WordPress 4.1 To Introduce Plugin Recommendations</a><br />\n<a href=\"http://wptavern.com/nrelate-will-shutdown-its-service-december-31st\" title=\"http://wptavern.com/nrelate-will-shutdown-its-service-december-31st\">nRelate Will Shutdown Its Service December 31st</a><br />\n<a href=\"http://wptavern.com/manage-multiple-wordpress-sites-with-wpdash-now-in-beta\" title=\"http://wptavern.com/manage-multiple-wordpress-sites-with-wpdash-now-in-beta\">Manage Multiple WordPress Sites with WPDASH, Now in Beta</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"http://storyftw.com/\" title=\"http://storyftw.com/\">StoryFTW</a> by Patrick Shanahan, is a simple swipe based story engine that allows you to use any kind of media imaginable to create your own dynamic slide by slide story. The review is based on an Alpha copy as the plugin is not publicly available yet.</p>\n<p><a href=\"https://wordpress.org/plugins/test-user-role/\" title=\"https://wordpress.org/plugins/test-user-role/\">Test User Role</a> allows you to quickly test other user roles from a super admin account to see what other users experience.</p>\n<p><a href=\"https://wordpress.org/plugins/grid/\" title=\"https://wordpress.org/plugins/grid/\">Grid</a> is a container based landing page editor.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, December 17th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #174:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Dec 2014 21:13:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"Akismet: Akismet 3.0.4 Plugin for WordPress Released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1750\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://blog.akismet.com/2014/12/11/akismet-3-0-4-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1113:\"<p>Version 3.0.4 of <a href=\"http://wordpress.org/plugins/akismet/\">the Akismet plugin for WordPress</a> is now available.</p>\n<p>This update adds better compatibility with Apache 2.4, allows <code>https</code> author URLs to be removed from comments, removes the &#8220;Check for Spam&#8221; button from the &#8220;Trash&#8221; and &#8220;Approved&#8221; queues, and allows for automatic API key configuration when Jetpack is installed and connected to a WordPress.com account.</p>\n<p>To upgrade, visit the Updates page of your WordPress dashboard and follow the instructions. If you need to download the plugin zip file directly, links to all versions are available in <a href=\"http://wordpress.org/plugins/akismet/\">the WordPress plugins directory</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1750/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1750/\" /></a> <img alt=\"\" border=\"0\" src=\"http://pixel.wp.com/b.gif?host=blog.akismet.com&blog=116920&post=1750&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Dec 2014 18:44:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Christopher Finke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"WPTavern: WordPress Themes Directory Now Requires All Themes to be Translation-Ready\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35363\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wptavern.com/wordpress-themes-directory-now-requires-all-themes-to-be-translation-ready\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4048:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/08/globe.jpg\" rel=\"prettyphoto[35363]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/08/globe.jpg?resize=1024%2C499\" alt=\"photo credit: . Entrer dans le rêve - cc\" class=\"size-full wp-image-29134\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/tranbina/4765484383/\">. Entrer dans le rêve</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>WordPress made great strides in 2014 towards improving internationalization for the global community. <a href=\"http://wptavern.com/wordpress-4-0-benny-now-available-for-download\" target=\"_blank\">WordPress 4.0</a> streamlined language management in the admin and brought language selection to the installation process.</p>\n<p>In the <a href=\"http://wptavern.com/matt-mullenwegs-state-of-the-word-highlights-internationalization-mobile-and-new-tools-for-wordpress-contributors\" target=\"_blank\">State of the Word</a> address this year, Matt Mullenweg highlighted the importance of internationalization to the project when he said, <strong>“If WordPress is going to be truly global, truly inclusive, it has to be fully available for other languages.&#8221;</strong> He also announced that fully localized plugin and theme directories will be available in the admin as of 4.1.</p>\n<p>This week the WordPress Theme Review Team <a href=\"https://make.wordpress.org/themes/2014/12/09/theme-review-team-weekly-notes-the-logs-are-3/\" target=\"_blank\">updated its guidelines</a> to require all new theme submissions to be translation-ready. Theme authors submitting new themes to the official directory must ensure that all text strings are translatable. This also applies to any updates to existing themes.</p>\n<h3>Tips for Making Your Theme Translation-Ready</h3>\n<p>The WordPress Theme Review Handbook doesn&#8217;t yet contain a section with information about preparing themes for translation. However, you can find all the basics on <a href=\"https://developer.wordpress.org/themes/functionality/internationalization/\" target=\"_blank\">how to internationalize a theme</a> in the WordPress Theme Developer Handbook, which is still a work in progress.</p>\n<p>The internationalization section also links to a number of videos and tutorials in its resources section. Many of these will be helpful in walking theme developers through the process of preparing themes for translation:</p>\n<ul>\n<li><a href=\"http://www.gnu.org/software/gettext/manual/html_node/\" target=\"_blank\">GNU gettext utilities</a></li>\n<li><a href=\"https://www.youtube.com/watch?v=fJfqgrzjEis\" target=\"_blank\">i18n: Preparing Your WordPress Theme for the World</a></li>\n<li><a href=\"http://wordpress.tv/2014/02/26/samuel-otto-wood-on-internationalization-plugins-and-themes-for-the-whole-world/\" target=\"_blank\">Samuel “Otto” Wood: On Internationalization: Plugins and Themes for the Whole World</a></li>\n<li><a href=\"https://pippinsplugins.com/use-wp_localize_script-it-is-awesome/\" target=\"_blank\">Use wp_localize_script, It Is Awesome</a></li>\n<li><a href=\"http://wordpress.tv/2009/11/14/ze-fontainhas-i18n-nyc09/\" target=\"_blank\">Zé Fontainhas: Lost in Translation—i18n and WordPress</a></li>\n<li><a href=\"http://ottopress.com/2012/internationalization-youre-probably-doing-it-wrong/\" target=\"_blank\">Internationalization: You’re Probably Doing It Wrong</a></li>\n</ul>\n<p>If a WordPress theme isn&#8217;t translatable, then the site it is running on is limited to the theme author&#8217;s language. If you invest your time and hard work into creating a WordPress theme, why not make sure that it&#8217;s able to be used all over the world?</p>\n<p>The new requirement from the Theme Review team is a major milestone in expanding WordPress&#8217; global reach. The official themes directory is often the first place that self-hosted WordPress users look when shopping for themes. The new translation-ready requirement will help ensure that WordPress.org&#8217;s vast library of themes are ready for global use.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Dec 2014 18:34:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"WPTavern: A New User’s Experience Installing and Using bbPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35320\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wptavern.com/a-new-users-experience-installing-and-using-bbpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8214:\"<p>bbPress is a <a title=\"https://bbpress.org/about/the-story/\" href=\"https://bbpress.org/about/the-story/\">10 year old project</a> that&#8217;s supposed to make it easy to attach a forum to WordPress. On the day after Christmas in 2004, Matt Mullenweg spent an entire weekend coding an alternative to <a title=\"http://minibb.net/\" href=\"http://minibb.net/\">miniBB</a>, from the ground up that at the time, powered the WordPress support forums. bbPress was stand-alone software until 2011, when the <a title=\"http://wptavern.com/bbpress-2-0-stable-now-available\" href=\"http://wptavern.com/bbpress-2-0-stable-now-available\">release of 2.0</a> transformed it into a WordPress plugin,</p>\n<p>Over the years, I&#8217;ve kept a close eye on bbPress but I&#8217;ve never used it for a project of my own. Since I&#8217;m only a new user once, I decided to document my experience of configuring and using it for the first time.</p>\n<h2>Activation and Configuration</h2>\n<p>Locating bbPress is easy as it usually shows up as a Featured Plugin on the Add New plugin screen. Once activated, a welcome screen displays information on what&#8217;s new, credits, and a link at the bottom to visit the forum settings.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressActivated.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35359\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressActivated.png?resize=1025%2C697\" alt=\"bbPress Welcome Screen After Activation\" /></a>bbPress Welcome Screen After Activation\n<p>When visiting the forum settings screen, I&#8217;m presented with a list of options with checkboxes and numbers. While there are not a lot of things to configure, I think a better presentation of the various options would be to split each major section into a tab of its own. Although it was my choice to visit the forum settings from the Welcome screen, I think the Welcome screen is a good place to use Admin Pointers to help new users create a new topic, forum, etc. I don&#8217;t understand why the Welcome screen has a link to forum settings since a new install won&#8217;t have anything to configure.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressOptions.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35360\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressOptions.png?resize=765%2C888\" alt=\"bbPress Forum Settings Screen\" /></a>bbPress Forum Settings Screen\n<p>While on the forum settings screen, I&#8217;m not sure what it is I&#8217;m supposed to configure in order for the forum to display on the frontend. At this point, I visit the <a title=\"http://codex.bbpress.org/\" href=\"http://codex.bbpress.org/\">Documentation section</a> of bbPress.org and locate a <a title=\"https://codex.bbpress.org/getting-started/\" href=\"https://codex.bbpress.org/getting-started/\">Getting Started</a> guide. It turns out, the guide is of no use to me or anyone else for that matter.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/GettingStartedToNowhere.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35361\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/GettingStartedToNowhere.png?resize=986%2C499\" alt=\"Getting Started To Nowhere\" /></a>Getting Started To Nowhere\n<p>The left hand sidebar has a list of related links which point to several different articles on user roles, conditional tags, and functions. It took some effort on my part, but I finally found the article on <a title=\"https://codex.bbpress.org/getting-started-with-bbpress/\" href=\"https://codex.bbpress.org/getting-started-with-bbpress/\">Getting Started with bbPress</a>. This page should be linked to from the <a title=\"http://codex.bbpress.org/\" href=\"http://codex.bbpress.org/\">Documentation main page</a> for the Getting Started link. This simple change will save users time and frustration.</p>\n<h2>Creating Forums</h2>\n<p>Using the Getting Started guide, I created my first forum. Since forums are Custom Post Types, the forum editor looks similar to the Post Editor. It would be nice if hints displayed above each field so users understand which part of the forum they&#8217;re connected to. For example, the title field should have a hint that says &#8220;Name of the forum&#8221; and above the editor, text that says, &#8220;A description of the forum&#8221;. Some of the items on the Forum creation screen make sense but it shouldn&#8217;t be assumed the user knows what each field corresponds to.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/CreatingAForumInbbPress.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35362\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/CreatingAForumInbbPress.png?resize=889%2C584\" alt=\"Creating a Forum in bbPress\" /></a>Creating a Forum in bbPress\n<p>There are two different types of forums, <strong>forum</strong> and <strong>category</strong>. Forums contain topics and can be the parent of other forums. Categories can only contain forums and are primarily used as a method of organization. The nomenclature used is enough to make anyone&#8217;s head spin.</p>\n<h2>Creating Topics</h2>\n<p>After creating a forum, I moved on to create a topic. Topics are similar to typical forum posts. Topics are one of the three <a title=\"https://codex.wordpress.org/Post_Types#Custom_Types\" href=\"https://codex.wordpress.org/Post_Types#Custom_Types\">Custom Post Types </a>created by bbPress, which means the Topic editor uses the same interface you&#8217;d see when writing a post. Similar to creating forums, I&#8217;d like to see the fields labeled for consistency. Creating topics from the backend of WordPress is fairly easy after creating the first forum.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressTopicCreated.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35365\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/bbPressTopicCreated.png?resize=898%2C668\" alt=\"bbPress Topic Created From The Backend of WordPress\" /></a>bbPress Topic Created From The Backend of WordPress\n<p>&nbsp;</p>\n<h2>The Frontend of bbPress</h2>\n<p>Everything up to this point has been managed from the backend of WordPress. I&#8217;ve created a category, forum, and topic. It&#8217;s time to see how bbPress works on the frontend. Replying to a topic is straight forward. A form is supplied with quick tag support so visitors can easily style text. After hitting the submit button, the page reloads and the reply is shown. Sometimes, replies don&#8217;t show up immediately because they&#8217;re moderated by Akismet.</p>\n<p>&nbsp;</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/ReplyingToATopic.png\" rel=\"prettyphoto[35320]\"><img class=\"size-full wp-image-35368\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/ReplyingToATopic.png?resize=684%2C795\" alt=\"Replying to a Topic on The Frontend of bbPress\" /></a>Replying to a Topic on The Frontend of bbPress\n<p>Once I got a handle for how bbPress is structured and what categories, forums, topics, and replies look like, I went back to the Forum Settings page.</p>\n<h2>Not Easy Enough</h2>\n<p>bbPress is a plugin, and because of that, I expect to be able to turn it on and have everything ready to go. As you can see from my experience, it doesn&#8217;t always work out that way, especially when using a theme that doesn&#8217;t support it out of the box. The <a title=\"https://codex.bbpress.org/getting-started-with-bbpress/\" href=\"https://codex.bbpress.org/getting-started-with-bbpress/\">Getting Started</a> guide is important information on understanding how to configure bbPress. Without it, I&#8217;d be lost in the dark.</p>\n<p>My initial experience is rough around the edges and at times frustrating, as I couldn&#8217;t easily find the help I needed. I can only imagine how many others have gone through the same experience. Hopefully, a few changes will be made to bbPress and its website to create a smoother new user experience.</p>\n<p>If you&#8217;ve recently installed or used bbPress for the first time, tell us about your experience in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Dec 2014 04:52:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: Change Post Types with the Post Type Switcher Plugin for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35093\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/change-post-types-with-the-post-type-switcher-plugin-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4408:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/train-switch.jpg\" rel=\"prettyphoto[35093]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/train-switch.jpg?resize=1024%2C492\" alt=\"photo credit: contemplative imaging - cc\" class=\"size-full wp-image-35340\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/thomas-merton/4334175428/\">contemplative imaging</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>When WordPress 3.0 introduced the ability for developers to register their own <a href=\"http://codex.wordpress.org/Post_Types#Custom_Post_Types\" target=\"_blank\">custom post types</a>, the software became far more flexible for use as a content management system. This was a major turning point for WordPress, as it gave developers a standard way to structure custom content with core-supported features.</p>\n<p>Four years later, custom post types are so commonly used that folks occasionally need a way to switch a post from one type to another. A site admin may want to change how content is structured and presented, and switching content to a new post type can be a huge time saver in some instances.</p>\n<p>The <a href=\"https://wordpress.org/plugins/post-type-switcher/\" target=\"_blank\">Post Type Switcher</a> plugin, authored by <a href=\"http://jaco.by/\" target=\"_blank\">John James Jacoby</a>, was created for exactly this purpose. It&#8217;s one of those plugins that you may not have ever known about until you&#8217;re on the hunt to find a way to convert a post from one type to another.</p>\n<p>The plugin adds a simple post type dropdown to the post editor, which allows you to reassign any post to a new post type.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/post-type-switcher.jpg\" rel=\"prettyphoto[35093]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/post-type-switcher.jpg?resize=772%2C250\" alt=\"post-type-switcher\" class=\"aligncenter size-full wp-image-35321\" /></a></p>\n<p>The handy thing is that Post Type Switcher can convert nearly every combination of posts, pages, attachments, custom post types, etc:</p>\n<ul>\n<li>Page to Post</li>\n<li>Post to Page</li>\n<li>Page to Attachment</li>\n<li>Post to Custom</li>\n</ul>\n<p>What happens when you change a post to a different type? Only the <code>\'post_type\'</code> property of a post is changed. Categories, tags, and custom taxonomies all remain untouched. Featured images remain in place. The post&#8217;s URL will change to whatever the new post type uses. For example, if you change a regular post to a testimonial post type that uses /testimonial/ in the URL, your newly converted post will follow the pattern of its new post type.</p>\n<p>The old post URL should 404 so that you can use a plugin to redirect to the new URL or add some custom rewrite rules to your .htaccess file. While testing the plugin with different post types, I only encountered one instance where a plugin didn&#8217;t properly 404 the original post, but most of the time you won&#8217;t have an issue with this.</p>\n<p>Jacoby has purposely excluded invisible post types, such as revisions, menus, etc., but you can filter <code>\'pts_post_type_filter\'</code> to change how this works if you need access to more post types.</p>\n<p><a href=\"https://profiles.wordpress.org/beatpanda/\" target=\"_blank\">Matthew Gerring</a>, a contributor to the plugin, helped to add bulk editing so that you can select all posts in a certain type and convert them to a new type with one quick action.</p>\n<p>Post Type Switcher is very useful if you started out putting content in regular posts but now want to move it into a portfolio plugin or testimonial plugin. Or perhaps you&#8217;ve been running bbPress on your site and want to extract a few of the most active posts to become regular blog posts instead. Another common use might be to convert a bunch of posts to pages in order to create a static reference section for your site. This plugin makes all of that possible.</p>\n<p>If you&#8217;re planning to use the plugin, make sure to test your post type switches in a development environment first. It&#8217;s also a good idea to backup your live site before making drastic changes to content. You can find <a href=\"https://wordpress.org/plugins/post-type-switcher/\" target=\"_blank\">Post Type Switcher</a> in the WordPress.org Plugin Directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 10 Dec 2014 22:13:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: BuddyPress 2.2 to Add Custom Post Type Support to the Activity Stream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35081\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wptavern.com/buddypress-2-2-to-add-custom-post-type-support-to-the-activity-stream\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3692:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/buddypress-wall.jpg\" rel=\"prettyphoto[35081]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/04/buddypress-wall.jpg?resize=1018%2C458\" alt=\"buddypress-wall\" class=\"aligncenter size-full wp-image-20901\" /></a></p>\n<p>BuddyPress 2.2 is shaping up to be an exciting release, packed full of new features for developers. <a href=\"http://wptavern.com/buddypress-2-2-will-add-support-for-composer\" target=\"_blank\">Support for Composer</a> will be included in 2.2, as well as <a href=\"http://wptavern.com/buddypress-2-2-on-track-to-provide-a-basic-member-type-api\" target=\"_blank\">a basic member type API</a>, which will allow developers to create different user types.</p>\n<p>The upcoming 2.2 release will also introduce the ability for new activity items to be generated when content is created by registered post types. This is a feature that already exists within the BuddyPress&#8217; blogs component and will be extended to include custom post types that declare support for it. Developers will be able to add support for CPTs with one simple line of code:</p>\n<pre class=\"brush: php; light: true; title: ; notranslate\">add_post_type_support( \'book\', \'buddypress-activity\' );</pre>\n<p>This will publish updates to the activity stream for the post type that you specify, using generic strings. The BuddyPress <a href=\"https://codex.buddypress.org/plugindev/post-types-activities/#adding-the-buddypress-support-and-specific-labels-at-post-type-registration\" target=\"_blank\">codex</a> has already been updated to show examples for how you can get more control over the activity attributes when you register the post type.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/cpt-activity.png\" rel=\"prettyphoto[35081]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/cpt-activity.png?resize=1025%2C326\" alt=\"cpt-activity\" class=\"aligncenter size-full wp-image-35302\" /></a></p>\n<p>&#8220;This update is about the <a href=\"https://buddypress.trac.wordpress.org/ticket/5669\" target=\"_blank\">first step</a> of it: ease the implementation of tracking the published post type items into the Activity stream,&#8221; BuddyPress core developer Mathieu Viet explained in the <a href=\"https://bpdevel.wordpress.com/2014/12/04/about-post-types-and-buddypress-activities/\" target=\"_blank\">announcement</a> on the BP development blog.</p>\n<p>When post type support is added to the activity stream, you will also be able to sort the new items via the activity dropdown filters. This filter is available on the frontend and in the backend.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/activity-dropdown.png\" rel=\"prettyphoto[35081]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/activity-dropdown.png?resize=1025%2C366\" alt=\"activity-dropdown\" class=\"aligncenter size-full wp-image-35299\" /></a></p>\n<p>These improvements are all recent additions to BuddyPress trunk. If you want to test 2.2 alpha, <a href=\"https://buddypress.org/download/\" target=\"_blank\">checkout BuddyPress trunk</a> via SVN or <a href=\"https://buddypress.trac.wordpress.org/browser/trunk\" target=\"_blank\">download the zip file</a>. Activate it and then add support for a custom post type that is active on your BuddyPress test site.</p>\n<p>The <a href=\"https://buddypress.trac.wordpress.org/ticket/3460\" target=\"_blank\">ticket</a> that houses the discussion on this issue has been open for three years. BuddyPress 2.2 finally answers this request and gives plugin developers a beautifully simple implementation for adding post type support to the activity stream.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 10 Dec 2014 07:28:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"WPTavern: New Plugin Adds Google’s No CAPTCHA reCAPTCHA to WordPress Login, Comment, and Registration Forms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35201\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:114:\"http://wptavern.com/new-plugin-adds-googles-no-captcha-recaptcha-to-wordpress-login-comment-and-registration-forms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3643:\"<p>Several plugins are starting to spring up in the WordPress Plugin Directory to bring Google&#8217;s new No Captcha reCAPTCHA to WordPress forms. With public hatred for CAPTCHAs at an all-time high, Google finally put its efforts into redesigning the experience, <a href=\"http://wptavern.com/googles-new-recaptcha-api-replaces-distorted-text-with-a-checkbox\" target=\"_blank\">replacing the distorted text with a simple checkbox</a>.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nocaptcha.gif\" rel=\"prettyphoto[35201]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nocaptcha.gif?resize=616%2C164\" alt=\"photo credit: Google Online Security Blog\" class=\"size-full wp-image-34870\" /></a>photo credit: <a href=\"http://googleonlinesecurity.blogspot.com/2014/12/are-you-robot-introducing-no-captcha.html\">Google Online Security Blog</a>\n<p>WordPress developers have been quick to take advantage of the new No CAPTCHA API to add it to WordPress forms. So far, the <a href=\"https://wordpress.org/plugins/no-captcha-recaptcha/\" target=\"_blank\">No CAPTCHA reCAPTCHA</a> plugin, created by Nigerian web developer <a href=\"http://w3guy.com/\" target=\"_blank\">Agbonghama Collins</a>, provides the most flexibility for specifying the forms where you want to add the protection.</p>\n<ul>\n<li>Option to activate CAPTCHA in either login, registration, comment or combination of two or all</li>\n<li>Choose a theme for the CAPTCHA (light or dark)</li>\n<li>Auto-detects the user&#8217;s language</li>\n</ul>\n<p>Once activated and configured, you&#8217;ll see the new reCAPTCHA added on the frontend:</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha-frontend.png\" rel=\"prettyphoto[35201]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha-frontend.png?resize=359%2C459\" alt=\"recaptcha-frontend\" class=\"aligncenter size-full wp-image-35276\" /></a></p>\n<p>The plugin is easy to configure &#8211; simply paste in your Google reCAPTCHA keys on the settings page:</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha-keys.png\" rel=\"prettyphoto[35201]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha-keys.png?resize=665%2C365\" alt=\"recaptcha-keys\" class=\"aligncenter size-full wp-image-35272\" /></a></p>\n<p>Select the login, registration, or comment forms, or any combination thereof, for adding No Captcha reCAPTCHA protection.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/select-form.png\" rel=\"prettyphoto[35201]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/select-form.png?resize=725%2C324\" alt=\"select-form\" class=\"aligncenter size-full wp-image-35275\" /></a></p>\n<p>Further down the page you have the option to force the plugin to use a specific language via a dropdown, or leave it on auto-detect. You can also set a custom error message for when the user fails to solve the CAPTCHA and select a theme for the CAPTCHA display.</p>\n<p>I tested the plugin and it works as advertised to add the new No Captcha reCAPTCHA. I discovered that it is not compatible with the Jetpack Comment module, so you&#8217;ll want to uncheck that box for comments if you&#8217;re using it. The <a href=\"https://wordpress.org/plugins/no-captcha-recaptcha/\" target=\"_blank\">No CAPTCHA reCAPTCHA</a> plugin is available for free from WordPress.org. It&#8217;s not yet known whether Google will create an official implementation for WordPress, but in the meantime, this plugin makes it easy to add reCAPTCHA to the WordPress forms that are the most vulnerable to spam.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Dec 2014 23:09:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Barry Kooij Adopts The Download Monitor Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35263\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wptavern.com/barry-kooji-adopts-the-download-monitor-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1987:\"<p>Developed by <a title=\"http://mikejolley.com/\" href=\"http://mikejolley.com/\">Mike Jolley</a>, <a title=\"https://wordpress.org/plugins/download-monitor/\" href=\"https://wordpress.org/plugins/download-monitor/\">Download Monitor</a> is an eight year old plugin with over 600k downloads. Download Monitor provides an interface for uploading and managing downloadable files including support for multiple versions, inserting download links into posts, and logging downloads.</p>\n<blockquote><p>It has been rewritten 4 times, seen well over 100 releases, and been downloaded 600,000 times. The latest ‘v1’ reboot has been praised and I often receive nice comments from users even though development has slowed of late.</p></blockquote>\n<p>Due to time constraints, Jolley placed Download Monitor up for adoption. <a title=\"http://www.barrykooij.com/\" href=\"http://www.barrykooij.com\">Barry Kooij</a>, a coworker of Jolley&#8217;s, adopted the plugin. Kooij is already working on the next version and users should see an update soon. Regarding the plugin&#8217;s future, Jolley states, &#8220;I’m really excited about its future and I’m happy that Download Monitor is in safe hands.&#8221;</p>\n<h2>How to Put a Plugin up For Adoption</h2>\n<p>The Download Monitor plugin has a happy ending but there are several plugins that are abandoned every year. If you&#8217;re thinking about abandoning your plugin, consider <a title=\"http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org\" href=\"http://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org\">putting it up for adoption</a> instead.</p>\n<p>When a plugin author adds the &#8216;<a title=\"https://wordpress.org/plugins/tags/adopt-me\" href=\"https://wordpress.org/plugins/tags/adopt-me\">adopt-me</a>&#8216; tag, it shows up in a list of other plugins using the same tag. Currently, there are 19 plugins available for adoption. Simply get in touch with the author and ask if you can take over development.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Dec 2014 22:36:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Coen Jacobs on Using The Right Tool For The Job\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35239\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wptavern.com/coen-jacobs-on-using-the-right-tool-for-the-job\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1397:\"<p>Coen Jacobs, who works as a backend developer, published a short video explaining why he doesn&#8217;t <a title=\"http://coenjacobs.me/why-not-full-time-wordpress-anymore/\" href=\"http://coenjacobs.me/why-not-full-time-wordpress-anymore/\">work with WordPress</a> full-time anymore. It&#8217;s not that he doesn&#8217;t like the project but rather, he&#8217;s gained a fresh perspective since stepping outside of the WordPress bubble.</p>\n<p><span class=\"embed-youtube\"></span></p>\n<blockquote><p>WordPress used to be the holy grail for me, I made everything with WordPress, even things that weren&#8217;t really suitable to be built on WordPress. I was an absolute fanboy who used WordPress for everything.</p></blockquote>\n<p>WordPress <a title=\"http://wptavern.com/what-would-it-take-for-wordpress-to-lose-its-dominance\" href=\"http://wptavern.com/what-would-it-take-for-wordpress-to-lose-its-dominance\">isn&#8217;t going away anytime soon</a> but it&#8217;s a risky move to place all your eggs in one basket.</p>\n<p>Instead of using WordPress for everything, he&#8217;s now using the best framework or tool for the job. I think this is a key lesson that a lot of WordPress developers need to be reminded of from time to time. WordPress is capable of handling a lot of different types of websites but it&#8217;s not suitable for every project.<em> Use the right tool for the job.<br />\n</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Dec 2014 21:14:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: WP Stagecoach to Bring 1-Click Staging Sites to WordPress in 2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32476\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wptavern.com/wp-stagecoach-to-bring-1-click-staging-sites-to-wordpress-in-2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3816:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-stagecoach.jpg\" rel=\"prettyphoto[32476]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-stagecoach.jpg?resize=683%2C298\" alt=\"wp-stagecoach\" class=\"aligncenter size-full wp-image-35226\" /></a></p>\n<p><a href=\"https://wpstagecoach.com\" target=\"_blank\">WP Stagecoach</a> has been in beta for the past few months and the team behind it is busy planning for an official launch in early 2015. The startup, created by Jonathan Kay, came in second, behind <a href=\"http://wpcurve.com/\" title=\"WP Curve\" target=\"_blank\">WP Curve</a>, in the first round of <a href=\"http://mattreport.com/episode-1-wordpress-startup-challenge/\" target=\"_blank\">Matt Report&#8217;s WordPress Startup Challenge</a>.</p>\n<p>The new service aims to create the most convenient way to stage a WordPress site, with 1-click copying from production to staging and 1-click to merge the changes back into the live site. WP Stagecoach offers a plugin that hooks your site up to the service with an API key. Staging sites are hosted on WP Stagecoach&#8217;s servers.</p>\n<p>The beta version of the service currently includes the following features:</p>\n<ul>\n<li>Create a staging copy of your live site with one click.</li>\n<li>Copy changes from your staging site back to your live site.</li>\n<li>Choose which changes to import. You can import some or all of your file changes, and/or your database changes.</li>\n<li>Password-protect your staging site.</li>\n<li>Staging site runs on WP Stagecoach&#8217;s server – no need to set up hosting for your staging site.</li>\n<li>Revert file changes if importing from your staging site doesn’t go as expected.</li>\n<li>Staging sites can be accessed via SSL-encryption</li>\n</ul>\n<p>After testing the beta on a simple blog, I found that the build process took several minutes. Once the site is created, you&#8217;ll be given SFTP/FTP login credentials and URL for your staging site. The site that WP Stagecoach creates is instantly public, which has me worried about duplicate content. If you use the service, you&#8217;ll want to log in and install a maintenance plugin to hide the staging site from the public.</p>\n<p>If an import gets interrupted, the plugin can pick up where it left off, which is helpful for larger sites. It also includes an advanced debug mode for tracking down problems.</p>\n<p>All of the staging sites are hosted on a standard LAMP stack, and users will not be able to reproduce their exact hosting environment with the service when it launches. For many people, the stack will be similar enough to their host and will cause no issues. However, if you are running on a more customized hosting environment, WP Stagecoach will likely not be suitable for creating your staging site.</p>\n<p>WP Stagecoach has plans to make it possible for users to create a staging site on their own servers, but this feature will be further down the road. When the team is able to add this, it will make the product a much more versatile tool for WordPress developers.</p>\n<p>At the moment, the service is very promising and offers a highly convenient way to create a staging site for a simple WordPress site on a standard LAMP stack. Those with a more customized server environment will have to look elsewhere for the time being. If the tool adapts to become more flexible, it will be better positioned to reach a larger audience with a wide range of hosting environments.</p>\n<p>WP Stagecoach pricing will be $12/month or $99/year for basic support. The beta is free and the team plans to add a few updates before the official launch. If you want to test the service, sign up on <a href=\"http://wptavern.com/ https://wpstagecoach.com/pricing/\" target=\"_blank\">wpstagecoach.com</a> to download the plugin.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Dec 2014 18:48:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: CEO and Envato Co-founder Collis Ta’eed On The First 6 Months of Envato\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35192\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/ceo-and-envato-co-founder-collis-taeed-on-the-first-6-months-of-envato\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2233:\"<p>Earlier this year, CEO and <a title=\"http://www.envato.com/\" href=\"http://www.envato.com/\">Envato</a> Co-founder, Collis Ta&#8217;eed, spoke at <a title=\"http://thesunrise.co/\" href=\"http://thesunrise.co/\">The Sunrise conference</a> in Sydney, Australia. The Sunrise is a conference where founders of Australia&#8217;s iconic startups describe the early years of their business. The presentation is 15 minutes in length with 30 minutes dedicated to questions.</p>\n<p>There&#8217;s a lot of great information in the presentation, especially if you&#8217;re running a bootstrapped business. I also admire Ta&#8217;eed&#8217;s delivery as he comes off as a straight shooter. He reminds me of myself when I tried to launch a business several years ago.</p>\n<h2>Presentation Highlights</h2>\n<p>Envato began as a stock Flash template marketplace called Flash Den. Flash Den was eventually renamed to Active Den due to Adobe owning the trademarks associated with Flash.</p>\n<p>Envato started with $30k and is still a bootstrapped company. Ta&#8217;eed receives numerous offers every year from venture capitalists looking to invest in Envato. So far, he has not accepted any outside funding.</p>\n<p><a title=\"http://appstorm.net/\" href=\"http://appstorm.net/\">AppStorm</a> was the precursor to the Apple App Store. Before Ta&#8217;eed could turn AppStorm into an app marketplace, Apple released the App Store crushing his idea.</p>\n<p>At 32:26, Ta&#8217;eed is asked how he came up with the name Envato. He bought it from <a title=\"https://www.brandbucket.com/\" href=\"https://www.brandbucket.com/\">Brandbucket</a> for $1k.</p>\n<p>At 38:50, Ta&#8217;eed is asked to describe how massive the Envato marketplace is. His response, &#8220;We sell something every 6 seconds, we sell a million WordPress theme per year, and we have the largest stock music marketplace by volume with a million tracks licensed each year.&#8221;</p>\n<p>At 42:52, Ta&#8217;eed is asked about Envato&#8217;s relationship to WordPress. He admits to the licensing challenges and mentions that, when Envato started selling WordPress themes, he didn&#8217;t know what the GPL was. He describes the relationship as symbiotic.</p>\n<p><span class=\"embed-youtube\"></span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 09 Dec 2014 02:35:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Manage Multiple WordPress Sites with WPDASH, Now in Beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=27624\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wptavern.com/manage-multiple-wordpress-sites-with-wpdash-now-in-beta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2721:\"<p><a href=\"http://en.wpdash.io/\" target=\"_blank\">WPDASH</a> is a new service that launched in beta today, created by a group of WordPress developers in Poland. It joins the ranks of <a href=\"https://managewp.com/\" target=\"_blank\">ManageWP</a>, <a href=\"https://wpremote.com/\" target=\"_blank\">WP Remote</a>, <a href=\"http://infinitewp.com/\" target=\"_blank\">InfiniteWP</a>, and a handful of others that provide a centralized WordPress dashboard for managing multiple sites.</p>\n<p>With the popularity of WordPress on the rise, many users have more than one site in operation. Those who work in development often have hundreds, if not thousands, of WordPress sites to look after, all of which require regular plugin and theme updates.</p>\n<p>The automatic background updates introduced in <a href=\"http://wptavern.com/wordpress-3-7-released-wordpress-now-updates-itself\" target=\"_blank\">WordPress 3.7</a> certainly ease the burden of maintenance for many WordPress agencies, but centralized dashboards are becoming critical for successfully managing backups, site uptime, and updates to themes and plugins for multiple installations.</p>\n<p>WPDASH is entering beta with an impressive array of features for managing sites, including the following:</p>\n<ul>\n<li>Add and modify posts and comments</li>\n<li>Install themes and plugins</li>\n<li>One-click updates</li>\n<li>Generate reports</li>\n<li>Create manual and automatic backups</li>\n<li>Monitor server uptime and user browsing habits</li>\n<li>Monitor accessibility of linked pages and inbound link statistics</li>\n<li>Two-factor authentication with Rublon</li>\n</ul>\n<p>Here&#8217;s a look at an example WPDASH overview of activity across all of your WordPress sites:</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-dash.jpg\" rel=\"prettyphoto[27624]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-dash.jpg?resize=720%2C772\" alt=\"wp-dash\" class=\"aligncenter size-full wp-image-35166\" /></a></p>\n<p>WPDASH also includes a number of advanced SEO-related features, such as integration with third-party tools for keyword monitoring and analytics services.</p>\n<p>Since the beta period is just now starting, we&#8217;ll be monitoring users&#8217; experiences to see how reliable the service is. WPDASH has not yet detailed its pricing, because the team is still ironing out features that will be added before launch. Beta testers have the opportunity to vote from the Features tab in the dashboard for new features that will be implemented.</p>\n<p>If you&#8217;re curious about the new service and want to join in the testing period, you can sign up for free at <a href=\"http://en.wpdash.io/\" target=\"_blank\">WPDASH.io</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Dec 2014 21:29:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Add an Auto Reply to Your Jetpack Contact Form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35098\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wptavern.com/add-an-auto-reply-to-your-jetpack-contact-form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4227:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/paper-airplaine.jpg\" rel=\"prettyphoto[35098]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/paper-airplaine.jpg?resize=1025%2C495\" alt=\"paper-airplaine\" class=\"aligncenter size-full wp-image-35147\" /></a></p>\n<p><a href=\"https://wordpress.org/plugins/jetpack/\" target=\"_blank\">Jetpack</a> has been downloaded more than 13 million times. The <a href=\"http://jetpack.me/support/contact-form/\" target=\"_blank\">Contact Form</a> module is one of its most popular features, as nearly every site requires a way for visitors to get in touch. The module is reliable and easy to use but fairly basic in terms of features.</p>\n<p>Fortunately, Jetpack makes it easy for you to extend its features with a plugin. <a href=\"http://www.hughlashbrooke.com/\" target=\"_blank\">Hugh Lashbrooke</a>, who has authored more than a dozen plugins hosted on WordPress.org, has just released <a href=\"https://wordpress.org/plugins/jetpack-contact-form-auto-reply/\" target=\"_blank\">Jetpack Contact Form Auto Reply</a> to make it easy for site admins to issue an automatic message in response to a contact form submission.</p>\n<p>The plugin adds a new Auto Reply sub-menu item under the Jetpack menu, with settings for two useful features:</p>\n<ul>\n<li>Craft a custom reply message using the WordPress WYSIWYG editor</li>\n<li>Set a unique from name and address for auto replies</li>\n</ul>\n<p>You can even add rich text or images to the custom reply message, which makes it easy to brand your communications for your company or organization.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/auto-reply.png\" rel=\"prettyphoto[35098]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/auto-reply.png?resize=1025%2C401\" alt=\"auto-reply\" class=\"aligncenter size-full wp-image-35107\" /></a></p>\n<p>The auto reply message could be something as simple as &#8220;We have received your request and will contact you shortly.&#8221; Or perhaps it&#8217;s a holiday and you want to update the auto reply to notify people of any delays in response time, i.e. &#8220;We will be out of the office until January 3, 2015.&#8221; This plugin provides an easy way to do that in the WordPress admin, without having to set up an auto-responder in your email.</p>\n<p>Lashbrooke originally created the plugin for his own use, because he was receiving numerous messages from people asking for support for his plugins hosted on WordPress.org and WooThemes.com. His custom auto reply message is designed to help point people to the appropriate forum, in case they contacted him for support-related questions.</p>\n<p>After testing the plugin, I can confirm that it works as advertised. The only tricky part is the last setting on the page, which calls for the label of the field in the contact form that contains the email address to use for the auto reply. You have to correctly identify this label or it won&#8217;t send. In my case the label was &#8216;Email,&#8217; which is likely to be a common one.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/auto-reply-email-settings.png\" rel=\"prettyphoto[35098]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/auto-reply-email-settings.png?resize=1025%2C279\" alt=\"auto-reply-email-settings\" class=\"aligncenter size-full wp-image-35108\" /></a></p>\n<p>While an auto reply might seem redundant, since Jetpack already displays a confirmation of the message sending successfully, that extra note in your visitor&#8217;s inbox can be reassuring, especially since it allows them to reply to the email if necessary. You can never underestimate the importance of communication in a customer&#8217;s decision-making process.</p>\n<p>Jetpack Contact Form Auto Reply is a handy add-on for the millions of Jetpack users out there who use the Contact Form module. <a href=\"https://wordpress.org/plugins/jetpack-contact-form-auto-reply/\" target=\"_blank\">Download</a> it from WordPress.org. If you&#8217;d like to contribute to make it better, feel free to fork the plugin on <a href=\"https://github.com/hlashbrooke/Jetpack-Contact-Form-Auto-Reply\" target=\"_blank\">GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Dec 2014 18:15:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: What Would it Take For WordPress to Lose its Dominance?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35076\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wptavern.com/what-would-it-take-for-wordpress-to-lose-its-dominance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3448:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/ThroneFeaturedImage.png\" rel=\"prettyphoto[35076]\"><img class=\"size-full wp-image-35085\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/ThroneFeaturedImage.png?resize=634%2C285\" alt=\"Throne Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/pasukaru76/9223676618/\">pasukaru76</a> &#8211; <a href=\"http://creativecommons.org/licenses/by/2.0/\">cc</a>\n<p>WordPress is 11 years old and used on over 20% of the web. Its popularity is made up of many facets including, the community, themes and plugins. In the realm of open source content management systems, nothing comes close to what WordPress has accomplished. Although it&#8217;s the market leader, its dominance won&#8217;t last forever.</p>\n<p>Mike Johnston of CMS Critic asks, &#8220;<a title=\"http://www.cmscritic.com/what-it-will-take-to-dethrone-wordpress/\" href=\"http://www.cmscritic.com/what-it-will-take-to-dethrone-wordpress/\">What It Will Take to Dethrone WordPress?</a>&#8221; In the article, Johnston explains why WordPress is on top and why Ghost is on the right path to possibly achieving similar success.</p>\n<blockquote><p>We&#8217;ve seen some successful upstarts come out of the wood work to try to take a piece of the pie and some are doing quite well in gaining momentum. One particular contender that comes to mind is Ghost.</p></blockquote>\n<p>While Ghost is doing well in its own right, <a title=\"http://wptavern.com/why-wordpress-doesnt-need-to-fear-ghost-yet\" href=\"http://wptavern.com/why-wordpress-doesnt-need-to-fear-ghost-yet\">I don&#8217;t think</a> it will knock on WordPress&#8217; door anytime soon. Johnston lists four things contenders must do in order to dethrone WordPress.</p>\n<ol>\n<li>Focus on marketing to developers</li>\n<li>Offer a migration path</li>\n<li>Offer hosted and self hosted options</li>\n<li>Build up a community</li>\n</ol>\n<p>The four steps he lists are a good start, but it&#8217;s going to take a lot more than that to take a chunk out of WordPress&#8217; market share. In 2009, I <a title=\"http://wptavern.com/six-ways-in-which-wordpress-could-die\" href=\"http://wptavern.com/six-ways-in-which-wordpress-could-die\">outlined six ways</a> WordPress could die and named <a title=\"http://www.habariproject.org/en/\" href=\"http://www.habariproject.org/en/\">Habari</a> as a viable competitor. Five years later, WordPress is bigger than ever and no one seems to remember the Habari project.</p>\n<h2>A Combination of Factors</h2>\n<p>I don&#8217;t think any <em>one thing</em> will put WordPress in second place. Instead, a combination of factors would likely need to take place. In no particular order, here are a couple of things that might lead to the project&#8217;s demise.</p>\n<ol>\n<li>Project leadership routinely ignores the majority.</li>\n<li>It becomes a large, bloated, legacy project that blocks innovation.</li>\n<li>A competing CMS comes along that does everything WordPress does, except better.</li>\n<li>The community in mass disappears or loses interest in favor of a competing product.</li>\n<li>A huge scandal takes place involving Automattic, the WordPress Foundation and those close to the project.</li>\n</ol>\n<p>I doubt any of these things will happen and WordPress will continue to be the market leader for at least the next 10 years. What risks or series of events do you think would lead to WordPress losing its dominance?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 06 Dec 2014 05:35:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Minnow: A Free Minimalist Blogging Theme from Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34709\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wptavern.com/minnow-a-free-minimalist-blogging-theme-from-automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2517:\"<p><a href=\"https://wordpress.org/themes/minnow\" title=\"Minnow\" target=\"_blank\">Minnow</a> is a beautiful, ultra-minimalist blogging theme from Automattic that just landed in the WordPress.org directory this week, bringing the company&#8217;s total free theme contributions to 54. It was designed by <a href=\"http://choycedesign.com/\" target=\"_blank\">Mel Choyce</a>, co-author of the popular <a href=\"http://wptavern.com/flounder-a-free-wordpress-theme-with-colorful-post-formats\" target=\"_blank\">Flounder</a> theme.</p>\n<p>Minnow features a single-column blog homepage, with a prominent social links menu at the top. The theme has support for all the standard post formats, with unique grey icons for each. The post meta design is tastefully simple and understated so that your content stays in focus.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/minnow.png\" rel=\"prettyphoto[34709]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/minnow.png?resize=1025%2C993\" alt=\"minnow\" class=\"aligncenter size-full wp-image-34912\" /></a></p>\n<p>Quotes, galleries, asides, etc. are all uniquely represented with subtle variations. Minnow also includes matching styles for threaded comments.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/quote.jpg\" rel=\"prettyphoto[34709]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/quote.jpg?resize=860%2C340\" alt=\"quote\" class=\"aligncenter size-full wp-image-35063\" /></a></p>\n<p>The theme has just a handful of customization options for changing the background image and/or color. It&#8217;s the type of theme that you can activate and have it looking like the demo in under two minutes.</p>\n<p>The theme is mobile friendly, and the 660px main content area sizes down gracefully for mobile devices. Minnow also includes a slide-out sidebar widget area. The primary navigation menu is pinned to the top of the sidebar, above any widgets.</p>\n<p>Check out the <a href=\"http://minnowdemo.wordpress.com/\" target=\"_blank\">live demo</a> to see Minnow in action. You&#8217;ll have to install the theme on your site in order to see the slide-out sidebar and navigation menu, as it is currently omitted in the demo.</p>\n<p>If you&#8217;re looking to jump start your blog for the upcoming new year, Minnow is an excellent choice. The clean design offers visitors a pleasant reading experience. <a href=\"https://wordpress.org/themes/minnow\" target=\"_blank\">Download</a> it for free from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Dec 2014 21:41:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Roots Starter Theme for WordPress Will Become Framework Agnostic in 2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=35007\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://wptavern.com/roots-starter-theme-for-wordpress-will-become-framework-agnostic-in-2015\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4399:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/roots.jpg\" rel=\"prettyphoto[35007]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/roots.jpg?resize=1024%2C477\" alt=\"photo credit: Buzz Hoffman - cc\" class=\"size-full wp-image-35036\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/buzzhoffman/3673683967/\">Buzz Hoffman</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>Major changes are coming to the <a href=\"http://roots.io/\" target=\"_blank\">Roots</a> starter theme for WordPress. Roots has appealed mainly to developers, because it incorporates modern build tools into its workflow. The theme  was first released in 2011 and now counts more than 70 contributors to the project.</p>\n<p>Roots currently utilizes HTML5 Boilerplate, Bootstrap, Grunt, and Bower in the starter theme but will will soon be moving to Gulp. The project&#8217;s GitHub repo has a <a href=\"https://github.com/roots/roots/pull/1138\" target=\"_blank\">Gulp branch</a> with the relevant discussion and commits.</p>\n<p><strong>&#8220;Gulp is faster, has nicer configuration files, allows us to easily compile both Less and Sass to the same stylesheet, and more,&#8221;</strong> Roots creator <a href=\"http://benword.com/\" target=\"_blank\">Ben Word</a> said, regarding the upcoming changes.</p>\n<p>This will also include an update to Roots&#8217; asset pipeline, which will allow theme developers to take CSS and JS from WordPress plugins and have it compiled into the single CSS and single JS files that the theme builds. The <a href=\"https://github.com/roots/roots/pull/1215\" target=\"_blank\">new asset pipeline</a> brings changes to project folders, removes differences between dev and production tasks, and adds a JSON-based asset pipeline.</p>\n<h3>Build a Roots-based Theme Using Any Framework</h3>\n<p>Additionally, the starter theme will be moving away from including <a href=\"http://getbootstrap.com/\" target=\"_blank\">Bootstrap</a> in order to become framework agnostic. &#8220;We&#8217;re going to have a Yeoman generator that will allow you to build a Roots based theme however you want,&#8221; Word said. &#8220;You&#8217;ll be able to pick from any framework, Bootstrap, Bootstrap Sass, Foundation, and more.&#8221;</p>\n<p>While Bootstrap still has a very large user base, the Roots community has shown more interest in other frameworks such as <a href=\"http://semantic-ui.com/\" target=\"_blank\">Semantic UI</a> and <a href=\"https://developers.google.com/web/starter-kit/\" target=\"_blank\">Google&#8217;s Web Starter Kit</a>.</p>\n<p>&#8220;A lot of people over the years have expressed that they like Roots, but don’t like Bootstrap,&#8221; Word explained. &#8220;We&#8217;ve even seen some forks pop up (Roots Foundation, for instance) to accommodate other frameworks. By becoming framework agnostic, the starter theme should be able to appeal to a wider audience.&#8221;</p>\n<p>Word and his team plan to have the generator ready for the public in the first quarter of 2015 and are currently working to incorporate work from other Yeoman generators.</p>\n<p>Last year, the Roots community introduced <a href=\"http://roots.io/wordpress-stack/\" target=\"_blank\">Bedrock</a>, a modern WordPress stack that uses Composer for managing WordPress along with Capistrano for deployment. Bedrock can be used with any theme. Since its launch, the project has struggled with branding issues. When all the new changes are merged into Roots&#8217; master branch, Word plans to rename the starter theme and keep Roots as the organization name.</p>\n<p>The Roots starter theme has always had a somewhat narrow audience due to the fact that it has a steeper learning curve than other starter themes. Making the change to be platform agnostic should open it up for more theme developers, but it will continue to cater primarily to those who are interested in using build scripts.</p>\n<p>&#8220;Roots has been at a point where you can’t use it if you’re not using npm, Bower, and Grunt, and we&#8217;ve completely stopped supporting users who don’t want to adapt to the better workflow we’ve created,&#8221; Word said. &#8220;I struggled in the past with choosing to support the average Joe WordPress developer or to push for WordPress devs to learn tools that make them better at their job. Workflow efficiency is definitely the ultimate goal.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Dec 2014 18:06:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: nRelate Will Shutdown Its Service December 31st\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34995\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wptavern.com/nrelate-will-shutdown-its-service-december-31st\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3942:\"<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/03/QikShutdownFeaturedImage.png\" rel=\"prettyphoto[34995]\"><img class=\"size-full wp-image-19708\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/03/QikShutdownFeaturedImage.png?resize=639%2C200\" alt=\"Qik Shuts Down Featured Image\" /></a>photo credit: <a href=\"http://www.flickr.com/photos/slimjim/2772087916/\">slimmer_jimmer</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a>\n<p>The content recommendation service <a title=\"http://nrelate.com\" href=\"http://nrelate.com\">nRelate</a>, <a title=\"http://nrelate.com/content/2014/12/01/farewell/\" href=\"http://nrelate.com/content/2014/12/01/farewell/\">announced</a> it will shut down its service December 31st. Launched in 2009, nRelate has provided billions of recommendations to over 100k sites. The service is shifting its assets to support its internal reference-style content properties. If you use nRelate, there is a <a title=\"http://nrelate.com/farewell-faqs/\" href=\"http://nrelate.com/farewell-faqs/\">farewell FAQ</a> available which has instructions on what to do.</p>\n<h2>YARPP and Jetpack Related Posts as Alternatives</h2>\n<p>There are three alternatives that come to mind with regards to related posts, <a title=\"https://wordpress.org/plugins/yet-another-related-posts-plugin/\" href=\"https://wordpress.org/plugins/yet-another-related-posts-plugin/\">YARPP</a>, <a title=\"https://wordpress.org/plugins/related-posts-for-wp/\" href=\"https://wordpress.org/plugins/related-posts-for-wp/\">Related Posts for WordPress</a>, and <a title=\"http://jetpack.me/support/related-posts/\" href=\"http://jetpack.me/support/related-posts/\">Jetpack Related Posts</a>. For several years, I used YARPP on WP Tavern to handle related posts and it performed flawlessly. However, at one point, it gave me performance problems because of the resources used on a shared webhosting server. The webhosting provider at the time pointed out that YARPP was taking up too many resources on the server. If you have a limited amount of posts or a beefy server, YARPP is a great alternative because it offers a variety of ways to display related posts.</p>\n<p>After encountering performance problems, I decided to go without related posts. <a title=\"http://wptavern.com/jetpack-2-9-introduces-multisite-support-and-related-posts-module\" href=\"http://wptavern.com/jetpack-2-9-introduces-multisite-support-and-related-posts-module\">Jetpack 2.9</a> released in early 2014, contained a new module called <a title=\"http://jetpack.me/support/related-posts/\" href=\"http://jetpack.me/support/related-posts/\">related posts</a>. Unlike YARPP, all of the processing and server resources were used on Automattic&#8217;s servers instead of my own and eliminated my performance issues with related posts. Keep in mind that when you use the Jetpack Related Posts module, the content is mirrored on WordPress.com for indexing and processing.</p>\n<p>Another thing to keep in mind is that the module will use the featured image attached to a post in the module. If a featured image is not detected, it uses the first image in the post which may or may not be optimal. You might also see a mix of related posts with and without images.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/JetpackRelatedPostsWithoutAnImage.png\" rel=\"prettyphoto[34995]\"><img class=\"size-full wp-image-34999\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/JetpackRelatedPostsWithoutAnImage.png?resize=679%2C266\" alt=\"Related Post Without an Image\" /></a>Related Post Without an Image\n<p>I&#8217;m of the mindset that if you can offload the processing required to determine post relationships, then do it. We&#8217;ve used the Jetpack Related Posts module on the Tavern for some time and haven&#8217;t experienced any issues. It&#8217;s also pretty good at being somewhat relevant. What do you use to handle related posts?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Dec 2014 07:52:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: Easily Show When WooCommerce Items Are New, On Sale, or Sold Out With Woo Stickers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34989\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wptavern.com/easily-show-when-woocommerce-items-are-new-on-sale-or-sold-out-with-woo-stickers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1706:\"<p>If you run a WooCommerce store with a lot of products and want a nice way to tell customers whether an item is new, on sale, or sold out, check out the <a title=\"https://wordpress.org/plugins/woo-stickers-by-webline/\" href=\"https://wordpress.org/plugins/woo-stickers-by-webline/\">Woo Stickers</a> plugin by Webline. Created by <a title=\"http://www.weblineindia.com/\" href=\"http://www.weblineindia.com/\">Webline India</a>, Woo Stickers makes it easy to provide visual cues on products. Stickers indicate whether a product is new, for sale, or sold out and comes in two styles, ribbon and round.</p>\n<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/StickerStyles.png\" rel=\"prettyphoto[34989]\"><img class=\"size-full wp-image-34990\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/StickerStyles.png?resize=779%2C484\" alt=\"Notification Stickers and Styles\" /></a>Notification Stickers and Styles\n<p>The plugin&#8217;s settings are modular in that you can configure stickers to display for some products while not appearing for others.</p>\n<a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/WooStickersSettings.png\" rel=\"prettyphoto[34989]\"><img class=\"size-full wp-image-34991\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/WooStickersSettings.png?resize=1025%2C361\" alt=\"Woo Sticker Settings\" /></a>Woo Sticker Settings\n<p>Woo Stickers uses image sprites so they should look fine for most WooCommerce store designs. Perhaps in the future, the plugin author can provide the ability to control the sprite and font colors for maximum theme compatibility. I tested the plugin in WordPress 4.0.1 and WooCommerce 2.2.8 and experienced no problems.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 05 Dec 2014 04:44:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: Five Beers: A Free AJAX-Powered Child Theme for Twenty Fifteen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34677\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/five-beers-an-ajax-powered-child-theme-for-twenty-fifteen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4184:\"<a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/five-beers-featured.jpg\" rel=\"prettyphoto[34677]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/five-beers-featured.jpg?resize=1024%2C505\" alt=\"photo credit: rchlnwnhm - cc\" class=\"size-full wp-image-34985\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/68442586@N02/13240338454/\">rchlnwnhm</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a>\n<p>WordPress 4.1 hasn&#8217;t yet been officially released, but child themes for the new <a href=\"http://twentyfifteendemo.wordpress.com/\" title=\"Twenty Fifteen demo\" target=\"_blank\">Twenty Fifteen</a> default theme are already popping up. The minimalist, blog-focused theme has so far been well received and users are already eagerly testing it out.</p>\n<p>WordPress developer <a href=\"https://github.com/chrismccoy\" target=\"_blank\">Chris McCoy</a> has created a Twenty Fifteen child theme with a unique twist. At first glance, <a href=\"https://github.com/chrismccoy/fivebeers\" target=\"_blank\">Five Beers</a> appears to be a colorless variation of the default theme, but under the hood you&#8217;ll find a set of powerful AJAX additions.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/five-beers.jpg\" rel=\"prettyphoto[34677]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/five-beers.jpg?resize=971%2C468\" alt=\"five-beers\" class=\"aligncenter size-full wp-image-34711\" /></a></p>\n<p>One of the most impressive features is the way Five Beers handles media display. It incorporates the <a href=\"http://stripjs.com/\" target=\"_blank\">Strip.js</a> lightbox to slide images and videos out from the side of the page. You can see a live example of it on the <a href=\"http://fivebeers.net/\" target=\"_blank\">Five Beers demo site</a>.</p>\n<p>The child theme includes all of the customization options of Twenty Fifteen plus several extra features:</p>\n<ul>\n<li>AJAX Live Search (still working out the bugs)</li>\n<li>AJAX comments</li>\n<li>AJAX archives</li>\n<li>AJAX A-Z Alphabet post loading</li>\n<li>AJAX infinite scrolling with SEO as a factor</li>\n<li>Custom tag page listed by letter</li>\n<li>Lightbox to adapt to galleries and video oEmbeds</li>\n<li>Unlimited widget area creation</li>\n</ul>\n<p>Additionally, when you publish a YouTube or Vimeo link, the theme will use the cover image (click to play) as the featured image. If no featured image is set, Five Beers will use a default click to play thumbnail.</p>\n<p>Building all of this functionality into the theme is a bit unorthodox, as most theme authors would opt to put these items into separate plugins. I asked McCoy why he opted to do it this way. &#8220;I’m trying to keep all functionality as the theme, because I prefer not to use a plugin if I don’t need to,&#8221; he said. If you use the theme, you could opt to use McCoy&#8217;s <a href=\"https://github.com/chrismccoy/strip\" target=\"_blank\">Strip Lightbox plugin</a> instead and then simply remove the include in the functions file for the lightbox.php file.</p>\n<p>Ultimately, it&#8217;s a theme McCoy built for himself one night while having five different brands of beer, hence the unique name. I&#8217;d like to see each piece of functionality pulled out and supported as a separate plugin, but this isn&#8217;t something he intends to do. McCoy originally planned to create it just for himself but will be adding more features next week.</p>\n<p>This child theme is particularly useful if you want to highlight your archived content by including alphabetical sorting and live search, making it easy for users to discover content as they are typing.</p>\n<p>Five Beers currently requires WordPress 4.1 Beta 1+ to use until 4.1 is officially released. The WordPress 4.1 project schedule has the release targeted for the week of December 8. McCoy does not plan to add the theme to WordPress.org, as the <a href=\"http://stripjs.com/license\" target=\"_blank\">Strip.js licensing</a> is not supported in the official directory.  You can download the Five Beers theme for free on <a href=\"https://github.com/chrismccoy/fivebeers\" target=\"_blank\">GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Dec 2014 22:48:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: How to Find the Number of Feedly Subscribers to Your Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34466\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wptavern.com/how-to-find-the-number-of-feedly-subscribers-to-your-blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5050:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly.jpg\" rel=\"prettyphoto[34466]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly.jpg?resize=1025%2C443\" alt=\"feedly\" class=\"aligncenter size-full wp-image-34964\" /></a></p>\n<p>When Google Reader was laid to rest on July 1, 2013, many users flocked to <a href=\"http://feedly.com/\" target=\"_blank\">Feedly</a>, one of the most popular alternatives. Even if you don&#8217;t use Feedly, it&#8217;s likely that many of your blog&#8217;s readers do. Therefore, if you want a true picture of the number of your RSS subscribers, digging into Feedly&#8217;s numbers should be part of your research.</p>\n<h3>Find Your Feedly Subscriber Count on Mobile</h3>\n<p>Feedly&#8217;s UI is notorious for being less than intuitive and <a href=\"http://blog.feedly.com/feedly-tutorial-v1/\" target=\"_blank\">confusing to navigate</a>. If you poke around, you can find a rough number of your subscribers. If you&#8217;re using a mobile device, simply search for your blog (even if you&#8217;re already subscribed), in the top search bar and it will display a rough count.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-mobile.jpg\" rel=\"prettyphoto[34466]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-mobile.jpg?resize=402%2C500\" alt=\"feedly-mobile\" class=\"aligncenter size-large wp-image-34933\" /></a></p>\n<h3>Find Your Feedly Subscriber Count in the Web App</h3>\n<p>If you&#8217;re looking for your subscriber count in the web app, click your site in the left sidebar among your subscriptions and then look for your total subscribers under the title.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-web-app.png\" rel=\"prettyphoto[34466]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-web-app.png?resize=1025%2C762\" alt=\"feedly-web-app\" class=\"aligncenter size-full wp-image-34942\" /></a></p>\n<p>That&#8217;s not too difficult, but what if you want to know the actual count of your Feedly subscribers? After all, there&#8217;s quite a difference between 3,001 and 3,999, especially when you are looking at setting goals. Once you pass 2,000, it seems that Feedly resorts to fuzzy rounding to the nearest thousand instead of reporting actual figures.</p>\n<h3>Feedly Insight Plugin for WordPress</h3>\n<p>WordPress sites can install a plugin called <a href=\"https://wordpress.org/plugins/feedly-insight/\" target=\"_blank\">Feedly Insight</a> to get an exact subscriber count. It utilizes the <a href=\"http://developer.feedly.com/\" target=\"_blank\">Feedly Cloud API</a> to tap into more exact data about your feed(s). Once you install the plugin, you&#8217;ll notice that it adds its own top level menu where you can click on the &#8220;Feedly Insight&#8221; submenu item. Scroll down to the search bar and enter your URL. It will return a few interesting stats, including languages and an exact subscriber count.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-insight.jpg\" rel=\"prettyphoto[34466]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/feedly-insight.jpg?resize=828%2C725\" alt=\"feedly-insight\" class=\"aligncenter size-full wp-image-34953\" /></a></p>\n<p>You can also search your competitors&#8217; URLs in order to see how well they&#8217;re doing at attracting subscribers. After performing your research, you can keep the plugin if you want to keep track of your Feedly stats via its dashboard widget, or you can uninstall it and check back again later.</p>\n<p>Having a full picture of RSS subscribers is important for publishers who want to tailor their content to appear better in feed readers. For example, if you find that you have a large number of Feedly subscribers, you will want to make sure that each post appears with an image. Feedly doesn&#8217;t have the ability to fetch your featured image. Instead, it grabs the first image displayed within your post to show as the thumbnail in its reader. If your post has no images, it will show a blank as the thumbnail, which isn&#8217;t ideal. Adding an image to each post will help you to avoid this.</p>\n<p>You can also <a href=\"https://docs.google.com/forms/d/1jmkC6avpJQgdQhuKd2wN0PSYeBzKQ3KQzJEF8F9vZy8/viewform\" target=\"_blank\">claim your own Feedly hashtag</a> using this Google form, which allows you to have more control over what people find when they search for your brand or your #name.</p>\n<p>If you&#8217;re a publisher, you cannot ignore Feedly, even if you&#8217;re not a fan of the product. Feed readers are still going strong and Feedly seems to be leading the pack after Google Reader died. If you have never checked to find out how many people are reading your blog through Feedly, you may be surprised. To get a rough idea, just log into the app. The <a href=\"https://wordpress.org/plugins/feedly-insight/\" target=\"_blank\">Feedly Insight</a> plugin offers a more detailed look and an easier way to monitor your stats.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Dec 2014 21:59:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Matt: Performance As Design\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=44539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"http://ma.tt/2014/12/performance-as-design/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:193:\"<p><a href=\"http://bradfrost.com/blog/post/performance-as-design/\">Performance As Design</a>, by Brad Frost. Great thoughts and links. Performance is going to be a big focus for me in 2015.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Dec 2014 15:50:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: WPWeekly Episode 173 – Interview With Happy Joe Founder, James Dalman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=34905&preview_id=34905\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/wpweekly-episode-173-interview-with-happy-joe-founder-james-dalman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3352:\"<p>In this episode of WordPress Weekly, <a href=\"http://marcuscouch.com/\" title=\"http://marcuscouch.com/\">Marcus Couch</a> and I discuss the news of the week and interview the founder of <a href=\"http://www.happyjoe.org/\" title=\"http://www.happyjoe.org/\">HappyJoe.org</a>, James Dalman. Happy Joe is a 501 c3 non-profit organization that helps U.S. veterans with entrepreneurship and employment opportunities.</p>\n<p>Dalman shares what inspired him to create the organization and the role WordPress plays in helping veterans secure jobs in the web technology industry.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://wptavern.com/wordcamp-maui-hi-set-for-february-13-14th-2015\" title=\"http://wptavern.com/wordcamp-maui-hi-set-for-february-13-14th-2015\">WordCamp Maui, HI Set For February 13-14th, 2015</a><br />\n<a href=\"http://wptavern.com/dawnpatrol-gives-fringe-wordpress-communities-a-voice\" title=\"http://wptavern.com/dawnpatrol-gives-fringe-wordpress-communities-a-voice\">DawnPatrol Gives Fringe WordPress Communities a Voice</a><br />\n<a href=\"http://wptavern.com/jp-bot-the-silent-bot-behind-the-jetpack-module-extraction-plugins\" title=\"http://wptavern.com/jp-bot-the-silent-bot-behind-the-jetpack-module-extraction-plugins\">JP Bot: The Silent Bot Behind the Jetpack Module Extraction Plugins</a><br />\n<a href=\"http://wptavern.com/infinitewp-client-plugin-releases-security-update\" title=\"http://wptavern.com/infinitewp-client-plugin-releases-security-update\">InfiniteWP Client Plugin Releases Security Update</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/before-deleting-the-posts/\" title=\"https://wordpress.org/plugins/before-deleting-the-posts/\">Before deleting the posts</a> backs up posts into an XML file before they&#8217;re emptied from the trash. The XML file is stored in the same format same as the Export from WordPress. If you want to restore the post, you can use the WordPress importer.</p>\n<p><a href=\"https://wordpress.org/plugins/gravity-forms-google-analytics-event-tracking/\" title=\"https://wordpress.org/plugins/gravity-forms-google-analytics-event-tracking/\">Gravity Forms Google Analytics Event Tracking</a> provides an easy way to add Google Analytics event tracking to Gravity Forms, allowing you to properly track form submissions as events and conversions within Google Analytics.</p>\n<p><a href=\"https://wordpress.org/plugins/wp-voice-recorder/\" title=\"https://wordpress.org/plugins/wp-voice-recorder/\">WP Voice Recorder</a> allows you to record audio and play it on the frontend of WordPress within a post. It saves the recorded audio file to a Dropbox account instead of saving it to the server.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, December 10th 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #173:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Dec 2014 06:11:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: WordPress 4.1 To Introduce Plugin Recommendations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34854\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wptavern.com/wordpress-4-1-to-introduce-plugin-recommendations\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2176:\"<p>On the Add New plugin page in WordPress 4.0, there are two different tabs to help users discover new plugins: Featured and Popular. What if WordPress could recommend plugins based on the ones you have installed? Thanks to a <a title=\"https://core.trac.wordpress.org/ticket/30337\" href=\"https://core.trac.wordpress.org/ticket/30337\">recent update</a> to the API, users will be able to access a list of recommended plugins in WordPress 4.1.</p>\n<p>The recommendations take into account the plugins you have installed and suggests plugins based on which ones are commonly used together. It&#8217;s similar to an e-commerce shopping cart that recommends products other customers have purchased based on what&#8217;s in the cart.</p>\n<h2>Recommended Plugins To Get its Own Tab</h2>\n<p>In today&#8217;s WordPress 4.1 developer meeting, the group <a title=\"https://wordpress.slack.com/archives/core/p1417641723005178\" href=\"https://wordpress.slack.com/archives/core/p1417641723005178\">reached a consensus</a> to create a new tab for Recommended plugins instead of replacing the Popular tab. I&#8217;m in favor of this decision because they each have a different definition. Also, the Popular tab shows which plugins are doing well across the directory. Another benefit to keeping the Popular plugins tab is for fresh installs of WordPress, as it gives users a good foundation to start looking for plugins.</p>\n<p>In my tests, I noticed that some of the plugins recommended to me are 5-8 years old. I&#8217;ve reported the behavior to Alex Shiels and it will be addressed before 4.1 ships. If you are testing WordPress 4.1 and come across any oddities with plugin recommendations, please <a title=\"https://core.trac.wordpress.org/ticket/30337\" href=\"https://core.trac.wordpress.org/ticket/30337\">report them</a> in the ticket.</p>\n<p>The Recommended plugins tab exposes new and useful plugins to users instead of limiting them to the Featured and Popular categories. Since recommendations are based on actual data, they should get better as time goes on. Do you think a recommended plugins page is a useful addition to the plugin discovery process? Let us know in the comments.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 23:33:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Google’s New reCAPTCHA API Replaces Distorted Text with a Checkbox\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34808\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wptavern.com/googles-new-recaptcha-api-replaces-distorted-text-with-a-checkbox\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3708:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha.png\" rel=\"prettyphoto[34808]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/recaptcha.png?resize=365%2C109\" alt=\"recaptcha\" class=\"alignright size-full wp-image-34867\" /></a>For the past several years, Google&#8217;s <a href=\"https://www.google.com/recaptcha\" target=\"_blank\">reCAPTCHA</a> has verified a user&#8217;s humanity by forcing you to decipher warped, nonsensical text. reCAPTCHA&#8217;s method of protecting websites from spam has long put the burden on the user to prove that he is not an abusive bot.</p>\n<p>This is all about to change as a result of Google&#8217;s most <a href=\"http://googleonlinesecurity.blogspot.com/2014/04/street-view-and-recaptcha-technology.html\" target=\"_blank\">recent research</a>, which indicates that smart bots are able to solve even the most distorted text puzzles with more than 99% accuracy. Since the CAPTCHA puzzles are often infuriating to humans and ineffective at stopping bots, Google put its efforts toward developing a better user experience.</p>\n<p>Today, Vinay Shet, Google&#8217;s Product Manager for reCAPTCHA, <a href=\"http://googleonlinesecurity.blogspot.com/2014/12/are-you-robot-introducing-no-captcha.html\" target=\"_blank\">announced</a> a new API called “No CAPTCHA reCAPTCHA.” This API utilizes an Advanced Risk Analysis engine that is capable of discerning between users and bots. The best part is that the interface has been simplified to a checkbox, a vast improvement over reCAPTCHA&#8217;s alphabet soup scramble.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nocaptcha.gif\" rel=\"prettyphoto[34808]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nocaptcha.gif?resize=616%2C164\" alt=\"photo credit: Google Online Security Blog\" class=\"size-full wp-image-34870\" /></a>photo credit: <a href=\"http://googleonlinesecurity.blogspot.com/2014/12/are-you-robot-introducing-no-captcha.html\">Google Online Security Blog</a>\n<p>WordPress.org is already using the new &#8220;No CAPTCHA reCAPTCHA&#8221; API and, according to the announcement, is providing users with a faster registration experience:</p>\n<blockquote><p>Early adopters, like <a href=\"https://support.snapchat.com/login2?next=/\" target=\"_blank\">Snapchat</a>, <a href=\"https://wordpress.org/support/register.php\" target=\"_blank\">WordPress</a>, <a href=\"https://www.humblebundle.com/\" target=\"_blank\">Humble Bundle</a>, and several others are already seeing great results with this new API. For example, in the last week, more than 60% of WordPress’ traffic and more than 80% of Humble Bundle’s traffic on reCAPTCHA encountered the No CAPTCHA experience—users got to these sites faster.</p></blockquote>\n<p>Several dozen WordPress <a href=\"https://wordpress.org/plugins/search.php?q=reCAPTCHA\" target=\"_blank\">plugins integrate reCAPTCHA</a> in one way or another to protect sites from bad bots. Plugins that integrate the new &#8220;No CAPTCHA reCAPTCHA&#8221; API will allow many users to pass through by simply checking a box. However, it does provide a fallback to the scrambled letters in cases where the Advanced Risk Analysis engine isn&#8217;t able to confidently assume that a user is human.</p>\n<p>A cursory examination of the changelogs on several reCAPTCHA plugins shows that plugin authors have not yet updated their extensions to indicate compatibility with the new API. Given that the user experience of the checkbox is far superior to distorted letters, we&#8217;re likely to see more developers take advantage of reCAPTCHA&#8217;s new API in the coming days. Does the new API make you more likely to use reCAPTCHA?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 21:57:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Salvador, Brazil to Host Its First WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34811\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wptavern.com/salvador-brazil-to-host-its-first-wordcamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5911:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wordcamp-salvador.jpg\" rel=\"prettyphoto[34811]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wordcamp-salvador.jpg?resize=912%2C422\" alt=\"wordcamp-salvador\" class=\"aligncenter size-full wp-image-34823\" /></a></p>\n<p>The very first <a href=\"http://2014.salvador.wordcamp.org/\" target=\"_blank\">WordCamp Salvador</a> is set to take place in Brazil this weekend on December 6th, bringing together approximately 160 attendees who are excited about connecting through WordPress. The more developed south and southeast regions of Brazil have had WordCamps in the past, but WordCamp Salvador will be the first in the northeast.</p>\n<p>Co-organizer <a href=\"https://profiles.wordpress.org/leobaiano/\" target=\"_blank\">Leo Baiano</a> is the founder of Salvador&#8217;s first WordPress meetup group and has been instrumental in growing the local community over the past year. He discovered WordPress nine years ago, which led him to get involved in fostering his local community.</p>\n<p>&#8220;The idea of holding WordCamp Salvador was born in early 2014. Many people have left the city to work in more technologically advanced cities like Sao Paulo and Rio de Janeiro, where there are many events happening and more companies value employees,&#8221; he said. Baiano became determined to bring WordCamp to Salvador. &#8220;I did not want to leave the city that I love to participate in important events and be valued as a professional; I prefer to fight to make things better here,&#8221; he said.</p>\n<p>When Baiano started the <a href=\"http://www.meetup.com/wpsalvador/\" target=\"_blank\">WP Salvador/Bahia meetup group</a>, he focused on bringing people together for small events with lectures on basic topics, as well as social gatherings. They hosted approximately 10 meetups before sending in an application to start organizing a WordCamp.</p>\n<p>&#8220;Without the meetups and the local community support, it would be almost impossible to make this WordCamp happen,&#8221; he said. &#8220;Now I have a team of five local co-organizers and lots of others willing to volunteer at the event.&#8221; Baiano also received help from friends who organized previous WordCamps as well as support from the <a href=\"http://guwp.org/\" target=\"_blank\">WordPress Brazil User Group</a>.</p>\n<h3>WP Salvador Meetup Group Helps Seniors Learn WordPress</h3>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-salvador-seniors.jpeg\" rel=\"prettyphoto[34811]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-salvador-seniors.jpeg?resize=660%2C362\" alt=\"wp-salvador-seniors\" class=\"aligncenter size-full wp-image-34834\" /></a></p>\n<p>One of the unique things about the local WordPress community in Salvador is its desire to work together to help more people benefit from the software.</p>\n<p>&#8220;Local Brazilian communities are all similar in essence, but what differentiates the Salvador community from others is the willingness we all have to get the group together and work on related projects,&#8221; Baiano said.</p>\n<p>&#8220;An example of that is this work we just started with this elderly group. Other group members already showed interest in running some workshops for them, without any financial return, just for the pleasure of working together.&#8221; The meetup group partnered with UNEB (State University of Bahia) and the UATI, a support unit for seniors.</p>\n<p>&#8220;We are teaching seniors how to create blogs with WordPress, and update and promote their blogs. This is a wonderful initiative because these seniors are looking for an occupation, something to pass the time, and they are very smart and interested in the lecture,&#8221; Baiano said.</p>\n<p>&#8220;I was surprised by their enthusiasm, all the time asking questions and wanting to learn more about it. In 2015 we will begin a series of workshops where this group of seniors will learn how to create a WordPress blog, how to produce content, basic SEO techniques such as promoting posts on social networks, how to increase the audience of the blog by interacting with readers and other blogs in the same niche.&#8221;</p>\n<h3>WordCamp Salvador Signifies an Important Milestone for the Local Community</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-salvador-meetup.jpg\" rel=\"prettyphoto[34811]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/wp-salvador-meetup.jpg?resize=1025%2C589\" alt=\"wp-salvador-meetup\" class=\"aligncenter size-full wp-image-34845\" /></a></p>\n<p>The local WordPress community in Salvador is just starting to take off, as meetup members gather around collaborative projects like the initiative to help seniors with WordPress. WordCamp Salvador will be an important milestone for solidifying the community.</p>\n<p>&#8220;My hope for this WordCamp is that it allows the community to grow even more, resulting in more people attending our future meetups and inspiring new collaborative projects,&#8221; Baiano said.</p>\n<p>&#8220;The event happening this year is very important if you take into account the momentum of the digital market in the city of Salvador right now. It’s a special moment, where many other groups have begun to organize and get together. The WordCamp will help foster future debates and help the market grow as a whole.&#8221;</p>\n<p>Baiano reports that current registered attendees are comprised of 75% locals and 24% from other regions in Brazil. He hopes that the WordCamp will connect local members to the wider WordPress community.</p>\n<p>&#8220;We are here to stay and we are available to help the WordPress community,&#8221; he said. &#8220;We hope to encourage our members to start contributing and engaging more in the global community, by helping on the official forums, translations, and on WordPress core.&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 19:52:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: jMonkeyEngine Migrates Community Site Away From BuddyPress and bbPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34733\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wptavern.com/jmonkeyengine-migrates-community-site-away-from-buddypress-and-bbpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9072:\"<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/MigrationFeaturedImage.png\" rel=\"prettyphoto[34733]\"><img class=\"size-full wp-image-34786\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/MigrationFeaturedImage.png?resize=637%2C239\" alt=\"Migration Featured Image\" /></a>photo credit: <a href=\"https://www.flickr.com/photos/karenapricot/1225579130/\">Karen Apricot New Orleans</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-sa/2.0/\">cc</a>\n<p><a title=\"http://jmonkeyengine.org/\" href=\"http://jmonkeyengine.org/\">jMonkeyEngine</a> is a <a href=\"http://en.wikipedia.org/wiki/Game_engine\" target=\"_blank\">game engine</a> made for developers who want to create 3D games following modern technology standards. The framework is programmed entirely in <a href=\"http://en.wikipedia.org/wiki/Java_%28programming_language%29\">Java</a> aimed at wide accessibility and quick deployment to desktop, web, and mobile platforms. Established in 2003, the jMonkeyEngine community forum has gone through at least four migrations.</p>\n<p>phpBB → SMF → BuddyPress Forum → bbPress 2.0 → Discourse.</p>\n<p>In late October, the jMonkeyEngine community hub went offline. When the site came back online, the team discovered performance issues. Due to performance reasons and a change in philosophy, the <a title=\"http://hub.jmonkeyengine.org/\" href=\"http://hub.jmonkeyengine.org/\">jMonkeyEngine project</a> is migrating its community and forum from <a title=\"http://hub.jmonkeyengine.org/2014/11/we-will-be-moving-soon/\" href=\"http://hub.jmonkeyengine.org/2014/11/we-will-be-moving-soon/\">BuddyPress and bbPress to Discourse</a>. This marks the fifth different forum migration in 10 years.</p>\n<h2>Why BuddyPress and bbPress Were Initially Chosen to Run The Community Hub</h2>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/09/buddypress-logo-blue.png\" rel=\"prettyphoto[34733]\"><img class=\"alignright wp-image-30655 size-medium\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/09/buddypress-logo-blue.png?resize=300%2C142\" alt=\"buddypress-logo-blue\" /></a>In a <a title=\"blog.erlend.sh/foundation-redefined-going-back-to-specialised-applications/\" href=\"http://wptavern.com/blog.erlend.sh/foundation-redefined-going-back-to-specialised-applications/\">post announcing</a> the change, jMonkeyEngine Community Manager, Erlend Sogge Heggen, cites the biggest mistake he made is using the forum component bundled with BuddyPress. In his grand vision for the site in 2010, Heggen envisioned the community site to have the following features:</p>\n<ul>\n<li>Forums</li>\n<li>Social</li>\n<li>Galleries</li>\n<li>Wikis</li>\n<li>Files</li>\n<li>Advanced user profiles</li>\n<li>Unified search</li>\n</ul>\n<p>BuddyPress was chosen because it offers many of these features out of the box and integrates seamlessly with WordPress user tables. Over time, two particular problems arose.</p>\n<ol>\n<li>No one on the community management team would touch the BuddyPress code because of its complexity.</li>\n<li>Even though BuddyPress has the features Heggen wants, it doesn&#8217;t do any of them particularly well.</li>\n</ol>\n<p>This brought about the realization that his community didn&#8217;t care for the galleries, wikis, or the advanced user profiles. Heggen says it&#8217;s the forum user&#8217;s cared about most, &#8220;So now we were stuck with a sub-par forum that everyone used, and a bunch of other sub-par features that no one used. In pursuit of the all-encompassing solution, I had downgraded the heart and soul of our website, and by extension our community: The forum.&#8221;</p>\n<h2>Separate Software For Specific Tasks</h2>\n<p>Heggen says they&#8217;ll continue to use WordPress for now, but only for blogging. &#8220;The only users WordPress will handle is our small team of authors; it really isn&#8217;t designed well for anything other than administrative use anyhow.&#8221;</p>\n<p>Instead of using software that fulfills multiple purposes, Heggen will use software specific to the task at hand and use APIs to bridge them together. &#8220;In the age of JSON APIs and SPAs, you don&#8217;t need that &#8216;one foundation to rule them all.\'&#8221;</p>\n<h2>When is bbPress The Right Choice?</h2>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/bbpress.png\" rel=\"prettyphoto[34733]\"><img class=\"aligncenter size-large wp-image-24338\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/bbpress.png?resize=500%2C184\" alt=\"bbpress\" /></a></p>\n<p>jMonkeyEngine has determined that BuddyPress and bbPress are no longer the right choice to build its community on. In a <a title=\"http://blog.erlend.sh/when-is-bbpress-the-right-choice/\" href=\"http://blog.erlend.sh/when-is-bbpress-the-right-choice/\">follow up post</a>, Heggen asks, is bbPress even right for anyone? According to Heggen, the custom post type is a lie and the project never gets the attention it deserves. &#8220;It&#8217;s under the official WordPress umbrella, but it&#8217;s not part of their product strategy, so in effect it&#8217;s just another plugin developed by hobbyists in their spare time.&#8221;</p>\n<p>Unlike bbPress, <a title=\"http://www.discourse.org/\" href=\"http://www.discourse.org/\">Discourse</a> has a team of paid developers working full-time to create the best community engagement/discussion software on the web. In less than two years, it looks and feels light-years beyond what bbPress offers. It&#8217;s worth noting that, like bbPress, Discourse is <a title=\"http://www.discourse.org/faq/#license\" href=\"http://www.discourse.org/faq/#license\">GPLv2 licensed</a>.</p>\n<p>Heggen recommends using bbPress only if it&#8217;s going to be a small subset of the site&#8217;s entire offering but says, &#8220;You should strongly reconsider whether it&#8217;s worth having a forum at all, because in my honest opinion a forum is an &#8216;all or nothing&#8217; sort of deal. It&#8217;s either a key component of your website, or it&#8217;s going to become a graveyard quicker than you can say &#8216;Welcome to our community!\'&#8221;</p>\n<h2>Still Hopeful For bbPress&#8217; Future</h2>\n<p>Despite moving the jMonkeyEngine community off of bbPress to Discourse and his gripes about the project, Heggen believes it can still be a viable competitor, &#8220;I still firmly believe in bbPress as a competitor to the likes of Muut and Disqus. It hasn&#8217;t lived up to its potential yet, but with a full-time developer, it very well could.&#8221;</p>\n<p>If John James Jacoby&#8217;s <a title=\"http://wptavern.com/john-james-jacoby-launches-indiegogo-campaign-to-fund-buddypress-bbpress-and-glotpress-development\" href=\"http://wptavern.com/john-james-jacoby-launches-indiegogo-campaign-to-fund-buddypress-bbpress-and-glotpress-development\">Indiegogo campaign</a> is successful, there will be at least one paid full-time developer to work on both bbPress and BuddyPress for the next six months. With nine days left, he still needs over $5,700 to reach his goal.</p>\n<h2>Community Engagement Crossroads</h2>\n<p>Automattic, the WordPress project, and bbPress are at a crossroad. The comment system in WordPress leaves a <a title=\"http://www.poststat.us/wordpress-comments/\" href=\"http://www.poststat.us/wordpress-comments/\">lot to be desired</a> and could use some serious improvements. Meanwhile, Automattic is sitting on a dormant <a title=\"http://intensedebate.com/\" href=\"http://intensedebate.com/\">commenting service</a> that hasn&#8217;t made any progress in years. bbPress development continues at a snail&#8217;s pace since it doesn&#8217;t have a committed team of developers and there are no signs of improvement on the horizon, outside of Jacoby&#8217;s campaign.</p>\n<p>One of my favorite quotes from Matt Mullenweg is from 2008, when Automattic acquired IntenseDebate. In <a title=\"http://ma.tt/2008/09/intense-debate-goes-automattic/\" href=\"http://ma.tt/2008/09/intense-debate-goes-automattic/\">the announcement</a>, Mullenweg said the following:</p>\n<blockquote><p>Long-term, I think that comments are the most crucial interaction point for blogs, and an area that deserves a lot of investment and innovation. Comments really haven’t changed in a decade, and it’s time to spice things up a little.</p></blockquote>\n<p>I realize 2008 was a different time on the web, but in six years, I&#8217;ve seen very little innovation with comments. Instead, large sites are <a title=\"http://www.top5seo.co.uk/copyblogger-comments/\" href=\"http://www.top5seo.co.uk/copyblogger-comments/\">shutting them off</a> or moving to third-party services such as Disqus and <a title=\"http://web.livefyre.com/comments/\" href=\"http://web.livefyre.com/comments/\">Livefyre</a>. Jetpack Comments isn&#8217;t the solution because it&#8217;s just an iframe that is not easily extendable by other plugins.</p>\n<p>I don&#8217;t know what the answer is to having a great community engagement/discussion experience in WordPress but Jetpack Comments, bbPress, IntenseDebate, and the native comment system isn&#8217;t cutting it.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 06:57:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: InfiniteWP Client Plugin Releases Security Update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34791\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wptavern.com/infinitewp-client-plugin-releases-security-update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1789:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/InfiniteWPBannerHeader.png\" rel=\"prettyphoto[34791]\"><img class=\"aligncenter size-large wp-image-34792\" src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/InfiniteWPBannerHeader.png?resize=500%2C160\" alt=\"InfiniteWP Banner Header\" /></a>If you use the <a title=\"https://wordpress.org/plugins/iwp-client/\" href=\"https://wordpress.org/plugins/iwp-client/\">InfiniteWP Client</a> plugin, log into your sites and check for updates. According <a title=\"http://blog.sucuri.net/2014/12/security-advisory-high-severity-infinitewp-client-wordpress-plugin.html\" href=\"http://blog.sucuri.net/2014/12/security-advisory-high-severity-infinitewp-client-wordpress-plugin.html\">to Sucuri</a>, versions under 1.3.8 are susceptible to a privilege escalation attack as well as a potential Object Injection Vulnerability. InfiniteWP Client is used to communicate to the <a title=\"http://infinitewp.com/\" href=\"http://infinitewp.com/\">Infinite WP</a> service to manage WordPress sites remotely.</p>\n<p>A malicious individual can use the vulnerability to disable a website by putting it into maintenance mode. If an attacker knows the site&#8217;s administrator username, they can force the site to display malicious content. Once the site is in maintenance mode, the following items can be injected into the site.</p>\n<ul>\n<li>Javascript or iframe malware.</li>\n<li>Spam links</li>\n<li>Defacement messages (the infamous “hacked by” type of attack)</li>\n</ul>\n<p>You&#8217;re strongly encouraged to update the plugin as soon as possible. The patched version is 1.3.8 and <a title=\"https://wordpress.org/plugins/iwp-client/\" href=\"https://wordpress.org/plugins/iwp-client/\">is available</a> on the WordPress plugin directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 01:23:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: Add Wedding Registry Links to WordPress with the Bean Registry Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34692\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wptavern.com/add-wedding-registry-links-to-wordpress-with-the-bean-registry-plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3103:\"<p>Wedding themes are a highly niche market for what is oftentimes a once-in-a-lifetime event. Consequently, plugins that extend these themes for wedding-specific functionality are not as common as plugins for portfolios, testimonials, recipes, etc. If you develop wedding themes, you may want to check out <a href=\"http://themebeans.com/plugins/bean-registry/\" target=\"_blank\">Bean Registry</a>, a new free plugin created by the folks at <a href=\"http://themebeans.com/\" target=\"_blank\">ThemeBeans</a>.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-plugin.jpg\" rel=\"prettyphoto[34692]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-plugin.jpg?resize=1025%2C660\" alt=\"registry-plugin\" class=\"aligncenter size-full wp-image-34760\" /></a></p>\n<p>Adding links to registries is a common request for wedding themes, but it usually requires pasting a block of code into a page or hunting down logos and trying to size them to look nice with the theme. Bean Registry offers an attractive and convenient way to place and link store logos within the WordPress post editor.</p>\n<p>Once installed, the plugin adds a new button to the visual editor where the user can select from a dropdown list of the most common stores where people register.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-shortcode.jpg\" rel=\"prettyphoto[34692]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-shortcode.jpg?resize=750%2C595\" alt=\"registry-shortcode\" class=\"aligncenter size-full wp-image-34756\" /></a></p>\n<p>This will automatically insert the correct shortcode and the user can then paste the registry link into the URL attribute.</p>\n<p>The resulting display on the frontend will look different, depending on what theme you&#8217;re using. The example below is from an unmodified version of Twenty Fifteen.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-frontend.jpg\" rel=\"prettyphoto[34692]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/registry-frontend.jpg?resize=901%2C646\" alt=\"registry-frontend\" class=\"aligncenter size-full wp-image-34757\" /></a></p>\n<p>ThemeBeans developed the plugin for use with its new Emma wedding theme, which includes a <a href=\"http://demo.themebeans.com/?theme=Emma\" target=\"_blank\">live demo</a> of Bean Registry in action. Because it was created for a wedding theme, the 18 stores currently included in the plugin mostly cater to weddings. After receiving some initial feedback, ThemeBeans plans to add more baby stores to the list. Future versions of the plugin will make it more flexible for use with baby showers and announcements.</p>\n<p>The Bean Registry plugin could be a handy tool for WordPress theme developers who want to include support for it in their wedding themes. Instead of trying to build registry listings from scratch, the plugin can be styled to match your theme. <a href=\"http://themebeans.com/plugins/bean-registry/\" target=\"_blank\">Download</a> it for free from ThemeBeans.com.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Dec 2014 00:08:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WPTavern: WP Engine Sponsors John James Jacoby to Work on HHVM Compatibility with BuddyPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34700\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"http://wptavern.com/wp-engine-sponsors-john-james-jacoby-to-work-on-hhvm-compatibility-with-buddypress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4384:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/wp-engine.jpg\" rel=\"prettyphoto[34700]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/wp-engine.jpg?resize=1025%2C427\" alt=\"wp-engine\" class=\"aligncenter size-full wp-image-34106\" /></a></p>\n<p>WP Engine <a href=\"http://wpengine.com/2014/12/02/labs-sponsors-buddypress-hhvm-compatability/\" target=\"_blank\">announced</a> today that the company will be sponsoring John James Jacoby to work on HHVM compatibility for BuddyPress. Mercury, the host&#8217;s new <a href=\"http://wptavern.com/wp-engine-partners-with-10up-to-launch-enterprise-hhvm-wordpress-hosting-platform\" target=\"_blank\">enterprise HHVM WordPress hosting platform</a>, debuted last month with initial benchmarks indicating performance improvements of up to 600%.</p>\n<p>Jacoby is the project lead for BuddyPress and a former employee of <a href=\"http://10up.com/\" target=\"_blank\">10up</a>, the agency WP Engine partnered with to build Mercury. He also recently created an <a href=\"http://wptavern.com/hhvm-for-varying-vagrant-vagrants-wordpress-development-on-speed\" target=\"_blank\">HHVM configuration for Varying Vagrant Vagrants</a>, which makes it easy to test WordPress on HHVM in a local development environment.</p>\n<h3>Taking a Chance on BuddyPress</h3>\n<p>WP Engine is sponsoring the HHVM + BuddyPress compatibility work as part of its <a href=\"http://wpengine.com/labs\" target=\"_blank\">Labs project</a>, headed up by Tomas Puig. Labs is a separate team within the company that works on new technologies and open source contribution. &#8220;Right now we can&#8217;t even load test BuddyPress without it breaking,&#8221; Puig said.</p>\n<p>Why is WP Engine prioritizing BuddyPress compatibility with HHVM? The company is taking a chance on WordPress&#8217; premier social networking plugin and, if successful, will become the fastest hosting platform available for running BuddyPress.</p>\n<p>&#8220;We saw such a surge of interest when we announced Mercury. We don&#8217;t have a lot of BuddyPress customers,&#8221; Puig told the Tavern. &#8220;But I think if we get BuddyPress performing well for HHVM, then people will want to use it even more. Also, core and bbPress work great with HHVM so we felt the third project should too, so everyone can benefit.&#8221; The technical objectives of the compatibility effort are to get BuddyPress working at parity with how it currently runs on PHP-FPM.</p>\n<p>&#8220;In my mind i&#8217;d love to see the major WP projects work with it,&#8221; Puig said. &#8220;If we see a 3-8x improvement in speed, it&#8217;s going help everyone trying to deploy BuddyPress. Also, I think more people will use it if it&#8217;s easier to support high user loads.&#8221;</p>\n<p>Puig did not have immediate access to the number of WP Engine customers currently running BuddyPress, but he said the company will continue with the investment regardless of small usage numbers. &#8220;Technology, once it&#8217;s a performant, great option, will get adopted,&#8221; he said. &#8220;But once the main body of work and the tests are built it gets much easier to keep that way moving forward.&#8221;</p>\n<p>WP Engine is engaging the Facebook team on the effort as well, as there might be things in HHVM that are preventing it from being compatible with BuddyPress. The company contracted Jacoby to work on the project for the month of December, before he gets started on the new year with his <a href=\"http://wptavern.com/john-james-jacoby-launches-indiegogo-campaign-to-fund-buddypress-bbpress-and-glotpress-development\" target=\"_blank\">BuddyPress, bbPress, and GlotPress development</a>. &#8220;It&#8217;s a bit unknown how much code needs to change to make it HHVM compliant, so we wanted the person who is the most familiar with the code base,&#8221; Puig said.</p>\n<p>WP Engine sponsoring Jacoby to work on this initiative benefits the open source BuddyPress plugin in a couple of major ways. In addition to supporting the project lead in working with the software, the HHVM compatibility project also ensures the future of BuddyPress working with modern technologies. Many believe that HHVM is going to revolutionize PHP, which means that hosting companies will soon be rushing to adopt it. Investing in BuddyPress compatibility with HHVM now means that the plugin won&#8217;t be left in the dust.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Dec 2014 22:28:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: How to Send a Quick Email With an Attachment From The WordPress Admin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34682\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wptavern.com/how-to-send-a-quick-email-with-an-attachment-from-the-wordpress-admin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2150:\"<p>If you&#8217;d like to be able to send a quick email from the backend of WordPress, the <a title=\"https://wordpress.org/plugins/quick-mail/\" href=\"https://wordpress.org/plugins/quick-mail/\">Quick Mail</a> plugin developed by <a title=\"http://wheredidmybraingo.com\" href=\"http://wheredidmybraingo.com\">Mitchell D. Miller</a>, may be the answer. Once activated, you&#8217;ll see a Quick Mail link in the Tools Menu. Using the form, you can send a quick email to an individual with the ability to attach <strong>one</strong> item.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/QuickMailForm.png\" rel=\"prettyphoto[34682]\"><img class=\"size-full wp-image-34684\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/QuickMailForm.png?resize=902%2C673\" alt=\"The Quick Mail Email Form\" /></a>The Quick Mail Email Form\n<p>Quick Mail sends emails as plain-text, including URLs. The text in the Message field is sanitized using the <a title=\"http://codex.wordpress.org/Function_Reference/sanitize_text_field\" href=\"http://codex.wordpress.org/Function_Reference/sanitize_text_field\">sanitize_text_field</a> function. Quick Mail is limited to those who have the capability to publish posts. Those who do not have the necessary capabilities will not see <strong>Quick Mail</strong> as an option in the Tools Menu. Mitchell says it has been tested with WordPress 4.0.1, PHP 5.4, and 5.5. There are no PHP errors or warnings with <a title=\"enables debug mode throughout WordPress\" href=\"http://codex.wordpress.org/WP_DEBUG\">WP_DEBUG</a> turned on.</p>\n<p>I tested the plugin and found it works as advertised. One thing I don&#8217;t understand is the yellow background. I feel it&#8217;s unnecessary but not a deal breaker. Unlike using an address book, you need to know the exact email address you&#8217;re going to send to. Something I think would be useful is the ability to select a registered user as the recipient via a drop down menu.</p>\n<p>Other than that, the plugin lives up to its name as a quick way to send an email with an attachment. What other situations can you think of where this plugin would come in handy?</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Dec 2014 04:18:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: WPWeekly Episode 172 – Thankful For WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wptavern.com?p=34671&preview_id=34671\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wptavern.com/wpweekly-episode-172-thankful-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3680:\"<p>In this episode of WordPress Weekly, <a title=\"http://marcuscouch.com/\" href=\"http://marcuscouch.com/\">Marcus Couch</a> and I share the top six WordPress things we&#8217;re thankful for in 2014. It turns out, we&#8217;re both thankful for the WordPress community and its podcasters. We discovered there are over 20 different podcasts devoted to WordPress. When I started <a title=\"http://wptavern.com/wpweekly-episode-1-%E2%80%93-the-beginning-of-something-special\" href=\"http://wptavern.com/wpweekly-episode-1-%E2%80%93-the-beginning-of-something-special\">WordPress Weekly in 2008</a>, there were only two or three. After giving thanks, we discuss the news of the week.</p>\n<h2>Stories Discussed:</h2>\n<p><a title=\"http://wptavern.com/wordpress-4-0-1-is-a-critical-security-release-that-fixes-a-cross-site-scripting-vulnerability\" href=\"http://wptavern.com/wordpress-4-0-1-is-a-critical-security-release-that-fixes-a-cross-site-scripting-vulnerability\">WordPress 4.0.1 is a Critical Security Release that Fixes a Cross-Site Scripting Vulnerability</a><br />\n<a title=\"http://wptavern.com/cyberchimps-is-looking-for-investors\" href=\"http://wptavern.com/cyberchimps-is-looking-for-investors\"> CyberChimps is Looking For Investors</a><br />\n<a title=\"http://wptavern.com/wordpress-4-0-1-exposes-bad-development-practices-used-in-some-plugins\" href=\"http://wptavern.com/wordpress-4-0-1-exposes-bad-development-practices-used-in-some-plugins\"> WordPress 4.0.1 Exposes Bad Development Practices Used in Some Plugins</a><br />\n<a title=\"http://wptavern.com/wordpress-4-1-to-remove-custom-background-and-header-admin-screens\" href=\"http://wptavern.com/wordpress-4-1-to-remove-custom-background-and-header-admin-screens\"> WordPress 4.1 to Remove Custom Background and Header Admin Screens</a><br />\n<a title=\"http://wptavern.com/where-to-find-wordpress-related-black-friday-deals\" href=\"http://wptavern.com/where-to-find-wordpress-related-black-friday-deals\"> Where to Find WordPress Related Black Friday Deals</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a title=\"https://wordpress.org/plugins/gravity-forms-sticky-list/\" href=\"https://wordpress.org/plugins/gravity-forms-sticky-list/\">Gravity Forms Sticky List</a> is an add-on Gravity Forms that lets you list and edit entries from the front end. You can display a list on the front end where users can view, delete and edit submitted entries.</p>\n<p><a title=\"https://wordpress.org/plugins/woo-stickers-by-webline/\" href=\"https://wordpress.org/plugins/woo-stickers-by-webline/\">WOO Stickers by Webline</a> is a product sticker plugin to improve the customer experience while shopping by providing stickers for New, On Sale and Soldout Products. View the plugin listing screenshots to see it in action.</p>\n<p><a title=\"https://wordpress.org/plugins/category-sticky-post/\" href=\"https://wordpress.org/plugins/category-sticky-post/\">Category Sticky Post</a> allows you to mark a post to be displayed to the top of each archive page for a specified category.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, December 3rd 9:30 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #172:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Dec 2014 02:35:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: JP Bot: The Silent Bot Behind the Jetpack Module Extraction Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34615\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://wptavern.com/jp-bot-the-silent-bot-behind-the-jetpack-module-extraction-plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5655:\"<p>Automattic <a href=\"http://jetpack.me/2011/03/09/blast-off/\" target=\"_blank\">launched Jetpack</a> in March 2011 with the mission to bring WordPress.com features to self-hosted WordPress sites. The <a href=\"https://wordpress.org/plugins/jetpack/\" target=\"_blank\">plugin</a> has now been downloaded more than 13 million times. It is widely used and even comes installed by default on many hosts that offer a 1-click WordPress installation option.</p>\n<p>In early 2011, few could have predicted that Jetpack would grow to house 33 modules, each of which could technically be its own plugin. Because the Jetpack family of modules has grown to such a large number, the settings page now includes multiple ways to filter the modules in addition to a module search box.</p>\n<p>Despite the fact that the Jetpack team has made great strides towards <a href=\"http://wptavern.com/jetpack-3-0-released-adds-bulk-module-management-site-verification-and-twitter-open-graph-support\" target=\"_blank\">improving the settings interface</a> to support easy deactivation of unused modules, many WordPress users have reservations about using it.</p>\n<h3>JP Bot Provides Alternatives to Popular Jetpack Modules</h3>\n<p>Jetpack&#8217;s ever-growing codebase has prompted many WordPress users to seek out and create alternatives to some of its best features. A couple weeks ago, we featured <a href=\"http://wptavern.com/get-jetpacks-markdown-module-without-using-jetpack\" target=\"_blank\">JP Markdown</a>, a plugin that duplicates Jetpack&#8217;s markdown module. It was created by web engineer <a href=\"http://ahs.pw/\" target=\"_blank\">Anas Sulaiman</a> who is the face behind <a href=\"https://profiles.wordpress.org/wpjp/\" target=\"_blank\">JP Bot</a>, the WordPress.org account dedicated to his collection of Jetpack-extraction plugins.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/jp-bot-plugins.jpg\" rel=\"prettyphoto[34615]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/11/jp-bot-plugins.jpg?resize=700%2C222\" alt=\"jp-bot-plugins\" class=\"aligncenter size-full wp-image-33603\" /></a></p>\n<p>I spoke with Sulaiman to find out his motivation for performing the extractions. His work began with an appreciation of Jetpack. &#8220;I really liked some of its modules, but not others. I also didn&#8217;t like having to install a bunch of plugins (modules in terms of Jetpack) that I never used,&#8221; he said.</p>\n<p>Sulaiman decided to dive into the Jetpack code and make it work the way he wanted, taking full advantage of the plugin&#8217;s GPL licensing. &#8220;A couple of days later, I had four modules of Jetpack running as standalone plugins on my WordPress installation. It started with Jetpack Sharing, Jetpack Gravatar Hovercards, Jetpack Omnisearch, and Jetpack Widget Visibility. Later on, I decided it would be nice to share these plugins,&#8221; he said.</p>\n<p>Sulaiman has now released six Jetpack-extraction plugins under the JP Bot account. &#8220;I don&#8217;t like calling these plugins mine. I merely copied code from Jetpack, with very few modifications,&#8221; he said.</p>\n<p>What specific changes does he make when he duplicates the modules? Sulaiman said that the process of converting a Jetpack module into a standalone plugin is fairly simple:</p>\n<ol>\n<li>Copy all related files into a new folder.</li>\n<li>Scan the code and remove any Jetpack dependencies. It could be commenting out some lines of code or editing others. There is no lost functionality. If a module is dependent on other parts of Jetpack, those other parts are copied over and the lines of code that depend on them are edited to correct references.</li>\n<li>Add a link to the settings page, i.e. &#8220;Settings&#8221; for Jetpack Sharing and &#8220;Go to Widgets&#8221; for Jetpack Widget Visibility.</li>\n</ol>\n<p>WordPress users who appreciate Jetpack&#8217;s features, but have reservations about connecting to a third-party service, will find that the JP Bot plugins are a suitable alternative. The most important consideration is whether or not these plugins will be maintained and updated to reflect changes made to Jetpack.</p>\n<p>Sulaiman told the Tavern that he will make every effort to maintain his extractions but admits there may be some delays. At the moment, he is committed to keeping his collection up to date. &#8220;I don&#8217;t usually give up on my projects, but if I must, I make sure they stay alive,&#8221; he said.</p>\n<p>He makes no promises to add to the six plugins that currently comprise the collection but is open to the idea. &#8220;I already extracted and published the modules I like. If Jetpack adds a new module and I like it, there&#8217;s a good chance I&#8217;ll extract it and publish it,&#8221; Sulaiman said.</p>\n<p>The JP Bot collection comes with no guarantee of support. &#8220;I don&#8217;t provide support for any JP plugin, unless the issue cannot be reproduced using the original Jetpack,&#8221; he said. &#8220;99% of the time, the post should go to Jetpack support forums. However, it should be noted that Jetpack team doesn&#8217;t like providing support for others&#8217; plugins.&#8221; Sulaiman advises users to request support from Jetpack based on the original module in question, instead of referencing the JP Bot plugin.</p>\n<p>While he plans to share future Jetpack extractions with users and keep his plugins updated, Sulaiman hopes that users will understand his desire to remain in the background with no obligation of support. &#8220;For this and that, all JP plugins are now maintained by the JP Bot &#8211; a dedicated, intelligent, friendly and silent bot!&#8221;</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Dec 2014 02:09:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WPTavern: DawnPatrol Gives Fringe WordPress Communities a Voice\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=32822\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wptavern.com/dawnpatrol-gives-fringe-wordpress-communities-a-voice\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3225:\"<p><a title=\"http://dawnpatrol.io/\" href=\"http://dawnpatrol.io/\">DawnPatrol</a> is a new project by Scott Basgaard and Noel Tock of <a title=\"http://hmn.md/\" href=\"http://hmn.md/\">HumanMade.</a> The site is billed as a <em>community experiment</em> that features video clips of WordCamp participants from across the world. With non-English downloads of WordPress <a title=\"http://www.poststat.us/matt-mullenwegs-2014-state-word/\" href=\"http://www.poststat.us/matt-mullenwegs-2014-state-word/\">overtaking the number of English downloads</a> for the first time this year, non-English speaking WordPress communities have become the silent majority. Using video and images, DawnPatrol gives fringe communities a voice.</p>\n<p>In some of the videos, attendees don&#8217;t speak English. DawnPatrol uses <a title=\"http://vimeo.com/\" href=\"http://vimeo.com/\">Vimeo </a>and working with <a title=\"http://www.amara.org/\" href=\"http://www.amara.org/\">Amara</a>, anyone can help to eliminate language barriers by contributing translated subtitles. The videos are licensed under <a class=\"markup--anchor markup--p-anchor\" href=\"http://creativecommons.org/licenses/by-nc/4.0/\" target=\"_blank\" rel=\"nofollow\">CC 4.0 BY-NC, </a>which means you must provide attribution and can not use them for commercial purposes. To view subtitles, look for the CC near the volume icon and select a language.</p>\n<p></p>\n<p>Each WordCamp seems to have its own character. DawnPatrol highlights the things and people who make each event unique. For example, every Japanese WordCamp, meetup, etc, uses a variant of its mascot, <a title=\"https://github.com/jawordpressorg/wapuu\" href=\"https://github.com/jawordpressorg/wapuu\">Wapuu</a>. It&#8217;s the little things in a local geographic area which almost guarantee they won&#8217;t become cookie cutter events.</p>\n<a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/WapuuMascot.jpg\" rel=\"prettyphoto[32822]\"><img class=\"wp-image-34629 size-full\" src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/WapuuMascot.jpg?resize=1025%2C685\" alt=\"A Wapuu For Everyone\" /></a>Image Courtesy of <a title=\"http://dawnpatrol.io/\" href=\"http://dawnpatrol.io/\">DawnPatrol.io</a>\n<p>So far this year, the WordPress Foundation has helped <a title=\"http://wordcamp.org/\" href=\"http://wordcamp.org/\">346 WordCamps in 48 countries</a> take place. Tock wants to expand on what the Foundation has done by creating entirely new events to bring people together. &#8220;Our ideas range from <em class=\"markup--em markup--p-em\">open retreats</em> (surfing, climbing and other outdoor activities to balance work and lifestyle) to <em class=\"markup--em markup--p-em\">non-profit contribution days </em>(similar to contributor days).&#8221; If you&#8217;re interested in finding out when events are scheduled, consider signing up to the DawnPatrol <a title=\"http://eepurl.com/6Kbw1\" href=\"http://eepurl.com/6Kbw1\">newsletter.</a></p>\n<p>DawnPatrol is a neat experiment because it fills a void and is a great way to showcase what makes fringe communities unique. Take a look at <a title=\"http://dawnpatrol.io/\" href=\"http://dawnpatrol.io/\">the site</a>, watch some of the videos and let us know what you think.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 02 Dec 2014 00:37:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"WPTavern: Nested Pages for WordPress: An Intuitive Drag-and-Drop Interface for Managing Pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=34553\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"http://wptavern.com/nested-pages-for-wordpress-an-intuitive-drag-and-drop-interface-for-managing-pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4917:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/nested-pages.png\" rel=\"prettyphoto[34553]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/12/nested-pages.png?resize=772%2C250\" alt=\"nested-pages\" class=\"aligncenter size-full wp-image-34576\" /></a></p>\n<p>When WordPress is used as a CMS, <a href=\"http://codex.wordpress.org/Pages\" target=\"_blank\">pages</a> are one of the most common ways for structuring content that doesn&#8217;t require the use of taxonomies. Unlike posts, pages are not arranged chronologically, but are instead interrelated with other pages by hierarchy. Some sites have hundreds or even thousands of parent and child pages.</p>\n<p>WordPress includes a very simple UI for indicating if a page is a subpage, but moving pages around within that structure can be a cumbersome process. That&#8217;s why developer <a href=\"https://github.com/kylephillips\" target=\"_blank\">Kyle Phillips</a> decided to create the <a href=\"http://nestedpages.com/\" target=\"_blank\">Nested Pages</a> plugin, which offers an intuitive drag-and-drop interface for page management. The plugin revamps the pages screen to make it cleaner and more user friendly.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nestedpages-screenshot.png\" rel=\"prettyphoto[34553]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nestedpages-screenshot.png?resize=741%2C516\" alt=\"nestedpages-screenshot\" class=\"aligncenter size-full wp-image-34587\" /></a></p>\n<p>Nested Pages arranges the page list in an expandable, sortable tree view where individual pages can be dragged into place. The UI is also touch-friendly, so mobile users can tap and drag to manage pages. It works in a similar way to WordPress&#8217; menu system.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/sorting-pages.gif\" rel=\"prettyphoto[34553]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/12/sorting-pages.gif?resize=1025%2C586\" alt=\"sorting-pages\" class=\"aligncenter size-full wp-image-34578\" /></a></p>\n<p>&#8220;I work on client sites full-time, and many times those sites have large page hierarchies that are difficult to manage within the native Pages listing,&#8221; Phillips said. &#8220;This proved to be a frustration point with clients.</p>\n<p>Nested Pages is unique in that it maintains the availability of the Quick Edit feature in the revamped pages interface with all the standard fields and a few extra custom fields for setting menu and visibility options. &#8220;While there are many &#8216;drag-and-drop&#8217; page administration plugins available, I could not find any that maintained quick edit functionality and did so in a clean, intuitive way,&#8221; Phillips said, explaining his inspiration for creating the plugin.</p>\n<p>Nested Pages also has a convenient feature where it will generate a native WordPress menu automatically to match your pages screen. &#8220;In designing the plugin, I was definitely inspired by the way other content management systems tackled this problem,&#8221; Phillips said. &#8220;In keeping with the &#8216;WordPress way&#8217;, I decided to include a menu that automatically synchronizes with page changes (while providing menu editing within the Quick Edit interface).&#8221;</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nestedpages-wordpress-auto-menu.png\" rel=\"prettyphoto[34553]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/12/nestedpages-wordpress-auto-menu.png?resize=729%2C485\" alt=\"nestedpages-wordpress-auto-menu\" class=\"aligncenter size-full wp-image-34596\" /></a></p>\n<p>So far, Phillips said the plugin has been well received since he released it a few weeks ago. Since that time, he has worked out a few small bugs and design considerations. &#8220;I&#8217;ve included the plugin in all my client work recently,&#8221; he said. &#8220;Clients have all assumed that it was part of the native WordPress interface (which I can only take as a good sign).&#8221;</p>\n<p>Nested Pages requires WordPress 3.8 or higher, and PHP version 5.3+. After testing the plugin, I found that it works smoothly, as page sorting and nesting are both saved in the background as you make changes to the structure. The plugin provides an elegant implementation of drag-and-drop page management and has the added benefit of cleaning up the pages screen with the expandable tree view. Phillips has incorporated all of these features while making it look like a natural part of WordPress.</p>\n<p>Nested pages is one of the best CMS-enhancing plugins I&#8217;ve seen in a long time. You can <a href=\"https://wordpress.org/plugins/wp-nested-pages/\" target=\"_blank\">download</a> it directly from WordPress.org. A full list of features, documentation, and FAQ are available on the <a href=\"http://nestedpages.com/\" target=\"_blank\">Nested Pages</a> website.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 01 Dec 2014 22:18:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 18 Dec 2014 12:59:57 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"245671\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 18 Dec 2014 12:45:13 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20141124234515\";}", "no");
INSERT INTO `wp_options` VALUES("186", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1418950798", "no");
INSERT INTO `wp_options` VALUES("187", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1418907598", "no");
INSERT INTO `wp_options` VALUES("188", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1418950798", "no");
INSERT INTO `wp_options` VALUES("189", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 18 Dec 2014 12:53:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet Web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Google Analytics by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2316@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"Track your WordPress site easily with the latest tracking codes and lots added data for search result pages and error pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Your WordPress, Streamlined.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using Yoast&#039;s WordPress SEO plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"W3 Total Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/w3-total-cache/#post-12073\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2009 18:46:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12073@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"Easy Web Performance Optimization (WPO) using caching: browser, page, object, database, minify and content delivery network support.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Frederick Townes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"The easiest, most effective way to secure WordPress in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"UpdraftPlus Backup and Restoration\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/updraftplus/#post-38058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 May 2012 15:14:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"38058@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Backup and restoration made easy. Complete backups; manual or scheduled (backup to S3, Dropbox, Google Drive, Rackspace, FTP, SFTP, email + others).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Anderson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Google Analytics Dashboard for WP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://wordpress.org/plugins/google-analytics-dashboard-for-wp/#post-50539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 10 Mar 2013 17:07:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"50539@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Displays Google Analytics reports and real-time statistics in your WordPress Dashboard. Inserts the latest tracking code in every page of your site.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alin Marcu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 10 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Wordfence Security is a free enterprise class security and performance plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:46:\"https://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Thu, 18 Dec 2014 12:59:58 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 09 Mar 2007 22:11:30 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20141124234515\";}", "no");
INSERT INTO `wp_options` VALUES("190", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1418950798", "no");
INSERT INTO `wp_options` VALUES("191", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1418907598", "no");
INSERT INTO `wp_options` VALUES("192", "_transient_timeout_plugin_slugs", "1419031719", "no");
INSERT INTO `wp_options` VALUES("193", "_transient_plugin_slugs", "a:12:{i:0;s:19:\"akismet/akismet.php\";i:1;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:2;s:33:\"ama_search_bar/ama_search_bar.php\";i:3;s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";i:4;s:48:\"covertstorecontent/covertstorecontent-plugin.php\";i:5;s:25:\"duplicator/duplicator.php\";i:6;s:19:\"jetpack/jetpack.php\";i:7;s:37:\"super-socializer/super_socializer.php\";i:8;s:27:\"wp-super-cache/wp-cache.php\";i:9;s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";i:10;s:26:\"youtube-widget/youtube.php\";i:11;s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";}", "no");
INSERT INTO `wp_options` VALUES("194", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1418950798", "no");
INSERT INTO `wp_options` VALUES("195", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2014/12/wordpress-4-1-release-candidate-3/\'>WordPress 4.1 Release Candidate 3</a> <span class=\"rss-date\">December 18, 2014</span><div class=\"rssSummary\">The next release candidate for WordPress 4.1 is now available for testing. Seventy changes have gone in since the first release candidate. With no known issues left, we plan to release 4.1 tomorrow, December 18. To test, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the release candidate here (zip). If you’d like to learn more about [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wptavern.com/intergalactic-a-bold-free-wordpress-theme-from-automattic\'>WPTavern: Intergalactic: A Bold Free WordPress Theme from Automattic</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/how-to-take-control-of-the-wordpress-heartbeat-api\'>WPTavern: How to Take Control of The WordPress Heartbeat API</a></li><li><a class=\'rsswidget\' href=\'http://wptavern.com/atlanta-wordpress-coders-guild-a-new-meetup-for-designers-and-programmers\'>WPTavern: Atlanta WordPress Coders Guild: A New Meetup for Designers and Programmers</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'https://wordpress.org/plugins/google-analytics-dashboard-for-wp/\' class=\'dashboard-news-plugin-link\'>Google Analytics Dashboard for WP</a>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=google-analytics-dashboard-for-wp&amp;_wpnonce=e8fe6f99d5&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Google Analytics Dashboard for WP\'>Install</a>)</span></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("200", "_transient_twentyfourteen_category_count", "1", "yes");
INSERT INTO `wp_options` VALUES("202", "theme_mods_twentyfourteen", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1418907641;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("203", "current_theme", "Covert Store Builder Theme", "yes");
INSERT INTO `wp_options` VALUES("204", "theme_mods_covertstorebuilder", "a:9:{i:0;b:0;s:16:\"background_color\";s:6:\"7e0000\";s:16:\"header_textcolor\";s:6:\"ffffff\";s:16:\"background_image\";s:71:\"http://beauty.demobay.info/wp-content/uploads/2014/12/cream-3027381.jpg\";s:22:\"background_image_thumb\";s:79:\"http://beauty.demobay.info/wp-content/uploads/2014/12/cream-3027381-150x150.jpg\";s:17:\"background_repeat\";s:6:\"repeat\";s:21:\"background_position_x\";s:4:\"left\";s:21:\"background_attachment\";s:6:\"scroll\";s:18:\"nav_menu_locations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("205", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("208", "csblic_key", "AP-09L192439X323780D", "yes");
INSERT INTO `wp_options` VALUES("209", "csblic_status", "COMPLETED", "yes");
INSERT INTO `wp_options` VALUES("210", "_transient_timeout_csblic_lastcheck", "1418950891", "no");
INSERT INTO `wp_options` VALUES("211", "_transient_csblic_lastcheck", "AP-09L192439X323780D", "no");
INSERT INTO `wp_options` VALUES("212", "imwb_zonpress_theme_options", "a:124:{s:10:\"faviconurl\";s:0:\"\";s:9:\"defOGPImg\";s:0:\"\";s:11:\"headerbgcol\";s:7:\"#9f0000\";s:14:\"sitemenutxtcol\";s:7:\"#f8e8e9\";s:13:\"headerscripts\";s:0:\"\";s:8:\"hidemenu\";s:1:\"N\";s:9:\"menubgcol\";s:7:\"#610000\";s:10:\"menutxtcol\";s:7:\"#f8e8e9\";s:13:\"menuseltxtcol\";s:7:\"#ffffff\";s:12:\"homepagemenu\";s:1:\"N\";s:7:\"mrsmenu\";s:1:\"N\";s:10:\"mrsmenutxt\";s:11:\"What\\\'s New\";s:12:\"mrsmenutitle\";s:15:\"See What\\\'s New\";s:11:\"includecats\";s:9:\"3,5,1,4,2\";s:12:\"othercatmenu\";s:1:\"Y\";s:15:\"othercatmenutxt\";s:4:\"More\";s:11:\"excludecats\";s:0:\"\";s:12:\"posthidemenu\";s:1:\"N\";s:13:\"postmenubgcol\";s:7:\"#610000\";s:14:\"postmenutxtcol\";s:7:\"#f8e8e9\";s:17:\"postmenuseltxtcol\";s:7:\"#ffffff\";s:11:\"postmrsmenu\";s:1:\"N\";s:14:\"postmrsmenutxt\";s:6:\"Newest\";s:11:\"posttrsmenu\";s:1:\"N\";s:14:\"posttrsmenutxt\";s:7:\"Popular\";s:11:\"posthpsmenu\";s:1:\"N\";s:14:\"posthpsmenutxt\";s:13:\"Highest Price\";s:11:\"postlpsmenu\";s:1:\"N\";s:14:\"postlpsmenutxt\";s:12:\"Lowest Price\";s:10:\"hidesearch\";s:1:\"N\";s:10:\"searchtext\";s:13:\"Find Stuff...\";s:10:\"hidefooter\";s:1:\"N\";s:14:\"hidesocialbtns\";s:1:\"N\";s:11:\"twitteruser\";s:0:\"\";s:12:\"facebookuser\";s:0:\"\";s:10:\"googleuser\";s:0:\"\";s:13:\"pinterestuser\";s:0:\"\";s:10:\"reddituser\";s:0:\"\";s:10:\"rssfeedurl\";s:32:\"http://beauty.demobay.info/feed/\";s:11:\"hiderotator\";s:1:\"N\";s:11:\"fplistorder\";s:1:\"0\";s:15:\"postsperrotator\";s:2:\"10\";s:12:\"delayrotator\";s:1:\"5\";s:13:\"fpexcludecats\";s:0:\"\";s:7:\"fpbgcol\";s:7:\"#ffffff\";s:8:\"fpbdrcol\";s:7:\"#ffffff\";s:10:\"fptitlecol\";s:7:\"#9f0000\";s:13:\"fptitlehvrcol\";s:7:\"#a03a18\";s:10:\"fppricecol\";s:7:\"#7e0000\";s:9:\"fpdesccol\";s:7:\"#430000\";s:11:\"fphideprice\";s:1:\"N\";s:9:\"listorder\";s:1:\"0\";s:13:\"hpexcludecats\";s:0:\"\";s:10:\"linknewwin\";s:1:\"1\";s:11:\"usenofollow\";s:1:\"1\";s:12:\"sidebarbgcol\";s:7:\"#ffffff\";s:16:\"widgettitlebgcol\";s:7:\"#f7f7f7\";s:17:\"widgettitletxtcol\";s:7:\"#610000\";s:9:\"showtitle\";s:1:\"1\";s:11:\"postcontent\";s:1:\"E\";s:9:\"postchars\";s:3:\"100\";s:12:\"postmoretext\";s:6:\"[More]\";s:12:\"shareoptions\";s:5:\"F,T,P\";s:9:\"postbgcol\";s:7:\"#f7f7f7\";s:12:\"posttitlecol\";s:7:\"#610000\";s:15:\"posttitlehvrcol\";s:7:\"#a03a18\";s:11:\"postdesccol\";s:7:\"#430000\";s:13:\"postprdbtntxt\";s:13:\"Check It Out!\";s:16:\"postprdbtntxtcol\";s:7:\"#FFFFFF\";s:15:\"postprdbtnbgcol\";s:7:\"#628523\";s:18:\"postprdbtnbghvrcol\";s:7:\"#496812\";s:12:\"hideptthumbs\";s:1:\"N\";s:13:\"ptthumbsshown\";s:1:\"6\";s:11:\"ptprdbtntxt\";s:8:\"Buy Now!\";s:11:\"hidepttitle\";s:1:\"N\";s:11:\"hideptprice\";s:1:\"N\";s:13:\"hideptdetails\";s:1:\"N\";s:11:\"commenttype\";s:1:\"0\";s:7:\"fbappid\";s:0:\"\";s:15:\"hideptlikestats\";s:1:\"N\";s:17:\"hideptcommenttime\";s:1:\"N\";s:11:\"pagesidebar\";s:1:\"0\";s:11:\"postsidebar\";s:1:\"2\";s:10:\"catsidebar\";s:1:\"2\";s:12:\"hidecatprice\";s:1:\"N\";s:11:\"hidecatdesc\";s:1:\"N\";s:11:\"postspercat\";s:2:\"12\";s:11:\"hidepgtitle\";s:1:\"N\";s:14:\"hidepgcomments\";s:1:\"N\";s:11:\"footerbgcol\";s:7:\"#7e0000\";s:12:\"footertxtcol\";s:7:\"#ffffff\";s:16:\"footertxtlinkcol\";s:7:\"#DDDDDD\";s:19:\"footertxtlinkhvrcol\";s:7:\"#DDDDDD\";s:15:\"addwishlisttext\";s:18:\"+ Add To Wish List\";s:14:\"onwishlisttext\";s:17:\"On Your Wish List\";s:15:\"delwishlisttext\";s:21:\"Remove From Wish List\";s:12:\"wishlisttext\";s:9:\"Wish List\";s:15:\"wishlistsidebar\";s:1:\"0\";s:14:\"wlshareoptions\";s:5:\"F,T,P\";s:11:\"wlsharetext\";s:22:\"Check out my Wish List\";s:18:\"newmemberadminmail\";s:1:\"1\";s:13:\"newmembermail\";s:1:\"1\";s:17:\"newmembermailsubj\";s:40:\"[{SITE_NAME}] Your username and password\";s:17:\"newmembermailbody\";s:99:\"Thank you for registering with: {SITE_NAME}\r\nUsername: {USERNAME}\r\nPassword: {PASSWORD}\r\n{SITE_URL}\";s:14:\"custdefaultimg\";s:0:\"\";s:10:\"titlelinks\";s:1:\"1\";s:10:\"imagelinks\";s:1:\"0\";s:11:\"buttonlinks\";s:1:\"0\";s:17:\"newmemberaroption\";s:1:\"N\";s:16:\"aweber_auth_code\";s:0:\"\";s:19:\"aweber_consumer_key\";s:0:\"\";s:22:\"aweber_consumer_secret\";s:0:\"\";s:17:\"aweber_access_key\";s:0:\"\";s:20:\"aweber_access_secret\";s:0:\"\";s:11:\"aweber_list\";s:0:\"\";s:19:\"getresponse_api_key\";s:0:\"\";s:20:\"getresponse_campaign\";s:0:\"\";s:10:\"ar_formurl\";s:0:\"\";s:7:\"ar_form\";s:0:\"\";s:15:\"ar_formfldemail\";s:0:\"\";s:14:\"ar_formfldname\";s:0:\"\";s:16:\"newmembercaptcha\";s:1:\"1\";s:15:\"homepagescripts\";s:0:\"\";s:11:\"licensecode\";s:20:\"AP-09L192439X323780D\";}", "yes");
INSERT INTO `wp_options` VALUES("222", "aioseop_options", "a:74:{s:12:\"aiosp_donate\";N;s:16:\"aiosp_home_title\";N;s:22:\"aiosp_home_description\";s:0:\"\";s:20:\"aiosp_togglekeywords\";i:0;s:19:\"aiosp_home_keywords\";N;s:9:\"aiosp_can\";i:1;s:30:\"aiosp_no_paged_canonical_links\";i:0;s:20:\"aiosp_rewrite_titles\";i:1;s:20:\"aiosp_force_rewrites\";i:1;s:24:\"aiosp_use_original_title\";i:0;s:16:\"aiosp_cap_titles\";i:1;s:14:\"aiosp_cap_cats\";i:1;s:23:\"aiosp_page_title_format\";s:27:\"%page_title% | %blog_title%\";s:23:\"aiosp_post_title_format\";s:27:\"%post_title% | %blog_title%\";s:27:\"aiosp_category_title_format\";s:31:\"%category_title% | %blog_title%\";s:26:\"aiosp_archive_title_format\";s:30:\"%archive_title% | %blog_title%\";s:23:\"aiosp_date_title_format\";s:21:\"%date% | %blog_title%\";s:25:\"aiosp_author_title_format\";s:23:\"%author% | %blog_title%\";s:22:\"aiosp_tag_title_format\";s:20:\"%tag% | %blog_title%\";s:25:\"aiosp_search_title_format\";s:23:\"%search% | %blog_title%\";s:24:\"aiosp_description_format\";s:13:\"%description%\";s:22:\"aiosp_404_title_format\";s:33:\"Nothing found for %request_words%\";s:18:\"aiosp_paged_format\";s:14:\" - Part %page%\";s:17:\"aiosp_enablecpost\";s:2:\"on\";s:19:\"aiosp_cpostadvanced\";i:0;s:17:\"aiosp_cpostactive\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:18:\"aiosp_cpostnoindex\";a:0:{}s:19:\"aiosp_cpostnofollow\";a:0:{}s:17:\"aiosp_cposttitles\";i:0;s:21:\"aiosp_posttypecolumns\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:15:\"aiosp_admin_bar\";s:2:\"on\";s:23:\"aiosp_custom_menu_order\";s:2:\"on\";s:19:\"aiosp_google_verify\";s:0:\"\";s:17:\"aiosp_bing_verify\";s:0:\"\";s:22:\"aiosp_pinterest_verify\";s:0:\"\";s:22:\"aiosp_google_publisher\";s:0:\"\";s:28:\"aiosp_google_disable_profile\";i:0;s:28:\"aiosp_google_author_advanced\";i:0;s:28:\"aiosp_google_author_location\";a:1:{i:0;s:3:\"all\";}s:29:\"aiosp_google_enable_publisher\";s:2:\"on\";s:30:\"aiosp_google_specify_publisher\";N;s:20:\"aiosp_google_connect\";N;s:25:\"aiosp_google_analytics_id\";N;s:32:\"aiosp_ga_use_universal_analytics\";i:0;s:15:\"aiosp_ga_domain\";N;s:21:\"aiosp_ga_multi_domain\";i:0;s:21:\"aiosp_ga_anonymize_ip\";N;s:28:\"aiosp_ga_display_advertising\";N;s:22:\"aiosp_ga_exclude_users\";N;s:29:\"aiosp_ga_track_outbound_links\";i:0;s:20:\"aiosp_use_categories\";i:0;s:26:\"aiosp_use_tags_as_keywords\";i:1;s:32:\"aiosp_dynamic_postspage_keywords\";i:1;s:22:\"aiosp_category_noindex\";i:1;s:26:\"aiosp_archive_date_noindex\";i:1;s:28:\"aiosp_archive_author_noindex\";i:1;s:18:\"aiosp_tags_noindex\";i:0;s:20:\"aiosp_search_noindex\";i:0;s:23:\"aiosp_paginated_noindex\";i:0;s:24:\"aiosp_paginated_nofollow\";i:0;s:11:\"aiosp_noodp\";i:0;s:12:\"aiosp_noydir\";i:0;s:27:\"aiosp_generate_descriptions\";i:1;s:20:\"aiosp_run_shortcodes\";i:0;s:33:\"aiosp_hide_paginated_descriptions\";i:0;s:32:\"aiosp_dont_truncate_descriptions\";i:0;s:19:\"aiosp_schema_markup\";i:1;s:20:\"aiosp_unprotect_meta\";i:0;s:14:\"aiosp_ex_pages\";s:0:\"\";s:20:\"aiosp_post_meta_tags\";s:0:\"\";s:20:\"aiosp_page_meta_tags\";s:0:\"\";s:21:\"aiosp_front_meta_tags\";s:0:\"\";s:20:\"aiosp_home_meta_tags\";s:0:\"\";s:12:\"aiosp_do_log\";N;}", "yes");
INSERT INTO `wp_options` VALUES("224", "the_champ_ss_version", "3.4.2", "yes");
INSERT INTO `wp_options` VALUES("225", "the_champ_login", "a:9:{s:5:\"title\";s:25:\"Login with your Social ID\";s:19:\"email_error_message\";s:50:\"Email you entered is already registered or invalid\";s:6:\"avatar\";i:1;s:14:\"email_required\";i:1;s:14:\"password_email\";i:1;s:16:\"email_popup_text\";s:65:\"Please enter a valid email address. You may require to verify it.\";s:13:\"enableAtLogin\";i:1;s:16:\"enableAtRegister\";i:1;s:15:\"enableAtComment\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("226", "the_champ_facebook", "a:7:{s:17:\"enable_fbcomments\";s:1:\"1\";s:11:\"feedMessage\";s:35:\"Has just logged into %website-name%\";s:12:\"comment_lang\";s:5:\"en_US\";s:9:\"feed_link\";s:26:\"http://beauty.demobay.info\";s:10:\"load_first\";i:1;s:9:\"switch_wp\";s:28:\"Switch to default commenting\";s:9:\"switch_fb\";s:29:\"Switch to Facebook commenting\";}", "yes");
INSERT INTO `wp_options` VALUES("227", "the_champ_sharing", "a:25:{s:6:\"enable\";s:1:\"1\";s:14:\"delete_options\";s:1:\"1\";s:14:\"bitly_username\";s:0:\"\";s:9:\"bitly_key\";s:0:\"\";s:16:\"twitter_username\";s:0:\"\";s:5:\"title\";s:13:\"Share the joy\";s:9:\"providers\";a:8:{i:0;s:8:\"facebook\";i:1;s:7:\"twitter\";i:2;s:8:\"linkedin\";i:3;s:6:\"google\";i:4;s:6:\"reddit\";i:5;s:9:\"delicious\";i:6;s:11:\"stumbleupon\";i:7;s:9:\"pinterest\";}s:23:\"horizontal_re_providers\";a:8:{i:0;s:8:\"facebook\";i:1;s:7:\"twitter\";i:2;s:6:\"google\";i:3;s:8:\"linkedin\";i:4;s:9:\"pinterest\";i:5;s:6:\"reddit\";i:6;s:9:\"delicious\";i:7;s:11:\"stumbleupon\";}s:3:\"top\";s:1:\"1\";s:6:\"bottom\";s:1:\"1\";s:4:\"home\";s:1:\"1\";s:4:\"post\";s:1:\"1\";s:4:\"page\";s:1:\"1\";s:7:\"excerpt\";s:1:\"1\";s:15:\"vertical_enable\";s:1:\"1\";s:18:\"vertical_providers\";a:8:{i:0;s:8:\"facebook\";i:1;s:7:\"twitter\";i:2;s:8:\"linkedin\";i:3;s:6:\"google\";i:4;s:6:\"reddit\";i:5;s:9:\"delicious\";i:6;s:11:\"stumbleupon\";i:7;s:9:\"pinterest\";}s:21:\"vertical_re_providers\";a:8:{i:0;s:8:\"facebook\";i:1;s:7:\"twitter\";i:2;s:6:\"google\";i:3;s:8:\"linkedin\";i:4;s:9:\"pinterest\";i:5;s:6:\"reddit\";i:6;s:9:\"delicious\";i:7;s:11:\"stumbleupon\";}s:11:\"vertical_bg\";s:0:\"\";s:9:\"alignment\";s:4:\"left\";s:11:\"left_offset\";s:1:\"0\";s:12:\"right_offset\";s:1:\"0\";s:10:\"top_offset\";s:3:\"100\";s:13:\"vertical_post\";s:1:\"1\";s:13:\"vertical_page\";s:1:\"1\";s:16:\"vertical_excerpt\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("234", "asd_version", "02.02.02", "yes");
INSERT INTO `wp_options` VALUES("236", "external_updates-ama_search_bar", "O:8:\"stdClass\":3:{s:9:\"lastCheck\";i:1418908194;s:14:\"checkedVersion\";s:5:\"2.2.2\";s:6:\"update\";O:8:\"stdClass\":6:{s:2:\"id\";i:0;s:4:\"slug\";s:14:\"ama_search_bar\";s:7:\"version\";s:5:\"2.2.2\";s:8:\"homepage\";s:23:\"http://amasearchbar.com\";s:12:\"download_url\";s:69:\"http://wppluginupdate.com/package-download.php?product=ama_search_bar\";s:14:\"upgrade_notice\";s:37:\"Get latest bugfixes and improvements.\";}}", "yes");
INSERT INTO `wp_options` VALUES("237", "widget_youtube", "a:6:{s:5:\"title\";s:14:\"10 Beauty Tips\";s:5:\"video\";s:43:\"https://www.youtube.com/watch?v=2ytTFnKLrAk\";s:7:\"videoid\";s:43:\"https://www.youtube.com/watch?v=2ytTFnKLrAk\";s:5:\"width\";s:3:\"200\";s:6:\"height\";s:3:\"165\";s:8:\"autoplay\";s:1:\"0\";}", "yes");
INSERT INTO `wp_options` VALUES("239", "widget_youtube_responsive", "a:2:{i:2;a:26:{s:5:\"title\";s:18:\"Top 10 Beauty Tips\";s:5:\"video\";s:43:\"https://www.youtube.com/watch?v=2ytTFnKLrAk\";s:8:\"autohide\";i:2;s:8:\"autoplay\";i:0;s:7:\"cc_load\";i:0;s:7:\"cc_lang\";s:0:\"\";s:5:\"color\";s:3:\"red\";s:8:\"controls\";i:1;s:9:\"disablekb\";i:0;s:5:\"end_m\";s:1:\"0\";s:5:\"end_s\";s:1:\"0\";s:15:\"allowfullscreen\";i:0;s:14:\"iv_load_policy\";i:1;s:4:\"loop\";i:0;s:14:\"modestbranding\";i:0;s:9:\"suggested\";i:0;s:8:\"showinfo\";i:0;s:7:\"start_m\";s:1:\"0\";s:7:\"start_s\";s:1:\"0\";s:5:\"theme\";s:4:\"dark\";s:7:\"quality\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:5:\"style\";s:0:\"\";s:4:\"maxw\";s:3:\"300\";s:3:\"w3c\";i:1;s:7:\"privacy\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("248", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1418952315", "yes");
INSERT INTO `wp_options` VALUES("249", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"4851\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"3015\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2967\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"2471\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"2299\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1879\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1692\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1646\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1639\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1623\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1584\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1564\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1469\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:4:\"1290\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:4:\"1243\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:4:\"1158\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:4:\"1134\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:4:\"1065\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:4:\"1051\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"888\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"883\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"864\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"826\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"823\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"772\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"741\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"740\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"694\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"682\";}s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";s:3:\"662\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"655\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"645\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"640\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"630\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"630\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"616\";}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";s:3:\"608\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"590\";}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"Share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";s:3:\"583\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"577\";}}", "yes");
INSERT INTO `wp_options` VALUES("252", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("254", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:57:\"https://downloads.wordpress.org/release/wordpress-4.1.zip\";s:10:\"no_content\";s:68:\"https://downloads.wordpress.org/release/wordpress-4.1-no-content.zip\";s:11:\"new_bundled\";s:69:\"https://downloads.wordpress.org/release/wordpress-4.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"4.1\";s:7:\"version\";s:3:\"4.1\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"4.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1418945315;s:15:\"version_checked\";s:3:\"4.1\";s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("255", "rewrite_rules", "a:71:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:58:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:68:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:88:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:83:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/trackback/?$\";s:85:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&tb=1\";s:77:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&feed=$matches[5]\";s:65:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/page/?([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&paged=$matches[5]\";s:72:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)/comment-page-([0-9]{1,})/?$\";s:98:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&cpage=$matches[5]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/([^/]+)(/[0-9]+)?/?$\";s:97:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&name=$matches[4]&page=$matches[5]\";s:47:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:57:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:77:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:72:\"[0-9]{4}/[0-9]{1,2}/[0-9]{1,2}/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&cpage=$matches[4]\";s:51:\"([0-9]{4})/([0-9]{1,2})/comment-page-([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&cpage=$matches[3]\";s:38:\"([0-9]{4})/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&cpage=$matches[2]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";}", "yes");
INSERT INTO `wp_options` VALUES("256", "can_compress_scripts", "0", "yes");
INSERT INTO `wp_options` VALUES("258", "theme-update-covertstorebuilder", "O:8:\"stdClass\":3:{s:9:\"lastCheck\";i:1418945315;s:14:\"checkedVersion\";s:3:\"1.6\";s:6:\"update\";N;}", "yes");
INSERT INTO `wp_options` VALUES("259", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1418945316;s:7:\"checked\";a:5:{s:18:\"covertstorebuilder\";s:3:\"1.6\";s:13:\"twentyfifteen\";s:3:\"1.0\";s:14:\"twentyfourteen\";s:3:\"1.3\";s:14:\"twentythirteen\";s:3:\"1.4\";s:12:\"twentytwelve\";s:3:\"1.6\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("262", "_site_transient_timeout_theme_roots", "1418945431", "yes");
INSERT INTO `wp_options` VALUES("263", "_site_transient_theme_roots", "a:5:{s:18:\"covertstorebuilder\";s:7:\"/themes\";s:13:\"twentyfifteen\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("268", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("269", "asd_cache", "a:7:{s:26:\"amazon.categories.US._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:34:{i:2619525011;s:10:\"Appliances\";i:2350149011;s:16:\"Apps for Android\";i:2617941011;s:21:\"Arts, Crafts & Sewing\";i:15684181;s:10:\"Automotive\";i:165796011;s:4:\"Baby\";i:3760911;s:6:\"Beauty\";i:283155;s:5:\"Books\";i:2335752011;s:25:\"Cell Phones & Accessories\";i:1036592;s:22:\"Clothing & Accessories\";i:4991425011;s:12:\"Collectibles\";i:541966;s:9:\"Computers\";i:172282;s:11:\"Electronics\";i:2238192011;s:10:\"Gift Cards\";i:16310101;s:22:\"Grocery & Gourmet Food\";i:3760901;s:22:\"Health & Personal Care\";i:1055398;s:14:\"Home & Kitchen\";i:16310091;s:23:\"Industrial & Scientific\";i:3367581;s:7:\"Jewelry\";i:133140011;s:12:\"Kindle Store\";i:599858;s:22:\"Magazine Subscriptions\";i:2625373011;s:11:\"Movies & TV\";i:163856011;s:9:\"MP3 Music\";i:5174;s:5:\"Music\";i:11091801;s:19:\"Musical Instruments\";i:1064954;s:15:\"Office Products\";i:2972638011;s:20:\"Patio, Lawn & Garden\";i:2619533011;s:12:\"Pet Supplies\";i:672123011;s:5:\"Shoes\";i:229534;s:8:\"Software\";i:3375251;s:17:\"Sports & Outdoors\";i:228013;s:24:\"Tools & Home Improvement\";i:165793011;s:12:\"Toys & Games\";i:468642;s:11:\"Video Games\";i:377110011;s:7:\"Watches\";}}s:26:\"amazon.categories.CA._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:13:{i:3561346011;s:4:\"Baby\";i:916520;s:5:\"Books\";i:667823011;s:11:\"Electronics\";i:2206275011;s:13:\"Home & Garden\";i:2972705011;s:12:\"Kindle Store\";i:917972;s:11:\"Movies & TV\";i:916514;s:5:\"Music\";i:3198021;s:8:\"Software\";i:2242989011;s:17:\"Sports & Outdoors\";i:3006902011;s:25:\"Tools & Building Supplies\";i:916518;s:5:\"Video\";i:3198031;s:11:\"Video Games\";i:2235620011;s:7:\"Watches\";}}s:26:\"amazon.categories.UK._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:29:{i:59624031;s:4:\"Baby\";i:117332031;s:6:\"Beauty\";i:266239;s:5:\"Books\";i:248877031;s:15:\"Car & Motorbike\";i:83450031;s:8:\"Clothing\";i:340831031;s:23:\"Computers & Accessories\";i:79903031;s:11:\"DIY & Tools\";i:560798;s:19:\"Electronics & Photo\";i:283926;s:9:\"Film & TV\";i:11052671;s:17:\"Garden & Outdoors\";i:340834031;s:7:\"Grocery\";i:65801031;s:15:\"Health & Beauty\";i:193716031;s:9:\"Jewellery\";i:341677031;s:12:\"Kindle Store\";i:11052681;s:14:\"Kitchen & Home\";i:908798031;s:16:\"Large Appliances\";i:213077031;s:8:\"Lighting\";i:77197031;s:13:\"MP3 Downloads\";i:229816;s:5:\"Music\";i:340837031;s:25:\"Musical Instruments  & DJ\";i:300703;s:16:\"PC & Video Games\";i:340840031;s:12:\"Pet Supplies\";i:355005011;s:19:\"Shoes & Accessories\";i:300435;s:8:\"Software\";i:318949011;s:16:\"Sports & Leisure\";i:192413031;s:28:\"Stationery & Office Supplies\";i:468292;s:12:\"Toys & Games\";i:573398;s:3:\"VHS\";i:328228011;s:7:\"Watches\";}}s:26:\"amazon.categories.DE._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:30:{i:340852031;s:16:\"Alles für Tiere\";i:78191031;s:4:\"Auto\";i:355007011;s:4:\"Baby\";i:80084031;s:8:\"Baumarkt\";i:213083031;s:11:\"Beleuchtung\";i:186606;s:7:\"Bücher\";i:192416031;s:26:\"Bürobedarf & Schreibwaren\";i:64187031;s:24:\"Drogerie & Körperpflege\";i:908823031;s:20:\"Elektro-Großgeräte\";i:562066;s:17:\"Elektronik & Foto\";i:284266;s:10:\"Filme & TV\";i:52044011;s:22:\"Fremdsprachige Bücher\";i:300992;s:5:\"Games\";i:3169211;s:30:\"Haushaltsgeräte & Staubsauger\";i:530484031;s:11:\"Kindle-Shop\";i:77028031;s:24:\"Kleidung, Schuhe & Uhren\";i:340846031;s:24:\"Lebensmittel & Getränke\";i:908829031;s:8:\"Motorrad\";i:77195031;s:13:\"MP3-Downloads\";i:290380;s:5:\"Musik\";i:340849031;s:31:\"Musikinstrumente & DJ-Equipment\";i:514699031;s:15:\"Notebooks & PCs\";i:84230031;s:22:\"Parfümerie & Kosmetik\";i:327472011;s:7:\"Schmuck\";i:355006011;s:20:\"Schuhe & Handtaschen\";i:301927;s:8:\"Software\";i:12950651;s:9:\"Spielzeug\";i:16435051;s:16:\"Sport & Freizeit\";i:193707031;s:5:\"Uhren\";i:1161658;s:13:\"Zeitschriften\";}}s:26:\"amazon.categories.ES._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:15:{i:1703495031;s:5:\"Bebé\";i:1748200031;s:13:\"Descargas MP3\";i:599370031;s:12:\"Electrónica\";i:599391031;s:5:\"Hogar\";i:667049031;s:12:\"Informática\";i:599385031;s:8:\"Juguetes\";i:599364031;s:6:\"Libros\";i:599367031;s:29:\"Libros en idiomas extranjeros\";i:599373031;s:7:\"Música\";i:599379031;s:15:\"Películas y TV\";i:599388031;s:7:\"Relojes\";i:599376031;s:8:\"Software\";i:818936031;s:13:\"Tienda Kindle\";i:599382031;s:11:\"Videojuegos\";i:1571262031;s:22:\"Zapatos y complementos\";}}s:26:\"amazon.categories.IN._root\";a:2:{s:6:\"expire\";i:1419030213;s:5:\"value\";a:21:{i:1571274031;s:4:\"Baby\";i:1355016031;s:6:\"Beauty\";i:976389031;s:5:\"Books\";i:1571271031;s:22:\"Clothing & Accessories\";i:976392031;s:23:\"Computers & Accessories\";i:976419031;s:11:\"Electronics\";i:1951048031;s:17:\"Fashion Jewellery\";i:3704982031;s:10:\"Gift Cards\";i:2454178031;s:25:\"Gourmet & Specialty Foods\";i:1983338031;s:19:\"Handbags & Clutches\";i:1350384031;s:22:\"Health & Personal Care\";i:976442031;s:14:\"Home & Kitchen\";i:2454169031;s:14:\"Luggage & Bags\";i:976416031;s:17:\"Movies & TV Shows\";i:976445031;s:5:\"Music\";i:2454181031;s:12:\"Pet Supplies\";i:1983396031;s:5:\"Shoes\";i:1984443031;s:26:\"Sports, Fitness & Outdoors\";i:1350380031;s:12:\"Toys & Games\";i:976460031;s:11:\"Video Games\";i:1350387031;s:7:\"Watches\";}}s:28:\"amazon.categories.US.3760911\";a:2:{s:6:\"expire\";i:1419030280;s:5:\"value\";a:6:{i:11055991;s:11:\"Bath & Body\";i:11056591;s:9:\"Fragrance\";i:11057241;s:9:\"Hair Care\";i:11058281;s:6:\"Makeup\";i:11060451;s:9:\"Skin Care\";i:11062741;s:19:\"Tools & Accessories\";}}}", "yes");
INSERT INTO `wp_options` VALUES("270", "asd_announcement_cache", "a:2:{s:4:\"data\";s:0:\"\";s:9:\"timestamp\";i:1418943813;}", "yes");
INSERT INTO `wp_options` VALUES("271", "asd_enabled", "1", "yes");
INSERT INTO `wp_options` VALUES("272", "asd_access_key", "AKIAJULJCU4YH7LDDYQA", "yes");
INSERT INTO `wp_options` VALUES("273", "asd_secret_access_key", "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", "yes");
INSERT INTO `wp_options` VALUES("274", "asd_US_affiliate_id", "freetos-20", "yes");
INSERT INTO `wp_options` VALUES("275", "asd_US_category", "3760911", "yes");
INSERT INTO `wp_options` VALUES("276", "asd_US_subcategory", "11055991", "yes");
INSERT INTO `wp_options` VALUES("277", "asd_CA_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("278", "asd_CA_category", "", "yes");
INSERT INTO `wp_options` VALUES("279", "asd_UK_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("280", "asd_UK_category", "", "yes");
INSERT INTO `wp_options` VALUES("281", "asd_DE_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("282", "asd_DE_category", "", "yes");
INSERT INTO `wp_options` VALUES("283", "asd_ES_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("284", "asd_ES_category", "", "yes");
INSERT INTO `wp_options` VALUES("285", "asd_IN_affiliate_id", "", "yes");
INSERT INTO `wp_options` VALUES("286", "asd_IN_category", "", "yes");
INSERT INTO `wp_options` VALUES("287", "asd_page_types", "a:3:{i:0;s:9:\"node_post\";i:1;s:9:\"node_page\";i:2;s:4:\"home\";}", "yes");
INSERT INTO `wp_options` VALUES("288", "asd_market", "US", "yes");
INSERT INTO `wp_options` VALUES("289", "asd_discount_visible", "0", "yes");
INSERT INTO `wp_options` VALUES("290", "asd_toolbar_position", "bottom", "yes");
INSERT INTO `wp_options` VALUES("291", "asd_show_on_mobile_devices", "1", "yes");
INSERT INTO `wp_options` VALUES("292", "asd_toolbar_background_color", "#ffffcc", "yes");
INSERT INTO `wp_options` VALUES("293", "asd_search_button_text", "Search", "yes");
INSERT INTO `wp_options` VALUES("294", "asd_search_button_background_color", "#cccccc", "yes");
INSERT INTO `wp_options` VALUES("295", "asd_search_button_text_color", "#000000", "yes");
INSERT INTO `wp_options` VALUES("296", "asd_buy_button_text", "Add to Cart", "yes");
INSERT INTO `wp_options` VALUES("297", "asd_buy_button_background_color", "#ffcc00", "yes");
INSERT INTO `wp_options` VALUES("298", "asd_buy_button_text_color", "#999999", "yes");
INSERT INTO `wp_options` VALUES("299", "imwb_zonpress_theme_products", "a:18:{s:10:\"createtags\";s:1:\"N\";s:7:\"badtags\";s:86:\"all,and,here,this,that,then,make,what,which,where,when,does,with,while,your,other,will\";s:11:\"addcomments\";s:1:\"N\";s:12:\"randcomments\";s:1:\"N\";s:8:\"amzaffid\";s:10:\"freetos-20\";s:9:\"amzpubkey\";s:20:\"AKIAJULJCU4YH7LDDYQA\";s:9:\"amzprikey\";s:40:\"IM/JT0I1yHRJSeB0BJE4hsz25snswQXaD6bLByZZ\";s:9:\"amzregion\";s:3:\"com\";s:14:\"amzincfeatures\";s:1:\"N\";s:13:\"amzpricetoson\";s:1:\"Y\";s:14:\"amzpriceupdate\";s:1:\"Y\";s:8:\"cjdevkey\";s:0:\"\";s:8:\"cjwebpid\";s:0:\"\";s:15:\"cjadvertiserids\";s:1:\"J\";s:6:\"cjcids\";s:0:\"\";s:6:\"ebayid\";s:0:\"\";s:9:\"ebayappid\";s:0:\"\";s:10:\"ebaysiteid\";s:1:\"0\";}", "yes");
INSERT INTO `wp_options` VALUES("306", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("307", "_site_transient_timeout_available_translations", "1418955275", "yes");
INSERT INTO `wp_options` VALUES("308", "_site_transient_available_translations", "a:44:{s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 13:48:58\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 20:37:50\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 10:25:25\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:22:\"Продължение\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 14:59:05\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 03:42:07\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-04 16:43:49\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.0/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-10-22 11:59:16\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Forts&#230;t\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 17:35:46\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Fortfahren\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 11:11:11\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 18:30:00\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 00:30:12\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-16 23:14:33\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 15:43:16\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 01:21:54\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/es_ES.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"es\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-04 19:47:01\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/es_CL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-04 07:49:30\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/es_PE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"es\";i:2;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 06:55:23\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.0/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 15:58:20\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 07:01:16\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 16:07:54\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 17:37:43\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.0/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 18:21:32\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 06:09:08\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"להמשיך\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 14:56:32\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 16:37:15\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Tovább\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 05:06:14\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 07:06:12\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 17:02:53\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"続ける\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 14:35:28\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 19:02:07\";s:12:\"english_name\";s:7:\"Burmese\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ေဆာင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 19:25:49\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 10:43:08\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 20:29:59\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 18:42:22\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 15:32:34\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 09:16:41\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 15:12:27\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 16:37:57\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 19:08:01\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 13:39:48\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-18 16:15:24\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/translation/core/4.1/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:3:\"4.1\";s:7:\"updated\";s:19:\"2014-12-17 11:21:37\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.1/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 00:41:46\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:3:\"4.0\";s:7:\"updated\";s:19:\"2014-09-05 06:58:31\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.0/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}}", "yes");
INSERT INTO `wp_options` VALUES("309", "WPLANG", "", "yes");
INSERT INTO `wp_options` VALUES("314", "imwb_covertstorecontent-AdminOptions", "a:25:{s:8:\"keywords\";s:85:\"luxury fragrance\r\nluxury makeup\r\nluxury skin care\r\nluxury nail care\r\nluxury hair care\";s:8:\"posttype\";s:1:\"0\";s:10:\"createtags\";s:1:\"N\";s:7:\"badtags\";s:82:\"and,here,this,that,then,make,what,which,where,when,does,with,while,your,other,will\";s:8:\"storeimg\";s:1:\"N\";s:11:\"addcomments\";s:1:\"N\";s:12:\"randcomments\";s:1:\"N\";s:6:\"lastkw\";i:0;s:8:\"amzaffid\";s:10:\"freetos-20\";s:9:\"amzpubkey\";s:20:\"AKIAJULJCU4YH7LDDYQA\";s:9:\"amzprikey\";s:40:\"IM/JT0I1yHRJSeB0BJE4hsz25snswQXaD6bLByZZ\";s:9:\"amzregion\";s:3:\"com\";s:14:\"amzincfeatures\";s:1:\"Y\";s:8:\"cjdevkey\";s:0:\"\";s:8:\"cjwebpid\";s:0:\"\";s:6:\"ebayid\";s:0:\"\";s:9:\"ebayappid\";s:0:\"\";s:10:\"ebaysiteid\";s:1:\"0\";s:13:\"facebookappid\";s:0:\"\";s:17:\"facebookappsecret\";s:0:\"\";s:14:\"facebookwallid\";s:0:\"\";s:13:\"twitterconkey\";s:0:\"\";s:16:\"twitterconsecret\";s:0:\"\";s:18:\"twitteraccesstoken\";s:0:\"\";s:21:\"twitteraccesstokensec\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("315", "imwb_covertstorecontent_update_check", "a:3:{s:12:\"last_checked\";s:19:\"2014-12-18 23:28:40\";s:14:\"latest_version\";s:3:\"1.6\";s:16:\"after_plugin_row\";s:192:\"Version 1.6 of Covert Store Content plugin is now available. <a href=\"http://covertcontent.com/store/plugin_update/std/update.html\" target=\"_blank\">Click Here</a> for details on how to update.\";}", "yes");
INSERT INTO `wp_options` VALUES("316", "imwb_covertstorecontent-amazon-1-AdminOptions", "a:12:{s:7:\"lastrun\";s:1:\"0\";s:8:\"feedname\";s:9:\"fragrance\";s:7:\"keyword\";s:16:\"luxury fragrance\";s:11:\"searchindex\";s:6:\"Beauty\";s:8:\"minprice\";s:0:\"\";s:8:\"maxprice\";s:0:\"\";s:13:\"catselecttype\";s:1:\"M\";s:10:\"categories\";s:1:\"3\";s:6:\"active\";s:1:\"Y\";s:9:\"postcount\";s:1:\"5\";s:9:\"posthours\";s:2:\"10\";s:10:\"socmessage\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("317", "imwb_covertstorecontent-amazon-2-AdminOptions", "a:12:{s:7:\"lastrun\";s:1:\"0\";s:8:\"feedname\";s:6:\"makeup\";s:7:\"keyword\";s:13:\"luxury makeup\";s:11:\"searchindex\";s:6:\"Beauty\";s:8:\"minprice\";s:0:\"\";s:8:\"maxprice\";s:0:\"\";s:13:\"catselecttype\";s:1:\"A\";s:10:\"categories\";s:1:\"1\";s:6:\"active\";s:1:\"Y\";s:9:\"postcount\";s:1:\"2\";s:9:\"posthours\";s:2:\"48\";s:10:\"socmessage\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("318", "imwb_covertstorecontent-amazon-3-AdminOptions", "a:12:{s:7:\"lastrun\";s:1:\"0\";s:8:\"feedname\";s:4:\"skin\";s:7:\"keyword\";s:16:\"luxury skin care\";s:11:\"searchindex\";s:6:\"Beauty\";s:8:\"minprice\";s:0:\"\";s:8:\"maxprice\";s:0:\"\";s:13:\"catselecttype\";s:1:\"A\";s:10:\"categories\";s:1:\"2\";s:6:\"active\";s:1:\"Y\";s:9:\"postcount\";s:1:\"2\";s:9:\"posthours\";s:2:\"24\";s:10:\"socmessage\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("319", "imwb_covertstorecontent-amazon-4-AdminOptions", "a:12:{s:7:\"lastrun\";s:1:\"0\";s:8:\"feedname\";s:4:\"nail\";s:7:\"keyword\";s:16:\"luxury nail care\";s:11:\"searchindex\";s:6:\"Beauty\";s:8:\"minprice\";s:0:\"\";s:8:\"maxprice\";s:0:\"\";s:13:\"catselecttype\";s:1:\"A\";s:10:\"categories\";s:1:\"4\";s:6:\"active\";s:1:\"Y\";s:9:\"postcount\";s:1:\"5\";s:9:\"posthours\";s:2:\"60\";s:10:\"socmessage\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("320", "imwb_covertstorecontent-amazon-5-AdminOptions", "a:12:{s:7:\"lastrun\";s:1:\"0\";s:8:\"feedname\";s:4:\"hair\";s:7:\"keyword\";s:16:\"luxury hair care\";s:11:\"searchindex\";s:6:\"Beauty\";s:8:\"minprice\";s:0:\"\";s:8:\"maxprice\";s:0:\"\";s:13:\"catselecttype\";s:1:\"A\";s:10:\"categories\";s:1:\"5\";s:6:\"active\";s:1:\"Y\";s:9:\"postcount\";s:1:\"3\";s:9:\"posthours\";s:2:\"24\";s:10:\"socmessage\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("321", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1418945317;s:7:\"checked\";a:12:{s:19:\"akismet/akismet.php\";s:5:\"3.0.4\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:7:\"2.2.3.1\";s:33:\"ama_search_bar/ama_search_bar.php\";s:5:\"2.2.2\";s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";s:3:\"1.4\";s:48:\"covertstorecontent/covertstorecontent-plugin.php\";s:3:\"1.5\";s:25:\"duplicator/duplicator.php\";s:5:\"0.5.8\";s:19:\"jetpack/jetpack.php\";s:3:\"3.3\";s:37:\"super-socializer/super_socializer.php\";s:5:\"3.4.2\";s:27:\"wp-super-cache/wp-cache.php\";s:5:\"1.4.2\";s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";s:5:\"1.8.7\";s:26:\"youtube-widget/youtube.php\";s:3:\"1.1\";s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";s:3:\"1.0\";}s:8:\"response\";a:1:{s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"53172\";s:4:\"slug\";s:30:\"clickbank-ads-clickbank-widget\";s:6:\"plugin\";s:48:\"clickbank-ads-clickbank-widget/clickbank-ads.php\";s:11:\"new_version\";s:3:\"1.5\";s:3:\"url\";s:61:\"https://wordpress.org/plugins/clickbank-ads-clickbank-widget/\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/plugin/clickbank-ads-clickbank-widget.zip\";}}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:9:{s:19:\"akismet/akismet.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:2:\"15\";s:4:\"slug\";s:7:\"akismet\";s:6:\"plugin\";s:19:\"akismet/akismet.php\";s:11:\"new_version\";s:5:\"3.0.4\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/akismet/\";s:7:\"package\";s:56:\"https://downloads.wordpress.org/plugin/akismet.3.0.4.zip\";}s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:3:\"520\";s:4:\"slug\";s:19:\"all-in-one-seo-pack\";s:6:\"plugin\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:11:\"new_version\";s:7:\"2.2.3.1\";s:3:\"url\";s:50:\"https://wordpress.org/plugins/all-in-one-seo-pack/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/all-in-one-seo-pack.zip\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:5:\"0.5.8\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.0.5.8.zip\";}s:19:\"jetpack/jetpack.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"20101\";s:4:\"slug\";s:7:\"jetpack\";s:6:\"plugin\";s:19:\"jetpack/jetpack.php\";s:11:\"new_version\";s:3:\"3.3\";s:3:\"url\";s:38:\"https://wordpress.org/plugins/jetpack/\";s:7:\"package\";s:54:\"https://downloads.wordpress.org/plugin/jetpack.3.3.zip\";}s:37:\"super-socializer/super_socializer.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:5:\"47516\";s:4:\"slug\";s:16:\"super-socializer\";s:6:\"plugin\";s:37:\"super-socializer/super_socializer.php\";s:11:\"new_version\";s:5:\"3.4.2\";s:14:\"upgrade_notice\";s:112:\"Verified compatibility with WordPress 4.0\n[Bugfix] Fatal error at &quot;Social Counter&quot; page in admin panel\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/super-socializer/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/super-socializer.zip\";}s:27:\"wp-super-cache/wp-cache.php\";O:8:\"stdClass\":7:{s:2:\"id\";s:4:\"1221\";s:4:\"slug\";s:14:\"wp-super-cache\";s:6:\"plugin\";s:27:\"wp-super-cache/wp-cache.php\";s:11:\"new_version\";s:5:\"1.4.2\";s:14:\"upgrade_notice\";s:91:\"Fixed &quot;acceptable file list&quot; and no caching for GET queries bugs in last release.\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/wp-super-cache/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/wp-super-cache.1.4.2.zip\";}s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"32977\";s:4:\"slug\";s:23:\"youtube-channel-gallery\";s:6:\"plugin\";s:51:\"youtube-channel-gallery/youtube-channel-gallery.php\";s:11:\"new_version\";s:5:\"1.8.7\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/youtube-channel-gallery/\";s:7:\"package\";s:72:\"https://downloads.wordpress.org/plugin/youtube-channel-gallery.1.8.7.zip\";}s:26:\"youtube-widget/youtube.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:4:\"2713\";s:4:\"slug\";s:14:\"youtube-widget\";s:6:\"plugin\";s:26:\"youtube-widget/youtube.php\";s:11:\"new_version\";s:3:\"1.1\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/youtube-widget/\";s:7:\"package\";s:57:\"https://downloads.wordpress.org/plugin/youtube-widget.zip\";}s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"46160\";s:4:\"slug\";s:25:\"youtube-widget-responsive\";s:6:\"plugin\";s:55:\"youtube-widget-responsive/youtube-widget-responsive.php\";s:11:\"new_version\";s:3:\"1.0\";s:3:\"url\";s:56:\"https://wordpress.org/plugins/youtube-widget-responsive/\";s:7:\"package\";s:68:\"https://downloads.wordpress.org/plugin/youtube-widget-responsive.zip\";}}}", "yes");
INSERT INTO `wp_options` VALUES("322", "duplicator_settings", "a:9:{s:7:\"version\";s:5:\"0.5.8\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("323", "duplicator_version_plugin", "0.5.8", "yes");
INSERT INTO `wp_options` VALUES("324", "duplicator_ui_view_state", "a:1:{s:14:\"dup-wpnotice01\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("325", "duplicator_package_active", "O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:26:\"20141218_luxurybeautygifts\";s:4:\"Hash\";s:29:\"5493633089ab97560141218232848\";s:8:\"NameHash\";s:56:\"20141218_luxurybeautygifts_5493633089ab97560141218232848\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:51:\"/home1/anton241/public_html/beauty/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://beauty.demobay.info/wp-snapshots/\";s:8:\"ScanFile\";s:66:\"20141218_luxurybeautygifts_5493633089ab97560141218232848_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":17:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:34:\"/home1/anton241/public_html/beauty\";s:4:\"Size\";i:0;s:12:\"WarnFileSize\";a:0:{}s:12:\"WarnFileName\";a:0:{}s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:5:\"Links\";a:0:{}s:8:\"OmitDirs\";a:0:{}s:9:\"OmitFiles\";a:0:{}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":16:{s:2:\"ID\";N;s:4:\"Name\";s:26:\"20141218_luxurybeautygifts\";s:4:\"Hash\";s:29:\"5493633089ab97560141218232848\";s:8:\"NameHash\";s:56:\"20141218_luxurybeautygifts_5493633089ab97560141218232848\";s:7:\"Version\";s:5:\"0.5.8\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:51:\"/home1/anton241/public_html/beauty/wp-snapshots/tmp\";s:8:\"StoreURL\";s:40:\"http://beauty.demobay.info/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:7:\"Archive\";r:15;s:9:\"Installer\";O:13:\"DUP_Installer\":11:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:30;}s:8:\"Database\";O:12:\"DUP_Database\":9:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"\0*\0Package\";r:30;s:25:\"\0DUP_Database\0dbStorePath\";N;}}s:28:\"\0DUP_Archive\0filterDirsArray\";a:0:{}s:28:\"\0DUP_Archive\0filterExtsArray\";a:0:{}}s:9:\"Installer\";r:45;s:8:\"Database\";r:57;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("2", "1", "_edit_lock", "1410890070:1");
INSERT INTO `wp_postmeta` VALUES("3", "1", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("15", "12", "_wp_attached_file", "2014/12/cream-302738.jpg");
INSERT INTO `wp_postmeta` VALUES("16", "12", "_wp_attachment_context", "custom-background");
INSERT INTO `wp_postmeta` VALUES("17", "12", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2416;s:6:\"height\";i:1359;s:4:\"file\";s:24:\"2014/12/cream-302738.jpg\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"cream-302738-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"cream-302738-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:25:\"cream-302738-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:24:\"cream-302738-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:24:\"cream-302738-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"cream-302738-153x86.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"cream-302738-170x95.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:95;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:22:\"cream-302738-50x28.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:28;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:14:\"Canon EOS 600D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"96\";s:3:\"iso\";s:3:\"320\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("18", "12", "_wp_attachment_is_custom_background", "covertstorebuilder");
INSERT INTO `wp_postmeta` VALUES("19", "13", "_wp_attached_file", "2014/12/cream-3027381.jpg");
INSERT INTO `wp_postmeta` VALUES("20", "13", "_wp_attachment_context", "custom-background");
INSERT INTO `wp_postmeta` VALUES("21", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:2416;s:6:\"height\";i:1359;s:4:\"file\";s:25:\"2014/12/cream-3027381.jpg\";s:5:\"sizes\";a:8:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"cream-3027381-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"cream-3027381-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"cream-3027381-1024x576.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:25:\"cream-3027381-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:25:\"cream-3027381-300x168.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:168;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:24:\"cream-3027381-153x86.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:86;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:24:\"cream-3027381-170x95.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:95;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:23:\"cream-3027381-50x28.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:28;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";d:5;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:14:\"Canon EOS 600D\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:2:\"96\";s:3:\"iso\";s:3:\"320\";s:13:\"shutter_speed\";s:7:\"0.00625\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("22", "13", "_wp_attachment_is_custom_background", "covertstorebuilder");
INSERT INTO `wp_postmeta` VALUES("24", "14", "imwb_cc_amazon_asin", "B00JF0IK12");
INSERT INTO `wp_postmeta` VALUES("25", "14", "_imwb_cc_amazon_asin_updated", "1418944098");
INSERT INTO `wp_postmeta` VALUES("26", "15", "_wp_attached_file", "2014/12/51Jqbi-USCL.jpg");
INSERT INTO `wp_postmeta` VALUES("27", "15", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51Jqbi-USCL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51Jqbi-USCL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51Jqbi-USCL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("28", "14", "_thumbnail_id", "15");
INSERT INTO `wp_postmeta` VALUES("29", "14", "imwb_zonpress_post_producturl", "http://www.amazon.com/Rimobul-Roll-N-Go-Cosmetic-Bathroom-Organizer/dp/B00JF0IK12%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JF0IK12");
INSERT INTO `wp_postmeta` VALUES("30", "14", "imwb_zonpress_post_price", "14.98");
INSERT INTO `wp_postmeta` VALUES("31", "14", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("32", "14", "_imwb_zonpress_post_imp", "5");
INSERT INTO `wp_postmeta` VALUES("33", "14", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("34", "14", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("35", "14", "imwb_interest_post_link_url", "http://www.amazon.com/Rimobul-Roll-N-Go-Cosmetic-Bathroom-Organizer/dp/B00JF0IK12%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JF0IK12");
INSERT INTO `wp_postmeta` VALUES("36", "14", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("38", "16", "imwb_cc_amazon_asin", "B00A42LERW");
INSERT INTO `wp_postmeta` VALUES("39", "16", "_imwb_cc_amazon_asin_updated", "1418944098");
INSERT INTO `wp_postmeta` VALUES("40", "17", "_wp_attached_file", "2014/12/41D4XmJtqBL.jpg");
INSERT INTO `wp_postmeta` VALUES("41", "17", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41D4XmJtqBL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41D4XmJtqBL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41D4XmJtqBL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("42", "16", "_thumbnail_id", "17");
INSERT INTO `wp_postmeta` VALUES("43", "16", "imwb_zonpress_post_producturl", "http://www.amazon.com/Bdellium-Tools-Professional-Antibacterial-Roll-Up/dp/B00A42LERW%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00A42LERW");
INSERT INTO `wp_postmeta` VALUES("44", "16", "imwb_zonpress_post_price", "148.5");
INSERT INTO `wp_postmeta` VALUES("45", "16", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("46", "16", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("47", "16", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("48", "16", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("49", "16", "imwb_interest_post_link_url", "http://www.amazon.com/Bdellium-Tools-Professional-Antibacterial-Roll-Up/dp/B00A42LERW%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00A42LERW");
INSERT INTO `wp_postmeta` VALUES("50", "16", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("52", "18", "imwb_cc_amazon_asin", "B00LMTD0FA");
INSERT INTO `wp_postmeta` VALUES("53", "18", "_imwb_cc_amazon_asin_updated", "1418944099");
INSERT INTO `wp_postmeta` VALUES("54", "19", "_wp_attached_file", "2014/12/515QdNyCwtL.jpg");
INSERT INTO `wp_postmeta` VALUES("55", "19", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/515QdNyCwtL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"515QdNyCwtL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"515QdNyCwtL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("56", "18", "_thumbnail_id", "19");
INSERT INTO `wp_postmeta` VALUES("57", "18", "imwb_zonpress_post_producturl", "http://www.amazon.com/Rimobul-Luxury-Cosmetic-Bathroom-Organizer/dp/B00LMTD0FA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00LMTD0FA");
INSERT INTO `wp_postmeta` VALUES("58", "18", "imwb_zonpress_post_price", "14.86");
INSERT INTO `wp_postmeta` VALUES("59", "18", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("60", "18", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("61", "18", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("62", "18", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("63", "18", "imwb_interest_post_link_url", "http://www.amazon.com/Rimobul-Luxury-Cosmetic-Bathroom-Organizer/dp/B00LMTD0FA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00LMTD0FA");
INSERT INTO `wp_postmeta` VALUES("64", "18", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("66", "20", "imwb_cc_amazon_asin", "B005ET4OIQ");
INSERT INTO `wp_postmeta` VALUES("67", "20", "_imwb_cc_amazon_asin_updated", "1418944099");
INSERT INTO `wp_postmeta` VALUES("68", "21", "_wp_attached_file", "2014/12/11EZ0-leiOL.jpg");
INSERT INTO `wp_postmeta` VALUES("69", "21", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:145;s:6:\"height\";i:145;s:4:\"file\";s:23:\"2014/12/11EZ0-leiOL.jpg\";s:5:\"sizes\";a:3:{s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"11EZ0-leiOL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"11EZ0-leiOL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"11EZ0-leiOL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("70", "20", "_thumbnail_id", "21");
INSERT INTO `wp_postmeta` VALUES("71", "20", "imwb_zonpress_post_producturl", "http://www.amazon.com/Decadent-Lipstick-Women-Luxury-Ounce/dp/B005ET4OIQ%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005ET4OIQ");
INSERT INTO `wp_postmeta` VALUES("72", "20", "imwb_zonpress_post_price", "3.35");
INSERT INTO `wp_postmeta` VALUES("73", "20", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("74", "20", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("75", "20", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("76", "20", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("77", "20", "imwb_interest_post_link_url", "http://www.amazon.com/Decadent-Lipstick-Women-Luxury-Ounce/dp/B005ET4OIQ%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005ET4OIQ");
INSERT INTO `wp_postmeta` VALUES("78", "20", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("80", "22", "imwb_cc_amazon_asin", "B00H3KK456");
INSERT INTO `wp_postmeta` VALUES("81", "22", "_imwb_cc_amazon_asin_updated", "1418944100");
INSERT INTO `wp_postmeta` VALUES("82", "23", "_wp_attached_file", "2014/12/41mSludP-L.jpg");
INSERT INTO `wp_postmeta` VALUES("83", "23", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:22:\"2014/12/41mSludP-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41mSludP-L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:20:\"41mSludP-L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("84", "22", "_thumbnail_id", "23");
INSERT INTO `wp_postmeta` VALUES("85", "22", "imwb_zonpress_post_producturl", "http://www.amazon.com/Introducing-Revolutionary-Product-Hyaluronic-Antioxidant/dp/B00H3KK456%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H3KK456");
INSERT INTO `wp_postmeta` VALUES("86", "22", "imwb_zonpress_post_price", "23.88");
INSERT INTO `wp_postmeta` VALUES("87", "22", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("88", "22", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("89", "22", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("90", "22", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("91", "22", "imwb_interest_post_link_url", "http://www.amazon.com/Introducing-Revolutionary-Product-Hyaluronic-Antioxidant/dp/B00H3KK456%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H3KK456");
INSERT INTO `wp_postmeta` VALUES("92", "22", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("94", "24", "imwb_cc_amazon_asin", "B00FXGZCFE");
INSERT INTO `wp_postmeta` VALUES("95", "24", "_imwb_cc_amazon_asin_updated", "1418944100");
INSERT INTO `wp_postmeta` VALUES("96", "25", "_wp_attached_file", "2014/12/51lEpLffrML.jpg");
INSERT INTO `wp_postmeta` VALUES("97", "25", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51lEpLffrML.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51lEpLffrML-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51lEpLffrML-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("98", "24", "_thumbnail_id", "25");
INSERT INTO `wp_postmeta` VALUES("99", "24", "imwb_zonpress_post_producturl", "http://www.amazon.com/Best-Makeup-Brushes-Friendly-Top-Instructions/dp/B00FXGZCFE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FXGZCFE");
INSERT INTO `wp_postmeta` VALUES("100", "24", "imwb_zonpress_post_price", "57.99");
INSERT INTO `wp_postmeta` VALUES("101", "24", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("102", "24", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("103", "24", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("104", "24", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("105", "24", "imwb_interest_post_link_url", "http://www.amazon.com/Best-Makeup-Brushes-Friendly-Top-Instructions/dp/B00FXGZCFE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FXGZCFE");
INSERT INTO `wp_postmeta` VALUES("106", "24", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("108", "26", "imwb_cc_amazon_asin", "B00CF6M0NC");
INSERT INTO `wp_postmeta` VALUES("109", "26", "_imwb_cc_amazon_asin_updated", "1418944101");
INSERT INTO `wp_postmeta` VALUES("110", "27", "_wp_attached_file", "2014/12/41QJxcz0K7L.jpg");
INSERT INTO `wp_postmeta` VALUES("111", "27", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41QJxcz0K7L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41QJxcz0K7L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41QJxcz0K7L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("112", "26", "_thumbnail_id", "27");
INSERT INTO `wp_postmeta` VALUES("113", "26", "imwb_zonpress_post_producturl", "http://www.amazon.com/Natural-Body-Lotion-Antioxidant-rich-Anti-inflammatory/dp/B00CF6M0NC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CF6M0NC");
INSERT INTO `wp_postmeta` VALUES("114", "26", "imwb_zonpress_post_price", "34");
INSERT INTO `wp_postmeta` VALUES("115", "26", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("116", "26", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("117", "26", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("118", "26", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("119", "26", "imwb_interest_post_link_url", "http://www.amazon.com/Natural-Body-Lotion-Antioxidant-rich-Anti-inflammatory/dp/B00CF6M0NC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CF6M0NC");
INSERT INTO `wp_postmeta` VALUES("120", "26", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("122", "28", "imwb_cc_amazon_asin", "B00H90VJV8");
INSERT INTO `wp_postmeta` VALUES("123", "28", "_imwb_cc_amazon_asin_updated", "1418944101");
INSERT INTO `wp_postmeta` VALUES("124", "29", "_wp_attached_file", "2014/12/51SAX8HsDLL.jpg");
INSERT INTO `wp_postmeta` VALUES("125", "29", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:406;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51SAX8HsDLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-244x300.jpg\";s:5:\"width\";i:244;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-203x250.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-203x250.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-104x128.jpg\";s:5:\"width\";i:104;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51SAX8HsDLL-114x140.jpg\";s:5:\"width\";i:114;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51SAX8HsDLL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("126", "28", "_thumbnail_id", "29");
INSERT INTO `wp_postmeta` VALUES("127", "28", "imwb_zonpress_post_producturl", "http://www.amazon.com/LORAC-Close-Real-Carpet-Tutorial/dp/B00H90VJV8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H90VJV8");
INSERT INTO `wp_postmeta` VALUES("128", "28", "imwb_zonpress_post_price", "42");
INSERT INTO `wp_postmeta` VALUES("129", "28", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("130", "28", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("131", "28", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("132", "28", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("133", "28", "imwb_interest_post_link_url", "http://www.amazon.com/LORAC-Close-Real-Carpet-Tutorial/dp/B00H90VJV8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H90VJV8");
INSERT INTO `wp_postmeta` VALUES("134", "28", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("136", "30", "imwb_cc_amazon_asin", "B001KYQ0CC");
INSERT INTO `wp_postmeta` VALUES("137", "30", "_imwb_cc_amazon_asin_updated", "1418944102");
INSERT INTO `wp_postmeta` VALUES("138", "31", "_wp_attached_file", "2014/12/31-4UVo0NiL.jpg");
INSERT INTO `wp_postmeta` VALUES("139", "31", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:499;s:4:\"file\";s:23:\"2014/12/31-4UVo0NiL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31-4UVo0NiL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31-4UVo0NiL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("140", "30", "_thumbnail_id", "31");
INSERT INTO `wp_postmeta` VALUES("141", "30", "imwb_zonpress_post_producturl", "http://www.amazon.com/Iman-Cosmetics-Luxury-Moisturizing-Lipstick/dp/B001KYQ0CC%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001KYQ0CC");
INSERT INTO `wp_postmeta` VALUES("142", "30", "imwb_zonpress_post_price", "10");
INSERT INTO `wp_postmeta` VALUES("143", "30", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("144", "30", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("145", "30", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("146", "30", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("147", "30", "imwb_interest_post_link_url", "http://www.amazon.com/Iman-Cosmetics-Luxury-Moisturizing-Lipstick/dp/B001KYQ0CC%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001KYQ0CC");
INSERT INTO `wp_postmeta` VALUES("148", "30", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("150", "32", "imwb_cc_amazon_asin", "B00P7TRXHW");
INSERT INTO `wp_postmeta` VALUES("151", "32", "_imwb_cc_amazon_asin_updated", "1418944102");
INSERT INTO `wp_postmeta` VALUES("152", "33", "_wp_attached_file", "2014/12/51l50j-oMhL.jpg");
INSERT INTO `wp_postmeta` VALUES("153", "33", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51l50j-oMhL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51l50j-oMhL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51l50j-oMhL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("154", "32", "_thumbnail_id", "33");
INSERT INTO `wp_postmeta` VALUES("155", "32", "imwb_zonpress_post_producturl", "http://www.amazon.com/Sannysis-Luxury-Multilayer-Statement-Necklace/dp/B00P7TRXHW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00P7TRXHW");
INSERT INTO `wp_postmeta` VALUES("156", "32", "imwb_zonpress_post_price", "2.99");
INSERT INTO `wp_postmeta` VALUES("157", "32", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("158", "32", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("159", "32", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("160", "32", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("161", "32", "imwb_interest_post_link_url", "http://www.amazon.com/Sannysis-Luxury-Multilayer-Statement-Necklace/dp/B00P7TRXHW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00P7TRXHW");
INSERT INTO `wp_postmeta` VALUES("162", "32", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("164", "34", "imwb_cc_amazon_asin", "B00MA4T640");
INSERT INTO `wp_postmeta` VALUES("165", "34", "_imwb_cc_amazon_asin_updated", "1418944103");
INSERT INTO `wp_postmeta` VALUES("166", "35", "_wp_attached_file", "2014/12/41xP34EIbkL.jpg");
INSERT INTO `wp_postmeta` VALUES("167", "35", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41xP34EIbkL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41xP34EIbkL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41xP34EIbkL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("168", "34", "_thumbnail_id", "35");
INSERT INTO `wp_postmeta` VALUES("169", "34", "imwb_zonpress_post_producturl", "http://www.amazon.com/GOODBUYER-Classic-Fashion-Concealer-Palette/dp/B00MA4T640%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00MA4T640");
INSERT INTO `wp_postmeta` VALUES("170", "34", "imwb_zonpress_post_price", "9.99");
INSERT INTO `wp_postmeta` VALUES("171", "34", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("172", "34", "_imwb_zonpress_post_imp", "5");
INSERT INTO `wp_postmeta` VALUES("173", "34", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("174", "34", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("175", "34", "imwb_interest_post_link_url", "http://www.amazon.com/GOODBUYER-Classic-Fashion-Concealer-Palette/dp/B00MA4T640%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00MA4T640");
INSERT INTO `wp_postmeta` VALUES("176", "34", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("178", "36", "imwb_cc_amazon_asin", "B0089154BW");
INSERT INTO `wp_postmeta` VALUES("179", "36", "_imwb_cc_amazon_asin_updated", "1418944103");
INSERT INTO `wp_postmeta` VALUES("180", "37", "_wp_attached_file", "2014/12/51DweSzsWIL.jpg");
INSERT INTO `wp_postmeta` VALUES("181", "37", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51DweSzsWIL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51DweSzsWIL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51DweSzsWIL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("182", "36", "_thumbnail_id", "37");
INSERT INTO `wp_postmeta` VALUES("183", "36", "imwb_zonpress_post_producturl", "http://www.amazon.com/Luxury-Divas-Cosmetic-Make-up-Organizer/dp/B0089154BW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0089154BW");
INSERT INTO `wp_postmeta` VALUES("184", "36", "imwb_zonpress_post_price", "18.99");
INSERT INTO `wp_postmeta` VALUES("185", "36", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("186", "36", "_imwb_zonpress_post_imp", "5");
INSERT INTO `wp_postmeta` VALUES("187", "36", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("188", "36", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("189", "36", "imwb_interest_post_link_url", "http://www.amazon.com/Luxury-Divas-Cosmetic-Make-up-Organizer/dp/B0089154BW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0089154BW");
INSERT INTO `wp_postmeta` VALUES("190", "36", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("192", "38", "imwb_cc_amazon_asin", "B00FJQFJX8");
INSERT INTO `wp_postmeta` VALUES("193", "38", "_imwb_cc_amazon_asin_updated", "1418944104");
INSERT INTO `wp_postmeta` VALUES("194", "39", "_wp_attached_file", "2014/12/41OzCxW-dVL.jpg");
INSERT INTO `wp_postmeta` VALUES("195", "39", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41OzCxW-dVL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41OzCxW-dVL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41OzCxW-dVL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("196", "38", "_thumbnail_id", "39");
INSERT INTO `wp_postmeta` VALUES("197", "38", "imwb_zonpress_post_producturl", "http://www.amazon.com/Bedtime-Bliss%C2%AE-Contoured-Comfortable-Includes/dp/B00FJQFJX8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJQFJX8");
INSERT INTO `wp_postmeta` VALUES("198", "38", "imwb_zonpress_post_price", "12.97");
INSERT INTO `wp_postmeta` VALUES("199", "38", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("200", "38", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("201", "38", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("202", "38", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("203", "38", "imwb_interest_post_link_url", "http://www.amazon.com/Bedtime-Bliss%C2%AE-Contoured-Comfortable-Includes/dp/B00FJQFJX8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJQFJX8");
INSERT INTO `wp_postmeta` VALUES("204", "38", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("206", "40", "imwb_cc_amazon_asin", "B002T3SL7A");
INSERT INTO `wp_postmeta` VALUES("207", "40", "_imwb_cc_amazon_asin_updated", "1418944104");
INSERT INTO `wp_postmeta` VALUES("208", "41", "_wp_attached_file", "2014/12/21g-hKDb89L.jpg");
INSERT INTO `wp_postmeta` VALUES("209", "41", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:350;s:4:\"file\";s:23:\"2014/12/21g-hKDb89L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21g-hKDb89L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21g-hKDb89L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("210", "40", "_thumbnail_id", "41");
INSERT INTO `wp_postmeta` VALUES("211", "40", "imwb_zonpress_post_producturl", "http://www.amazon.com/Christian-Dior-Skinflash-Radiance-Boosting/dp/B002T3SL7A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002T3SL7A");
INSERT INTO `wp_postmeta` VALUES("212", "40", "imwb_zonpress_post_price", "36.95");
INSERT INTO `wp_postmeta` VALUES("213", "40", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("214", "40", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("215", "40", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("216", "40", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("217", "40", "imwb_interest_post_link_url", "http://www.amazon.com/Christian-Dior-Skinflash-Radiance-Boosting/dp/B002T3SL7A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002T3SL7A");
INSERT INTO `wp_postmeta` VALUES("218", "40", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("220", "42", "imwb_cc_amazon_asin", "B00819USTA");
INSERT INTO `wp_postmeta` VALUES("221", "42", "_imwb_cc_amazon_asin_updated", "1418944105");
INSERT INTO `wp_postmeta` VALUES("222", "43", "_wp_attached_file", "2014/12/414Y5AGRKRL.jpg");
INSERT INTO `wp_postmeta` VALUES("223", "43", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:441;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/414Y5AGRKRL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-265x300.jpg\";s:5:\"width\";i:265;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-221x250.jpg\";s:5:\"width\";i:221;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-221x250.jpg\";s:5:\"width\";i:221;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-113x128.jpg\";s:5:\"width\";i:113;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"414Y5AGRKRL-123x140.jpg\";s:5:\"width\";i:123;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"414Y5AGRKRL-44x50.jpg\";s:5:\"width\";i:44;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("224", "42", "_thumbnail_id", "43");
INSERT INTO `wp_postmeta` VALUES("225", "42", "imwb_zonpress_post_producturl", "http://www.amazon.com/Gorgeous-Cosmetics-Powder-Perfect-Pressed/dp/B00819USTA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00819USTA");
INSERT INTO `wp_postmeta` VALUES("226", "42", "imwb_zonpress_post_price", "38");
INSERT INTO `wp_postmeta` VALUES("227", "42", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("228", "42", "_imwb_zonpress_post_imp", "1");
INSERT INTO `wp_postmeta` VALUES("229", "42", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("230", "42", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("231", "42", "imwb_interest_post_link_url", "http://www.amazon.com/Gorgeous-Cosmetics-Powder-Perfect-Pressed/dp/B00819USTA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00819USTA");
INSERT INTO `wp_postmeta` VALUES("232", "42", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("234", "44", "imwb_cc_amazon_asin", "B004YVDM2Y");
INSERT INTO `wp_postmeta` VALUES("235", "44", "_imwb_cc_amazon_asin_updated", "1418944105");
INSERT INTO `wp_postmeta` VALUES("236", "45", "_wp_attached_file", "2014/12/41zufnK-snL.jpg");
INSERT INTO `wp_postmeta` VALUES("237", "45", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:310;s:4:\"file\";s:23:\"2014/12/41zufnK-snL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41zufnK-snL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41zufnK-snL-300x186.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:186;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41zufnK-snL-300x186.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:186;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41zufnK-snL-300x186.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:186;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41zufnK-snL-153x95.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:95;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41zufnK-snL-170x105.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:105;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41zufnK-snL-50x31.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:31;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("238", "44", "_thumbnail_id", "45");
INSERT INTO `wp_postmeta` VALUES("239", "44", "imwb_zonpress_post_producturl", "http://www.amazon.com/stila-The-Light-Shadow-Palette/dp/B004YVDM2Y%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004YVDM2Y");
INSERT INTO `wp_postmeta` VALUES("240", "44", "imwb_zonpress_post_price", "20");
INSERT INTO `wp_postmeta` VALUES("241", "44", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("242", "44", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("243", "44", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("244", "44", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("245", "44", "imwb_interest_post_link_url", "http://www.amazon.com/stila-The-Light-Shadow-Palette/dp/B004YVDM2Y%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004YVDM2Y");
INSERT INTO `wp_postmeta` VALUES("246", "44", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("248", "46", "imwb_cc_amazon_asin", "B00PZLYVL8");
INSERT INTO `wp_postmeta` VALUES("249", "46", "_imwb_cc_amazon_asin_updated", "1418944105");
INSERT INTO `wp_postmeta` VALUES("250", "47", "_wp_attached_file", "2014/12/41nFJo8EZ9L.jpg");
INSERT INTO `wp_postmeta` VALUES("251", "47", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41nFJo8EZ9L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41nFJo8EZ9L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41nFJo8EZ9L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("252", "46", "_thumbnail_id", "47");
INSERT INTO `wp_postmeta` VALUES("253", "46", "imwb_zonpress_post_producturl", "http://www.amazon.com/Guciheaven-Women-Winter-Western-Platform/dp/B00PZLYVL8%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00PZLYVL8");
INSERT INTO `wp_postmeta` VALUES("254", "46", "imwb_zonpress_post_price", "90");
INSERT INTO `wp_postmeta` VALUES("255", "46", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("256", "46", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("257", "46", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("258", "46", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("259", "46", "imwb_interest_post_link_url", "http://www.amazon.com/Guciheaven-Women-Winter-Western-Platform/dp/B00PZLYVL8%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00PZLYVL8");
INSERT INTO `wp_postmeta` VALUES("260", "46", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("262", "48", "imwb_cc_amazon_asin", "B004FKNBWA");
INSERT INTO `wp_postmeta` VALUES("263", "48", "_imwb_cc_amazon_asin_updated", "1418944106");
INSERT INTO `wp_postmeta` VALUES("264", "49", "_wp_attached_file", "2014/12/41jq624lNLL.jpg");
INSERT INTO `wp_postmeta` VALUES("265", "49", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41jq624lNLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41jq624lNLL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41jq624lNLL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("266", "48", "_thumbnail_id", "49");
INSERT INTO `wp_postmeta` VALUES("267", "48", "imwb_zonpress_post_producturl", "http://www.amazon.com/Maxwell-Scott-Luxury-Leather-Cosmetic/dp/B004FKNBWA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004FKNBWA");
INSERT INTO `wp_postmeta` VALUES("268", "48", "imwb_zonpress_post_price", "71");
INSERT INTO `wp_postmeta` VALUES("269", "48", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("270", "48", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("271", "48", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("272", "48", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("273", "48", "imwb_interest_post_link_url", "http://www.amazon.com/Maxwell-Scott-Luxury-Leather-Cosmetic/dp/B004FKNBWA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004FKNBWA");
INSERT INTO `wp_postmeta` VALUES("274", "48", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("276", "50", "imwb_cc_amazon_asin", "B0007O1XQE");
INSERT INTO `wp_postmeta` VALUES("277", "50", "_imwb_cc_amazon_asin_updated", "1418944106");
INSERT INTO `wp_postmeta` VALUES("278", "51", "_wp_attached_file", "2014/12/31lE2jLaNgL.jpg");
INSERT INTO `wp_postmeta` VALUES("279", "51", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:304;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31lE2jLaNgL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31lE2jLaNgL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31lE2jLaNgL-182x300.jpg\";s:5:\"width\";i:182;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31lE2jLaNgL-152x250.jpg\";s:5:\"width\";i:152;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31lE2jLaNgL-152x250.jpg\";s:5:\"width\";i:152;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31lE2jLaNgL-78x128.jpg\";s:5:\"width\";i:78;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31lE2jLaNgL-85x140.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31lE2jLaNgL-30x50.jpg\";s:5:\"width\";i:30;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("280", "50", "_thumbnail_id", "51");
INSERT INTO `wp_postmeta` VALUES("281", "50", "imwb_zonpress_post_producturl", "http://www.amazon.com/Wolford-Individual-Pantyhose-Hosiery-Cosmetic/dp/B0007O1XQE%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0007O1XQE");
INSERT INTO `wp_postmeta` VALUES("282", "50", "imwb_zonpress_post_price", "44.49");
INSERT INTO `wp_postmeta` VALUES("283", "50", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("284", "50", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("285", "50", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("286", "50", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("287", "50", "imwb_interest_post_link_url", "http://www.amazon.com/Wolford-Individual-Pantyhose-Hosiery-Cosmetic/dp/B0007O1XQE%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0007O1XQE");
INSERT INTO `wp_postmeta` VALUES("288", "50", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("290", "52", "imwb_cc_amazon_asin", "B00CV96RO6");
INSERT INTO `wp_postmeta` VALUES("291", "52", "_imwb_cc_amazon_asin_updated", "1418944152");
INSERT INTO `wp_postmeta` VALUES("292", "53", "_wp_attached_file", "2014/12/510SrxUCfkL.jpg");
INSERT INTO `wp_postmeta` VALUES("293", "53", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/510SrxUCfkL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"510SrxUCfkL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"510SrxUCfkL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("294", "52", "_thumbnail_id", "53");
INSERT INTO `wp_postmeta` VALUES("295", "52", "imwb_zonpress_post_producturl", "http://www.amazon.com/Nanshy-Luxury-Makeup-Brushes-Elegant/dp/B00CV96RO6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CV96RO6");
INSERT INTO `wp_postmeta` VALUES("296", "52", "imwb_zonpress_post_price", "44.95");
INSERT INTO `wp_postmeta` VALUES("297", "52", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("298", "52", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("299", "52", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("300", "52", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("301", "52", "imwb_interest_post_link_url", "http://www.amazon.com/Nanshy-Luxury-Makeup-Brushes-Elegant/dp/B00CV96RO6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00CV96RO6");
INSERT INTO `wp_postmeta` VALUES("302", "52", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("304", "54", "imwb_cc_amazon_asin", "B00B2I7Z0C");
INSERT INTO `wp_postmeta` VALUES("305", "54", "_imwb_cc_amazon_asin_updated", "1418944152");
INSERT INTO `wp_postmeta` VALUES("306", "55", "_wp_attached_file", "2014/12/51kEiA7cYjL.jpg");
INSERT INTO `wp_postmeta` VALUES("307", "55", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:467;s:4:\"file\";s:23:\"2014/12/51kEiA7cYjL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-300x280.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:280;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-268x250.jpg\";s:5:\"width\";i:268;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-268x250.jpg\";s:5:\"width\";i:268;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-137x128.jpg\";s:5:\"width\";i:137;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51kEiA7cYjL-150x140.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51kEiA7cYjL-50x47.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:47;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("308", "54", "_thumbnail_id", "55");
INSERT INTO `wp_postmeta` VALUES("309", "54", "imwb_zonpress_post_producturl", "http://www.amazon.com/SDBING-Acrylic-Cosmetics-Organizer-Crystal/dp/B00B2I7Z0C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B2I7Z0C");
INSERT INTO `wp_postmeta` VALUES("310", "54", "imwb_zonpress_post_price", "8");
INSERT INTO `wp_postmeta` VALUES("311", "54", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("312", "54", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("313", "54", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("314", "54", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("315", "54", "imwb_interest_post_link_url", "http://www.amazon.com/SDBING-Acrylic-Cosmetics-Organizer-Crystal/dp/B00B2I7Z0C%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00B2I7Z0C");
INSERT INTO `wp_postmeta` VALUES("316", "54", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("318", "56", "imwb_cc_amazon_asin", "B00942W51C");
INSERT INTO `wp_postmeta` VALUES("319", "56", "_imwb_cc_amazon_asin_updated", "1418944153");
INSERT INTO `wp_postmeta` VALUES("320", "57", "_wp_attached_file", "2014/12/41PiIPc0CLL.jpg");
INSERT INTO `wp_postmeta` VALUES("321", "57", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:350;s:4:\"file\";s:23:\"2014/12/41PiIPc0CLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41PiIPc0CLL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41PiIPc0CLL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("322", "56", "_thumbnail_id", "57");
INSERT INTO `wp_postmeta` VALUES("323", "56", "imwb_zonpress_post_producturl", "http://www.amazon.com/Ben-Nye-Luxury-Powders-Banana/dp/B00942W51C%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00942W51C");
INSERT INTO `wp_postmeta` VALUES("324", "56", "imwb_zonpress_post_price", "15.09");
INSERT INTO `wp_postmeta` VALUES("325", "56", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("326", "56", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("327", "56", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("328", "56", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("329", "56", "imwb_interest_post_link_url", "http://www.amazon.com/Ben-Nye-Luxury-Powders-Banana/dp/B00942W51C%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00942W51C");
INSERT INTO `wp_postmeta` VALUES("330", "56", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("332", "58", "imwb_cc_amazon_asin", "B003AT1CLE");
INSERT INTO `wp_postmeta` VALUES("333", "58", "_imwb_cc_amazon_asin_updated", "1418944153");
INSERT INTO `wp_postmeta` VALUES("334", "59", "_wp_attached_file", "2014/12/21IH29XIhxL.jpg");
INSERT INTO `wp_postmeta` VALUES("335", "59", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:225;s:6:\"height\";i:270;s:4:\"file\";s:23:\"2014/12/21IH29XIhxL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21IH29XIhxL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21IH29XIhxL-208x250.jpg\";s:5:\"width\";i:208;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21IH29XIhxL-208x250.jpg\";s:5:\"width\";i:208;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21IH29XIhxL-107x128.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21IH29XIhxL-117x140.jpg\";s:5:\"width\";i:117;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21IH29XIhxL-42x50.jpg\";s:5:\"width\";i:42;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("336", "58", "_thumbnail_id", "59");
INSERT INTO `wp_postmeta` VALUES("337", "58", "imwb_zonpress_post_producturl", "http://www.amazon.com/Banana-Luxury-Powder-Makeup-Kardashian/dp/B003AT1CLE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003AT1CLE");
INSERT INTO `wp_postmeta` VALUES("338", "58", "imwb_zonpress_post_price", "19.5");
INSERT INTO `wp_postmeta` VALUES("339", "58", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("340", "58", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("341", "58", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("342", "58", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("343", "58", "imwb_interest_post_link_url", "http://www.amazon.com/Banana-Luxury-Powder-Makeup-Kardashian/dp/B003AT1CLE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003AT1CLE");
INSERT INTO `wp_postmeta` VALUES("344", "58", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("346", "60", "imwb_cc_amazon_asin", "B00JCUC368");
INSERT INTO `wp_postmeta` VALUES("347", "60", "_imwb_cc_amazon_asin_updated", "1418944153");
INSERT INTO `wp_postmeta` VALUES("348", "61", "_wp_attached_file", "2014/12/51s5vUmqplL.jpg");
INSERT INTO `wp_postmeta` VALUES("349", "61", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:476;s:4:\"file\";s:23:\"2014/12/51s5vUmqplL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-300x286.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:286;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-263x250.jpg\";s:5:\"width\";i:263;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-263x250.jpg\";s:5:\"width\";i:263;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-134x128.jpg\";s:5:\"width\";i:134;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51s5vUmqplL-147x140.jpg\";s:5:\"width\";i:147;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51s5vUmqplL-50x48.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:48;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("350", "60", "_thumbnail_id", "61");
INSERT INTO `wp_postmeta` VALUES("351", "60", "imwb_zonpress_post_producturl", "http://www.amazon.com/Beauty-Acrylic-Organizer-Cosmetics-1155/dp/B00JCUC368%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JCUC368");
INSERT INTO `wp_postmeta` VALUES("352", "60", "imwb_zonpress_post_price", "35");
INSERT INTO `wp_postmeta` VALUES("353", "60", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("354", "60", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("355", "60", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("356", "60", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("357", "60", "imwb_interest_post_link_url", "http://www.amazon.com/Beauty-Acrylic-Organizer-Cosmetics-1155/dp/B00JCUC368%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JCUC368");
INSERT INTO `wp_postmeta` VALUES("358", "60", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("360", "62", "imwb_cc_amazon_asin", "B00IIUK41E");
INSERT INTO `wp_postmeta` VALUES("361", "62", "_imwb_cc_amazon_asin_updated", "1418944154");
INSERT INTO `wp_postmeta` VALUES("362", "63", "_wp_attached_file", "2014/12/51mOchLG7uL.jpg");
INSERT INTO `wp_postmeta` VALUES("363", "63", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51mOchLG7uL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51mOchLG7uL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51mOchLG7uL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("364", "62", "_thumbnail_id", "63");
INSERT INTO `wp_postmeta` VALUES("365", "62", "imwb_zonpress_post_producturl", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1005-5/dp/B00IIUK41E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IIUK41E");
INSERT INTO `wp_postmeta` VALUES("366", "62", "imwb_zonpress_post_price", "28");
INSERT INTO `wp_postmeta` VALUES("367", "62", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("368", "62", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("369", "62", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("370", "62", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("371", "62", "imwb_interest_post_link_url", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1005-5/dp/B00IIUK41E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IIUK41E");
INSERT INTO `wp_postmeta` VALUES("372", "62", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("374", "64", "imwb_cc_amazon_asin", "B00JG5NVEC");
INSERT INTO `wp_postmeta` VALUES("375", "64", "_imwb_cc_amazon_asin_updated", "1418944155");
INSERT INTO `wp_postmeta` VALUES("376", "65", "_wp_attached_file", "2014/12/51tDZyTpqUL.jpg");
INSERT INTO `wp_postmeta` VALUES("377", "65", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:393;s:4:\"file\";s:23:\"2014/12/51tDZyTpqUL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-300x236.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:236;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-300x236.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:236;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-300x236.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:236;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-153x120.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:120;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51tDZyTpqUL-170x134.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:134;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51tDZyTpqUL-50x39.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:39;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("378", "64", "_thumbnail_id", "65");
INSERT INTO `wp_postmeta` VALUES("379", "64", "imwb_zonpress_post_producturl", "http://www.amazon.com/Luxury-Makeup-Cosmetic-Jewelry-Storage/dp/B00JG5NVEC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JG5NVEC");
INSERT INTO `wp_postmeta` VALUES("380", "64", "imwb_zonpress_post_price", "49.95");
INSERT INTO `wp_postmeta` VALUES("381", "64", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("382", "64", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("383", "64", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("384", "64", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("385", "64", "imwb_interest_post_link_url", "http://www.amazon.com/Luxury-Makeup-Cosmetic-Jewelry-Storage/dp/B00JG5NVEC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JG5NVEC");
INSERT INTO `wp_postmeta` VALUES("386", "64", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("388", "66", "imwb_cc_amazon_asin", "B00I8SN94A");
INSERT INTO `wp_postmeta` VALUES("389", "66", "_imwb_cc_amazon_asin_updated", "1418944155");
INSERT INTO `wp_postmeta` VALUES("390", "67", "_wp_attached_file", "2014/12/51im9EDdYwL.jpg");
INSERT INTO `wp_postmeta` VALUES("391", "67", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51im9EDdYwL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51im9EDdYwL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51im9EDdYwL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("392", "66", "_thumbnail_id", "67");
INSERT INTO `wp_postmeta` VALUES("393", "66", "imwb_zonpress_post_producturl", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1304/dp/B00I8SN94A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00I8SN94A");
INSERT INTO `wp_postmeta` VALUES("394", "66", "imwb_zonpress_post_price", "35");
INSERT INTO `wp_postmeta` VALUES("395", "66", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("396", "66", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("397", "66", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("398", "66", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("399", "66", "imwb_interest_post_link_url", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1304/dp/B00I8SN94A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00I8SN94A");
INSERT INTO `wp_postmeta` VALUES("400", "66", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("402", "68", "imwb_cc_amazon_asin", "B000WY3ALA");
INSERT INTO `wp_postmeta` VALUES("403", "68", "_imwb_cc_amazon_asin_updated", "1418944156");
INSERT INTO `wp_postmeta` VALUES("404", "69", "_wp_attached_file", "2014/12/41bg-9iaztL.jpg");
INSERT INTO `wp_postmeta` VALUES("405", "69", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:400;s:6:\"height\";i:399;s:4:\"file\";s:23:\"2014/12/41bg-9iaztL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-251x250.jpg\";s:5:\"width\";i:251;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41bg-9iaztL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41bg-9iaztL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("406", "68", "_thumbnail_id", "69");
INSERT INTO `wp_postmeta` VALUES("407", "68", "imwb_zonpress_post_producturl", "http://www.amazon.com/Iman-Cosmetics-Luxury-Pressed-Powder/dp/B000WY3ALA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000WY3ALA");
INSERT INTO `wp_postmeta` VALUES("408", "68", "imwb_zonpress_post_price", "16");
INSERT INTO `wp_postmeta` VALUES("409", "68", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("410", "68", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("411", "68", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("412", "68", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("413", "68", "imwb_interest_post_link_url", "http://www.amazon.com/Iman-Cosmetics-Luxury-Pressed-Powder/dp/B000WY3ALA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000WY3ALA");
INSERT INTO `wp_postmeta` VALUES("414", "68", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("416", "70", "imwb_cc_amazon_asin", "B00IIUM2TG");
INSERT INTO `wp_postmeta` VALUES("417", "70", "_imwb_cc_amazon_asin_updated", "1418944156");
INSERT INTO `wp_postmeta` VALUES("418", "71", "_wp_attached_file", "2014/12/51p5xGtrGTL.jpg");
INSERT INTO `wp_postmeta` VALUES("419", "71", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:457;s:4:\"file\";s:23:\"2014/12/51p5xGtrGTL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-300x274.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:274;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-274x250.jpg\";s:5:\"width\";i:274;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-274x250.jpg\";s:5:\"width\";i:274;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-140x128.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51p5xGtrGTL-153x140.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51p5xGtrGTL-50x46.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("420", "70", "_thumbnail_id", "71");
INSERT INTO `wp_postmeta` VALUES("421", "70", "imwb_zonpress_post_producturl", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1005-4/dp/B00IIUM2TG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IIUM2TG");
INSERT INTO `wp_postmeta` VALUES("422", "70", "imwb_zonpress_post_price", "19.99");
INSERT INTO `wp_postmeta` VALUES("423", "70", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("424", "70", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("425", "70", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("426", "70", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("427", "70", "imwb_interest_post_link_url", "http://www.amazon.com/Acrylic-Cosmetic-Organizer-Drawers-1005-4/dp/B00IIUM2TG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00IIUM2TG");
INSERT INTO `wp_postmeta` VALUES("428", "70", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("430", "72", "imwb_cc_amazon_asin", "B0089HGSDE");
INSERT INTO `wp_postmeta` VALUES("431", "72", "_imwb_cc_amazon_asin_updated", "1418944197");
INSERT INTO `wp_postmeta` VALUES("432", "73", "_wp_attached_file", "2014/12/41Xs31LRdYL.jpg");
INSERT INTO `wp_postmeta` VALUES("433", "73", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:459;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41Xs31LRdYL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-275x300.jpg\";s:5:\"width\";i:275;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-230x250.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-230x250.jpg\";s:5:\"width\";i:230;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-118x128.jpg\";s:5:\"width\";i:118;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41Xs31LRdYL-129x140.jpg\";s:5:\"width\";i:129;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41Xs31LRdYL-46x50.jpg\";s:5:\"width\";i:46;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("434", "72", "_thumbnail_id", "73");
INSERT INTO `wp_postmeta` VALUES("435", "72", "imwb_zonpress_post_producturl", "http://www.amazon.com/BURBERRY-Women-Eau-Parfum-100/dp/B0089HGSDE%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0089HGSDE");
INSERT INTO `wp_postmeta` VALUES("436", "72", "imwb_zonpress_post_price", "85");
INSERT INTO `wp_postmeta` VALUES("437", "72", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("438", "72", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("439", "72", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("440", "72", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("441", "72", "imwb_interest_post_link_url", "http://www.amazon.com/BURBERRY-Women-Eau-Parfum-100/dp/B0089HGSDE%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0089HGSDE");
INSERT INTO `wp_postmeta` VALUES("442", "72", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("444", "74", "imwb_cc_amazon_asin", "B00E20VG48");
INSERT INTO `wp_postmeta` VALUES("445", "74", "_imwb_cc_amazon_asin_updated", "1418944198");
INSERT INTO `wp_postmeta` VALUES("446", "75", "_wp_attached_file", "2014/12/41E-T71rQHL.jpg");
INSERT INTO `wp_postmeta` VALUES("447", "75", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41E-T71rQHL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41E-T71rQHL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41E-T71rQHL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("448", "74", "_thumbnail_id", "75");
INSERT INTO `wp_postmeta` VALUES("449", "74", "imwb_zonpress_post_producturl", "http://www.amazon.com/SEA-Premium-Moisturizing-Lotion-Women/dp/B00E20VG48%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E20VG48");
INSERT INTO `wp_postmeta` VALUES("450", "74", "imwb_zonpress_post_price", "20");
INSERT INTO `wp_postmeta` VALUES("451", "74", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("452", "74", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("453", "74", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("454", "74", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("455", "74", "imwb_interest_post_link_url", "http://www.amazon.com/SEA-Premium-Moisturizing-Lotion-Women/dp/B00E20VG48%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00E20VG48");
INSERT INTO `wp_postmeta` VALUES("456", "74", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("458", "76", "imwb_cc_amazon_asin", "B0009OAI2C");
INSERT INTO `wp_postmeta` VALUES("459", "76", "_imwb_cc_amazon_asin_updated", "1418944198");
INSERT INTO `wp_postmeta` VALUES("460", "77", "_wp_attached_file", "2014/12/416hdqpfdhL.jpg");
INSERT INTO `wp_postmeta` VALUES("461", "77", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/416hdqpfdhL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"416hdqpfdhL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"416hdqpfdhL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("462", "76", "_thumbnail_id", "77");
INSERT INTO `wp_postmeta` VALUES("463", "76", "imwb_zonpress_post_producturl", "http://www.amazon.com/Arden-Beauty-Elizabeth-Women-Parfum/dp/B0009OAI2C%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0009OAI2C");
INSERT INTO `wp_postmeta` VALUES("464", "76", "imwb_zonpress_post_price", "15.06");
INSERT INTO `wp_postmeta` VALUES("465", "76", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("466", "76", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("467", "76", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("468", "76", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("469", "76", "imwb_interest_post_link_url", "http://www.amazon.com/Arden-Beauty-Elizabeth-Women-Parfum/dp/B0009OAI2C%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0009OAI2C");
INSERT INTO `wp_postmeta` VALUES("470", "76", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("472", "78", "imwb_cc_amazon_asin", "B000C1W5GY");
INSERT INTO `wp_postmeta` VALUES("473", "78", "_imwb_cc_amazon_asin_updated", "1418944199");
INSERT INTO `wp_postmeta` VALUES("474", "79", "_wp_attached_file", "2014/12/21ChdPcs-oL.jpg");
INSERT INTO `wp_postmeta` VALUES("475", "79", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/12/21ChdPcs-oL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21ChdPcs-oL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21ChdPcs-oL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21ChdPcs-oL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21ChdPcs-oL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21ChdPcs-oL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21ChdPcs-oL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("476", "78", "_thumbnail_id", "79");
INSERT INTO `wp_postmeta` VALUES("477", "78", "imwb_zonpress_post_producturl", "http://www.amazon.com/SWISS-Victorinox-Women-TOILETTE-SPRAY/dp/B000C1W5GY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000C1W5GY");
INSERT INTO `wp_postmeta` VALUES("478", "78", "imwb_zonpress_post_price", "24.75");
INSERT INTO `wp_postmeta` VALUES("479", "78", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("480", "78", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("481", "78", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("482", "78", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("483", "78", "imwb_interest_post_link_url", "http://www.amazon.com/SWISS-Victorinox-Women-TOILETTE-SPRAY/dp/B000C1W5GY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000C1W5GY");
INSERT INTO `wp_postmeta` VALUES("484", "78", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("486", "80", "imwb_cc_amazon_asin", "B001LNOER0");
INSERT INTO `wp_postmeta` VALUES("487", "80", "_imwb_cc_amazon_asin_updated", "1418944199");
INSERT INTO `wp_postmeta` VALUES("488", "81", "_wp_attached_file", "2014/12/41A7H-6NR8L.jpg");
INSERT INTO `wp_postmeta` VALUES("489", "81", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:335;s:4:\"file\";s:23:\"2014/12/41A7H-6NR8L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-300x201.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:201;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-300x201.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:201;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-300x201.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:201;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-153x103.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:103;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41A7H-6NR8L-170x114.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:114;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41A7H-6NR8L-50x34.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:34;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("490", "80", "_thumbnail_id", "81");
INSERT INTO `wp_postmeta` VALUES("491", "80", "imwb_zonpress_post_producturl", "http://www.amazon.com/Pre-Provence-Enriched-Everyday-French/dp/B001LNOER0%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001LNOER0");
INSERT INTO `wp_postmeta` VALUES("492", "80", "imwb_zonpress_post_price", "5.89");
INSERT INTO `wp_postmeta` VALUES("493", "80", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("494", "80", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("495", "80", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("496", "80", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("497", "80", "imwb_interest_post_link_url", "http://www.amazon.com/Pre-Provence-Enriched-Everyday-French/dp/B001LNOER0%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB001LNOER0");
INSERT INTO `wp_postmeta` VALUES("498", "80", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("500", "82", "imwb_cc_amazon_asin", "B00FJW3K24");
INSERT INTO `wp_postmeta` VALUES("501", "82", "_imwb_cc_amazon_asin_updated", "1418944199");
INSERT INTO `wp_postmeta` VALUES("502", "83", "_wp_attached_file", "2014/12/318k6cYgLsL.jpg");
INSERT INTO `wp_postmeta` VALUES("503", "83", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/318k6cYgLsL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"318k6cYgLsL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"318k6cYgLsL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("504", "82", "_thumbnail_id", "83");
INSERT INTO `wp_postmeta` VALUES("505", "82", "imwb_zonpress_post_producturl", "http://www.amazon.com/Lasting-Illusions-Luxury-Fragrance-Eternity/dp/B00FJW3K24%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJW3K24");
INSERT INTO `wp_postmeta` VALUES("506", "82", "imwb_zonpress_post_price", "9.88");
INSERT INTO `wp_postmeta` VALUES("507", "82", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("508", "82", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("509", "82", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("510", "82", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("511", "82", "imwb_interest_post_link_url", "http://www.amazon.com/Lasting-Illusions-Luxury-Fragrance-Eternity/dp/B00FJW3K24%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJW3K24");
INSERT INTO `wp_postmeta` VALUES("512", "82", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("514", "84", "imwb_cc_amazon_asin", "B0039514XU");
INSERT INTO `wp_postmeta` VALUES("515", "84", "_imwb_cc_amazon_asin_updated", "1418944200");
INSERT INTO `wp_postmeta` VALUES("516", "85", "_wp_attached_file", "2014/12/41umBnW4kGL.jpg");
INSERT INTO `wp_postmeta` VALUES("517", "85", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41umBnW4kGL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41umBnW4kGL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41umBnW4kGL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("518", "84", "_thumbnail_id", "85");
INSERT INTO `wp_postmeta` VALUES("519", "84", "imwb_zonpress_post_producturl", "http://www.amazon.com/NEST-Fragrances-NEST01-BG-Scented-Classic/dp/B0039514XU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0039514XU");
INSERT INTO `wp_postmeta` VALUES("520", "84", "imwb_zonpress_post_price", "31.97");
INSERT INTO `wp_postmeta` VALUES("521", "84", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("522", "84", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("523", "84", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("524", "84", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("525", "84", "imwb_interest_post_link_url", "http://www.amazon.com/NEST-Fragrances-NEST01-BG-Scented-Classic/dp/B0039514XU%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0039514XU");
INSERT INTO `wp_postmeta` VALUES("526", "84", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("528", "86", "imwb_cc_amazon_asin", "B00FBH6WFY");
INSERT INTO `wp_postmeta` VALUES("529", "86", "_imwb_cc_amazon_asin_updated", "1418944200");
INSERT INTO `wp_postmeta` VALUES("530", "87", "_wp_attached_file", "2014/12/41Jp-VTJTuL.jpg");
INSERT INTO `wp_postmeta` VALUES("531", "87", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:341;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41Jp-VTJTuL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41Jp-VTJTuL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41Jp-VTJTuL-205x300.jpg\";s:5:\"width\";i:205;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41Jp-VTJTuL-171x250.jpg\";s:5:\"width\";i:171;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41Jp-VTJTuL-171x250.jpg\";s:5:\"width\";i:171;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41Jp-VTJTuL-87x128.jpg\";s:5:\"width\";i:87;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41Jp-VTJTuL-95x140.jpg\";s:5:\"width\";i:95;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41Jp-VTJTuL-34x50.jpg\";s:5:\"width\";i:34;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("532", "86", "_thumbnail_id", "87");
INSERT INTO `wp_postmeta` VALUES("533", "86", "imwb_zonpress_post_producturl", "http://www.amazon.com/BURBERRY-The-Beat-Woman-Toilette/dp/B00FBH6WFY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FBH6WFY");
INSERT INTO `wp_postmeta` VALUES("534", "86", "imwb_zonpress_post_price", "80");
INSERT INTO `wp_postmeta` VALUES("535", "86", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("536", "86", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("537", "86", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("538", "86", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("539", "86", "imwb_interest_post_link_url", "http://www.amazon.com/BURBERRY-The-Beat-Woman-Toilette/dp/B00FBH6WFY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FBH6WFY");
INSERT INTO `wp_postmeta` VALUES("540", "86", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("542", "88", "imwb_cc_amazon_asin", "B0012RST8K");
INSERT INTO `wp_postmeta` VALUES("543", "88", "_imwb_cc_amazon_asin_updated", "1418944201");
INSERT INTO `wp_postmeta` VALUES("544", "89", "_wp_attached_file", "2014/12/31mmi8YzclL.jpg");
INSERT INTO `wp_postmeta` VALUES("545", "89", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:433;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31mmi8YzclL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-260x300.jpg\";s:5:\"width\";i:260;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-217x250.jpg\";s:5:\"width\";i:217;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-217x250.jpg\";s:5:\"width\";i:217;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-111x128.jpg\";s:5:\"width\";i:111;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31mmi8YzclL-121x140.jpg\";s:5:\"width\";i:121;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31mmi8YzclL-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("546", "88", "_thumbnail_id", "89");
INSERT INTO `wp_postmeta` VALUES("547", "88", "imwb_zonpress_post_producturl", "http://www.amazon.com/Cashmere-Donna-Karan-Women-3-4-Ounces/dp/B0012RST8K%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0012RST8K");
INSERT INTO `wp_postmeta` VALUES("548", "88", "imwb_zonpress_post_price", "54");
INSERT INTO `wp_postmeta` VALUES("549", "88", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("550", "88", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("551", "88", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("552", "88", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("553", "88", "imwb_interest_post_link_url", "http://www.amazon.com/Cashmere-Donna-Karan-Women-3-4-Ounces/dp/B0012RST8K%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0012RST8K");
INSERT INTO `wp_postmeta` VALUES("554", "88", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("556", "90", "imwb_cc_amazon_asin", "B00BR1M5YK");
INSERT INTO `wp_postmeta` VALUES("557", "90", "_imwb_cc_amazon_asin_updated", "1418944201");
INSERT INTO `wp_postmeta` VALUES("558", "91", "_wp_attached_file", "2014/12/41ZKF8pPsLL.jpg");
INSERT INTO `wp_postmeta` VALUES("559", "91", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:253;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41ZKF8pPsLL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41ZKF8pPsLL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41ZKF8pPsLL-152x300.jpg\";s:5:\"width\";i:152;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41ZKF8pPsLL-127x250.jpg\";s:5:\"width\";i:127;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41ZKF8pPsLL-127x250.jpg\";s:5:\"width\";i:127;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41ZKF8pPsLL-65x128.jpg\";s:5:\"width\";i:65;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41ZKF8pPsLL-71x140.jpg\";s:5:\"width\";i:71;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41ZKF8pPsLL-25x50.jpg\";s:5:\"width\";i:25;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("560", "90", "_thumbnail_id", "91");
INSERT INTO `wp_postmeta` VALUES("561", "90", "imwb_zonpress_post_producturl", "http://www.amazon.com/BURBERRY-Brit-Women-Eau-Toilette/dp/B00BR1M5YK%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BR1M5YK");
INSERT INTO `wp_postmeta` VALUES("562", "90", "imwb_zonpress_post_price", "84");
INSERT INTO `wp_postmeta` VALUES("563", "90", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("564", "90", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("565", "90", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("566", "90", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("567", "90", "imwb_interest_post_link_url", "http://www.amazon.com/BURBERRY-Brit-Women-Eau-Toilette/dp/B00BR1M5YK%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BR1M5YK");
INSERT INTO `wp_postmeta` VALUES("568", "90", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("570", "92", "imwb_cc_amazon_asin", "B0006PKF2W");
INSERT INTO `wp_postmeta` VALUES("571", "92", "_imwb_cc_amazon_asin_updated", "1418944202");
INSERT INTO `wp_postmeta` VALUES("572", "93", "_wp_attached_file", "2014/12/216UOVOu-zL.jpg");
INSERT INTO `wp_postmeta` VALUES("573", "93", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/12/216UOVOu-zL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"216UOVOu-zL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"216UOVOu-zL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"216UOVOu-zL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"216UOVOu-zL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"216UOVOu-zL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"216UOVOu-zL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("574", "92", "_thumbnail_id", "93");
INSERT INTO `wp_postmeta` VALUES("575", "92", "imwb_zonpress_post_producturl", "http://www.amazon.com/Lavender-Taylor-London-Luxury-Perfumed/dp/B0006PKF2W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0006PKF2W");
INSERT INTO `wp_postmeta` VALUES("576", "92", "imwb_zonpress_post_price", "19.99");
INSERT INTO `wp_postmeta` VALUES("577", "92", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("578", "92", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("579", "92", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("580", "92", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("581", "92", "imwb_interest_post_link_url", "http://www.amazon.com/Lavender-Taylor-London-Luxury-Perfumed/dp/B0006PKF2W%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0006PKF2W");
INSERT INTO `wp_postmeta` VALUES("582", "92", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("584", "94", "imwb_cc_amazon_asin", "B00K8F86YY");
INSERT INTO `wp_postmeta` VALUES("585", "94", "_imwb_cc_amazon_asin_updated", "1418944202");
INSERT INTO `wp_postmeta` VALUES("586", "95", "_wp_attached_file", "2014/12/11lF6hrumzL.jpg");
INSERT INTO `wp_postmeta` VALUES("587", "95", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:180;s:6:\"height\";i:180;s:4:\"file\";s:23:\"2014/12/11lF6hrumzL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"11lF6hrumzL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"11lF6hrumzL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"11lF6hrumzL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"11lF6hrumzL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("588", "94", "_thumbnail_id", "95");
INSERT INTO `wp_postmeta` VALUES("589", "94", "imwb_zonpress_post_producturl", "http://www.amazon.com/Lasting-Illusions-Men-Acqua-Gio/dp/B00K8F86YY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00K8F86YY");
INSERT INTO `wp_postmeta` VALUES("590", "94", "imwb_zonpress_post_price", "12.29");
INSERT INTO `wp_postmeta` VALUES("591", "94", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("592", "94", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("593", "94", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("594", "94", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("595", "94", "imwb_interest_post_link_url", "http://www.amazon.com/Lasting-Illusions-Men-Acqua-Gio/dp/B00K8F86YY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00K8F86YY");
INSERT INTO `wp_postmeta` VALUES("596", "94", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("598", "96", "imwb_cc_amazon_asin", "B004LD7GJU");
INSERT INTO `wp_postmeta` VALUES("599", "96", "_imwb_cc_amazon_asin_updated", "1418944203");
INSERT INTO `wp_postmeta` VALUES("600", "97", "_wp_attached_file", "2014/12/51LDsRBbooL.jpg");
INSERT INTO `wp_postmeta` VALUES("601", "97", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51LDsRBbooL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51LDsRBbooL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51LDsRBbooL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("602", "96", "_thumbnail_id", "97");
INSERT INTO `wp_postmeta` VALUES("603", "96", "imwb_zonpress_post_producturl", "http://www.amazon.com/Jimmy-Choo-Women-Parfum-Spray/dp/B004LD7GJU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004LD7GJU");
INSERT INTO `wp_postmeta` VALUES("604", "96", "imwb_zonpress_post_price", "31");
INSERT INTO `wp_postmeta` VALUES("605", "96", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("606", "96", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("607", "96", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("608", "96", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("609", "96", "imwb_interest_post_link_url", "http://www.amazon.com/Jimmy-Choo-Women-Parfum-Spray/dp/B004LD7GJU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB004LD7GJU");
INSERT INTO `wp_postmeta` VALUES("610", "96", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("612", "98", "imwb_cc_amazon_asin", "B00FBH64NY");
INSERT INTO `wp_postmeta` VALUES("613", "98", "_imwb_cc_amazon_asin_updated", "1418944204");
INSERT INTO `wp_postmeta` VALUES("614", "99", "_wp_attached_file", "2014/12/31PEWwIuaAL.jpg");
INSERT INTO `wp_postmeta` VALUES("615", "99", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:213;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31PEWwIuaAL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31PEWwIuaAL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31PEWwIuaAL-128x300.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31PEWwIuaAL-107x250.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31PEWwIuaAL-107x250.jpg\";s:5:\"width\";i:107;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31PEWwIuaAL-55x128.jpg\";s:5:\"width\";i:55;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31PEWwIuaAL-60x140.jpg\";s:5:\"width\";i:60;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31PEWwIuaAL-21x50.jpg\";s:5:\"width\";i:21;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("616", "98", "_thumbnail_id", "99");
INSERT INTO `wp_postmeta` VALUES("617", "98", "imwb_zonpress_post_producturl", "http://www.amazon.com/BURBERRY-Touch-Women-Eau-Parfum/dp/B00FBH64NY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FBH64NY");
INSERT INTO `wp_postmeta` VALUES("618", "98", "imwb_zonpress_post_price", "90");
INSERT INTO `wp_postmeta` VALUES("619", "98", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("620", "98", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("621", "98", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("622", "98", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("623", "98", "imwb_interest_post_link_url", "http://www.amazon.com/BURBERRY-Touch-Women-Eau-Parfum/dp/B00FBH64NY%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FBH64NY");
INSERT INTO `wp_postmeta` VALUES("624", "98", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("626", "100", "imwb_cc_amazon_asin", "B0050ZINKO");
INSERT INTO `wp_postmeta` VALUES("627", "100", "_imwb_cc_amazon_asin_updated", "1418944205");
INSERT INTO `wp_postmeta` VALUES("628", "101", "_wp_attached_file", "2014/12/31ylgR5JjAL.jpg");
INSERT INTO `wp_postmeta` VALUES("629", "101", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/12/31ylgR5JjAL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31ylgR5JjAL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31ylgR5JjAL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31ylgR5JjAL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31ylgR5JjAL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31ylgR5JjAL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31ylgR5JjAL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("630", "100", "_thumbnail_id", "101");
INSERT INTO `wp_postmeta` VALUES("631", "100", "imwb_zonpress_post_producturl", "http://www.amazon.com/Buchman-Luxury-Estee-Lauder-Perfume/dp/B0050ZINKO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0050ZINKO");
INSERT INTO `wp_postmeta` VALUES("632", "100", "imwb_zonpress_post_price", "65.95");
INSERT INTO `wp_postmeta` VALUES("633", "100", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("634", "100", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("635", "100", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("636", "100", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("637", "100", "imwb_interest_post_link_url", "http://www.amazon.com/Buchman-Luxury-Estee-Lauder-Perfume/dp/B0050ZINKO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0050ZINKO");
INSERT INTO `wp_postmeta` VALUES("638", "100", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("640", "102", "imwb_cc_amazon_asin", "B00FY5KVRI");
INSERT INTO `wp_postmeta` VALUES("641", "102", "_imwb_cc_amazon_asin_updated", "1418944205");
INSERT INTO `wp_postmeta` VALUES("642", "103", "_wp_attached_file", "2014/12/21zhLkKRWVL.jpg");
INSERT INTO `wp_postmeta` VALUES("643", "103", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:142;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/21zhLkKRWVL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21zhLkKRWVL-142x150.jpg\";s:5:\"width\";i:142;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:22:\"21zhLkKRWVL-85x300.jpg\";s:5:\"width\";i:85;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21zhLkKRWVL-71x250.jpg\";s:5:\"width\";i:71;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21zhLkKRWVL-71x250.jpg\";s:5:\"width\";i:71;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21zhLkKRWVL-36x128.jpg\";s:5:\"width\";i:36;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21zhLkKRWVL-40x140.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21zhLkKRWVL-14x50.jpg\";s:5:\"width\";i:14;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("644", "102", "_thumbnail_id", "103");
INSERT INTO `wp_postmeta` VALUES("645", "102", "imwb_zonpress_post_producturl", "http://www.amazon.com/BURBERRY-Sport-Women-Eau-Toilette/dp/B00FY5KVRI%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FY5KVRI");
INSERT INTO `wp_postmeta` VALUES("646", "102", "imwb_zonpress_post_price", "80");
INSERT INTO `wp_postmeta` VALUES("647", "102", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("648", "102", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("649", "102", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("650", "102", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("651", "102", "imwb_interest_post_link_url", "http://www.amazon.com/BURBERRY-Sport-Women-Eau-Toilette/dp/B00FY5KVRI%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FY5KVRI");
INSERT INTO `wp_postmeta` VALUES("652", "102", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("654", "104", "imwb_cc_amazon_asin", "B000C2175S");
INSERT INTO `wp_postmeta` VALUES("655", "104", "_imwb_cc_amazon_asin_updated", "1418944206");
INSERT INTO `wp_postmeta` VALUES("656", "105", "_wp_attached_file", "2014/12/31FVvlkKsjL.jpg");
INSERT INTO `wp_postmeta` VALUES("657", "105", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:350;s:4:\"file\";s:23:\"2014/12/31FVvlkKsjL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31FVvlkKsjL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31FVvlkKsjL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("658", "104", "_thumbnail_id", "105");
INSERT INTO `wp_postmeta` VALUES("659", "104", "imwb_zonpress_post_producturl", "http://www.amazon.com/Cerruti-Nino-Women-Luxury-Lotion/dp/B000C2175S%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000C2175S");
INSERT INTO `wp_postmeta` VALUES("660", "104", "imwb_zonpress_post_price", "10.29");
INSERT INTO `wp_postmeta` VALUES("661", "104", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("662", "104", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("663", "104", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("664", "104", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("665", "104", "imwb_interest_post_link_url", "http://www.amazon.com/Cerruti-Nino-Women-Luxury-Lotion/dp/B000C2175S%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000C2175S");
INSERT INTO `wp_postmeta` VALUES("666", "104", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("668", "106", "imwb_cc_amazon_asin", "B0019LRD9A");
INSERT INTO `wp_postmeta` VALUES("669", "106", "_imwb_cc_amazon_asin_updated", "1418944252");
INSERT INTO `wp_postmeta` VALUES("670", "107", "_wp_attached_file", "2014/12/51E51U2CZ-L.jpg");
INSERT INTO `wp_postmeta` VALUES("671", "107", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51E51U2CZ-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51E51U2CZ-L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51E51U2CZ-L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("672", "106", "_thumbnail_id", "107");
INSERT INTO `wp_postmeta` VALUES("673", "106", "imwb_zonpress_post_producturl", "http://www.amazon.com/Enjoy-Sulfate-free-Hydrating-Shampoo-Conditioner/dp/B0019LRD9A%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0019LRD9A");
INSERT INTO `wp_postmeta` VALUES("674", "106", "imwb_zonpress_post_price", "39.47");
INSERT INTO `wp_postmeta` VALUES("675", "106", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("676", "106", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("677", "106", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("678", "106", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("679", "106", "imwb_interest_post_link_url", "http://www.amazon.com/Enjoy-Sulfate-free-Hydrating-Shampoo-Conditioner/dp/B0019LRD9A%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0019LRD9A");
INSERT INTO `wp_postmeta` VALUES("680", "106", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("682", "108", "imwb_cc_amazon_asin", "B0079R6BD2");
INSERT INTO `wp_postmeta` VALUES("683", "108", "_imwb_cc_amazon_asin_updated", "1418944253");
INSERT INTO `wp_postmeta` VALUES("684", "109", "_wp_attached_file", "2014/12/41O3BmiNgTL.jpg");
INSERT INTO `wp_postmeta` VALUES("685", "109", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41O3BmiNgTL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41O3BmiNgTL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41O3BmiNgTL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("686", "108", "_thumbnail_id", "109");
INSERT INTO `wp_postmeta` VALUES("687", "108", "imwb_zonpress_post_producturl", "http://www.amazon.com/Pura-dor-Prevention-Premium-Organic/dp/B0079R6BD2%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0079R6BD2");
INSERT INTO `wp_postmeta` VALUES("688", "108", "imwb_zonpress_post_price", "18.99");
INSERT INTO `wp_postmeta` VALUES("689", "108", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("690", "108", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("691", "108", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("692", "108", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("693", "108", "imwb_interest_post_link_url", "http://www.amazon.com/Pura-dor-Prevention-Premium-Organic/dp/B0079R6BD2%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0079R6BD2");
INSERT INTO `wp_postmeta` VALUES("694", "108", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("696", "110", "imwb_cc_amazon_asin", "B00KP5Y6N2");
INSERT INTO `wp_postmeta` VALUES("697", "110", "_imwb_cc_amazon_asin_updated", "1418944254");
INSERT INTO `wp_postmeta` VALUES("698", "111", "_wp_attached_file", "2014/12/51qm1Lpo8-L.jpg");
INSERT INTO `wp_postmeta` VALUES("699", "111", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:469;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51qm1Lpo8-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-281x300.jpg\";s:5:\"width\";i:281;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-120x128.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51qm1Lpo8-L-131x140.jpg\";s:5:\"width\";i:131;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51qm1Lpo8-L-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("700", "110", "_thumbnail_id", "111");
INSERT INTO `wp_postmeta` VALUES("701", "110", "imwb_zonpress_post_producturl", "http://www.amazon.com/Best-Leave-In-Conditioner-Hair-Serum/dp/B00KP5Y6N2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KP5Y6N2");
INSERT INTO `wp_postmeta` VALUES("702", "110", "imwb_zonpress_post_price", "27.49");
INSERT INTO `wp_postmeta` VALUES("703", "110", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("704", "110", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("705", "110", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("706", "110", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("707", "110", "imwb_interest_post_link_url", "http://www.amazon.com/Best-Leave-In-Conditioner-Hair-Serum/dp/B00KP5Y6N2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KP5Y6N2");
INSERT INTO `wp_postmeta` VALUES("708", "110", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("710", "112", "imwb_cc_amazon_asin", "B00KOKS2NI");
INSERT INTO `wp_postmeta` VALUES("711", "112", "_imwb_cc_amazon_asin_updated", "1418944254");
INSERT INTO `wp_postmeta` VALUES("712", "113", "_wp_attached_file", "2014/12/51C7UXlyDeL.jpg");
INSERT INTO `wp_postmeta` VALUES("713", "113", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51C7UXlyDeL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51C7UXlyDeL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51C7UXlyDeL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("714", "112", "_thumbnail_id", "113");
INSERT INTO `wp_postmeta` VALUES("715", "112", "imwb_zonpress_post_producturl", "http://www.amazon.com/Best-Deep-Conditioner-Hair-Mask/dp/B00KOKS2NI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KOKS2NI");
INSERT INTO `wp_postmeta` VALUES("716", "112", "imwb_zonpress_post_price", "18.99");
INSERT INTO `wp_postmeta` VALUES("717", "112", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("718", "112", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("719", "112", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("720", "112", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("721", "112", "imwb_interest_post_link_url", "http://www.amazon.com/Best-Deep-Conditioner-Hair-Mask/dp/B00KOKS2NI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KOKS2NI");
INSERT INTO `wp_postmeta` VALUES("722", "112", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("724", "114", "imwb_cc_amazon_asin", "B0032FSDOA");
INSERT INTO `wp_postmeta` VALUES("725", "114", "_imwb_cc_amazon_asin_updated", "1418944255");
INSERT INTO `wp_postmeta` VALUES("726", "115", "_wp_attached_file", "2014/12/31eIF1DNwrL.jpg");
INSERT INTO `wp_postmeta` VALUES("727", "115", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31eIF1DNwrL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31eIF1DNwrL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31eIF1DNwrL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("728", "114", "_thumbnail_id", "115");
INSERT INTO `wp_postmeta` VALUES("729", "114", "imwb_zonpress_post_producturl", "http://www.amazon.com/Regenepure-DR-Hair-Loss-Treatment/dp/B0032FSDOA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0032FSDOA");
INSERT INTO `wp_postmeta` VALUES("730", "114", "imwb_zonpress_post_price", "17.1");
INSERT INTO `wp_postmeta` VALUES("731", "114", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("732", "114", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("733", "114", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("734", "114", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("735", "114", "imwb_interest_post_link_url", "http://www.amazon.com/Regenepure-DR-Hair-Loss-Treatment/dp/B0032FSDOA%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0032FSDOA");
INSERT INTO `wp_postmeta` VALUES("736", "114", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("738", "116", "imwb_cc_amazon_asin", "B00KPU21DE");
INSERT INTO `wp_postmeta` VALUES("739", "116", "_imwb_cc_amazon_asin_updated", "1418944255");
INSERT INTO `wp_postmeta` VALUES("740", "117", "_wp_attached_file", "2014/12/51cPByYotXL.jpg");
INSERT INTO `wp_postmeta` VALUES("741", "117", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:375;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51cPByYotXL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51cPByYotXL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51cPByYotXL-225x300.jpg\";s:5:\"width\";i:225;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51cPByYotXL-188x250.jpg\";s:5:\"width\";i:188;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51cPByYotXL-188x250.jpg\";s:5:\"width\";i:188;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"51cPByYotXL-96x128.jpg\";s:5:\"width\";i:96;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51cPByYotXL-105x140.jpg\";s:5:\"width\";i:105;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51cPByYotXL-38x50.jpg\";s:5:\"width\";i:38;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("742", "116", "_thumbnail_id", "117");
INSERT INTO `wp_postmeta` VALUES("743", "116", "imwb_zonpress_post_producturl", "http://www.amazon.com/Best-Leave-In-Conditioner-Hair-Moisturizer/dp/B00KPU21DE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KPU21DE");
INSERT INTO `wp_postmeta` VALUES("744", "116", "imwb_zonpress_post_price", "21.99");
INSERT INTO `wp_postmeta` VALUES("745", "116", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("746", "116", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("747", "116", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("748", "116", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("749", "116", "imwb_interest_post_link_url", "http://www.amazon.com/Best-Leave-In-Conditioner-Hair-Moisturizer/dp/B00KPU21DE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KPU21DE");
INSERT INTO `wp_postmeta` VALUES("750", "116", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("752", "118", "imwb_cc_amazon_asin", "B00N9P7AWO");
INSERT INTO `wp_postmeta` VALUES("753", "118", "_imwb_cc_amazon_asin_updated", "1418944256");
INSERT INTO `wp_postmeta` VALUES("754", "119", "_wp_attached_file", "2014/12/51tEGaKbpnL.jpg");
INSERT INTO `wp_postmeta` VALUES("755", "119", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51tEGaKbpnL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51tEGaKbpnL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51tEGaKbpnL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("756", "118", "_thumbnail_id", "119");
INSERT INTO `wp_postmeta` VALUES("757", "118", "imwb_zonpress_post_producturl", "http://www.amazon.com/Charcoal-Natural-Cleansing-Exfoliating-Beauty/dp/B00N9P7AWO%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00N9P7AWO");
INSERT INTO `wp_postmeta` VALUES("758", "118", "imwb_zonpress_post_price", "14.99");
INSERT INTO `wp_postmeta` VALUES("759", "118", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("760", "118", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("761", "118", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("762", "118", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("763", "118", "imwb_interest_post_link_url", "http://www.amazon.com/Charcoal-Natural-Cleansing-Exfoliating-Beauty/dp/B00N9P7AWO%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00N9P7AWO");
INSERT INTO `wp_postmeta` VALUES("764", "118", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("766", "120", "imwb_cc_amazon_asin", "B00O4HTP0G");
INSERT INTO `wp_postmeta` VALUES("767", "120", "_imwb_cc_amazon_asin_updated", "1418944256");
INSERT INTO `wp_postmeta` VALUES("768", "121", "_wp_attached_file", "2014/12/518EypESbpL.jpg");
INSERT INTO `wp_postmeta` VALUES("769", "121", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/518EypESbpL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"518EypESbpL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"518EypESbpL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("770", "120", "_thumbnail_id", "121");
INSERT INTO `wp_postmeta` VALUES("771", "120", "imwb_zonpress_post_producturl", "http://www.amazon.com/Dexe-Hair-Builder-Fibers-Application/dp/B00O4HTP0G%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00O4HTP0G");
INSERT INTO `wp_postmeta` VALUES("772", "120", "imwb_zonpress_post_price", "11.95");
INSERT INTO `wp_postmeta` VALUES("773", "120", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("774", "120", "_imwb_zonpress_post_imp", "4");
INSERT INTO `wp_postmeta` VALUES("775", "120", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("776", "120", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("777", "120", "imwb_interest_post_link_url", "http://www.amazon.com/Dexe-Hair-Builder-Fibers-Application/dp/B00O4HTP0G%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00O4HTP0G");
INSERT INTO `wp_postmeta` VALUES("778", "120", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("780", "122", "imwb_cc_amazon_asin", "B00KMTA7MK");
INSERT INTO `wp_postmeta` VALUES("781", "122", "_imwb_cc_amazon_asin_updated", "1418944257");
INSERT INTO `wp_postmeta` VALUES("782", "123", "_wp_attached_file", "2014/12/51OGk1wU6gL.jpg");
INSERT INTO `wp_postmeta` VALUES("783", "123", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:469;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51OGk1wU6gL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-281x300.jpg\";s:5:\"width\";i:281;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-120x128.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51OGk1wU6gL-131x140.jpg\";s:5:\"width\";i:131;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51OGk1wU6gL-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("784", "122", "_thumbnail_id", "123");
INSERT INTO `wp_postmeta` VALUES("785", "122", "imwb_zonpress_post_producturl", "http://www.amazon.com/Hair-Relaxer-Texturizer-Anti-Frizz-Cream/dp/B00KMTA7MK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KMTA7MK");
INSERT INTO `wp_postmeta` VALUES("786", "122", "imwb_zonpress_post_price", "18.99");
INSERT INTO `wp_postmeta` VALUES("787", "122", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("788", "122", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("789", "122", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("790", "122", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("791", "122", "imwb_interest_post_link_url", "http://www.amazon.com/Hair-Relaxer-Texturizer-Anti-Frizz-Cream/dp/B00KMTA7MK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KMTA7MK");
INSERT INTO `wp_postmeta` VALUES("792", "122", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("794", "124", "imwb_cc_amazon_asin", "B00O4IKM70");
INSERT INTO `wp_postmeta` VALUES("795", "124", "_imwb_cc_amazon_asin_updated", "1418944257");
INSERT INTO `wp_postmeta` VALUES("796", "125", "_wp_attached_file", "2014/12/41by8eTbInL.jpg");
INSERT INTO `wp_postmeta` VALUES("797", "125", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41by8eTbInL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41by8eTbInL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41by8eTbInL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("798", "124", "_thumbnail_id", "125");
INSERT INTO `wp_postmeta` VALUES("799", "124", "imwb_zonpress_post_producturl", "http://www.amazon.com/Hair-Maker-Bilding-Kit-Replacement/dp/B00O4IKM70%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00O4IKM70");
INSERT INTO `wp_postmeta` VALUES("800", "124", "imwb_zonpress_post_price", "24.95");
INSERT INTO `wp_postmeta` VALUES("801", "124", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("802", "124", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("803", "124", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("804", "124", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("805", "124", "imwb_interest_post_link_url", "http://www.amazon.com/Hair-Maker-Bilding-Kit-Replacement/dp/B00O4IKM70%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00O4IKM70");
INSERT INTO `wp_postmeta` VALUES("806", "124", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("807", "126", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("808", "126", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("809", "126", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("810", "126", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("811", "126", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("812", "126", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("813", "126", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("814", "126", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("816", "127", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("817", "127", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("818", "127", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("819", "127", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("820", "127", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("821", "127", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("822", "127", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("823", "127", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("825", "128", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("826", "128", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("827", "128", "_menu_item_object_id", "1");
INSERT INTO `wp_postmeta` VALUES("828", "128", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("829", "128", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("830", "128", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("831", "128", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("832", "128", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("834", "129", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("835", "129", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("836", "129", "_menu_item_object_id", "4");
INSERT INTO `wp_postmeta` VALUES("837", "129", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("838", "129", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("839", "129", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("840", "129", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("841", "129", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("843", "130", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("844", "130", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("845", "130", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("846", "130", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("847", "130", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("848", "130", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("849", "130", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("850", "130", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("853", "131", "imwb_cc_amazon_asin", "B00H1P15VK");
INSERT INTO `wp_postmeta` VALUES("854", "131", "_imwb_cc_amazon_asin_updated", "1418944638");
INSERT INTO `wp_postmeta` VALUES("855", "132", "_wp_attached_file", "2014/12/51ntXbRdhgL.jpg");
INSERT INTO `wp_postmeta` VALUES("856", "132", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51ntXbRdhgL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51ntXbRdhgL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51ntXbRdhgL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("857", "131", "_thumbnail_id", "132");
INSERT INTO `wp_postmeta` VALUES("858", "131", "imwb_zonpress_post_producturl", "http://www.amazon.com/OJIA-Personal-Manicure-Pedicure-Grooming/dp/B00H1P15VK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H1P15VK");
INSERT INTO `wp_postmeta` VALUES("859", "131", "imwb_zonpress_post_price", "18.96");
INSERT INTO `wp_postmeta` VALUES("860", "131", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("861", "131", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("862", "131", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("863", "131", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("864", "131", "imwb_interest_post_link_url", "http://www.amazon.com/OJIA-Personal-Manicure-Pedicure-Grooming/dp/B00H1P15VK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00H1P15VK");
INSERT INTO `wp_postmeta` VALUES("865", "131", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("867", "133", "imwb_cc_amazon_asin", "B00FECVBNY");
INSERT INTO `wp_postmeta` VALUES("868", "133", "_imwb_cc_amazon_asin_updated", "1418944639");
INSERT INTO `wp_postmeta` VALUES("869", "134", "_wp_attached_file", "2014/12/51biDKlZyjL.jpg");
INSERT INTO `wp_postmeta` VALUES("870", "134", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51biDKlZyjL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51biDKlZyjL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51biDKlZyjL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("871", "133", "_thumbnail_id", "134");
INSERT INTO `wp_postmeta` VALUES("872", "133", "imwb_zonpress_post_producturl", "http://www.amazon.com/OJIA-Stainless-Professional-Manicure-Pedicure/dp/B00FECVBNY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FECVBNY");
INSERT INTO `wp_postmeta` VALUES("873", "133", "imwb_zonpress_post_price", "7.52");
INSERT INTO `wp_postmeta` VALUES("874", "133", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("875", "133", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("876", "133", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("877", "133", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("878", "133", "imwb_interest_post_link_url", "http://www.amazon.com/OJIA-Stainless-Professional-Manicure-Pedicure/dp/B00FECVBNY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FECVBNY");
INSERT INTO `wp_postmeta` VALUES("879", "133", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("881", "135", "imwb_cc_amazon_asin", "B00N0MWUFS");
INSERT INTO `wp_postmeta` VALUES("882", "135", "_imwb_cc_amazon_asin_updated", "1418944639");
INSERT INTO `wp_postmeta` VALUES("883", "136", "_wp_attached_file", "2014/12/41JTNoG7v7L.jpg");
INSERT INTO `wp_postmeta` VALUES("884", "136", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:331;s:4:\"file\";s:23:\"2014/12/41JTNoG7v7L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-300x199.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:199;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-153x101.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:101;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41JTNoG7v7L-170x113.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:113;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41JTNoG7v7L-50x33.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:33;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("885", "135", "_thumbnail_id", "136");
INSERT INTO `wp_postmeta` VALUES("886", "135", "imwb_zonpress_post_producturl", "http://www.amazon.com/Wild-us-Personal-Manicure-Pedicure-Grooming/dp/B00N0MWUFS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00N0MWUFS");
INSERT INTO `wp_postmeta` VALUES("887", "135", "imwb_zonpress_post_price", "12.99");
INSERT INTO `wp_postmeta` VALUES("888", "135", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("889", "135", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("890", "135", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("891", "135", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("892", "135", "imwb_interest_post_link_url", "http://www.amazon.com/Wild-us-Personal-Manicure-Pedicure-Grooming/dp/B00N0MWUFS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00N0MWUFS");
INSERT INTO `wp_postmeta` VALUES("893", "135", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("895", "137", "imwb_cc_amazon_asin", "B00GQ0GD4A");
INSERT INTO `wp_postmeta` VALUES("896", "137", "_imwb_cc_amazon_asin_updated", "1418944640");
INSERT INTO `wp_postmeta` VALUES("897", "138", "_wp_attached_file", "2014/12/51hqz3b2PjL.jpg");
INSERT INTO `wp_postmeta` VALUES("898", "138", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51hqz3b2PjL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51hqz3b2PjL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51hqz3b2PjL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("899", "137", "_thumbnail_id", "138");
INSERT INTO `wp_postmeta` VALUES("900", "137", "imwb_zonpress_post_producturl", "http://www.amazon.com/Clyppi-Fingernail-Clippers-Professional-Stainless/dp/B00GQ0GD4A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GQ0GD4A");
INSERT INTO `wp_postmeta` VALUES("901", "137", "imwb_zonpress_post_price", "14.97");
INSERT INTO `wp_postmeta` VALUES("902", "137", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("903", "137", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("904", "137", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("905", "137", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("906", "137", "imwb_interest_post_link_url", "http://www.amazon.com/Clyppi-Fingernail-Clippers-Professional-Stainless/dp/B00GQ0GD4A%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GQ0GD4A");
INSERT INTO `wp_postmeta` VALUES("907", "137", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("909", "139", "imwb_cc_amazon_asin", "B00FEANPYE");
INSERT INTO `wp_postmeta` VALUES("910", "139", "_imwb_cc_amazon_asin_updated", "1418944640");
INSERT INTO `wp_postmeta` VALUES("911", "140", "_wp_attached_file", "2014/12/41rPfCXT9HL.jpg");
INSERT INTO `wp_postmeta` VALUES("912", "140", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:375;s:4:\"file\";s:23:\"2014/12/41rPfCXT9HL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-153x115.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41rPfCXT9HL-170x128.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41rPfCXT9HL-50x38.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("913", "139", "_thumbnail_id", "140");
INSERT INTO `wp_postmeta` VALUES("914", "139", "imwb_zonpress_post_producturl", "http://www.amazon.com/OJIA-Personal-Manicure-Pedicure-Grooming/dp/B00FEANPYE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FEANPYE");
INSERT INTO `wp_postmeta` VALUES("915", "139", "imwb_zonpress_post_price", "16.96");
INSERT INTO `wp_postmeta` VALUES("916", "139", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("917", "139", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("918", "139", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("919", "139", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("920", "139", "imwb_interest_post_link_url", "http://www.amazon.com/OJIA-Personal-Manicure-Pedicure-Grooming/dp/B00FEANPYE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FEANPYE");
INSERT INTO `wp_postmeta` VALUES("921", "139", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("923", "141", "imwb_cc_amazon_asin", "B00LUIUCYK");
INSERT INTO `wp_postmeta` VALUES("924", "141", "_imwb_cc_amazon_asin_updated", "1418944641");
INSERT INTO `wp_postmeta` VALUES("925", "142", "_wp_attached_file", "2014/12/51Cd7sH3lKL.jpg");
INSERT INTO `wp_postmeta` VALUES("926", "142", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:417;s:4:\"file\";s:23:\"2014/12/51Cd7sH3lKL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-300x250.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-300x250.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-300x250.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-153x128.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51Cd7sH3lKL-168x140.jpg\";s:5:\"width\";i:168;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51Cd7sH3lKL-50x42.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:42;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("927", "141", "_thumbnail_id", "142");
INSERT INTO `wp_postmeta` VALUES("928", "141", "imwb_zonpress_post_producturl", "http://www.amazon.com/niceeshop-Personal-Manicure-Pedicure-Clipper/dp/B00LUIUCYK%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00LUIUCYK");
INSERT INTO `wp_postmeta` VALUES("929", "141", "imwb_zonpress_post_price", "12.59");
INSERT INTO `wp_postmeta` VALUES("930", "141", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("931", "141", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("932", "141", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("933", "141", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("934", "141", "imwb_interest_post_link_url", "http://www.amazon.com/niceeshop-Personal-Manicure-Pedicure-Clipper/dp/B00LUIUCYK%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00LUIUCYK");
INSERT INTO `wp_postmeta` VALUES("935", "141", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("937", "143", "imwb_cc_amazon_asin", "B00HQV0QSW");
INSERT INTO `wp_postmeta` VALUES("938", "143", "_imwb_cc_amazon_asin_updated", "1418944641");
INSERT INTO `wp_postmeta` VALUES("939", "144", "_wp_attached_file", "2014/12/41-xPAFe-4L.jpg");
INSERT INTO `wp_postmeta` VALUES("940", "144", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:352;s:4:\"file\";s:23:\"2014/12/41-xPAFe-4L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-300x211.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:211;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-300x211.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:211;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-300x211.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:211;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-153x108.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:108;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41-xPAFe-4L-170x120.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:120;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41-xPAFe-4L-50x35.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:35;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("941", "143", "_thumbnail_id", "144");
INSERT INTO `wp_postmeta` VALUES("942", "143", "imwb_zonpress_post_producturl", "http://www.amazon.com/Stainless-Personal-Manicure-Pedicure-Convenient/dp/B00HQV0QSW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HQV0QSW");
INSERT INTO `wp_postmeta` VALUES("943", "143", "imwb_zonpress_post_price", "13.5");
INSERT INTO `wp_postmeta` VALUES("944", "143", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("945", "143", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("946", "143", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("947", "143", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("948", "143", "imwb_interest_post_link_url", "http://www.amazon.com/Stainless-Personal-Manicure-Pedicure-Convenient/dp/B00HQV0QSW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00HQV0QSW");
INSERT INTO `wp_postmeta` VALUES("949", "143", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("951", "145", "imwb_cc_amazon_asin", "B002UXRE0Y");
INSERT INTO `wp_postmeta` VALUES("952", "145", "_imwb_cc_amazon_asin_updated", "1418944642");
INSERT INTO `wp_postmeta` VALUES("953", "146", "_wp_attached_file", "2014/12/21qMy1BBR7L.jpg");
INSERT INTO `wp_postmeta` VALUES("954", "146", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:188;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/21qMy1BBR7L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21qMy1BBR7L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"21qMy1BBR7L-113x300.jpg\";s:5:\"width\";i:113;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"21qMy1BBR7L-94x250.jpg\";s:5:\"width\";i:94;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"21qMy1BBR7L-94x250.jpg\";s:5:\"width\";i:94;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"21qMy1BBR7L-48x128.jpg\";s:5:\"width\";i:48;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"21qMy1BBR7L-53x140.jpg\";s:5:\"width\";i:53;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21qMy1BBR7L-19x50.jpg\";s:5:\"width\";i:19;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("955", "145", "_thumbnail_id", "146");
INSERT INTO `wp_postmeta` VALUES("956", "145", "imwb_zonpress_post_producturl", "http://www.amazon.com/JAPONESQUE-MT-560-Nail-Nippers/dp/B002UXRE0Y%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002UXRE0Y");
INSERT INTO `wp_postmeta` VALUES("957", "145", "imwb_zonpress_post_price", "27.11");
INSERT INTO `wp_postmeta` VALUES("958", "145", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("959", "145", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("960", "145", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("961", "145", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("962", "145", "imwb_interest_post_link_url", "http://www.amazon.com/JAPONESQUE-MT-560-Nail-Nippers/dp/B002UXRE0Y%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002UXRE0Y");
INSERT INTO `wp_postmeta` VALUES("963", "145", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("965", "147", "imwb_cc_amazon_asin", "B00MPIGQXU");
INSERT INTO `wp_postmeta` VALUES("966", "147", "_imwb_cc_amazon_asin_updated", "1418944642");
INSERT INTO `wp_postmeta` VALUES("967", "148", "_wp_attached_file", "2014/12/51oXEolVfCL.jpg");
INSERT INTO `wp_postmeta` VALUES("968", "148", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:448;s:4:\"file\";s:23:\"2014/12/51oXEolVfCL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-300x269.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:269;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-279x250.jpg\";s:5:\"width\";i:279;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-279x250.jpg\";s:5:\"width\";i:279;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-143x128.jpg\";s:5:\"width\";i:143;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51oXEolVfCL-156x140.jpg\";s:5:\"width\";i:156;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51oXEolVfCL-50x45.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:45;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("969", "147", "_thumbnail_id", "148");
INSERT INTO `wp_postmeta` VALUES("970", "147", "imwb_zonpress_post_producturl", "http://www.amazon.com/FOONEE-Personal-Manicure-Pedicure-Clipper/dp/B00MPIGQXU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00MPIGQXU");
INSERT INTO `wp_postmeta` VALUES("971", "147", "imwb_zonpress_post_price", "6.79");
INSERT INTO `wp_postmeta` VALUES("972", "147", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("973", "147", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("974", "147", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("975", "147", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("976", "147", "imwb_interest_post_link_url", "http://www.amazon.com/FOONEE-Personal-Manicure-Pedicure-Clipper/dp/B00MPIGQXU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00MPIGQXU");
INSERT INTO `wp_postmeta` VALUES("977", "147", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("979", "149", "imwb_cc_amazon_asin", "B00J7Q1AV6");
INSERT INTO `wp_postmeta` VALUES("980", "149", "_imwb_cc_amazon_asin_updated", "1418944643");
INSERT INTO `wp_postmeta` VALUES("981", "150", "_wp_attached_file", "2014/12/41qQTbUhyCL.jpg");
INSERT INTO `wp_postmeta` VALUES("982", "150", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41qQTbUhyCL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41qQTbUhyCL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41qQTbUhyCL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("983", "149", "_thumbnail_id", "150");
INSERT INTO `wp_postmeta` VALUES("984", "149", "imwb_zonpress_post_producturl", "http://www.amazon.com/Clyppi-Clippers-Superior-Professional-Stainless/dp/B00J7Q1AV6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00J7Q1AV6");
INSERT INTO `wp_postmeta` VALUES("985", "149", "imwb_zonpress_post_price", "14.97");
INSERT INTO `wp_postmeta` VALUES("986", "149", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("987", "149", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("988", "149", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("989", "149", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("990", "149", "imwb_interest_post_link_url", "http://www.amazon.com/Clyppi-Clippers-Superior-Professional-Stainless/dp/B00J7Q1AV6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00J7Q1AV6");
INSERT INTO `wp_postmeta` VALUES("991", "149", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("992", "151", "imwb_cc_amazon_asin", "B003LR3MQ8");
INSERT INTO `wp_postmeta` VALUES("993", "151", "_imwb_cc_amazon_asin_updated", "1418944691");
INSERT INTO `wp_postmeta` VALUES("994", "152", "_wp_attached_file", "2014/12/41Qzt8wABML.jpg");
INSERT INTO `wp_postmeta` VALUES("995", "152", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:364;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41Qzt8wABML.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41Qzt8wABML-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41Qzt8wABML-218x300.jpg\";s:5:\"width\";i:218;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41Qzt8wABML-182x250.jpg\";s:5:\"width\";i:182;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41Qzt8wABML-182x250.jpg\";s:5:\"width\";i:182;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41Qzt8wABML-93x128.jpg\";s:5:\"width\";i:93;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41Qzt8wABML-102x140.jpg\";s:5:\"width\";i:102;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41Qzt8wABML-36x50.jpg\";s:5:\"width\";i:36;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("996", "151", "_thumbnail_id", "152");
INSERT INTO `wp_postmeta` VALUES("997", "151", "imwb_zonpress_post_producturl", "http://www.amazon.com/Image-Skin-Care-Hydrating-Repair/dp/B003LR3MQ8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003LR3MQ8");
INSERT INTO `wp_postmeta` VALUES("998", "151", "imwb_zonpress_post_price", "31.81");
INSERT INTO `wp_postmeta` VALUES("999", "151", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1000", "151", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1001", "151", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1002", "151", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1003", "151", "imwb_interest_post_link_url", "http://www.amazon.com/Image-Skin-Care-Hydrating-Repair/dp/B003LR3MQ8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB003LR3MQ8");
INSERT INTO `wp_postmeta` VALUES("1004", "151", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1005", "153", "imwb_cc_amazon_asin", "B005R1SZNQ");
INSERT INTO `wp_postmeta` VALUES("1006", "153", "_imwb_cc_amazon_asin_updated", "1418944692");
INSERT INTO `wp_postmeta` VALUES("1007", "154", "_wp_attached_file", "2014/12/11sqGqEDjhL.jpg");
INSERT INTO `wp_postmeta` VALUES("1008", "154", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:161;s:6:\"height\";i:313;s:4:\"file\";s:23:\"2014/12/11sqGqEDjhL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"11sqGqEDjhL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"11sqGqEDjhL-154x300.jpg\";s:5:\"width\";i:154;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"11sqGqEDjhL-129x250.jpg\";s:5:\"width\";i:129;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"11sqGqEDjhL-129x250.jpg\";s:5:\"width\";i:129;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"11sqGqEDjhL-66x128.jpg\";s:5:\"width\";i:66;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"11sqGqEDjhL-72x140.jpg\";s:5:\"width\";i:72;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"11sqGqEDjhL-26x50.jpg\";s:5:\"width\";i:26;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1009", "153", "_thumbnail_id", "154");
INSERT INTO `wp_postmeta` VALUES("1010", "153", "imwb_zonpress_post_producturl", "http://www.amazon.com/Image-Skin-Care-Exfoliating-Scrub/dp/B005R1SZNQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005R1SZNQ");
INSERT INTO `wp_postmeta` VALUES("1011", "153", "imwb_zonpress_post_price", "10");
INSERT INTO `wp_postmeta` VALUES("1012", "153", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1013", "153", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1014", "153", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1015", "153", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1016", "153", "imwb_interest_post_link_url", "http://www.amazon.com/Image-Skin-Care-Exfoliating-Scrub/dp/B005R1SZNQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005R1SZNQ");
INSERT INTO `wp_postmeta` VALUES("1017", "153", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1018", "155", "imwb_cc_amazon_asin", "B000Z601F8");
INSERT INTO `wp_postmeta` VALUES("1019", "155", "_imwb_cc_amazon_asin_updated", "1418944692");
INSERT INTO `wp_postmeta` VALUES("1020", "156", "_wp_attached_file", "2014/12/41a4LipSN-L.jpg");
INSERT INTO `wp_postmeta` VALUES("1021", "156", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:445;s:4:\"file\";s:23:\"2014/12/41a4LipSN-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-300x267.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:267;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-281x250.jpg\";s:5:\"width\";i:281;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-281x250.jpg\";s:5:\"width\";i:281;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-144x128.jpg\";s:5:\"width\";i:144;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41a4LipSN-L-157x140.jpg\";s:5:\"width\";i:157;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41a4LipSN-L-50x45.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:45;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1022", "155", "_thumbnail_id", "156");
INSERT INTO `wp_postmeta` VALUES("1023", "155", "imwb_zonpress_post_producturl", "http://www.amazon.com/Baxter-California-Skin-1-2-3-Kit/dp/B000Z601F8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000Z601F8");
INSERT INTO `wp_postmeta` VALUES("1024", "155", "imwb_zonpress_post_price", "48");
INSERT INTO `wp_postmeta` VALUES("1025", "155", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1026", "155", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1027", "155", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1028", "155", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1029", "155", "imwb_interest_post_link_url", "http://www.amazon.com/Baxter-California-Skin-1-2-3-Kit/dp/B000Z601F8%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB000Z601F8");
INSERT INTO `wp_postmeta` VALUES("1030", "155", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1031", "157", "imwb_cc_amazon_asin", "B00GW4FGIO");
INSERT INTO `wp_postmeta` VALUES("1032", "157", "_imwb_cc_amazon_asin_updated", "1418944693");
INSERT INTO `wp_postmeta` VALUES("1033", "158", "_wp_attached_file", "2014/12/41G92WlnyQL.jpg");
INSERT INTO `wp_postmeta` VALUES("1034", "158", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:300;s:4:\"file\";s:23:\"2014/12/41G92WlnyQL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41G92WlnyQL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41G92WlnyQL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1035", "157", "_thumbnail_id", "158");
INSERT INTO `wp_postmeta` VALUES("1036", "157", "imwb_zonpress_post_producturl", "http://www.amazon.com/REN-Ren-Luxury-Rose-Gift/dp/B00GW4FGIO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GW4FGIO");
INSERT INTO `wp_postmeta` VALUES("1037", "157", "imwb_zonpress_post_price", "78");
INSERT INTO `wp_postmeta` VALUES("1038", "157", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1039", "157", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1040", "157", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1041", "157", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1042", "157", "imwb_interest_post_link_url", "http://www.amazon.com/REN-Ren-Luxury-Rose-Gift/dp/B00GW4FGIO%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GW4FGIO");
INSERT INTO `wp_postmeta` VALUES("1043", "157", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1044", "159", "imwb_cc_amazon_asin", "B005RGN1WQ");
INSERT INTO `wp_postmeta` VALUES("1045", "159", "_imwb_cc_amazon_asin_updated", "1418944693");
INSERT INTO `wp_postmeta` VALUES("1046", "160", "_wp_attached_file", "2014/12/21GtgiaqS-L.jpg");
INSERT INTO `wp_postmeta` VALUES("1047", "160", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:246;s:6:\"height\";i:264;s:4:\"file\";s:23:\"2014/12/21GtgiaqS-L.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21GtgiaqS-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21GtgiaqS-L-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21GtgiaqS-L-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21GtgiaqS-L-119x128.jpg\";s:5:\"width\";i:119;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21GtgiaqS-L-130x140.jpg\";s:5:\"width\";i:130;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21GtgiaqS-L-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1048", "159", "_thumbnail_id", "160");
INSERT INTO `wp_postmeta` VALUES("1049", "159", "imwb_zonpress_post_producturl", "http://www.amazon.com/Image-Skin-Ageless-Total-Rejuvenating/dp/B005RGN1WQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005RGN1WQ");
INSERT INTO `wp_postmeta` VALUES("1050", "159", "imwb_zonpress_post_price", "17.95");
INSERT INTO `wp_postmeta` VALUES("1051", "159", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1052", "159", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1053", "159", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1054", "159", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1055", "159", "imwb_interest_post_link_url", "http://www.amazon.com/Image-Skin-Ageless-Total-Rejuvenating/dp/B005RGN1WQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005RGN1WQ");
INSERT INTO `wp_postmeta` VALUES("1056", "159", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1057", "161", "imwb_cc_amazon_asin", "B00FJPJ084");
INSERT INTO `wp_postmeta` VALUES("1058", "161", "_imwb_cc_amazon_asin_updated", "1418944694");
INSERT INTO `wp_postmeta` VALUES("1059", "162", "_wp_attached_file", "2014/12/51O1sP0ciJL.jpg");
INSERT INTO `wp_postmeta` VALUES("1060", "162", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51O1sP0ciJL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51O1sP0ciJL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51O1sP0ciJL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1061", "161", "_thumbnail_id", "162");
INSERT INTO `wp_postmeta` VALUES("1062", "161", "imwb_zonpress_post_producturl", "http://www.amazon.com/Anti-Aging-Cream-Moisturizing-Satisfaction/dp/B00FJPJ084%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJPJ084");
INSERT INTO `wp_postmeta` VALUES("1063", "161", "imwb_zonpress_post_price", "29.99");
INSERT INTO `wp_postmeta` VALUES("1064", "161", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1065", "161", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1066", "161", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1067", "161", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1068", "161", "imwb_interest_post_link_url", "http://www.amazon.com/Anti-Aging-Cream-Moisturizing-Satisfaction/dp/B00FJPJ084%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00FJPJ084");
INSERT INTO `wp_postmeta` VALUES("1069", "161", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1070", "163", "imwb_cc_amazon_asin", "B00NK3VZOY");
INSERT INTO `wp_postmeta` VALUES("1071", "163", "_imwb_cc_amazon_asin_updated", "1418944694");
INSERT INTO `wp_postmeta` VALUES("1072", "164", "_wp_attached_file", "2014/12/51UOmVhk4IL.jpg");
INSERT INTO `wp_postmeta` VALUES("1073", "164", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51UOmVhk4IL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51UOmVhk4IL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51UOmVhk4IL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1074", "163", "_thumbnail_id", "164");
INSERT INTO `wp_postmeta` VALUES("1075", "163", "imwb_zonpress_post_producturl", "http://www.amazon.com/Facial-Mask-treatments-blackheads-decollete/dp/B00NK3VZOY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NK3VZOY");
INSERT INTO `wp_postmeta` VALUES("1076", "163", "imwb_zonpress_post_price", "35.17");
INSERT INTO `wp_postmeta` VALUES("1077", "163", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1078", "163", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1079", "163", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1080", "163", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1081", "163", "imwb_interest_post_link_url", "http://www.amazon.com/Facial-Mask-treatments-blackheads-decollete/dp/B00NK3VZOY%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NK3VZOY");
INSERT INTO `wp_postmeta` VALUES("1082", "163", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1083", "165", "imwb_cc_amazon_asin", "B007CMLYJK");
INSERT INTO `wp_postmeta` VALUES("1084", "165", "_imwb_cc_amazon_asin_updated", "1418944695");
INSERT INTO `wp_postmeta` VALUES("1085", "166", "_wp_attached_file", "2014/12/31K2joGFRFL.jpg");
INSERT INTO `wp_postmeta` VALUES("1086", "166", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:346;s:6:\"height\";i:403;s:4:\"file\";s:23:\"2014/12/31K2joGFRFL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-258x300.jpg\";s:5:\"width\";i:258;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-215x250.jpg\";s:5:\"width\";i:215;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-215x250.jpg\";s:5:\"width\";i:215;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-110x128.jpg\";s:5:\"width\";i:110;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31K2joGFRFL-120x140.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31K2joGFRFL-43x50.jpg\";s:5:\"width\";i:43;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1087", "165", "_thumbnail_id", "166");
INSERT INTO `wp_postmeta` VALUES("1088", "165", "imwb_zonpress_post_producturl", "http://www.amazon.com/The-History-Whoo-Gongjinhyang-Luxury/dp/B007CMLYJK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007CMLYJK");
INSERT INTO `wp_postmeta` VALUES("1089", "165", "imwb_zonpress_post_price", "37.98");
INSERT INTO `wp_postmeta` VALUES("1090", "165", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1091", "165", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1092", "165", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1093", "165", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1094", "165", "imwb_interest_post_link_url", "http://www.amazon.com/The-History-Whoo-Gongjinhyang-Luxury/dp/B007CMLYJK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007CMLYJK");
INSERT INTO `wp_postmeta` VALUES("1095", "165", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1096", "167", "imwb_cc_amazon_asin", "B00GVHPHTK");
INSERT INTO `wp_postmeta` VALUES("1097", "167", "_imwb_cc_amazon_asin_updated", "1418944695");
INSERT INTO `wp_postmeta` VALUES("1098", "168", "_wp_attached_file", "2014/12/31tKYXP7sOL.jpg");
INSERT INTO `wp_postmeta` VALUES("1099", "168", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31tKYXP7sOL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31tKYXP7sOL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31tKYXP7sOL-210x300.jpg\";s:5:\"width\";i:210;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31tKYXP7sOL-175x250.jpg\";s:5:\"width\";i:175;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31tKYXP7sOL-175x250.jpg\";s:5:\"width\";i:175;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"31tKYXP7sOL-90x128.jpg\";s:5:\"width\";i:90;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"31tKYXP7sOL-98x140.jpg\";s:5:\"width\";i:98;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31tKYXP7sOL-35x50.jpg\";s:5:\"width\";i:35;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1100", "167", "_thumbnail_id", "168");
INSERT INTO `wp_postmeta` VALUES("1101", "167", "imwb_zonpress_post_producturl", "http://www.amazon.com/Hyaluronic-Acid-Serum-Vitamin-Moisturizer/dp/B00GVHPHTK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GVHPHTK");
INSERT INTO `wp_postmeta` VALUES("1102", "167", "imwb_zonpress_post_price", "29.99");
INSERT INTO `wp_postmeta` VALUES("1103", "167", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1104", "167", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1105", "167", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1106", "167", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1107", "167", "imwb_interest_post_link_url", "http://www.amazon.com/Hyaluronic-Acid-Serum-Vitamin-Moisturizer/dp/B00GVHPHTK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GVHPHTK");
INSERT INTO `wp_postmeta` VALUES("1108", "167", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1109", "169", "imwb_cc_amazon_asin", "B00JFT2Z14");
INSERT INTO `wp_postmeta` VALUES("1110", "169", "_imwb_cc_amazon_asin_updated", "1418944695");
INSERT INTO `wp_postmeta` VALUES("1111", "170", "_wp_attached_file", "2014/12/41bhu8atpAL.jpg");
INSERT INTO `wp_postmeta` VALUES("1112", "170", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:337;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41bhu8atpAL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41bhu8atpAL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41bhu8atpAL-202x300.jpg\";s:5:\"width\";i:202;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41bhu8atpAL-169x250.jpg\";s:5:\"width\";i:169;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41bhu8atpAL-169x250.jpg\";s:5:\"width\";i:169;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41bhu8atpAL-86x128.jpg\";s:5:\"width\";i:86;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41bhu8atpAL-94x140.jpg\";s:5:\"width\";i:94;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41bhu8atpAL-34x50.jpg\";s:5:\"width\";i:34;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1113", "169", "_thumbnail_id", "170");
INSERT INTO `wp_postmeta` VALUES("1114", "169", "imwb_zonpress_post_producturl", "http://www.amazon.com/Super-Serum-Breakthrough-Hyaluronic-Effective/dp/B00JFT2Z14%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JFT2Z14");
INSERT INTO `wp_postmeta` VALUES("1115", "169", "imwb_zonpress_post_price", "28.95");
INSERT INTO `wp_postmeta` VALUES("1116", "169", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1117", "169", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1118", "169", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1119", "169", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1120", "169", "imwb_interest_post_link_url", "http://www.amazon.com/Super-Serum-Breakthrough-Hyaluronic-Effective/dp/B00JFT2Z14%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JFT2Z14");
INSERT INTO `wp_postmeta` VALUES("1121", "169", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1122", "171", "imwb_cc_amazon_asin", "B00OGUB23E");
INSERT INTO `wp_postmeta` VALUES("1123", "171", "_imwb_cc_amazon_asin_updated", "1418944696");
INSERT INTO `wp_postmeta` VALUES("1124", "172", "_wp_attached_file", "2014/12/41mVJ3uG9lL.jpg");
INSERT INTO `wp_postmeta` VALUES("1125", "172", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:339;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41mVJ3uG9lL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41mVJ3uG9lL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41mVJ3uG9lL-203x300.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41mVJ3uG9lL-170x250.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41mVJ3uG9lL-170x250.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41mVJ3uG9lL-87x128.jpg\";s:5:\"width\";i:87;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41mVJ3uG9lL-95x140.jpg\";s:5:\"width\";i:95;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41mVJ3uG9lL-34x50.jpg\";s:5:\"width\";i:34;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1126", "171", "_thumbnail_id", "172");
INSERT INTO `wp_postmeta` VALUES("1127", "171", "imwb_zonpress_post_producturl", "http://www.amazon.com/Alina-Skin-Care-Enhanced-Hyaluronic/dp/B00OGUB23E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00OGUB23E");
INSERT INTO `wp_postmeta` VALUES("1128", "171", "imwb_zonpress_post_price", "35");
INSERT INTO `wp_postmeta` VALUES("1129", "171", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1130", "171", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1131", "171", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1132", "171", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1133", "171", "imwb_interest_post_link_url", "http://www.amazon.com/Alina-Skin-Care-Enhanced-Hyaluronic/dp/B00OGUB23E%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00OGUB23E");
INSERT INTO `wp_postmeta` VALUES("1134", "171", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1135", "173", "imwb_cc_amazon_asin", "B006HTLUFC");
INSERT INTO `wp_postmeta` VALUES("1136", "173", "_imwb_cc_amazon_asin_updated", "1418944696");
INSERT INTO `wp_postmeta` VALUES("1137", "174", "_wp_attached_file", "2014/12/51gs3bTkg4L.jpg");
INSERT INTO `wp_postmeta` VALUES("1138", "174", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51gs3bTkg4L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51gs3bTkg4L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51gs3bTkg4L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1139", "173", "_thumbnail_id", "174");
INSERT INTO `wp_postmeta` VALUES("1140", "173", "imwb_zonpress_post_producturl", "http://www.amazon.com/Vegan-Vegetarian-Moisturizing-SW-Basics/dp/B006HTLUFC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006HTLUFC");
INSERT INTO `wp_postmeta` VALUES("1141", "173", "imwb_zonpress_post_price", "11");
INSERT INTO `wp_postmeta` VALUES("1142", "173", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1143", "173", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1144", "173", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1145", "173", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1146", "173", "imwb_interest_post_link_url", "http://www.amazon.com/Vegan-Vegetarian-Moisturizing-SW-Basics/dp/B006HTLUFC%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB006HTLUFC");
INSERT INTO `wp_postmeta` VALUES("1147", "173", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1148", "175", "imwb_cc_amazon_asin", "B00GHK20PK");
INSERT INTO `wp_postmeta` VALUES("1149", "175", "_imwb_cc_amazon_asin_updated", "1418944697");
INSERT INTO `wp_postmeta` VALUES("1150", "176", "_wp_attached_file", "2014/12/41m5INuEUJL.jpg");
INSERT INTO `wp_postmeta` VALUES("1151", "176", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:337;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41m5INuEUJL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41m5INuEUJL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41m5INuEUJL-202x300.jpg\";s:5:\"width\";i:202;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41m5INuEUJL-169x250.jpg\";s:5:\"width\";i:169;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41m5INuEUJL-169x250.jpg\";s:5:\"width\";i:169;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41m5INuEUJL-86x128.jpg\";s:5:\"width\";i:86;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41m5INuEUJL-94x140.jpg\";s:5:\"width\";i:94;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41m5INuEUJL-34x50.jpg\";s:5:\"width\";i:34;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1152", "175", "_thumbnail_id", "176");
INSERT INTO `wp_postmeta` VALUES("1153", "175", "imwb_zonpress_post_producturl", "http://www.amazon.com/Natural-Vitamin-Serum-20%25-Professional/dp/B00GHK20PK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GHK20PK");
INSERT INTO `wp_postmeta` VALUES("1154", "175", "imwb_zonpress_post_price", "22.95");
INSERT INTO `wp_postmeta` VALUES("1155", "175", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1156", "175", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1157", "175", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1158", "175", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1159", "175", "imwb_interest_post_link_url", "http://www.amazon.com/Natural-Vitamin-Serum-20%25-Professional/dp/B00GHK20PK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00GHK20PK");
INSERT INTO `wp_postmeta` VALUES("1160", "175", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1161", "177", "imwb_cc_amazon_asin", "B002AMUGFU");
INSERT INTO `wp_postmeta` VALUES("1162", "177", "_imwb_cc_amazon_asin_updated", "1418944697");
INSERT INTO `wp_postmeta` VALUES("1163", "178", "_wp_attached_file", "2014/12/21X-C6tKWuL.jpg");
INSERT INTO `wp_postmeta` VALUES("1164", "178", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/12/21X-C6tKWuL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21X-C6tKWuL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21X-C6tKWuL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21X-C6tKWuL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21X-C6tKWuL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21X-C6tKWuL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21X-C6tKWuL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1165", "177", "_thumbnail_id", "178");
INSERT INTO `wp_postmeta` VALUES("1166", "177", "imwb_zonpress_post_producturl", "http://www.amazon.com/Sisley-Botanical-Confort-Extreme-1-6-Ounce/dp/B002AMUGFU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002AMUGFU");
INSERT INTO `wp_postmeta` VALUES("1167", "177", "imwb_zonpress_post_price", "90");
INSERT INTO `wp_postmeta` VALUES("1168", "177", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1169", "177", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1170", "177", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1171", "177", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1172", "177", "imwb_interest_post_link_url", "http://www.amazon.com/Sisley-Botanical-Confort-Extreme-1-6-Ounce/dp/B002AMUGFU%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002AMUGFU");
INSERT INTO `wp_postmeta` VALUES("1173", "177", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1174", "179", "imwb_cc_amazon_asin", "B007Z5P6OI");
INSERT INTO `wp_postmeta` VALUES("1175", "179", "_imwb_cc_amazon_asin_updated", "1418944697");
INSERT INTO `wp_postmeta` VALUES("1176", "180", "_wp_attached_file", "2014/12/4112TcD6q-L.jpg");
INSERT INTO `wp_postmeta` VALUES("1177", "180", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:375;s:4:\"file\";s:23:\"2014/12/4112TcD6q-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-153x115.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:115;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"4112TcD6q-L-170x128.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"4112TcD6q-L-50x38.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1178", "179", "_thumbnail_id", "180");
INSERT INTO `wp_postmeta` VALUES("1179", "179", "imwb_zonpress_post_producturl", "http://www.amazon.com/Eminence-Organics-Coconut-Corrective-Moisturizer/dp/B007Z5P6OI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007Z5P6OI");
INSERT INTO `wp_postmeta` VALUES("1180", "179", "imwb_zonpress_post_price", "37.7");
INSERT INTO `wp_postmeta` VALUES("1181", "179", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1182", "179", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1183", "179", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1184", "179", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1185", "179", "imwb_interest_post_link_url", "http://www.amazon.com/Eminence-Organics-Coconut-Corrective-Moisturizer/dp/B007Z5P6OI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB007Z5P6OI");
INSERT INTO `wp_postmeta` VALUES("1186", "179", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1187", "179", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1188", "179", "_wp_trash_meta_time", "1418944717");
INSERT INTO `wp_postmeta` VALUES("1189", "177", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1190", "177", "_wp_trash_meta_time", "1418944717");
INSERT INTO `wp_postmeta` VALUES("1191", "175", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1192", "175", "_wp_trash_meta_time", "1418944717");
INSERT INTO `wp_postmeta` VALUES("1193", "173", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1194", "173", "_wp_trash_meta_time", "1418944717");
INSERT INTO `wp_postmeta` VALUES("1195", "171", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1196", "171", "_wp_trash_meta_time", "1418944717");
INSERT INTO `wp_postmeta` VALUES("1197", "169", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1198", "169", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1199", "167", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1200", "167", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1201", "165", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1202", "165", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1203", "163", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1204", "163", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1205", "161", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1206", "161", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1207", "159", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1208", "159", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1209", "157", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1210", "157", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1211", "155", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1212", "155", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1213", "153", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1214", "153", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1215", "151", "_wp_trash_meta_status", "draft");
INSERT INTO `wp_postmeta` VALUES("1216", "151", "_wp_trash_meta_time", "1418944718");
INSERT INTO `wp_postmeta` VALUES("1218", "196", "imwb_cc_amazon_asin", "B0006O4M8Q");
INSERT INTO `wp_postmeta` VALUES("1219", "196", "_imwb_cc_amazon_asin_updated", "1418944754");
INSERT INTO `wp_postmeta` VALUES("1220", "197", "_wp_attached_file", "2014/12/41WghEFDhSL.jpg");
INSERT INTO `wp_postmeta` VALUES("1221", "197", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:197;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41WghEFDhSL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41WghEFDhSL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41WghEFDhSL-118x300.jpg\";s:5:\"width\";i:118;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:22:\"41WghEFDhSL-99x250.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:22:\"41WghEFDhSL-99x250.jpg\";s:5:\"width\";i:99;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41WghEFDhSL-50x128.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41WghEFDhSL-55x140.jpg\";s:5:\"width\";i:55;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41WghEFDhSL-20x50.jpg\";s:5:\"width\";i:20;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1222", "196", "_thumbnail_id", "197");
INSERT INTO `wp_postmeta` VALUES("1223", "196", "imwb_zonpress_post_producturl", "http://www.amazon.com/Jack-Black-Industrial-Strength-Healer/dp/B0006O4M8Q%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0006O4M8Q");
INSERT INTO `wp_postmeta` VALUES("1224", "196", "imwb_zonpress_post_price", "15");
INSERT INTO `wp_postmeta` VALUES("1225", "196", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1226", "196", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1227", "196", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1228", "196", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1229", "196", "imwb_interest_post_link_url", "http://www.amazon.com/Jack-Black-Industrial-Strength-Healer/dp/B0006O4M8Q%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB0006O4M8Q");
INSERT INTO `wp_postmeta` VALUES("1230", "196", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1232", "198", "imwb_cc_amazon_asin", "B00BPMS3ZQ");
INSERT INTO `wp_postmeta` VALUES("1233", "198", "_imwb_cc_amazon_asin_updated", "1418944755");
INSERT INTO `wp_postmeta` VALUES("1234", "199", "_wp_attached_file", "2014/12/21b5tlWRVSL.jpg");
INSERT INTO `wp_postmeta` VALUES("1235", "199", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:170;s:6:\"height\";i:156;s:4:\"file\";s:23:\"2014/12/21b5tlWRVSL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21b5tlWRVSL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21b5tlWRVSL-139x128.jpg\";s:5:\"width\";i:139;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21b5tlWRVSL-153x140.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21b5tlWRVSL-50x46.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:46;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1236", "198", "_thumbnail_id", "199");
INSERT INTO `wp_postmeta` VALUES("1237", "198", "imwb_zonpress_post_producturl", "http://www.amazon.com/Helan-Oily-Skin-Care-Cream-gel/dp/B00BPMS3ZQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BPMS3ZQ");
INSERT INTO `wp_postmeta` VALUES("1238", "198", "imwb_zonpress_post_price", "34");
INSERT INTO `wp_postmeta` VALUES("1239", "198", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1240", "198", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1241", "198", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1242", "198", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1243", "198", "imwb_interest_post_link_url", "http://www.amazon.com/Helan-Oily-Skin-Care-Cream-gel/dp/B00BPMS3ZQ%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00BPMS3ZQ");
INSERT INTO `wp_postmeta` VALUES("1244", "198", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1246", "200", "imwb_cc_amazon_asin", "B00NDLS01O");
INSERT INTO `wp_postmeta` VALUES("1247", "200", "_imwb_cc_amazon_asin_updated", "1418944755");
INSERT INTO `wp_postmeta` VALUES("1248", "201", "_wp_attached_file", "2014/12/51f0c3lD2kL.jpg");
INSERT INTO `wp_postmeta` VALUES("1249", "201", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51f0c3lD2kL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51f0c3lD2kL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51f0c3lD2kL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1250", "200", "_thumbnail_id", "201");
INSERT INTO `wp_postmeta` VALUES("1251", "200", "imwb_zonpress_post_producturl", "http://www.amazon.com/Best-New-Acne-Treatment-exfoliators/dp/B00NDLS01O%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NDLS01O");
INSERT INTO `wp_postmeta` VALUES("1252", "200", "imwb_zonpress_post_price", "35.27");
INSERT INTO `wp_postmeta` VALUES("1253", "200", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1254", "200", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1255", "200", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1256", "200", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1257", "200", "imwb_interest_post_link_url", "http://www.amazon.com/Best-New-Acne-Treatment-exfoliators/dp/B00NDLS01O%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NDLS01O");
INSERT INTO `wp_postmeta` VALUES("1258", "200", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1260", "202", "imwb_cc_amazon_asin", "B00ONGTSWS");
INSERT INTO `wp_postmeta` VALUES("1261", "202", "_imwb_cc_amazon_asin_updated", "1418944755");
INSERT INTO `wp_postmeta` VALUES("1262", "203", "_wp_attached_file", "2014/12/51s5pbptkDL.jpg");
INSERT INTO `wp_postmeta` VALUES("1263", "203", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:406;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51s5pbptkDL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-244x300.jpg\";s:5:\"width\";i:244;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-203x250.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-203x250.jpg\";s:5:\"width\";i:203;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-104x128.jpg\";s:5:\"width\";i:104;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51s5pbptkDL-114x140.jpg\";s:5:\"width\";i:114;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51s5pbptkDL-41x50.jpg\";s:5:\"width\";i:41;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1264", "202", "_thumbnail_id", "203");
INSERT INTO `wp_postmeta` VALUES("1265", "202", "imwb_zonpress_post_producturl", "http://www.amazon.com/Luxe-Lumineux-Argan-Oil-Infused-Gift/dp/B00ONGTSWS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00ONGTSWS");
INSERT INTO `wp_postmeta` VALUES("1266", "202", "imwb_zonpress_post_price", "45");
INSERT INTO `wp_postmeta` VALUES("1267", "202", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1268", "202", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1269", "202", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1270", "202", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1271", "202", "imwb_interest_post_link_url", "http://www.amazon.com/Luxe-Lumineux-Argan-Oil-Infused-Gift/dp/B00ONGTSWS%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00ONGTSWS");
INSERT INTO `wp_postmeta` VALUES("1272", "202", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1274", "204", "imwb_cc_amazon_asin", "B002AMUGGO");
INSERT INTO `wp_postmeta` VALUES("1275", "204", "_imwb_cc_amazon_asin_updated", "1418944756");
INSERT INTO `wp_postmeta` VALUES("1276", "205", "_wp_attached_file", "2014/12/31cW7Hc6tkL.jpg");
INSERT INTO `wp_postmeta` VALUES("1277", "205", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:23:\"2014/12/31cW7Hc6tkL.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31cW7Hc6tkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31cW7Hc6tkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31cW7Hc6tkL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31cW7Hc6tkL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31cW7Hc6tkL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31cW7Hc6tkL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1278", "204", "_thumbnail_id", "205");
INSERT INTO `wp_postmeta` VALUES("1279", "204", "imwb_zonpress_post_producturl", "http://www.amazon.com/Sisley-Botanical-Confort-Extreme-1-6-Ounce/dp/B002AMUGGO%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002AMUGGO");
INSERT INTO `wp_postmeta` VALUES("1280", "204", "imwb_zonpress_post_price", "112.75");
INSERT INTO `wp_postmeta` VALUES("1281", "204", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1282", "204", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1283", "204", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1284", "204", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1285", "204", "imwb_interest_post_link_url", "http://www.amazon.com/Sisley-Botanical-Confort-Extreme-1-6-Ounce/dp/B002AMUGGO%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002AMUGGO");
INSERT INTO `wp_postmeta` VALUES("1286", "204", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1288", "206", "imwb_cc_amazon_asin", "B005713US6");
INSERT INTO `wp_postmeta` VALUES("1289", "206", "_imwb_cc_amazon_asin_updated", "1418944756");
INSERT INTO `wp_postmeta` VALUES("1290", "207", "_wp_attached_file", "2014/12/21FtTJ-ghDL.jpg");
INSERT INTO `wp_postmeta` VALUES("1291", "207", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:192;s:6:\"height\";i:172;s:4:\"file\";s:23:\"2014/12/21FtTJ-ghDL.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21FtTJ-ghDL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21FtTJ-ghDL-143x128.jpg\";s:5:\"width\";i:143;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21FtTJ-ghDL-156x140.jpg\";s:5:\"width\";i:156;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21FtTJ-ghDL-50x45.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:45;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1292", "206", "_thumbnail_id", "207");
INSERT INTO `wp_postmeta` VALUES("1293", "206", "imwb_zonpress_post_producturl", "http://www.amazon.com/Atomy-Skin-Care-6-System/dp/B005713US6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005713US6");
INSERT INTO `wp_postmeta` VALUES("1294", "206", "imwb_zonpress_post_price", "106.98");
INSERT INTO `wp_postmeta` VALUES("1295", "206", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1296", "206", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1297", "206", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1298", "206", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1299", "206", "imwb_interest_post_link_url", "http://www.amazon.com/Atomy-Skin-Care-6-System/dp/B005713US6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005713US6");
INSERT INTO `wp_postmeta` VALUES("1300", "206", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1302", "208", "imwb_cc_amazon_asin", "B00KRL6RI6");
INSERT INTO `wp_postmeta` VALUES("1303", "208", "_imwb_cc_amazon_asin_updated", "1418944757");
INSERT INTO `wp_postmeta` VALUES("1304", "209", "_wp_attached_file", "2014/12/51lMGC89qfL.jpg");
INSERT INTO `wp_postmeta` VALUES("1305", "209", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:469;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/51lMGC89qfL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-281x300.jpg\";s:5:\"width\";i:281;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-235x250.jpg\";s:5:\"width\";i:235;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-120x128.jpg\";s:5:\"width\";i:120;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51lMGC89qfL-131x140.jpg\";s:5:\"width\";i:131;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51lMGC89qfL-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1306", "208", "_thumbnail_id", "209");
INSERT INTO `wp_postmeta` VALUES("1307", "208", "imwb_zonpress_post_producturl", "http://www.amazon.com/Dry-Itchy-Skin-Body-Kit/dp/B00KRL6RI6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KRL6RI6");
INSERT INTO `wp_postmeta` VALUES("1308", "208", "imwb_zonpress_post_price", "29.79");
INSERT INTO `wp_postmeta` VALUES("1309", "208", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1310", "208", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1311", "208", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1312", "208", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1313", "208", "imwb_interest_post_link_url", "http://www.amazon.com/Dry-Itchy-Skin-Body-Kit/dp/B00KRL6RI6%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00KRL6RI6");
INSERT INTO `wp_postmeta` VALUES("1314", "208", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1316", "210", "imwb_cc_amazon_asin", "B005U723NK");
INSERT INTO `wp_postmeta` VALUES("1317", "210", "_imwb_cc_amazon_asin_updated", "1418944757");
INSERT INTO `wp_postmeta` VALUES("1318", "211", "_wp_attached_file", "2014/12/219-JTkm24L.jpg");
INSERT INTO `wp_postmeta` VALUES("1319", "211", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:246;s:6:\"height\";i:264;s:4:\"file\";s:23:\"2014/12/219-JTkm24L.jpg\";s:5:\"sizes\";a:6:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"219-JTkm24L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"219-JTkm24L-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"219-JTkm24L-233x250.jpg\";s:5:\"width\";i:233;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"219-JTkm24L-119x128.jpg\";s:5:\"width\";i:119;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"219-JTkm24L-130x140.jpg\";s:5:\"width\";i:130;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"219-JTkm24L-47x50.jpg\";s:5:\"width\";i:47;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1320", "210", "_thumbnail_id", "211");
INSERT INTO `wp_postmeta` VALUES("1321", "210", "imwb_zonpress_post_producturl", "http://www.amazon.com/Image-Skin-Care-Firming-Creme/dp/B005U723NK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005U723NK");
INSERT INTO `wp_postmeta` VALUES("1322", "210", "imwb_zonpress_post_price", "43.46");
INSERT INTO `wp_postmeta` VALUES("1323", "210", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1324", "210", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1325", "210", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1326", "210", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1327", "210", "imwb_interest_post_link_url", "http://www.amazon.com/Image-Skin-Care-Firming-Creme/dp/B005U723NK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB005U723NK");
INSERT INTO `wp_postmeta` VALUES("1328", "210", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1330", "212", "imwb_cc_amazon_asin", "B00NEPFTJK");
INSERT INTO `wp_postmeta` VALUES("1331", "212", "_imwb_cc_amazon_asin_updated", "1418944757");
INSERT INTO `wp_postmeta` VALUES("1332", "213", "_wp_attached_file", "2014/12/41zOauIuGhL.jpg");
INSERT INTO `wp_postmeta` VALUES("1333", "213", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:395;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41zOauIuGhL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-237x300.jpg\";s:5:\"width\";i:237;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-198x250.jpg\";s:5:\"width\";i:198;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-198x250.jpg\";s:5:\"width\";i:198;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-101x128.jpg\";s:5:\"width\";i:101;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41zOauIuGhL-111x140.jpg\";s:5:\"width\";i:111;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41zOauIuGhL-40x50.jpg\";s:5:\"width\";i:40;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1334", "212", "_thumbnail_id", "213");
INSERT INTO `wp_postmeta` VALUES("1335", "212", "imwb_zonpress_post_producturl", "http://www.amazon.com/StriVectin-AR-Advanced-Retinol-Trio-Skin/dp/B00NEPFTJK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NEPFTJK");
INSERT INTO `wp_postmeta` VALUES("1336", "212", "imwb_zonpress_post_price", "89");
INSERT INTO `wp_postmeta` VALUES("1337", "212", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1338", "212", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1339", "212", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1340", "212", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1341", "212", "imwb_interest_post_link_url", "http://www.amazon.com/StriVectin-AR-Advanced-Retinol-Trio-Skin/dp/B00NEPFTJK%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00NEPFTJK");
INSERT INTO `wp_postmeta` VALUES("1342", "212", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1344", "214", "imwb_cc_amazon_asin", "B009CF6JWW");
INSERT INTO `wp_postmeta` VALUES("1345", "214", "_imwb_cc_amazon_asin_updated", "1418944758");
INSERT INTO `wp_postmeta` VALUES("1346", "215", "_wp_attached_file", "2014/12/21Hb30mcV-L.jpg");
INSERT INTO `wp_postmeta` VALUES("1347", "215", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:300;s:6:\"height\";i:300;s:4:\"file\";s:23:\"2014/12/21Hb30mcV-L.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"21Hb30mcV-L-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"21Hb30mcV-L-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1348", "214", "_thumbnail_id", "215");
INSERT INTO `wp_postmeta` VALUES("1349", "214", "imwb_zonpress_post_producturl", "http://www.amazon.com/Artistry-Luxury-Creme-Eye/dp/B009CF6JWW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB009CF6JWW");
INSERT INTO `wp_postmeta` VALUES("1350", "214", "imwb_zonpress_post_price", "136.39");
INSERT INTO `wp_postmeta` VALUES("1351", "214", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1352", "214", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1353", "214", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1354", "214", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1355", "214", "imwb_interest_post_link_url", "http://www.amazon.com/Artistry-Luxury-Creme-Eye/dp/B009CF6JWW%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB009CF6JWW");
INSERT INTO `wp_postmeta` VALUES("1356", "214", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1358", "216", "imwb_cc_amazon_asin", "B00J6E8DGE");
INSERT INTO `wp_postmeta` VALUES("1359", "216", "_imwb_cc_amazon_asin_updated", "1418944758");
INSERT INTO `wp_postmeta` VALUES("1360", "217", "_wp_attached_file", "2014/12/41TYonWKRkL.jpg");
INSERT INTO `wp_postmeta` VALUES("1361", "217", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:423;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41TYonWKRkL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-254x300.jpg\";s:5:\"width\";i:254;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-212x250.jpg\";s:5:\"width\";i:212;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-212x250.jpg\";s:5:\"width\";i:212;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-108x128.jpg\";s:5:\"width\";i:108;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41TYonWKRkL-118x140.jpg\";s:5:\"width\";i:118;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41TYonWKRkL-42x50.jpg\";s:5:\"width\";i:42;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1362", "216", "_thumbnail_id", "217");
INSERT INTO `wp_postmeta` VALUES("1363", "216", "imwb_zonpress_post_producturl", "http://www.amazon.com/Dermatouch-Exfoliating-Wrinkle-Reducer-Treatment/dp/B00J6E8DGE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00J6E8DGE");
INSERT INTO `wp_postmeta` VALUES("1364", "216", "imwb_zonpress_post_price", "35");
INSERT INTO `wp_postmeta` VALUES("1365", "216", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1366", "216", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1367", "216", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1368", "216", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1369", "216", "imwb_interest_post_link_url", "http://www.amazon.com/Dermatouch-Exfoliating-Wrinkle-Reducer-Treatment/dp/B00J6E8DGE%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00J6E8DGE");
INSERT INTO `wp_postmeta` VALUES("1370", "216", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1372", "218", "imwb_cc_amazon_asin", "B002R177NI");
INSERT INTO `wp_postmeta` VALUES("1373", "218", "_imwb_cc_amazon_asin_updated", "1418944759");
INSERT INTO `wp_postmeta` VALUES("1374", "219", "_wp_attached_file", "2014/12/41weCvz1FFL.jpg");
INSERT INTO `wp_postmeta` VALUES("1375", "219", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:350;s:6:\"height\";i:350;s:4:\"file\";s:23:\"2014/12/41weCvz1FFL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-300x300.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-250x250.jpg\";s:5:\"width\";i:250;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-128x128.jpg\";s:5:\"width\";i:128;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"41weCvz1FFL-140x140.jpg\";s:5:\"width\";i:140;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41weCvz1FFL-50x50.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1376", "218", "_thumbnail_id", "219");
INSERT INTO `wp_postmeta` VALUES("1377", "218", "imwb_zonpress_post_producturl", "http://www.amazon.com/Clarins-Line-Control-Cream-Skin-Ounce/dp/B002R177NI%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002R177NI");
INSERT INTO `wp_postmeta` VALUES("1378", "218", "imwb_zonpress_post_price", "26.95");
INSERT INTO `wp_postmeta` VALUES("1379", "218", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1380", "218", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1381", "218", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1382", "218", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1383", "218", "imwb_interest_post_link_url", "http://www.amazon.com/Clarins-Line-Control-Cream-Skin-Ounce/dp/B002R177NI%3Fpsc%3D1%26SubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002R177NI");
INSERT INTO `wp_postmeta` VALUES("1384", "218", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1386", "220", "imwb_cc_amazon_asin", "B002LDVSS2");
INSERT INTO `wp_postmeta` VALUES("1387", "220", "_imwb_cc_amazon_asin_updated", "1418944759");
INSERT INTO `wp_postmeta` VALUES("1388", "221", "_wp_attached_file", "2014/12/41maHeF8DgL.jpg");
INSERT INTO `wp_postmeta` VALUES("1389", "221", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:211;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/41maHeF8DgL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"41maHeF8DgL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"41maHeF8DgL-127x300.jpg\";s:5:\"width\";i:127;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"41maHeF8DgL-106x250.jpg\";s:5:\"width\";i:106;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"41maHeF8DgL-106x250.jpg\";s:5:\"width\";i:106;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:22:\"41maHeF8DgL-54x128.jpg\";s:5:\"width\";i:54;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:22:\"41maHeF8DgL-59x140.jpg\";s:5:\"width\";i:59;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"41maHeF8DgL-21x50.jpg\";s:5:\"width\";i:21;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1390", "220", "_thumbnail_id", "221");
INSERT INTO `wp_postmeta` VALUES("1391", "220", "imwb_zonpress_post_producturl", "http://www.amazon.com/Clarks-Botanicals-Skin-Clearing-Face/dp/B002LDVSS2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002LDVSS2");
INSERT INTO `wp_postmeta` VALUES("1392", "220", "imwb_zonpress_post_price", "44.01");
INSERT INTO `wp_postmeta` VALUES("1393", "220", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1394", "220", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1395", "220", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1396", "220", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1397", "220", "imwb_interest_post_link_url", "http://www.amazon.com/Clarks-Botanicals-Skin-Clearing-Face/dp/B002LDVSS2%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002LDVSS2");
INSERT INTO `wp_postmeta` VALUES("1398", "220", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1400", "222", "imwb_cc_amazon_asin", "B002VJLWCI");
INSERT INTO `wp_postmeta` VALUES("1401", "222", "_imwb_cc_amazon_asin_updated", "1418944760");
INSERT INTO `wp_postmeta` VALUES("1402", "223", "_wp_attached_file", "2014/12/51ig2icKvcL.jpg");
INSERT INTO `wp_postmeta` VALUES("1403", "223", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:500;s:6:\"height\";i:414;s:4:\"file\";s:23:\"2014/12/51ig2icKvcL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-300x248.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:248;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-300x248.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:248;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-300x248.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:248;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-153x128.jpg\";s:5:\"width\";i:153;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"51ig2icKvcL-170x140.jpg\";s:5:\"width\";i:170;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"51ig2icKvcL-50x41.jpg\";s:5:\"width\";i:50;s:6:\"height\";i:41;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1404", "222", "_thumbnail_id", "223");
INSERT INTO `wp_postmeta` VALUES("1405", "222", "imwb_zonpress_post_producturl", "http://www.amazon.com/Jack-Black-First-Class-Travel/dp/B002VJLWCI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002VJLWCI");
INSERT INTO `wp_postmeta` VALUES("1406", "222", "imwb_zonpress_post_price", "49");
INSERT INTO `wp_postmeta` VALUES("1407", "222", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1408", "222", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1409", "222", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1410", "222", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1411", "222", "imwb_interest_post_link_url", "http://www.amazon.com/Jack-Black-First-Class-Travel/dp/B002VJLWCI%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB002VJLWCI");
INSERT INTO `wp_postmeta` VALUES("1412", "222", "imwb_interest_post_link_text", "From Amazon");
INSERT INTO `wp_postmeta` VALUES("1414", "224", "imwb_cc_amazon_asin", "B00JVAATAG");
INSERT INTO `wp_postmeta` VALUES("1415", "224", "_imwb_cc_amazon_asin_updated", "1418944760");
INSERT INTO `wp_postmeta` VALUES("1416", "225", "_wp_attached_file", "2014/12/31hTXcZDLRL.jpg");
INSERT INTO `wp_postmeta` VALUES("1417", "225", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:478;s:6:\"height\";i:500;s:4:\"file\";s:23:\"2014/12/31hTXcZDLRL.jpg\";s:5:\"sizes\";a:7:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-287x300.jpg\";s:5:\"width\";i:287;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-239x250.jpg\";s:5:\"width\";i:239;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:22:\"imwb-zonpress-carousel\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-239x250.jpg\";s:5:\"width\";i:239;s:6:\"height\";i:250;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-large-thumb\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-122x128.jpg\";s:5:\"width\";i:122;s:6:\"height\";i:128;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:23:\"imwb-zonpress-cat-thumb\";a:4:{s:4:\"file\";s:23:\"31hTXcZDLRL-134x140.jpg\";s:5:\"width\";i:134;s:6:\"height\";i:140;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:25:\"imwb-zonpress-small-thumb\";a:4:{s:4:\"file\";s:21:\"31hTXcZDLRL-48x50.jpg\";s:5:\"width\";i:48;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:11:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";s:11:\"orientation\";i:0;}}");
INSERT INTO `wp_postmeta` VALUES("1418", "224", "_thumbnail_id", "225");
INSERT INTO `wp_postmeta` VALUES("1419", "224", "imwb_zonpress_post_producturl", "http://www.amazon.com/20%25-Natural-Vitamin-Facial-Serum/dp/B00JVAATAG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JVAATAG");
INSERT INTO `wp_postmeta` VALUES("1420", "224", "imwb_zonpress_post_price", "24.99");
INSERT INTO `wp_postmeta` VALUES("1421", "224", "imwb_zonpress_post_currency", "$");
INSERT INTO `wp_postmeta` VALUES("1422", "224", "_imwb_zonpress_post_imp", "0");
INSERT INTO `wp_postmeta` VALUES("1423", "224", "_imwb_zonpress_post_clicks", "0");
INSERT INTO `wp_postmeta` VALUES("1424", "224", "_imwb_zonpress_post_ctr", "0");
INSERT INTO `wp_postmeta` VALUES("1425", "224", "imwb_interest_post_link_url", "http://www.amazon.com/20%25-Natural-Vitamin-Facial-Serum/dp/B00JVAATAG%3FSubscriptionId%3DAKIAJULJCU4YH7LDDYQA%26tag%3Dfreetos-20%26linkCode%3Dxm2%26camp%3D2025%26creative%3D165953%26creativeASIN%3DB00JVAATAG");
INSERT INTO `wp_postmeta` VALUES("1426", "224", "imwb_interest_post_link_text", "From Amazon");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "publish", "closed", "closed", "", "hello-world", "", "", "2014-09-16 17:54:30", "2014-09-16 17:54:30", "", "0", "http://beauty.demobay.info//?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://beauty.demobay.info//wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "publish", "open", "open", "", "sample-page", "", "", "2014-09-16 17:32:31", "2014-09-16 17:32:31", "", "0", "http://beauty.demobay.info//?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2014-09-16 17:54:30", "2014-09-16 17:54:30", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "inherit", "closed", "closed", "", "1-revision-v1", "", "", "2014-09-16 17:54:30", "2014-09-16 17:54:30", "", "1", "http://beauty.demobay.info//2014/09/16/1-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2014-12-18 12:59:54", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2014-12-18 12:59:54", "0000-00-00 00:00:00", "", "0", "http://beauty.demobay.info/?p=6", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2014-12-18 13:20:35", "2014-12-18 13:20:35", "http://beauty.demobay.info/wp-content/uploads/2014/12/cream-302738.jpg", "cream-302738.jpg", "", "inherit", "closed", "closed", "", "cream-302738-jpg", "", "", "2014-12-18 13:20:35", "2014-12-18 13:20:35", "", "0", "http://beauty.demobay.info/wp-content/uploads/2014/12/cream-302738.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2014-12-18 13:24:26", "2014-12-18 13:24:26", "http://beauty.demobay.info/wp-content/uploads/2014/12/cream-3027381.jpg", "cream-3027381.jpg", "", "inherit", "closed", "closed", "", "cream-3027381-jpg", "", "", "2014-12-18 13:24:26", "2014-12-18 13:24:26", "", "0", "http://beauty.demobay.info/wp-content/uploads/2014/12/cream-3027381.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2014-12-18 23:08:17", "2014-12-18 23:08:17", "<p>Specifications:<br />\n<br /> Package Include: 1* cosmetic bag<br />\n<br /> Rolled up measures 10*5 inch<br />\n<br /> Rolled out measures: 20*10 inch </p>\n<p>The quad large pack is a multiple compartment roll-up cosmetic bag<br />\n<br /> Keep your handbag organised and in control. Put all of your items<br />\n<br /> in this handbag organiser then place it in the handbag you are going to<br />\n<br />use for the day. You will never have to rummage around your bag for those keys or purse again. </p>\n<p> (Colors shown in pictures may slightly differ from actual product due to lighting and color settings.)</p>\n", "Rimobul Luxury Roll-N-Go Cosmetic Bag Roll Up Bathroom Organizer Black", "", "publish", "closed", "closed", "", "rimobul-luxury-roll-n-go-cosmetic-bag-roll-up-bathroom-organizer-black", "", "", "2014-12-18 23:08:17", "2014-12-18 23:08:17", "", "0", "http://beauty.demobay.info/2014/12/18/rimobul-luxury-roll-n-go-cosmetic-bag-roll-up-bathroom-organizer-black/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "", "51Jqbi-USCL", "", "inherit", "closed", "closed", "", "51jqbi-uscl", "", "", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "", "14", "http://beauty.demobay.info/wp-content/uploads/2014/12/51Jqbi-USCL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "<p>This professional luxury brush set from Bdellium\'s studio line is hand-crafted with a yellow wood handle and an aluminum ferrule. Hand-crafted brushes. Professional anti-bacterial brushes. Eco-friendly products.</p>\n", "Bdellium Tools Professional Antibacterial Makeup Studio Line Luxury 24pc. Brush Set with Roll-Up Pouch", "", "publish", "closed", "closed", "", "bdellium-tools-professional-antibacterial-makeup-studio-line-luxury-24pc-brush-set-with-roll-up-pouch", "", "", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "", "0", "http://beauty.demobay.info/2014/12/18/bdellium-tools-professional-antibacterial-makeup-studio-line-luxury-24pc-brush-set-with-roll-up-pouch/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "", "41D4XmJtqBL", "", "inherit", "closed", "closed", "", "41d4xmjtqbl", "", "", "2014-12-18 23:08:18", "2014-12-18 23:08:18", "", "16", "http://beauty.demobay.info/wp-content/uploads/2014/12/41D4XmJtqBL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "<p>Specifications:<br />\n<br /> Package Include: 1* cosmetic bag<br />\n<br /> Rolled up measures 10*5 inch<br />\n<br /> Rolled out measures: 20*10 inch </p>\n<p>The quad large pack is a multiple compartment roll-up cosmetic bag<br />\n<br /> Keep your handbag organised and in control. Put all of your items<br />\n<br /> in this handbag organiser then place it in the handbag you are going to<br />\n<br />use for the day. You will never have to rummage around your bag for those keys or purse again. </p>\n<p> (Colors shown in pictures may slightly differ from actual product due to lighting and color settings.)</p>\n", "Rimobul Luxury Roll N Go Cosmetic Bag Roll Up Bathroom Organizer Red & Hot Pink (Red & Hot Pink)", "", "publish", "closed", "closed", "", "rimobul-luxury-roll-n-go-cosmetic-bag-roll-up-bathroom-organizer-red-hot-pink-red-hot-pink", "", "", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "0", "http://beauty.demobay.info/2014/12/18/rimobul-luxury-roll-n-go-cosmetic-bag-roll-up-bathroom-organizer-red-hot-pink-red-hot-pink/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "515QdNyCwtL", "", "inherit", "closed", "closed", "", "515qdnycwtl", "", "", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "18", "http://beauty.demobay.info/wp-content/uploads/2014/12/515QdNyCwtL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "<p>Decadent lipstick luxury by Tigi for women 0.14 ounce lipstick. Decadent lipstick luxury was launched by the design house of Tigi. It is recommended for daily use. Please store in a cool dry place. 0.14 ounce lipstick.</p>\n", "Tigi Decadent Lipstick for Women, Luxury, 0.14 Ounce", "", "publish", "closed", "closed", "", "tigi-decadent-lipstick-for-women-luxury-0-14-ounce", "", "", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "0", "http://beauty.demobay.info/2014/12/18/tigi-decadent-lipstick-for-women-luxury-0-14-ounce/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "11EZ0-leiOL", "", "inherit", "closed", "closed", "", "11ez0-leiol", "", "", "2014-12-18 23:08:19", "2014-12-18 23:08:19", "", "20", "http://beauty.demobay.info/wp-content/uploads/2014/12/11EZ0-leiOL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "<p> New Protection Against Aging, An Intensive Supercharged Serum.</p>\n<p>One Lifevest, a Beverly Hills beauty secret created as an organic alternative to plastic surgery, botox and laser treatment is now offered exclusively to you online. Our clients have witnessed skin problems such as fine lines, discoloration or uneven skin tone reduced visibly within three weeks of use. Daily long-term use provides optimal results. </p>\n<p>Our high quality Vitamin C + Hyaluronic Acid serum uses only the highest natural and organic ingredients.</p>\n<p>Our serum contains Hyaluronic Acid which has been proven to reverse signs of aging. We have infused Vitamin C to increase the production of collagen on your face, returning elasticity to the skin. Vitamin C also acts as a powerful antioxidant, neutralizing free radicals, leaving skin firm and glowing. You skin tone will even out and reduce sagginess under your eyes. Unlike cream, serum penetrates to the deepest layers of the skin, guaranteeing a permanent solution to your problematic skin. The fountain of youth is finally here. </p>\n<p>Our Green Commitment</p>\n<p>Our packaging is made from biodegradable materials and 10% of our profits go to environmental non-profits. </p>\n<p>Our Product Works - We Guarantee It.</p>\n<p>We are positive that you will love our product. We are so confident we will provide 30 days money back guarantee if you are not satisfied for any. </p>\n<p> Important Information </p>\n<p>This unbelievable price is only offered for a limited time. </p>\n<p> Start Enjoying Younger and Healthier Skin Right Away</p>\n<p>Enjoy the benefits of this potent supercharged anti-aging serum and get ready to receive compliments from friends and family on your new glowing skin! Add One Lifevest to your shopping cart so your order can be shipped as soon as possible. Attention: Add 3 items in shopping cart pay ONLY 2!</p>\n", "Introducing Revolutionary Product: A Luxury Anti Aging Treatment Formula, Organic Vitamin C Serum 20% + Hyaluronic Acid. For Men and Women, One Life Vest Promises You\'ll Look Brighter and Feel Stronger in Just Weeks. Anti Aging Skin Care - Face Serum - Organic Vitamins - Antioxidant Serum - Vitamin C SkinCare - Topical Vitamin C - Dr Oz - Ascorbic Acid Serum. BUY 2 get 1 FREE!", "", "publish", "closed", "closed", "", "introducing-revolutionary-product-a-luxury-anti-aging-treatment-formula-organic-vitamin-c-serum-20-hyaluronic-acid-for-men-and-women-one-life-vest-promises-youll-look-brighter-and-feel-stronge", "", "", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "0", "http://beauty.demobay.info/2014/12/18/introducing-revolutionary-product-a-luxury-anti-aging-treatment-formula-organic-vitamin-c-serum-20-hyaluronic-acid-for-men-and-women-one-life-vest-promises-youll-look-brighter-and-feel-stronge/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "41mSludP-L", "", "inherit", "closed", "closed", "", "41msludp-l", "", "", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "22", "http://beauty.demobay.info/wp-content/uploads/2014/12/41mSludP-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "<p align=\"center\" style=\"font-size:2em;color:red;\">Pin Up Passion 11pc Vegan & Eco Friendly Makeup Brush Set - The Official Tool Of Glamor</p>\n<p align=\"center\" style=\"font-size:2em;color:black;\">Created By Sorelle Amore</p>\n<p>Flawless makeup is achieved through the use of the right tools, more so than the products used.</p>\n<p> \n<p>If you\'re a woman who seeks to present your absolute best and most glamorous self to the world, you cannot look past this specifically created tool for glamour.</p>\n<p>The hand sourced brushes are made from top grade synthetic materials with high-density synthetic bristles, solid bamboo handles with double crimped aluminium ferrule ensuring they do not shed. Quality is key.</p>\n<p> Your new glamour tool kit includes 11 vital brushes, each one specially designed for each area of the face. These brushes include the following brushes: kabuki foundation, flat foundation, powder, bronzer, contour, concealer, eyeshadow, eyeshadow blending, eyebrow and eyeliner right angled, eyebrow and eyelash comb and lipstick brush with lid for storage</p>\n<p>Be amazed by the softness and density of the bristles, helping with even and smooth application of your favourite makeup products. </p>\n<p>These sturdy and long lasting brushes, along with your stunning, red makeup brush holder will look beautifully in your makeup collections for years to come.</p>\n<p> \n<p style=\"font-size:2em;color:red;\">Life Wouldn\'t Be Complete Without A Bonus: </p>\n<p>Receive makeup brush instructions on the best use of each brush. Valued at $195.</p>\n<p>  \n<p>BUY WITH CONFIDENCE</p>\n<p> \n<p>We know you\'ll love your new makeup brushes so we\'re offering a 60 day 100% money back guarantee.</p>\n<p>Supplies are limited: join the glamour world NOW by clicking the orange  \"Add to Cart\" button at the top of this page</p>\n", "Best Makeup Brushes - 11pc Makeup Brush Set - Used By Celebrity YouTubers. Eco & Vegan Friendly.Top Grade Long Lasting Materials. Soft On Skin. Luxury Holder Case. How-To Instructions Included.", "", "publish", "closed", "closed", "", "best-makeup-brushes-11pc-makeup-brush-set-used-by-celebrity-youtubers-eco-vegan-friendly-top-grade-long-lasting-materials-soft-on-skin-luxury-holder-case-how-to-instructions-included", "", "", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "0", "http://beauty.demobay.info/2014/12/18/best-makeup-brushes-11pc-makeup-brush-set-used-by-celebrity-youtubers-eco-vegan-friendly-top-grade-long-lasting-materials-soft-on-skin-luxury-holder-case-how-to-instructions-included/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "51lEpLffrML", "", "inherit", "closed", "closed", "", "51leplffrml", "", "", "2014-12-18 23:08:20", "2014-12-18 23:08:20", "", "24", "http://beauty.demobay.info/wp-content/uploads/2014/12/51lEpLffrML.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "<p>Your Search For The Best Hydrating Natural Body Lotion is Over!</p>\n<p>This Body and Face Moisturizer Will Repair Your Irritated Skin</p>\n<p> - Absorbs quickly leaving your skin light and baby smooth, with no greasy or sticky feel<br />\n<br />- Strengthens skin\'s protective layer, so you can wave \'Goodbye\' to irritated and sensitive skin<br />\n<br />- Designed to hydrate and moisturize multiple layers of your skin from top down (not only the surface as other lotions)<br />\n<br />- A very light, clean and fresh scent, so you can wear any perfume or body spray with it<br />\n<br />- Designed for all skin types and very gentle in nature, therefore, can be used on sensitive skin and even babies<br />\n<br />- Excellent in low, medium and high humidity environments<br />\n<br />- A little goes a long way; especially, after your skin\'s moisture is restored<br />\n<br />- No animal testing </p>\n<p>This mix of ingredients helps protect against dryness, helps in the increase of CELL METABOLISM and soothes the area while keeping your skin vibrantly smooth.</p>\n<p> A dynamic synergy of quality ingredients includes Algae Extract or seaweed, a mineral-rich ingredient harvested from the sea that is known to provide surface hydration and a protective barrier to the skin, and Saccharide Isomerate, a water-binding agent known for its effectiveness as a moisturizer. Combined with essential amino acids and Apricot Kernel Oil, rich in vitamins A, B2, B6 and E, and Sunflower Seed Oil, often recommended for use on sensitive or inflamed skin. </p>\n<p>Apply this lotion for 30 days in a row and you\'ll see the difference in your skin. After your skin will become healthier and firmer you can apply the lotion less often.</p>\n<p>We are proud and stand by our Natural VibrancyTM products 100%. If you are not happy with our pure body lotion just send it back for a full refund.</p>\n<p>It\'s time to soak yourself, your family, friends and take your skin back in time!</p>\n", "Natural Body Lotion - Antioxidant-rich & Anti-inflammatory - Luxury Face Moisturizer for Men & Women - Seaweed & Green Tea Extract That Deeply Hydrates & Soothes Normal to Dry & Very Sensitive, Irritated, Acne Prone Skin - Alcohol Free!", "", "publish", "closed", "closed", "", "natural-body-lotion-antioxidant-rich-anti-inflammatory-luxury-face-moisturizer-for-men-women-seaweed-green-tea-extract-that-deeply-hydrates-soothes-normal-to-dry-very-sensitive-irrita", "", "", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "0", "http://beauty.demobay.info/2014/12/18/natural-body-lotion-antioxidant-rich-anti-inflammatory-luxury-face-moisturizer-for-men-women-seaweed-green-tea-extract-that-deeply-hydrates-soothes-normal-to-dry-very-sensitive-irrita/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "41QJxcz0K7L", "", "inherit", "closed", "closed", "", "41qjxcz0k7l", "", "", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "26", "http://beauty.demobay.info/wp-content/uploads/2014/12/41QJxcz0K7L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "<p>I created LORAC\'s close up pro face tutorial to give you all the tools you need to easily create a natural day or dramatic night look. I share my professional makeup tips that will take you from real life to red carpet by teaching you how to create each look using my favorite must-have products: porefection mattifying face primer (travel-size), pro palette (mini), pro mascara, pro powder cheek stain in rosy glow, lorac lip lustre in peach lustre and a tutorial booklet with removable instructions that cling to your mirror everything you need to do makeup like a pro. Remember, practice makes picture-perfect. Here\'s to putting your best face forward.</p>\n", "LORAC Close Up Real Life to Red Carpet PRO Face Tutorial", "", "publish", "closed", "closed", "", "lorac-close-up-real-life-to-red-carpet-pro-face-tutorial", "", "", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "0", "http://beauty.demobay.info/2014/12/18/lorac-close-up-real-life-to-red-carpet-pro-face-tutorial/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "51SAX8HsDLL", "", "inherit", "closed", "closed", "", "51sax8hsdll", "", "", "2014-12-18 23:08:21", "2014-12-18 23:08:21", "", "28", "http://beauty.demobay.info/wp-content/uploads/2014/12/51SAX8HsDLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "<p>Iman Cosmetics Luxury Moisturizing Lipstick -- Teak</p>\n<p>Iman Cosmetics Luxury Moisturizing Lipstick has a long-lasting effect on your lips, so you don\'t want it missing from your collection. It is to be used on its own or with an enhancer for added effect. Your lips are hydrated, plus the product contains necessary constituents for a smooth glide. It applies evenly allowing you to define easily. Use it for lip definition. Iman moisturizing lipstick can be used along with a lipstick or on its own. It gives it a sheen.</p>\n<p>Just For You: Suitable for women who need hydrated lips.</p>\n<p>A Closer Look: Iman Cosmetics Luxury Moisturizing Lipstick is developed as an emollient low gloss to care for your lips while defining and styling for a smooth finish. </p>\n<p>You Won\'t Find: Harsh chemicals</p>\n", "Iman Cosmetics Luxury Moisturizing Lipstick - Black Brandy", "", "publish", "closed", "closed", "", "iman-cosmetics-luxury-moisturizing-lipstick-black-brandy", "", "", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "0", "http://beauty.demobay.info/2014/12/18/iman-cosmetics-luxury-moisturizing-lipstick-black-brandy/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "31-4UVo0NiL", "", "inherit", "closed", "closed", "", "31-4uvo0nil", "", "", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "30", "http://beauty.demobay.info/wp-content/uploads/2014/12/31-4UVo0NiL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "<p>1PC Fashion Trend Womens Ladies Multilayer Big Pearl Bib Statement Charm Necklace(without retail package)</p>\n", "Sannysis Luxury Trend Womens Ladies Multilayer Big Pearl Bib Statement Charm Necklace", "", "publish", "closed", "closed", "", "sannysis-luxury-trend-womens-ladies-multilayer-big-pearl-bib-statement-charm-necklace", "", "", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "0", "http://beauty.demobay.info/2014/12/18/sannysis-luxury-trend-womens-ladies-multilayer-big-pearl-bib-statement-charm-necklace/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "51l50j-oMhL", "", "inherit", "closed", "closed", "", "51l50j-omhl", "", "", "2014-12-18 23:08:22", "2014-12-18 23:08:22", "", "32", "http://beauty.demobay.info/wp-content/uploads/2014/12/51l50j-oMhL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "<p>It Is Perfect For Professional Salon, Wedding, Parties And Home Use And Comes With a Luxury Black Palette Case;<br />\nThe Set Is In Excellent Quality And So Versatile And Convenient To Use.</p>\n", "GOODBUYER Classic Fashion Makeup Tools Concealer Palette Makeup Set (10 Colors)", "", "publish", "closed", "closed", "", "goodbuyer-classic-fashion-makeup-tools-concealer-palette-makeup-set-10-colors", "", "", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "", "0", "http://beauty.demobay.info/2014/12/18/goodbuyer-classic-fashion-makeup-tools-concealer-palette-makeup-set-10-colors/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("35", "1", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "", "41xP34EIbkL", "", "inherit", "closed", "closed", "", "41xp34eibkl", "", "", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "", "34", "http://beauty.demobay.info/wp-content/uploads/2014/12/41xP34EIbkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "<p>This adorable polka dot printed bag is perfect for travel and can fit all of the Diva\'s on the go necessities. Interior boasts many pockets that can easily accommodate items such as make up and other cosmetics. Exterior also has numerous pockets. <br>This has two removable snap button straps for easy carrying.</br><br>Easily Packable & Portable</br><br>Removable Straps</br><br></br> Handbag measures 9.5 inches wide. Handbag measures 5 inches top to bottom. Handbag measures 3.5 inches deep.</p>\n", "Luxury Divas Black & Pink Polka Dot Tote Travel Cosmetic Make-up Bag Organizer", "", "publish", "closed", "closed", "", "luxury-divas-black-pink-polka-dot-tote-travel-cosmetic-make-up-bag-organizer", "", "", "2014-12-18 23:08:23", "2014-12-18 23:08:23", "", "0", "http://beauty.demobay.info/2014/12/18/luxury-divas-black-pink-polka-dot-tote-travel-cosmetic-make-up-bag-organizer/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "51DweSzsWIL", "", "inherit", "closed", "closed", "", "51dweszswil", "", "", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "36", "http://beauty.demobay.info/wp-content/uploads/2014/12/51DweSzsWIL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "<p>Wish You Could Sleep Better? You Need Bedtime Bliss. Have you ever purchased a sleep mask that\'s poor quality, lets the light in, is uncomfortable and worst of all, breaks after a few uses? Do you struggle to sleep at night because the street lamps are too bright? Does your husband watch T.V late into the night or does your wife read in bed into the small hours? Problem Solved! With the Bedtime Bliss mask, you can block out the light and get to sleep quickly. There\'s no skimping on quality and no discomfort or your money back, GUARANTEED. Choose the Best with Bedtime Bliss. The contoured design of our sleep mask means that its much more comfortable than the traditional style masks. It blocks out the light while still giving you the freedom to open your eyes and allowing REM sleep. Its the perfect solution to ensure that you get a good night\'s sleep and wake up feeling refreshed the next day. We want you to be happy, so we\'re including FREE earplugs (color of free ear plugs may vary), carry case, AND an eBook completely free that\'s packed with natural sleep tips to ensure you get a great sleep. You\'ll also get our 90 Day Blissful Sleep Guarantee - If you\'re not completely satisfied simply contact us for a full refund. Why wait? Now\'s the perfect time to click Add To Cart and get your set NOW.</p>\n", "Bedtime Bliss® Contoured & Comfortable Sleep Mask & Ear Plug Set. Includes Carry Pouch for Eye Mask and Ear Plugs - Great for Travel, Shift Work & Meditation", "", "publish", "closed", "closed", "", "bedtime-bliss-contoured-comfortable-sleep-mask-ear-plug-set-includes-carry-pouch-for-eye-mask-and-ear-plugs-great-for-travel-shift-work-meditation", "", "", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "0", "http://beauty.demobay.info/2014/12/18/bedtime-bliss-contoured-comfortable-sleep-mask-ear-plug-set-includes-carry-pouch-for-eye-mask-and-ear-plugs-great-for-travel-shift-work-meditation/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "41OzCxW-dVL", "", "inherit", "closed", "closed", "", "41ozcxw-dvl", "", "", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "38", "http://beauty.demobay.info/wp-content/uploads/2014/12/41OzCxW-dVL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "<p>Buy Christian Dior Makeup Primer & Base - Christian Dior Skinflash Primer Radiance Boosting Makeup Primer 001 Sheer Glow</p>\n", "Christian Dior Skinflash Primer Radiance Boosting Makeup No.001 Sheer Glow Women Makeup, 0.5 Ounce", "", "publish", "closed", "closed", "", "christian-dior-skinflash-primer-radiance-boosting-makeup-no-001-sheer-glow-women-makeup-0-5-ounce", "", "", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "0", "http://beauty.demobay.info/2014/12/18/christian-dior-skinflash-primer-radiance-boosting-makeup-no-001-sheer-glow-women-makeup-0-5-ounce/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "21g-hKDb89L", "", "inherit", "closed", "closed", "", "21g-hkdb89l", "", "", "2014-12-18 23:08:24", "2014-12-18 23:08:24", "", "40", "http://beauty.demobay.info/wp-content/uploads/2014/12/21g-hKDb89L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "<p>Your dream of a perfect complexion is now a reality. This triple milled foundation powder feels as soft as silk. Illuminative properties correct and even the appearance of skin tone, providing a naturally healthy finish. Let your natural beauty shine through by wearing alone.  Or, wear over base perfect liquid foundation or sheer brilliance liquid foundation for a truly gorgeous complexion. </p>\n", "Gorgeous Cosmetics Powder Perfect Pressed Powder, 01-PP", "", "publish", "closed", "closed", "", "gorgeous-cosmetics-powder-perfect-pressed-powder-01-pp", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "0", "http://beauty.demobay.info/2014/12/18/gorgeous-cosmetics-powder-perfect-pressed-powder-01-pp/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "414Y5AGRKRL", "", "inherit", "closed", "closed", "", "414y5agrkrl", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "42", "http://beauty.demobay.info/wp-content/uploads/2014/12/414Y5AGRKRL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "<p>The In The Light palette is a beautiful collection of Stila\'s award-winning eye shadows in wearable, neutral shades for every skintone that can be worn wet or dry. The palette also includes an exclusive Smudge Stick Waterproof Eye Liner in Damsel, a matte chocolate brown, and a 6-page look book with detailed how-to tips and tricks.</p>\n", "stila In The Light Eye Shadow Palette", "", "publish", "closed", "closed", "", "stila-in-the-light-eye-shadow-palette", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "0", "http://beauty.demobay.info/2014/12/18/stila-in-the-light-eye-shadow-palette/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "41zufnK-snL", "", "inherit", "closed", "closed", "", "41zufnk-snl", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "44", "http://beauty.demobay.info/wp-content/uploads/2014/12/41zufnK-snL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "<p>Guciheaven, Exquisite leather shoes<br>Each pair of carefully polished<br>Every process embodies the shoe-making craftsman<br>The material of high quality<br>comfortable hand feeling<br>Fashionable and beautiful<br>Design simple and easy<br>Natural rubber sole stand wear and tear<br> When you to wear it you will Feel very comfortable<br>Make you Enjoy the everyday good life<br></p>\n", "Guciheaven Women Winter New Western Style Platform Rough Heels Short Boots(8 B(M)US, Black)", "", "publish", "closed", "closed", "", "guciheaven-women-winter-new-western-style-platform-rough-heels-short-boots8-bmus-black", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "0", "http://beauty.demobay.info/2014/12/18/guciheaven-women-winter-new-western-style-platform-rough-heels-short-boots8-bmus-black/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "41nFJo8EZ9L", "", "inherit", "closed", "closed", "", "41nfjo8ez9l", "", "", "2014-12-18 23:08:25", "2014-12-18 23:08:25", "", "46", "http://beauty.demobay.info/wp-content/uploads/2014/12/41nFJo8EZ9L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "<p>This black cosmetic bag has been made from some of the finest supple vegetable tanned leather. Whether travelling abroad or heading out for the night, this cosmetic bag can follow you in the smallest of handbags. Although petite, this make up bag has more than enough room for your cosmetic essentials! The wipe clean lining ensures that even if you spill some make up your favourite accessory will remain looking pristine. Handmade to last a lifetime, this black cosmetic bag would make a perfect treat for yourself or a loved one.</p>\n", "Maxwell Scott Luxury Black Leather Cosmetic Bag (Chia) - One Size", "", "publish", "closed", "closed", "", "maxwell-scott-luxury-black-leather-cosmetic-bag-chia-one-size", "", "", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "0", "http://beauty.demobay.info/2014/12/18/maxwell-scott-luxury-black-leather-cosmetic-bag-chia-one-size/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "41jq624lNLL", "", "inherit", "closed", "closed", "", "41jq624lnll", "", "", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "48", "http://beauty.demobay.info/wp-content/uploads/2014/12/41jq624lNLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "<p>This is how favourite tights should feel: soft to the touch with an extraordinarily even look, they add a hint of luxury and elegance to any occasion. Wolford\'s Individual 10 Denier Tights feature a barely visible shadow toe reinforcement , cotton gusset and reinforced panty part for optimum comfort in sizes XL and XXL. Thanks to the use of double-wrapped elastane in each row you get an excellent stretch and a perfect fit. A real all-rounder in mat transparency, these tights are sure to endure any daytime or evening event effortlessly. 80% Nylon, 19% Elastane, 1% Cotton</p>\n", "Wolford Individual 10 Pantyhose Hosiery Cosmetic Medium", "", "publish", "closed", "closed", "", "wolford-individual-10-pantyhose-hosiery-cosmetic-medium", "", "", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "0", "http://beauty.demobay.info/2014/12/18/wolford-individual-10-pantyhose-hosiery-cosmetic-medium/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "31lE2jLaNgL", "", "inherit", "closed", "closed", "", "31le2jlangl", "", "", "2014-12-18 23:08:26", "2014-12-18 23:08:26", "", "50", "http://beauty.demobay.info/wp-content/uploads/2014/12/31lE2jLaNgL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("52", "1", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "<p>Makeup Brush Set is an essential beauty tool to get the new look.<br />\n<br /> Using this 13 piece Luxury Brush Kit you will finally be able to achieve the desired appearance you always wanted! </p>\n<p> This<br />\nMakeup Brush Set includes: </p>\n<p> Liner Brush - length 4.7in (12cm)<br />\n<br /> Small Shadow Brush - length 4.7in (12cm)<br />\n<br /> Crease Brush - length 4.7in (12cm)<br />\n<br /> Shadow Brush - length 4.7in (12cm)<br />\n<br /> Fluffy Shadow Blending Brush - length 4.7in (12cm)<br />\n<br /> Concealer Brush - length 4.7in (12cm)<br />\n<br /> Eyelash/Eyebrow Spoolie - length 5.9in (15cm)<br />\n<br /> Angled Brow Brush - length 4.5in (11.5cm)<br />\n<br /> Angled Shadow Brush - length 4.7in (12cm)<br />\n<br /> Angled Blush Brush - length 5.9in (15cm)<br />\n<br /> Foundation Brush - length 5.5in (14cm)<br />\n<br /> Powder Brush - length 5.7in (14.5cm)<br />\n<br /> Powder/Foundation Brush - length 5.5in (14cm) </p>\n<p>Elegant Brush Bag<br />\n<br /> Keep you brushes organized with this folding, easy to carry pouch. Each brush arrives in a clear plastic wrap to keep them clean and secure. </p>\n<p>Cruelty Free Beauty Brand<br />\n<br /> All brushes are synthetic and Vegan - there has been NO ANIMAL TESTING! Nanshy.com is a proud member of People for the Ethical Treatment of Animals - PETA.org and is against cruelty to animals. </p>\n<p>Quality Assurance<br />\n<br /> Designed in United Kingdom our brushes are assembled by hand and extensively tested. Every brush comes with Nanshy logo printed on. </p>\n<p>What will you get? Nanshy ergonomic makeup brushes in an elegant brush pouch.</p>\n", "Nanshy Luxury Makeup Brush Set (13 Face and Eye Brushes with Elegant Brush Bag Case)", "", "publish", "closed", "closed", "", "nanshy-luxury-makeup-brush-set-13-face-and-eye-brushes-with-elegant-brush-bag-case", "", "", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "0", "http://beauty.demobay.info/2014/12/18/nanshy-luxury-makeup-brush-set-13-face-and-eye-brushes-with-elegant-brush-bag-case/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("53", "1", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "510SrxUCfkL", "", "inherit", "closed", "closed", "", "510srxucfkl", "", "", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "52", "http://beauty.demobay.info/wp-content/uploads/2014/12/510SrxUCfkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "<p>Regarding Acrylic :  Acrylic is a useful, clear plastic that resembles glass. But it has properties that make it superior to glass in many ways. It is many times stronger than glass, making it much more impact resistant and therefore safer. Acrylic also insulates better than glass, potentially saving on heating bills. Adding to this favorable array of properties, a  transparency rate of 93% makes acrylic the clearest material known. Very thick glass will have a green tint, while acrylic remains clear. </p>\n<p>Note :</p>\n<p>1,Although it has a hard and clear surface, please avoid sharp scratch to keep its aesthetic.</p>\n<p>2, Acrylic also insulates better than glass or plastic, but please don\'t close to the source of ignition to avoid damaging.</p>\n<p>3, Cosmetic organizer isn\'t the Anti-Pressure product, please don\'t place too heavy articles.</p>\n", "SDBING Acrylic Makeup Cosmetics Organizer Luxury Crystal Insert Holder Box", "", "publish", "closed", "closed", "", "sdbing-acrylic-makeup-cosmetics-organizer-luxury-crystal-insert-holder-box", "", "", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "0", "http://beauty.demobay.info/2014/12/18/sdbing-acrylic-makeup-cosmetics-organizer-luxury-crystal-insert-holder-box/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("55", "1", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "51kEiA7cYjL", "", "inherit", "closed", "closed", "", "51keia7cyjl", "", "", "2014-12-18 23:09:12", "2014-12-18 23:09:12", "", "54", "http://beauty.demobay.info/wp-content/uploads/2014/12/51kEiA7cYjL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "<p>Formerly known as Visage Poudre Luxury Powders, these ultra-neutral powders provide superior matte and subtle finishing. Often compared to French powders with silky-fine textures. the Ben Nye Bella line of powders are translucent with just a hint of color. Please Note: This product does NOT come with a seal!<br />\nPlease note: Powders may settle and compress during shipping and some bottles may appear to be partially empty. Shaking the product vigorously will decompress the powder and return it to its original state.</p>\n", "Ben Nye Luxury Powders - Banana 1.5oz", "", "publish", "closed", "closed", "", "ben-nye-luxury-powders-banana-1-5oz", "", "", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "0", "http://beauty.demobay.info/2014/12/18/ben-nye-luxury-powders-banana-1-5oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("57", "1", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "41PiIPc0CLL", "", "inherit", "closed", "closed", "", "41piipc0cll", "", "", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "56", "http://beauty.demobay.info/wp-content/uploads/2014/12/41PiIPc0CLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "<p>NEW BEN NYE LUXURY FACE POWDERCOLOR: BANANASIZE: 3ozALL OUR PRODUCTS ARE 100% AUTHENTICSAME DAY SHIPPING WITH TRACKING NUMBERBen Nye Luxury Powders provide superior matte and subtle finishing. Often compared to French powders with silky-fine textures. the Ben Nye Bella line of powders are translucent with just a hint of color</p>\n", "Ben Nye Banana Luxury Face Powder 3.0 oz Makeup Kim Kardashian NEW!!!", "", "publish", "closed", "closed", "", "ben-nye-banana-luxury-face-powder-3-0-oz-makeup-kim-kardashian-new", "", "", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "0", "http://beauty.demobay.info/2014/12/18/ben-nye-banana-luxury-face-powder-3-0-oz-makeup-kim-kardashian-new/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "21IH29XIhxL", "", "inherit", "closed", "closed", "", "21ih29xihxl", "", "", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "58", "http://beauty.demobay.info/wp-content/uploads/2014/12/21IH29XIhxL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "<p>Regarding Acrylic<br />\nAcrylic is a useful, clear plastic that resembles glass. But it has properties that make it superior to glass in many ways. It is many times stronger than glass, making it much more impact resistant and therefore safer. Acrylic also insulates better than glass, potentially saving on heating bills. Adding to this favorable array of properties, a transparency rate of 93% makes acrylic the clearest material known. Very thick glass will have a green tint, while acrylic remains clear.<br />\nNote :<br />\n1,Although it has a hard and clear surface, please avoid sharp scratch to keep its aesthetic.<br />\n2,Acrylic also insulates better than glass or plastic, but please don\'t close to the source of ignition to avoid damaging.<br />\n3,Cosmetic organizer isn\'t the Anti-Pressure product, please don\'t place too heavy articles.</p>\n", "Beauty Acrylic Makeup Organizer Luxury Cosmetics Acrylic Clear Case Storage Insert Holder Box 1155", "", "publish", "closed", "closed", "", "beauty-acrylic-makeup-organizer-luxury-cosmetics-acrylic-clear-case-storage-insert-holder-box-1155", "", "", "2014-12-18 23:09:13", "2014-12-18 23:09:13", "", "0", "http://beauty.demobay.info/2014/12/18/beauty-acrylic-makeup-organizer-luxury-cosmetics-acrylic-clear-case-storage-insert-holder-box-1155/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "", "51s5vUmqplL", "", "inherit", "closed", "closed", "", "51s5vumqpll", "", "", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "", "60", "http://beauty.demobay.info/wp-content/uploads/2014/12/51s5vUmqplL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "<p>[Regarding Acrylic]<br />\nAcrylic is a useful, clear plastic that resembles glass. But it has properties that make it superior to glass in many ways. It is many times stronger than glass, making it much more impact resistant and therefore safer. Acrylic also insulates better than glass, potentially saving on heating bills. Adding to this favorable array of properties, a transparency rate of 93% makes acrylic the clearest material known. Very thick glass will have a green tint, while acrylic remains clear.<br />\nNote :<br />\n1,Although it has a hard and clear surface, please avoid sharp scratch to keep its aesthetic.<br />\n2,Acrylic also insulates better than glass or plastic, but please don\'t close to the source of ignition to avoid damaging.<br />\n3,Cosmetic organizer isn\'t the Anti-Pressure product, please don\'t place too heavy articles.</p>\n", "Luxury Acrylic Cosmetic Organizer Makeup Box 6 Drawers 1005-5***", "", "publish", "closed", "closed", "", "luxury-acrylic-cosmetic-organizer-makeup-box-6-drawers-1005-5", "", "", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "", "0", "http://beauty.demobay.info/2014/12/18/luxury-acrylic-cosmetic-organizer-makeup-box-6-drawers-1005-5/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "", "51mOchLG7uL", "", "inherit", "closed", "closed", "", "51mochlg7ul", "", "", "2014-12-18 23:09:14", "2014-12-18 23:09:14", "", "62", "http://beauty.demobay.info/wp-content/uploads/2014/12/51mOchLG7uL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "<p>LARGE MAKEUP COSMETIC CASE </p>\n<p>Do you own a lot of makeup/Cosmetics that don\'t fit into the standard small cosmetic bag? Do you need too many cosmetic bags to hold your ever expanding cosmetic collection? Or do you travel a lot and have a hard time keeping your cosmetics organized in one place on the go? </p>\n<p>You have now found YOUR PERFECT COSMETIC CASE </p>\n<p>This large ,fashionable and chic case is roomy enough with the organization you need to accommodate all of your small and large makeup, Jewelry and beauty accessories. Its 2 fine handles and shoulder strap makes it a breeze to travel with. </p>\n<p>*Well-made and sturdy.<br />\n<br />*Large and roomy interior.<br />\n<br />*Includes 4 pull-out trays for perfect organization.<br />\n<br />*Includes free shoulder strap.<br />\n<br />*Removable full interior for easy cleaning and access.<br />\n<br />*Stylish, chic exterior. </p>\n<p>-Money back guaranteed if dissatisfied. We guarantee our products.<br />\n<br /> <br />\nSo go ahead and click on the Add to Cart button before the price increases</p>\n", "Large Luxury Makeup Cosmetic Studio Case / Jewelry Storage - Organizer . Shoulder Bag With 4 Extendable Trays, Carrier Handle & Travel Shoulder Strap. Spacious Design To Fit all Cosmetics & Beauty Accessories - Black", "", "publish", "closed", "closed", "", "large-luxury-makeup-cosmetic-studio-case-jewelry-storage-organizer-shoulder-bag-with-4-extendable-trays-carrier-handle-travel-shoulder-strap-spacious-design-to-fit-all-cosmetics-beauty-acc", "", "", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "0", "http://beauty.demobay.info/2014/12/18/large-luxury-makeup-cosmetic-studio-case-jewelry-storage-organizer-shoulder-bag-with-4-extendable-trays-carrier-handle-travel-shoulder-strap-spacious-design-to-fit-all-cosmetics-beauty-acc/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "51tDZyTpqUL", "", "inherit", "closed", "closed", "", "51tdzytpqul", "", "", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "64", "http://beauty.demobay.info/wp-content/uploads/2014/12/51tDZyTpqUL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "<p>[Regarding Acrylic]<br />\nAcrylic is a useful, clear plastic that resembles glass. But it has properties that make it superior to glass in many ways. It is many times stronger than glass, making it much more impact resistant and therefore safer. Acrylic also insulates better than glass, potentially saving on heating bills. Adding to this favorable array of properties, a transparency rate of 93% makes acrylic the clearest material known. Very thick glass will have a green tint, while acrylic remains clear.<br />\nNote :<br />\n1,Although it has a hard and clear surface, please avoid sharp scratch to keep its aesthetic.<br />\n2,Acrylic also insulates better than glass or plastic, but please don\'t close to the source of ignition to avoid damaging.<br />\n3,Cosmetic organizer isn\'t the Anti-Pressure product, please don\'t place too heavy articles.</p>\n", "Luxury Acrylic Cosmetic Organizer Makeup Box 3 Drawers 1304*** Top and Bottom Set", "", "publish", "closed", "closed", "", "luxury-acrylic-cosmetic-organizer-makeup-box-3-drawers-1304-top-and-bottom-set", "", "", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "0", "http://beauty.demobay.info/2014/12/18/luxury-acrylic-cosmetic-organizer-makeup-box-3-drawers-1304-top-and-bottom-set/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "51im9EDdYwL", "", "inherit", "closed", "closed", "", "51im9eddywl", "", "", "2014-12-18 23:09:15", "2014-12-18 23:09:15", "", "66", "http://beauty.demobay.info/wp-content/uploads/2014/12/51im9EDdYwL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "<p>Iman Cosmetics Luxury Pressed Powder -- Clay Medium Dark</p>\n<p>The Iman Cosmetics Luxury Pressed Powder helps control skin oiliness with its light powder formula. This translucent powder assists you in keeping your skin shine-free and moisture balanced. The Iman Cosmetics Luxury Pressed Powder helps you completely beautify your face. It has light shades that enhance a wide range of skin tones. It manages to control oil without drying your skin. Wear it alone or over foundation, which will give your makeup a perfect final touch. A silky powder blush, the Iman Pressed Powder gives you a finish that\'s long lasting and appears natural. </p>\n<p><br>Just for you: Oily skin<br><br>A Closer Look:  Iman Cosmetics Luxury Pressed Powder has a light, translucent formula, which helps in providing a matte finish.<br><br>You Won\'t Find: Harsh chemicals<br></p>\n", "Iman Cosmetics Luxury Pressed Powder -- Clay Medium Dark", "", "publish", "closed", "closed", "", "iman-cosmetics-luxury-pressed-powder-clay-medium-dark", "", "", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "0", "http://beauty.demobay.info/2014/12/18/iman-cosmetics-luxury-pressed-powder-clay-medium-dark/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "41bg-9iaztL", "", "inherit", "closed", "closed", "", "41bg-9iaztl", "", "", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "68", "http://beauty.demobay.info/wp-content/uploads/2014/12/41bg-9iaztL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "<p>[Regarding Acrylic]<br />\nAcrylic is a useful, clear plastic that resembles glass. But it has properties that make it superior to glass in many ways. It is many times stronger than glass, making it much more impact resistant and therefore safer. Acrylic also insulates better than glass, potentially saving on heating bills. Adding to this favorable array of properties, a transparency rate of 93% makes acrylic the clearest material known. Very thick glass will have a green tint, while acrylic remains clear.<br />\nNote :<br />\n1,Although it has a hard and clear surface, please avoid sharp scratch to keep its aesthetic.<br />\n2,Acrylic also insulates better than glass or plastic, but please don\'t close to the source of ignition to avoid damaging.<br />\n3,Cosmetic organizer isn\'t the Anti-Pressure product, please don\'t place too heavy articles.</p>\n", "Luxury Acrylic Cosmetic Organizer Makeup Box 3 Drawers 1005-4***", "", "publish", "closed", "closed", "", "luxury-acrylic-cosmetic-organizer-makeup-box-3-drawers-1005-4", "", "", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "0", "http://beauty.demobay.info/2014/12/18/luxury-acrylic-cosmetic-organizer-makeup-box-3-drawers-1005-4/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "51p5xGtrGTL", "", "inherit", "closed", "closed", "", "51p5xgtrgtl", "", "", "2014-12-18 23:09:16", "2014-12-18 23:09:16", "", "70", "http://beauty.demobay.info/wp-content/uploads/2014/12/51p5xGtrGTL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2014-12-18 23:09:56", "2014-12-18 23:09:56", "<p>Burberry for Women Eau de Parfum is a fresh and sensual fragrance. The scent features fruity top notes of blackcurrant, fresh green apple and bright bergamot. Heart notes of cedar wood, jasmine, moss are intensified with warm notes of sandalwood for a rich and sensual tone. Warm notes of musk and vanilla smooth the base. Presented in a glass bottle. 100ml. Made in France</p>\n", "BURBERRY for Women Eau de Parfum, 100 ml.", "", "publish", "closed", "closed", "", "burberry-for-women-eau-de-parfum-100-ml", "", "", "2014-12-18 23:09:56", "2014-12-18 23:09:56", "", "0", "http://beauty.demobay.info/2014/12/18/burberry-for-women-eau-de-parfum-100-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2014-12-18 23:09:57", "2014-12-18 23:09:57", "", "41Xs31LRdYL", "", "inherit", "closed", "closed", "", "41xs31lrdyl", "", "", "2014-12-18 23:09:57", "2014-12-18 23:09:57", "", "72", "http://beauty.demobay.info/wp-content/uploads/2014/12/41Xs31LRdYL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "<p>SEA Premium Moisturizing Lotion will aid to rediscover the joy of a Soft Beautiful Radiant and Youthful Skin</p>\n<p>Luxury Body Lotion helps to restore the health and beauty of your skin in a Natural way</p>\n<p>- Unscented, Fragrance free body lotion.<br />\n<br>- 24 hour moisturizing lotion for day and night use.<br />\n<br>- Paraben free hand and body lotion.<br />\n<br>- Cleverly researched ingredients.</p>\n<p>Contains Shea Butter, Emu Oil and Aloe Vera.</p>\n<p>Start to enjoy the widely known benefits of Shea Butter and Aloe Vera plus the Power of Emu Oil which until now has been relatively kept for high end very expensive beauty products.</p>\n<p>SEA Premium Moisturizing Body lotion is not only unique but it is different even in texture and can be applied as generously as required</p>\n<p>- Not tested on animals<br />\n<br>- Contains no petroleum products<br />\n - Natural Body Lotion<br />\n<br>- Ingredients from Natural based products</p>\n<p>Life time no quibble guarantee. We are confident you will like it. Guaranteed</p>\n<p>To join countless others that are already enjoying this amazing product Click the Buy Button on the top of this page now</p>\n", "SEA Premium Moisturizing Body Lotion for Men and Women - Fragrance Free - Natural Skin Care Lotion - with Shea Butter Emu Oil and Aloe Vera - Firming Paraben Free Luxury Moisturizer - Best Hand Unscented Personal Care Lotion - Life Time Guarantee", "", "publish", "closed", "closed", "", "sea-premium-moisturizing-body-lotion-for-men-and-women-fragrance-free-natural-skin-care-lotion-with-shea-butter-emu-oil-and-aloe-vera-firming-paraben-free-luxury-moisturizer-best-hand-unscen", "", "", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "0", "http://beauty.demobay.info/2014/12/18/sea-premium-moisturizing-body-lotion-for-men-and-women-fragrance-free-natural-skin-care-lotion-with-shea-butter-emu-oil-and-aloe-vera-firming-paraben-free-luxury-moisturizer-best-hand-unscen/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "41E-T71rQHL", "", "inherit", "closed", "closed", "", "41e-t71rqhl", "", "", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "74", "http://beauty.demobay.info/wp-content/uploads/2014/12/41E-T71rQHL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "<p>Introduced in 2002. Fragrance notes: a floral bouquet, very feminine. Recommended use: daytime.When applying any fragrance please consider that there are several factors which can affect the natural smell of your skin and, in turn, the way a scent smells on you.  For instance, your mood, stress level, age, body chemistry, diet, and current medications may all alter the scents you wear.  Similarly, factor such as dry or oily skin can even affect the amount of time a fragrance will last after being applied</p>\n", "Arden Beauty By Elizabeth Arden For Women. Eau De Parfum Spray 3.3 Ounces", "", "publish", "closed", "closed", "", "arden-beauty-by-elizabeth-arden-for-women-eau-de-parfum-spray-3-3-ounces", "", "", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "0", "http://beauty.demobay.info/2014/12/18/arden-beauty-by-elizabeth-arden-for-women-eau-de-parfum-spray-3-3-ounces/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "416hdqpfdhL", "", "inherit", "closed", "closed", "", "416hdqpfdhl", "", "", "2014-12-18 23:09:58", "2014-12-18 23:09:58", "", "76", "http://beauty.demobay.info/wp-content/uploads/2014/12/416hdqpfdhL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "<p>Introduced in 2002. Fragrance notes: mandarin, musk and muguet. Recommended use: daytime.When applying any fragrance please consider that there are several factors which can affect the natural smell of your skin and, in turn, the way a scent smells on you.  For instance, your mood, stress level, age, body chemistry, diet, and current medications may all alter the scents you wear.  Similarly, factor such as dry or oily skin can even affect the amount of time a fragrance will last after being applied</p>\n", "SWISS ARMY by Victorinox for Women  EAU DE TOILETTE SPRAY 3.4 oz / 100 ml", "", "publish", "closed", "closed", "", "swiss-army-by-victorinox-for-women-eau-de-toilette-spray-3-4-oz-100-ml", "", "", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "0", "http://beauty.demobay.info/2014/12/18/swiss-army-by-victorinox-for-women-eau-de-toilette-spray-3-4-oz-100-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "21ChdPcs-oL", "", "inherit", "closed", "closed", "", "21chdpcs-ol", "", "", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "78", "http://beauty.demobay.info/wp-content/uploads/2014/12/21ChdPcs-oL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "<p>These best-selling soaps are triple milled in Provence using the old-world methods. They’re enriched with natural shea butter to cleanse and soften, and infused with pure essential oils to add delicate aroma. Equally wonderful for gifts, guests and personal care.  This large 250 gram bar is our best value, the fragrance maintains until the soap is all used up.</p>\n", "Pre de Provence Soap Shea Enriched Everyday 250 Gram Extra Large French Soap Bar - Sage", "", "publish", "closed", "closed", "", "pre-de-provence-soap-shea-enriched-everyday-250-gram-extra-large-french-soap-bar-sage", "", "", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "0", "http://beauty.demobay.info/2014/12/18/pre-de-provence-soap-shea-enriched-everyday-250-gram-extra-large-french-soap-bar-sage/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "41A7H-6NR8L", "", "inherit", "closed", "closed", "", "41a7h-6nr8l", "", "", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "80", "http://beauty.demobay.info/wp-content/uploads/2014/12/41A7H-6NR8L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "<p>Lasting Illusions Luxury Fragrance Mist For Women Eternity 7.7 fl. oz<br />\nAn Illussion Eternity 7.7 fl. oz</p>\n", "Lasting Illusions Luxury Fragrance Mist For Women Eternity 7.7 fl. oz", "", "publish", "closed", "closed", "", "lasting-illusions-luxury-fragrance-mist-for-women-eternity-7-7-fl-oz", "", "", "2014-12-18 23:09:59", "2014-12-18 23:09:59", "", "0", "http://beauty.demobay.info/2014/12/18/lasting-illusions-luxury-fragrance-mist-for-women-eternity-7-7-fl-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "318k6cYgLsL", "", "inherit", "closed", "closed", "", "318k6cyglsl", "", "", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "82", "http://beauty.demobay.info/wp-content/uploads/2014/12/318k6cYgLsL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "<p>The Blue Garden candle by NEST Fragrances includes notes of blue hydrangea, hyacinth and forget-me-nots that are blended with fresh green notes and a dew drop accord to create the aroma of a lush floral garden. A portion of the proceeds from the sale of this candle will be donated to Autism Speaks. The scent is housed in a blue glass and blue box.  The NEST Fragrances everyday collection combines color, texture and fragrance to enhance the everyday living and entertaining experience. The glass vases are designed to compliment the beauty of its surroundings; the classic shape and modern stripe etching will complement any décor. Each of the fragrances has been created by the most accomplished perfumers at the world\'s leading fragrance houses.</p>\n", "NEST Fragrances NEST01-BG Blue Garden Scented Classic Candle", "", "publish", "closed", "closed", "", "nest-fragrances-nest01-bg-blue-garden-scented-classic-candle", "", "", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "0", "http://beauty.demobay.info/2014/12/18/nest-fragrances-nest01-bg-blue-garden-scented-classic-candle/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "41umBnW4kGL", "", "inherit", "closed", "closed", "", "41umbnw4kgl", "", "", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "84", "http://beauty.demobay.info/wp-content/uploads/2014/12/41umBnW4kGL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "<p>Burberry The Beat Eau de Toilette is an effortlessly intense and energetic fragrance. The scent features modern and unexpected top notes of bergamot, cardamom, fiery pink pepper and mandarin. Heart notes of Ceylon tea, iris and bluebell add a floral texture. Seductive white musk, vetiver and cedarwood give depth to this sensual, youthful fragrance. Presented in a check-patterned glass bottle. 75ml. Made in France</p>\n", "BURBERRY The Beat for Woman Eau de Toilette, 75 ml.", "", "publish", "closed", "closed", "", "burberry-the-beat-for-woman-eau-de-toilette-75-ml", "", "", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "0", "http://beauty.demobay.info/2014/12/18/burberry-the-beat-for-woman-eau-de-toilette-75-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("87", "1", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "41Jp-VTJTuL", "", "inherit", "closed", "closed", "", "41jp-vtjtul", "", "", "2014-12-18 23:10:00", "2014-12-18 23:10:00", "", "86", "http://beauty.demobay.info/wp-content/uploads/2014/12/41Jp-VTJTuL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "<p>Launched by the design house of Donna Karan in 1994, CASHMERE MIST is a women\'s fragrance that possesses a blend of fresh floral jasmine, sandalwood & vanilla.  It is recommended for daytime wear.When applying any fragrance please consider that there are several factors which can affect the natural smell of your skin and, in turn, the way a scent smells on you.  For instance, your mood, stress level, age, body chemistry, diet, and current medications may all alter the scents you wear.  Similarly, factor such as dry or oily skin can even affect the amount of time a fragrance will last after being applied</p>\n", "Cashmere Mist By Donna Karan For Women. Eau De Parfum Spray 3.4-Ounces", "", "publish", "closed", "closed", "", "cashmere-mist-by-donna-karan-for-women-eau-de-parfum-spray-3-4-ounces", "", "", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "0", "http://beauty.demobay.info/2014/12/18/cashmere-mist-by-donna-karan-for-women-eau-de-parfum-spray-3-4-ounces/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("89", "1", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "31mmi8YzclL", "", "inherit", "closed", "closed", "", "31mmi8yzcll", "", "", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "88", "http://beauty.demobay.info/wp-content/uploads/2014/12/31mmi8YzclL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "<p>Burberry Brit Eau de Toilette is a light interpretation of the timeless Brit fragrance. The scent features fresh and playful top notes with Italian lime, icy pear and crisp green almond. Soft floral heart notes of lush white peony are sweetened with sugared almond. Warming amber and mahogany are calmed with sensual notes of vanilla bean. Presented in a check glass bottle. 100ml. Made in France</p>\n", "BURBERRY Brit for Women Eau de Toilette, 100 ml.", "", "publish", "closed", "closed", "", "burberry-brit-for-women-eau-de-toilette-100-ml", "", "", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "0", "http://beauty.demobay.info/2014/12/18/burberry-brit-for-women-eau-de-toilette-100-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("91", "1", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "41ZKF8pPsLL", "", "inherit", "closed", "closed", "", "41zkf8ppsll", "", "", "2014-12-18 23:10:01", "2014-12-18 23:10:01", "", "90", "http://beauty.demobay.info/wp-content/uploads/2014/12/41ZKF8pPsLL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("92", "1", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "<p>Taylor of London Lavender Gift Box (3 Bars) 3.5ozea bar</p>\n", "Lavender by Taylor of London for Women Luxury Perfumed Soaps, 3 Count", "", "publish", "closed", "closed", "", "lavender-by-taylor-of-london-for-women-luxury-perfumed-soaps-3-count", "", "", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "0", "http://beauty.demobay.info/2014/12/18/lavender-by-taylor-of-london-for-women-luxury-perfumed-soaps-3-count/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("93", "1", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "216UOVOu-zL", "", "inherit", "closed", "closed", "", "216uovou-zl", "", "", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "92", "http://beauty.demobay.info/wp-content/uploads/2014/12/216UOVOu-zL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("94", "1", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "<p>Lasting Illusions Luxury Fragrance Mist For Men Acqua Di Gio<br />\nAn Illussion of Men Acqua Di Gio 7.7 fl. oz</p>\n", "Lasting Illusions Luxury Fragrance Mist For Men Acqua Di Gio 7.7 fl. oz", "", "publish", "closed", "closed", "", "lasting-illusions-luxury-fragrance-mist-for-men-acqua-di-gio-7-7-fl-oz", "", "", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "0", "http://beauty.demobay.info/2014/12/18/lasting-illusions-luxury-fragrance-mist-for-men-acqua-di-gio-7-7-fl-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("95", "1", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "11lF6hrumzL", "", "inherit", "closed", "closed", "", "11lf6hrumzl", "", "", "2014-12-18 23:10:02", "2014-12-18 23:10:02", "", "94", "http://beauty.demobay.info/wp-content/uploads/2014/12/11lF6hrumzL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("96", "1", "2014-12-18 23:10:03", "2014-12-18 23:10:03", "<p>Imagine femininity, luxury and style--bottled. Introducing Jimmy Choo, the fragrance. Expressing an aura of strength and beauty, glamour and confidence, it is inspired by modern women. Luminous green top notes, a heart of rich and exotic tiger orchid and lingering sensual base notes of sweet toffee and Indonesian patchouli leave a sensual memory on the skin. Notes: sweet orange, pear nectar, tiger orchid, Indonesian patchouli, caramel.</p>\n<p>Weight: 2 oz</p>\n<p>Special Shipping Information: This product may not be available for 1 or 2 day shipping due to federal regulations that require it to ship via ground ship methods only. This product can only be shipped within the 48 contiguous states.</p>\n", "Jimmy Choo Women Eau De Parfum Spray, 2 Ounce", "", "publish", "closed", "closed", "", "jimmy-choo-women-eau-de-parfum-spray-2-ounce", "", "", "2014-12-18 23:10:03", "2014-12-18 23:10:03", "", "0", "http://beauty.demobay.info/2014/12/18/jimmy-choo-women-eau-de-parfum-spray-2-ounce/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("97", "1", "2014-12-18 23:10:03", "2014-12-18 23:10:03", "", "51LDsRBbooL", "", "inherit", "closed", "closed", "", "51ldsrbbool", "", "", "2014-12-18 23:10:03", "2014-12-18 23:10:03", "", "96", "http://beauty.demobay.info/wp-content/uploads/2014/12/51LDsRBbooL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("98", "1", "2014-12-18 23:10:04", "2014-12-18 23:10:04", "<p>Burberry Touch Eau de Parfum is a luminous floral fragrance. The scent features top notes of vibrant California orange, blackcurrant, fresh dewberry and subtle rose oil. Seductive heart notes of jasmine, Madonna lily and tuberose are softened with a hint of peach and raspberry. Cedar wood, oak moss and vanilla complement the fruity notes, adding a soothing warmth. Presented in a clear glass bottle. 100ml. Made in France</p>\n", "BURBERRY Touch for Women Eau de Parfum, 100 ml.", "", "publish", "closed", "closed", "", "burberry-touch-for-women-eau-de-parfum-100-ml", "", "", "2014-12-18 23:10:04", "2014-12-18 23:10:04", "", "0", "http://beauty.demobay.info/2014/12/18/burberry-touch-for-women-eau-de-parfum-100-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("99", "1", "2014-12-18 23:10:04", "2014-12-18 23:10:04", "", "31PEWwIuaAL", "", "inherit", "closed", "closed", "", "31pewwiuaal", "", "", "2014-12-18 23:10:04", "2014-12-18 23:10:04", "", "98", "http://beauty.demobay.info/wp-content/uploads/2014/12/31PEWwIuaAL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("100", "1", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "<p>Launched by the design house of Estee Lauder in 2009, DANA BUCHMAN LUXURY by Estee Lauder for Women posesses a blend of:  It is recommended for  wear.</p>\n", "Dana Buchman Luxury By Estee Lauder Perfume Spray 1.7 Oz for Women", "", "publish", "closed", "closed", "", "dana-buchman-luxury-by-estee-lauder-perfume-spray-1-7-oz-for-women", "", "", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "0", "http://beauty.demobay.info/2014/12/18/dana-buchman-luxury-by-estee-lauder-perfume-spray-1-7-oz-for-women/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("101", "1", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "31ylgR5JjAL", "", "inherit", "closed", "closed", "", "31ylgr5jjal", "", "", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "100", "http://beauty.demobay.info/wp-content/uploads/2014/12/31ylgR5JjAL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "<p>Burberry Sport for Women is a lively floral fragrance that combines sporty and dynamic notes. A fresh, zesty floral fragrance. The immediate sparkle of mandarin couples with a refreshing sea-salt accord that travels through the fragrance like a ray of energy. The luminous hydroponic freesia and fresh honeysuckle sign the fragrance with a natural crystalline floralcy, both vivid and healthy. The solar sand notes and the vivacious vetiver blend together in a vibrant and refined trail.</p>\n", "BURBERRY Sport for Women Eau de Toilette, 75 ml.", "", "publish", "closed", "closed", "", "burberry-sport-for-women-eau-de-toilette-75-ml", "", "", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "0", "http://beauty.demobay.info/2014/12/18/burberry-sport-for-women-eau-de-toilette-75-ml/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("103", "1", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "21zhLkKRWVL", "", "inherit", "closed", "closed", "", "21zhlkkrwvl", "", "", "2014-12-18 23:10:05", "2014-12-18 23:10:05", "", "102", "http://beauty.demobay.info/wp-content/uploads/2014/12/21zhLkKRWVL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("104", "1", "2014-12-18 23:10:06", "2014-12-18 23:10:06", "<p>Introduced in 2000. Fragrance notes: the lovely scent of leaves and fresh-cut grass, outdoorsy, yet also great for evening. Recommended use: evening.When applying any fragrance please consider that there are several factors which can affect the natural smell of your skin and, in turn, the way a scent smells on you.  For instance, your mood, stress level, age, body chemistry, diet, and current medications may all alter the scents you wear.  Similarly, factor such as dry or oily skin can even affect the amount of time a fragrance will last after being applied</p>\n", "Cerruti Image By Nino Cerruti For Women. Luxury Body Lotion 6.8 Oz.", "", "publish", "closed", "closed", "", "cerruti-image-by-nino-cerruti-for-women-luxury-body-lotion-6-8-oz", "", "", "2014-12-18 23:10:06", "2014-12-18 23:10:06", "", "0", "http://beauty.demobay.info/2014/12/18/cerruti-image-by-nino-cerruti-for-women-luxury-body-lotion-6-8-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("105", "1", "2014-12-18 23:10:06", "2014-12-18 23:10:06", "", "31FVvlkKsjL", "", "inherit", "closed", "closed", "", "31fvvlkksjl", "", "", "2014-12-18 23:10:06", "2014-12-18 23:10:06", "", "104", "http://beauty.demobay.info/wp-content/uploads/2014/12/31FVvlkKsjL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("106", "1", "2014-12-18 23:10:52", "2014-12-18 23:10:52", "<p>ENJOY Sulfate-Free Luxury Shampoo and Conditioner: <br> For hair that needs extra strength, now there is haircare that\'s gentle. The ENJOY Luxury Shampoo and Conditioner system contains ingredients, which strengthens hair after just one wash. This hydrating shampoo and conditioner gently cleanses and nourishes dry hair to leave it strong and silky. Rich lather and natural aromatic properties help energize and invigorate the senses. The ENJOY Sulfate-Free color care shampoo treatment protects and conditions hair for long-lasting color purity.  <br> <br> POPULAR NEEDS AND USES: <br> SULFATE-FREE:  Sulfate-Free Shampoo, Sulfate Free Dandruff Conditioner <br> BENEFITS:  Detangler Shampoo, Hair Thickening Shampoo, Hydrating Conditioner, Strengthening Shampoo <br> CLASSIFICATIONS:  Natural Conditioner, Organic Shampoo, Color Treated Hair Products <br> REPAIRING: Repairing Conditioner, Smoothing Shampoo, Moisturizing Shampoo, Hair Treatment</p>\n", "Enjoy Sulfate-free Hydrating Duo (Shampoo and Conditioner) - 33.8 Oz", "", "publish", "closed", "closed", "", "enjoy-sulfate-free-hydrating-duo-shampoo-and-conditioner-33-8-oz", "", "", "2014-12-18 23:10:52", "2014-12-18 23:10:52", "", "0", "http://beauty.demobay.info/2014/12/18/enjoy-sulfate-free-hydrating-duo-shampoo-and-conditioner-33-8-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("107", "1", "2014-12-18 23:10:52", "2014-12-18 23:10:52", "", "51E51U2CZ-L", "", "inherit", "closed", "closed", "", "51e51u2cz-l", "", "", "2014-12-18 23:10:52", "2014-12-18 23:10:52", "", "106", "http://beauty.demobay.info/wp-content/uploads/2014/12/51E51U2CZ-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("108", "1", "2014-12-18 23:10:53", "2014-12-18 23:10:53", "<p>Our naturally organic shampoo for hair loss treatment is free of harsh chemicals that are the current and leading cause of many chronic hair conditions. Our shampoo is free of sodium lauryl sulfate (SLS), parabens, DEA, gluten, artificial colors, artificial fragrances and harsh preservatives. This gentle formula is fortified with an organic blend of argan oil, B vitamin complex, biotin, nettles extract, saw palmetto, he shou wu (fo-ti) and other clinically proven natural ingredients to aid against hair loss. Ingredients are specially selected for increased bioavailability and maximum absorption. It starts by nourishing hair follicles with essential nutrients to reverse any damage and begin the healing process. Biotin strengthens hair strands, niacin increases circulation and our exclusive DHT blocker blend promotes healthy hair growth. Continued use will prevent further hair loss. Safe for daily use, all hair types and both men and women. Product of U.S.A.</p>\n", "Pura d\'or Hair Loss Prevention Premium Organic Shampoo, Brown and Blue, 16 Fluid Ounce", "", "publish", "closed", "closed", "", "pura-dor-hair-loss-prevention-premium-organic-shampoo-brown-and-blue-16-fluid-ounce", "", "", "2014-12-18 23:10:53", "2014-12-18 23:10:53", "", "0", "http://beauty.demobay.info/2014/12/18/pura-dor-hair-loss-prevention-premium-organic-shampoo-brown-and-blue-16-fluid-ounce/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("109", "1", "2014-12-18 23:10:53", "2014-12-18 23:10:53", "", "41O3BmiNgTL", "", "inherit", "closed", "closed", "", "41o3bmingtl", "", "", "2014-12-18 23:10:53", "2014-12-18 23:10:53", "", "108", "http://beauty.demobay.info/wp-content/uploads/2014/12/41O3BmiNgTL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("110", "1", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "<p>★ Daily Leave-In Conditioner and Hair Serum Natural Treatment ★ </p>\n<p>Ever struggled with a dull, dry or damaged hair?<br />Wish to Have a more Vital, Soften and Shiny Hair Appearance?</p>\n<p>If so, then you need to give this hair leave in conditioner nourishing kit a try</p>\n<p>The hair care cream light texture is designed to nurture and moisturize the hair and delicately reduce hair volume<br />The Argan Oil serum treatment will leave the hair smooth, flexible with a vital radiant glow...</p>\n<p>Why customers Worldwide LOVE This KIT?</p>\n<p>• Amazon UNCOMPARABLE Argan Hair Nourishment Moisturizing Kit Treatment<br />• Nourishes, Moisturizes, Protects and Preserves Styling and Hair Shine All Day<br />• Suitable for Regular to Wavy Normal to Dry Hair Types<br />• Does not Attract Grime, It is Not Oily and can be Easily Rinsed Off<br />• EXCLUSIVE Unique High Quality Herbal Complex Hair Leave-In Treatment</p>\n<p>Customer Satisfaction Guaranteed:</p>\n<p>Vitamins\' Argan Oil based products are already manufactured for more than 20 years and with great success to the top hairdressing boutique salons</p>\n<p>We GUARANTEE that Your Hair will Look and Feel Better than Before Thanks to this Exclusive Nourishing Kit or We will Give You 100% of Your Money... Contact Us for the Radiant Hair FREE Tips Guide!</p>\n<p>Don\'t Miss Our Limited Time Offer!<br />➨ Click the Orange \'Add to Cart\' Button to Ensure Your Hair Nourishing Kit Set Discounted Deal...</p>\n", "Best Leave-In Conditioner & Hair Serum Kit - CHRISTMAS HOLIDAYS SALE! - Thin to Normal Hair Treatment - Natural Moroccan Argan Daily Hair Moisturizer Relaxer Nourishing Cream + Argan Oil Serum Nourishment for Dry Hair - Sulfate & Alcohol Free Hair Products to Nourish, Moisturize, Protect and Promote Hair Shine Gloss - Fancy Set Gift Box - (13.5 oz / 400 ml) + (1.0 oz / 30 ml) - 100% Customer Satisfaction GUARANTEED Hair Nourishing & Serum Therapy!", "", "publish", "closed", "closed", "", "best-leave-in-conditioner-hair-serum-kit-christmas-holidays-sale-thin-to-normal-hair-treatment-natural-moroccan-argan-daily-hair-moisturizer-relaxer-nourishing-cream-argan-oil-serum-nourish", "", "", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "0", "http://beauty.demobay.info/2014/12/18/best-leave-in-conditioner-hair-serum-kit-christmas-holidays-sale-thin-to-normal-hair-treatment-natural-moroccan-argan-daily-hair-moisturizer-relaxer-nourishing-cream-argan-oil-serum-nourish/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("111", "1", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "51qm1Lpo8-L", "", "inherit", "closed", "closed", "", "51qm1lpo8-l", "", "", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "110", "http://beauty.demobay.info/wp-content/uploads/2014/12/51qm1Lpo8-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("112", "1", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "<p>★ Unique Rich Hair Mask Deep Conditioner Treatment for Thin to Normal Hair ★ </p>\n<p>Ever struggled with a dry, damaged or dull hair?<br />Do you wish to own a vital, soft, smooth and silky hair?</p>\n<p>The Argan Oil deep conditioning hair mask is specifically formulated to help reverse hair damages with long lasting results, leaving it vital, refreshed, revitalized with a silky radiant hair shine</p>\n<p>Why Customers Worldwide LOVE This Argan Hair Mask?</p>\n<p>• Natural Argan Deep Conditioner Hair Mask Treatment Therapy for Thin to Normal Hair<br />• Thoroughly Moisturizes, Hydrates, Nourishes, Smoothes and Softens the Hair with a Radiant Glow<br />• Revitalizes, Restores, Repairs and Strengthens The Hair While Protecting it Against External Damages<br />• Retains Hair Essential Fatty Acids, Vitamins and Antioxidants. No Sulfate, No Salts, No Alcohol, Not Tested on Animals<br />• UNIQUE Exclusive High Quality Hair Mask Herbal Complex for Dry and Damaged Thin Hair</p>\n<p>Customer Satisfaction Guaranteed:</p>\n<p>Vitamins\' Argan Oil based products are already manufactured for more than 20 years and with great success to top hairdressing professional boutique salons</p>\n<p>We GUARANTEE that Your Skin will Look and Feel Much Better than Before or 100% of Your Money Back... Contact Us for the FREE Hair Shine Guide!</p>\n<p>Don\'t Miss Our Limited Time Offer!<br />➨ Click the Orange \'Add to Cart\' Button to Ensure Your Argan Oil Thin Hair Mask Treatment Deal...</p>\n", "Best Deep Conditioner Hair Mask - CHRISTMAS HOLIDAYS SALE! - Thin to Normal Hair Treatment - Natural Moroccan Argan Oil Rich Mask for Dry or Damaged Fine to Normal Hair - Alcohol & Sulfate Free Long Lasting Conditioning Hair Reconstruction Deep Repair Nourishment - (8.5 oz / 250 ml) - 100% Customer Satisfaction GUARANTEED Thin Hair Restorative Therapy!", "", "publish", "closed", "closed", "", "best-deep-conditioner-hair-mask-christmas-holidays-sale-thin-to-normal-hair-treatment-natural-moroccan-argan-oil-rich-mask-for-dry-or-damaged-fine-to-normal-hair-alcohol-sulfate-free-long-l", "", "", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "0", "http://beauty.demobay.info/2014/12/18/best-deep-conditioner-hair-mask-christmas-holidays-sale-thin-to-normal-hair-treatment-natural-moroccan-argan-oil-rich-mask-for-dry-or-damaged-fine-to-normal-hair-alcohol-sulfate-free-long-l/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("113", "1", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "51C7UXlyDeL", "", "inherit", "closed", "closed", "", "51c7uxlydel", "", "", "2014-12-18 23:10:54", "2014-12-18 23:10:54", "", "112", "http://beauty.demobay.info/wp-content/uploads/2014/12/51C7UXlyDeL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("114", "1", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "<p>The Regenepure DR hair loss shampoo helps to treat baldness as well as dandruff issues and relieves dry, itchy and oily scalps. It is an intensive, restorative formula recommended by physicians; it also helps in repairing hair from the roots and provides the ultimate skin treatment. RegenePure® DR contains Ketoconazole, a powerful antifungal that is often used for dandruff treatment. It also makes the hair look and feel thicker. In recent studies, it has also been shown to block DHT production, which can curb hair loss and helps to stimulate hair growth in men and women. Apart from Ketoconazole, RegenePure® DR is packed with other beneficial elements, including Saw Palmetto extract, Vitamin B6 and Zinc Oxide. Niacin, Caffeine and Linolenic Acid are also included to stimulate the scalp, while Emu and Jojoba oils keep the skin supple and rejuvenated and also help in nourishing the scalp by turning dry and damaged hair into fuller and thicker hair.</p>\n", "Regenepure DR Hair Loss Shampoo For Hair Growth and Scalp Treatment in Men and Women", "", "publish", "closed", "closed", "", "regenepure-dr-hair-loss-shampoo-for-hair-growth-and-scalp-treatment-in-men-and-women", "", "", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "0", "http://beauty.demobay.info/2014/12/18/regenepure-dr-hair-loss-shampoo-for-hair-growth-and-scalp-treatment-in-men-and-women/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("115", "1", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "31eIF1DNwrL", "", "inherit", "closed", "closed", "", "31eif1dnwrl", "", "", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "114", "http://beauty.demobay.info/wp-content/uploads/2014/12/31eIF1DNwrL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("116", "1", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "<p>★ Unique Olive Oil Leave-In Conditioner Daily Hair Moisturizer Treatment ★ </p>\n<p>Ever struggled with a frizzy dry dull hair?<br />Wish to have a more vital, healthier, soften and refreshed hair?</p>\n<p>This high quality natural thin to normal hair nourishing cream is a unique way to moisturize, hydrate, nourish, protect and preserve desired hair styling and vitality all day</p>\n<p>Why Customers Worldwide LOVE This Top Leave-In Conditioner Lotion?</p>\n<p>• VEGAN Natural UNIQUE Oils Blend Leave-In Conditioner Therapy<br />• Moisturizes, Hydrates, Nourishes, Protects, Styles and Promotes Hair\'s Vitality. Fights Split Ends Formation<br />• Preserves High Concentrations of Fatty Acids, Antioxidants, Minerals and Vitamins Crucial for the Hair<br />• No Paraben, No Alcohol, No Artificial Preservatives, Fragrances or Colors. Environmental Friendly, Bio Degradable, Not Tested on Animals<br />• Based on Pure Extra Virgin Olive Oil, Coconut Oil, Jojoba Oil + Additional Natural Oils Extracts</p>\n<p>Customer Satisfaction Guaranteed:</p>\n<p>Aya Natural believes that products which are not fit to eat, should NOT be applied to the hair. Aya Natural Products are Sold Worldwide in Premium Luxury Natural Beauty Stores for Years and with Great Success...</p>\n<p>We GUARANTEE that Your Hair will Look and Feel Much Better than Before... Contact Us for the FREE Guide!</p>\n<p>Don\'t Miss Our Limited Time Promo Offer!<br />➨ Click the Orange \'Add to Cart\' Button to Ensure Your Leave-In Conditioner Deal...</p>\n", "Best Leave-In Conditioner Hair Moisturizer - CHRISTMAS HOLIDAYS SALE! - VEGAN Thin to Normal Hair Daily Nourishing Moisturizing Relaxer - Natural Hair Care Cream Nourishment Treatment - Pure Extra Virgin Olive Oil, Coconut and Jojoba Oils Blend - Paraben, Alcohol & Sulfate Free Hair Products - (8.1 oz / 240 ml) - 100% Satisfaction GUARANTEED Hair Leave-In Conditioner!", "", "publish", "closed", "closed", "", "best-leave-in-conditioner-hair-moisturizer-christmas-holidays-sale-vegan-thin-to-normal-hair-daily-nourishing-moisturizing-relaxer-natural-hair-care-cream-nourishment-treatment-pure-extra-vir", "", "", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "0", "http://beauty.demobay.info/2014/12/18/best-leave-in-conditioner-hair-moisturizer-christmas-holidays-sale-vegan-thin-to-normal-hair-daily-nourishing-moisturizing-relaxer-natural-hair-care-cream-nourishment-treatment-pure-extra-vir/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("117", "1", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "51cPByYotXL", "", "inherit", "closed", "closed", "", "51cpbyyotxl", "", "", "2014-12-18 23:10:55", "2014-12-18 23:10:55", "", "116", "http://beauty.demobay.info/wp-content/uploads/2014/12/51cPByYotXL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("118", "1", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "<p style=\"background: url(http://ecx.images-amazon.com/images/I/9113rl4f12L._SL1500_.jpg) no-repeat; height: 1500px; width: 1000px;\">\n<p> Konjac Sponge (3-pack) - Bamboo Charcoal, Green Tea and Natural White</p>\n<p> - 100% Natural & Organic</p>\n<p>  </p>\n<p>Benefits</p>\n<p> • Carefully Handmade from 100% Natural Ingredients<br>• Chemical Free - 100% Safe & Non Toxic<br>• Gently Exfoliates, While Deeply Cleanses Skin<br>• Balances Skin pH, Leaving Skin Feeling Revitalized<br>• Luxuriously Soft and Uses Little Cleanser\n<p> </p>\n<p>Who can benefit?</p>\n<p>• People with Acne, Blackheads, Rosacea, Excema, Dermatitis & Psoriasis<br>• Anyone with Sensitive Skin & Babies<br>• Both Men and Women\n<p> </p>\n<p>Ethical Commitment</p>\n<p>• 100% Naturally Sustainable - Made from Naturally Grown Plants<br>• Greener than Harvested Sea Sponges<br>• Safer than Chemically Made Sponges<br>• The Environment is not Polluted <br>• Cruelty-Free - Not Animal Tested<br>• Vegan\n<p> </p>\n<p>Inside Package</p>\n<p>1 x Charcoal Konjac Sponge<br>1 x Green Tea Konjac Sponge<br>1 x Natural White Konjac Sponge<br><br>Note: Sponges Ship Dry\n<p> </p>\n<p>Our Guarantee</p>\n<p>We are so confident in our Konjac Sponges, we offer 100% Satisfaction in our hassle-free Replacement Guarantee.</p>\n<p> </p>\n<p align=\"left\" style=\"font-size:1.4em;color:red\">Click the Add To Cart at the Top of The Page and Buy the Best in Facial Care Now!</p>\n", "Konjac Sponge (3 Pack) Charcoal, Green Tea & Natural Facial Cleansing & Exfoliating Beauty Sponges", "", "publish", "closed", "closed", "", "konjac-sponge-3-pack-charcoal-green-tea-natural-facial-cleansing-exfoliating-beauty-sponges", "", "", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "0", "http://beauty.demobay.info/2014/12/18/konjac-sponge-3-pack-charcoal-green-tea-natural-facial-cleansing-exfoliating-beauty-sponges/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("119", "1", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "51tEGaKbpnL", "", "inherit", "closed", "closed", "", "51tegakbpnl", "", "", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "118", "http://beauty.demobay.info/wp-content/uploads/2014/12/51tEGaKbpnL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("120", "1", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "<p>Dexe Hair Fibers are a safe and natural  way to make your hair look full and attractive. Cotton Fibers stick to your hair adding extra body and fullness without the use of harsh treatments or surgery. You can take 5 minutes to apply and go all day long without having to worry about wig or toupee placement.  Get a more natural look and  feel better about your overall appearance.</p>\n", "Dexe Hair Builder Fibers - Cotton Fiber Makes Hair Thick for a Day- Easy Quick Application - Amazing Temporary Hair Loss Treatment Without the Use of Wigs or Harsh Transplant Surgery- For Both Men and Women - Natural Plant Fibers Mimic Human Hair - Makes Thin Hair Very Thick - A Growth Substitute Safe for Everyday Use (black)", "", "publish", "closed", "closed", "", "dexe-hair-builder-fibers-cotton-fiber-makes-hair-thick-for-a-day-easy-quick-application-amazing-temporary-hair-loss-treatment-without-the-use-of-wigs-or-harsh-transplant-surgery-for-both-men-and", "", "", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "0", "http://beauty.demobay.info/2014/12/18/dexe-hair-builder-fibers-cotton-fiber-makes-hair-thick-for-a-day-easy-quick-application-amazing-temporary-hair-loss-treatment-without-the-use-of-wigs-or-harsh-transplant-surgery-for-both-men-and/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("121", "1", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "518EypESbpL", "", "inherit", "closed", "closed", "", "518eypesbpl", "", "", "2014-12-18 23:10:56", "2014-12-18 23:10:56", "", "120", "http://beauty.demobay.info/wp-content/uploads/2014/12/518EypESbpL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("122", "1", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "<p>★ Unique Argan Oil Hair Styling Natural Relaxer Treatment ★</p>\n<p>Ever struggled with a frizzy, curly, unruly and unmanageable hair?<br />Wish to have a more vital, healthier, smoother & refreshed hair styled appearance?</p>\n<p>This high quality natural hair styling rich texture cream is a unique way to moisturize, hydrate, nourish and preserve desired hair styling and vitality throughout the day...</p>\n<p>Why Customers Worldwide LOVE This Top Hair Relaxer Creme?</p>\n<p>• Natural Unique Rich Thick Argan Hair Relaxing and Styling Texturizer Treatment<br />• Moisturizes, Hydrates, Nourishes, Protects, Shapes and Styles Thick to Regular Curly or Frizzy Hair<br />• Retains High Concentrations of Fatty Acids, Antioxidants and Vitamins Essential to a Healthy Styled Hair<br />• Promotes Hair Smoothness, Softness and Vitality. No Sulfate, No Salt, No Alcohol, Not Tested on Animals<br />• UNIQUE Exclusive High Quality Hair Styling Herbal Complex for a Healthy Vital Softer Manageable Hair</p>\n<p>Customer Satisfaction Guaranteed:</p>\n<p>Vitamins\' Argan Oil based products are manufactured with great success for more than 20 years to the top hairdressing professional boutique salons...</p>\n<p>We GUARANTEE that Your Hair will Look and Feel Much Better than Before or 100% of Your Money Back... Contact Us for the FREE Guide!</p>\n<p>Don\'t Miss Our Limited Time Offer!<br />➨ Click the Orange \'Add to Cart\' Button to Ensure Your Hair Relaxer Argan Treatment Deal...</p>\n", "Hair Relaxer Texturizer Anti-Frizz Cream - Natural Moroccan Argan Oil Frizz Control Hair Styling Hydrating Treatment ★ Alcohol & Sulfate Free Creme Lotion to Reduce Volume of Frizzed & Naturally Curly Hair, Moisturize, Nourish, Style and Preserve Hair Shine ★ In a Fancy Decorated Gift Box ★ (10.1 oz / 300 ml) ★ 100% Customer Satisfaction GUARANTEED Hair Relaxing Therapy!", "", "publish", "closed", "closed", "", "hair-relaxer-texturizer-anti-frizz-cream-natural-moroccan-argan-oil-frizz-control-hair-styling-hydrating-treatment-%e2%98%85-alcohol-sulfate-free-creme-lotion-to-reduce-volume-of-frizzed-natural", "", "", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "0", "http://beauty.demobay.info/2014/12/18/hair-relaxer-texturizer-anti-frizz-cream-natural-moroccan-argan-oil-frizz-control-hair-styling-hydrating-treatment-%e2%98%85-alcohol-sulfate-free-creme-lotion-to-reduce-volume-of-frizzed-natural/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("123", "1", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "51OGk1wU6gL", "", "inherit", "closed", "closed", "", "51ogk1wu6gl", "", "", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "122", "http://beauty.demobay.info/wp-content/uploads/2014/12/51OGk1wU6gL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("124", "1", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "<p>Hair Maker 30 Build Ups is a safe and natural  way to make your hair look full and attractive. Cotton Fibers stick to your hair adding extra body and fullness without the use of harsh treatments or surgery. You can take 5 minutes to apply and go all day long without having to worry about wig or toupee placement.  Get a more natural look and  feel better about your overall appearance.</p>\n", "Hair Maker Bilding Kit - Natural Hair Replacement - Cotton Fiber Makes Hair Thick for a Day- Easy Quick Application - Amazing Temporary Hair Loss Treatment Without the Use of Wigs or Harsh Transplant Surgery- For Both Men and Women - Natural Plant Fibers Mimic Human Hair - Makes Thin Hair Very Thick - A Growth Substitute Safe for Everyday Use (Dark Brown)", "", "publish", "closed", "closed", "", "hair-maker-bilding-kit-natural-hair-replacement-cotton-fiber-makes-hair-thick-for-a-day-easy-quick-application-amazing-temporary-hair-loss-treatment-without-the-use-of-wigs-or-harsh-transplant", "", "", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "0", "http://beauty.demobay.info/2014/12/18/hair-maker-bilding-kit-natural-hair-replacement-cotton-fiber-makes-hair-thick-for-a-day-easy-quick-application-amazing-temporary-hair-loss-treatment-without-the-use-of-wigs-or-harsh-transplant/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("125", "1", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "41by8eTbInL", "", "inherit", "closed", "closed", "", "41by8etbinl", "", "", "2014-12-18 23:10:57", "2014-12-18 23:10:57", "", "124", "http://beauty.demobay.info/wp-content/uploads/2014/12/41by8eTbInL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("126", "1", "2014-12-18 23:13:23", "2014-12-18 23:13:23", " ", "", "", "publish", "closed", "closed", "", "126", "", "", "2014-12-18 23:13:23", "2014-12-18 23:13:23", "", "0", "http://beauty.demobay.info/?p=126", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("127", "1", "2014-12-18 23:13:23", "2014-12-18 23:13:23", " ", "", "", "publish", "closed", "closed", "", "127", "", "", "2014-12-18 23:13:23", "2014-12-18 23:13:23", "", "0", "http://beauty.demobay.info/?p=127", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("128", "1", "2014-12-18 23:13:23", "2014-12-18 23:13:23", " ", "", "", "publish", "closed", "closed", "", "128", "", "", "2014-12-18 23:13:23", "2014-12-18 23:13:23", "", "0", "http://beauty.demobay.info/?p=128", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("129", "1", "2014-12-18 23:13:23", "2014-12-18 23:13:23", " ", "", "", "publish", "closed", "closed", "", "129", "", "", "2014-12-18 23:13:23", "2014-12-18 23:13:23", "", "0", "http://beauty.demobay.info/?p=129", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("130", "1", "2014-12-18 23:13:23", "2014-12-18 23:13:23", " ", "", "", "publish", "closed", "closed", "", "130", "", "", "2014-12-18 23:13:23", "2014-12-18 23:13:23", "", "0", "http://beauty.demobay.info/?p=130", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("131", "1", "2014-12-18 23:17:18", "2014-12-18 23:17:18", "<p>What it is:<br />\nA 12 piece mini nail manicure pedicure set with all the essentials to keep your fingers and toes perfectly pretty. </p>\n<p>What it does:<br />\nFile, nip, and clip even while you\'re away from home with this set of must have nail-perfecting tools. The soft touch handles make achieving a perfect manicure and pedicure easy and comfortable. The kit also includes tweezers and scissors for precise touch-ups. The clutch is lined in brown velvet to preserve the integrity of your tools and the chic genuine leather exterior will have you excited to show off your set. </p>\n<p>This set contains:\n</p>\n<p>nail scissors, nail clippers, cuticle pusher, nail file, tweezers, nail cleaner, toe nail clippers, and cuticle trimmers.</p>\n<p>What this Kit can do for you:</p>\n<p>Great for traveling<br />\nA perfect gift for that special person<br />\nCombines 11 essential tools for everyday grooming and hygiene needs<br />\nLasts a lifetime</p>\n", "OJIA 12pcs Luxury Black PU Leather Nail Care Personal Manicure & Pedicure Set, Manicure Travel & Grooming Set Kit, Nail Clipper", "", "publish", "closed", "closed", "", "ojia-12pcs-luxury-black-pu-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper", "", "", "2014-12-18 23:17:18", "2014-12-18 23:17:18", "", "0", "http://beauty.demobay.info/2014/12/18/ojia-12pcs-luxury-black-pu-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("132", "1", "2014-12-18 23:17:18", "2014-12-18 23:17:18", "", "51ntXbRdhgL", "", "inherit", "closed", "closed", "", "51ntxbrdhgl", "", "", "2014-12-18 23:17:18", "2014-12-18 23:17:18", "", "131", "http://beauty.demobay.info/wp-content/uploads/2014/12/51ntXbRdhgL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("133", "1", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "<p>What it is:<br />\nA twelve-piece mini nail manicure pedicure set with all the essentials to keep your fingers and toes perfectly pretty. </p>\n<p>What it does:<br />\nFile, nip, and clip even while you\'re away from home with this set of must have nail-perfecting tools. The soft touch handles make achieving a perfect manicure and pedicure easy and comfortable. The kit also includes tweezers and scissors for precise touch-ups. The clutch is lined in brown velvet to preserve the integrity of your tools and the chic PU leather exterior will have you excited to show off your set. \n</p>\n<p>This set contains:\n</p>\n<p>Two nail clippers: increased cutting force and special polishing technology to assure clean and easy nail trimming. There are a large one and a smaller one for different nail sizes.<br />\n  One toenail clipper: specially designed for trimming hard toenails.<br />\n  One cuticle trimmer: ideal blade structure and angle for effectively trimming cuticles. Perfect for exfoliation treatment around finger nails.<br />\n  One tweezer for removing unwanted hair.<br />\n  One pair of beauty scissors for eyebrow trimming.<br />\n  One nail file.<br />\n  One single-edged double-sided push stick.<br />\n  One V-shaped push stick.<br />\nOne ear pick.<br />\nOne pealing knife<br />\nOne double-Sided Blackhead Removal Needle and Loop<br />\n  All those 12 tools are gathered in a delicate leather case.\n</p>\n<p>What this Kit can do for you:</p>\n<p>Great for traveling<br />\nA perfect gift for that special person<br />\nCombines 12 essential tools for everyday grooming and hygiene needs<br />\nLasts a lifetime</p>\n", "OJIA 12pcs Stainless Steel Professional Manicure Pedicure Set ,Travel & Grooming Set, Personal Care Tools, Nail Scissors Nail Clippers Kit with Luxury Leather Case", "", "publish", "closed", "closed", "", "ojia-12pcs-stainless-steel-professional-manicure-pedicure-set-travel-grooming-set-personal-care-tools-nail-scissors-nail-clippers-kit-with-luxury-leather-case", "", "", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "0", "http://beauty.demobay.info/2014/12/18/ojia-12pcs-stainless-steel-professional-manicure-pedicure-set-travel-grooming-set-personal-care-tools-nail-scissors-nail-clippers-kit-with-luxury-leather-case/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("134", "1", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "51biDKlZyjL", "", "inherit", "closed", "closed", "", "51bidklzyjl", "", "", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "133", "http://beauty.demobay.info/wp-content/uploads/2014/12/51biDKlZyjL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("135", "1", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "<p>What it is: A 11 piece mini nail manicure pedicure set with all the essentials to keep your fingers and toes perfectly pretty. </p>\n<p> What it does: File, nip, and clip even while you\'re away from home with this set of must have nail-perfecting tools. The soft touch handles make achieving a perfect manicure and pedicure easy and comfortable. The kit also includes tweezers and scissors for precise touch-ups. The clutch is lined in brown velvet to preserve the integrity of your tools and the chic genuine leather exterior will have you excited to show off your set. </p>\n<p> This set contains: nail scissors, nail clippers, cuticle pusher, nail file, tweezers, nail cleaner, toe nail clippers, and cuticle trimmers. </p>\n<p> What this Kit can do for you: Great for traveling A perfect gift for that special person Combines 11 essential tools for everyday grooming and hygiene needs Lasts a lifetime</p>\n", "Wild-us Luxury Genuine Red Color Leather Nail Care Personal Manicure & Pedicure Set, Manicure Travel & Grooming Set Kit, Nail Clipper", "", "publish", "closed", "closed", "", "wild-us-luxury-genuine-red-color-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper", "", "", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "0", "http://beauty.demobay.info/2014/12/18/wild-us-luxury-genuine-red-color-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("136", "1", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "41JTNoG7v7L", "", "inherit", "closed", "closed", "", "41jtnog7v7l", "", "", "2014-12-18 23:17:19", "2014-12-18 23:17:19", "", "135", "http://beauty.demobay.info/wp-content/uploads/2014/12/41JTNoG7v7L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("137", "1", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "\n<p>Warning: Your Family & Friends May Try To Steal Your CLYPPI Fingernail Clippers!</p>\n<p>Why?</p>\n<p>It is probably because your CLYPPI:</p>\n<p>• looks modern & stylish<br />• feels sturdy & is a good weight<br />• is ergonomically designed to fit comfortably into your hand and so that you can see what you are doing<br />• will not slip out of your hand due to the matte, brushed steel finish<br />• is easy to use - the lever presses down with little effort (even for kids & those who suffer from complaints like Arthritis)</p>\n<p>Or maybe it is the way your CLYPPI cuts cleanly every time without cracking, splitting or tearing your nails. They probably love the way this:</p>\n<p>• gives you a professional looking manicure<br />• removes the need for filing (though there is a handy nail file in the lever)<br />• eliminates the risk of infection (very suitable for Diabetics)</p>\n<p>Beware! Leave your CLYPPI unattended at your peril!</p>\n<p>Your friends & family may not be able to keep their hands off. THEIR nail clipper probably looks cheap & nasty. It may have chrome plating which is chipping off. The thumb lever may be loose. Even worse, THEIR clipper cuts their nails badly.</p>\n<p>YOUR CLYPPI will look good for ever because it:</p>\n<p>• is made of high quality Stainless Steel<br />•has a matte, brushed steel finish<br />• nothing has been added which could peel or fall off.</p>\n<p>It will effortlessly & consistently cut your nails cleanly & precisely - resulting in perfectly manicured nails you can be proud of. After all, it is the little things that give a lasting first impression.</p>\n<p>Your CLYPPI comes with a full LIFETIME GUARANTEE.</p>\n<p>There is really nothing to lose and everything to gain!</p>\n<p>To order your very own CLYPPI simply click the Add to Cart button above.</p>\n<p>And once it is YOURS, remember to keep it safe ;)</p></p>\n", "Clyppi: BEST Fingernail Clippers | Perfect XMAS GIFTS For Men & Women | Extra Sharp Easy Grip Nail Clipper | Professional Deluxe Stainless Steel Nail Clippers", "", "publish", "closed", "closed", "", "clyppi-best-fingernail-clippers-perfect-xmas-gifts-for-men-women-extra-sharp-easy-grip-nail-clipper-professional-deluxe-stainless-steel-nail-clippers", "", "", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "", "0", "http://beauty.demobay.info/2014/12/18/clyppi-best-fingernail-clippers-perfect-xmas-gifts-for-men-women-extra-sharp-easy-grip-nail-clipper-professional-deluxe-stainless-steel-nail-clippers/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "", "51hqz3b2PjL", "", "inherit", "closed", "closed", "", "51hqz3b2pjl", "", "", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "", "137", "http://beauty.demobay.info/wp-content/uploads/2014/12/51hqz3b2PjL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("139", "1", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "<p>What it is:<br />\nA 11 piece mini nail manicure pedicure set with all the essentials to keep your fingers and toes perfectly pretty. </p>\n<p>What it does:<br />\nFile, nip, and clip even while you\'re away from home with this set of must have nail-perfecting tools. The soft touch handles make achieving a perfect manicure and pedicure easy and comfortable. The kit also includes tweezers and scissors for precise touch-ups. The clutch is lined in brown velvet to preserve the integrity of your tools and the chic genuine leather exterior will have you excited to show off your set. </p>\n<p>This set contains:\n</p>\n<p>nail scissors, nail clippers, cuticle pusher, nail file, tweezers, nail cleaner, toe nail clippers, and cuticle trimmers.</p>\n<p>What this Kit can do for you:</p>\n<p>Great for traveling<br />\nA perfect gift for that special person<br />\nCombines 11 essential tools for everyday grooming and hygiene needs<br />\nLasts a lifetime</p>\n", "OJIA 11pcs Luxury Genuine Brown Leather Nail Care Personal Manicure & Pedicure Set, Manicure Travel & Grooming Set Kit, Nail Clipper", "", "publish", "closed", "closed", "", "ojia-11pcs-luxury-genuine-brown-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper", "", "", "2014-12-18 23:17:20", "2014-12-18 23:17:20", "", "0", "http://beauty.demobay.info/2014/12/18/ojia-11pcs-luxury-genuine-brown-leather-nail-care-personal-manicure-pedicure-set-manicure-travel-grooming-set-kit-nail-clipper/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "41rPfCXT9HL", "", "inherit", "closed", "closed", "", "41rpfcxt9hl", "", "", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "139", "http://beauty.demobay.info/wp-content/uploads/2014/12/41rPfCXT9HL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("141", "1", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "<p>The set contains: nail scissors, nail clippers, cuticle pusher, nail file, tweezers, nail cleaner, toe nail clippers, and cuticle trimmers.<br /> With this kit,you won\'t need to buy single product when you want clip your nails<br /> Single space for each tool,zipper closure and with a clear view of all the tool you need<br /> Easy to storage and carry<br /> Looks exquisite and fits into your travel luggage and handbags easily,handy for use</p>\n<p> Kindly note:<br /> Please keep away from children because both of the clipper and pusher are extremely sharp.<br /> Color:show as picture</p>\n<p>Package include:<br /> 1 x nail clipper set(including 12 different nail clippers)</p>\n<p>Please note:<br /> 1> niceeshop(TM) is a registered trademark and the only authorized seller of niceeshop branded products.<br /> 2> niceeshop provide you various kinds of great products at the lowest possible prices, welcome to our store and get what you want !!!<br /> 3> niceeshop highly appriciate all customers\' opinions to improve the selling ,also if anything you unsatisfied, pls contact our customer service department for probable best solution.</p>\n", "niceeshop(TM) Luxury Nail Care Personal Manicure Pedicure Nail Clipper Set with Brown Leather Case,11pcs", "", "publish", "closed", "closed", "", "niceeshoptm-luxury-nail-care-personal-manicure-pedicure-nail-clipper-set-with-brown-leather-case11pcs", "", "", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "0", "http://beauty.demobay.info/2014/12/18/niceeshoptm-luxury-nail-care-personal-manicure-pedicure-nail-clipper-set-with-brown-leather-case11pcs/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "51Cd7sH3lKL", "", "inherit", "closed", "closed", "", "51cd7sh3lkl", "", "", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "141", "http://beauty.demobay.info/wp-content/uploads/2014/12/51Cd7sH3lKL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "<p>12 PIECE MANICURE AND PEDICURE SET, includes essential grooming<br><br />\nPerfect for professional or for general household use.<br><br />\nMaterials: High quality Tungsten Steel<br><br />\nPortable convenient to carry for traveling.<br></p>\n", "NSSTAR New 12 Pcs High Quality Stainless Steel Personal Nail Care Manicure Pedicure Set Kit Ear pick Nail Clipper Set Convenient Travel & Grooming Kit With Luxury Box Case", "", "publish", "closed", "closed", "", "nsstar-new-12-pcs-high-quality-stainless-steel-personal-nail-care-manicure-pedicure-set-kit-ear-pick-nail-clipper-set-convenient-travel-grooming-kit-with-luxury-box-case", "", "", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "0", "http://beauty.demobay.info/2014/12/18/nsstar-new-12-pcs-high-quality-stainless-steel-personal-nail-care-manicure-pedicure-set-kit-ear-pick-nail-clipper-set-convenient-travel-grooming-kit-with-luxury-box-case/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "41-xPAFe-4L", "", "inherit", "closed", "closed", "", "41-xpafe-4l", "", "", "2014-12-18 23:17:21", "2014-12-18 23:17:21", "", "143", "http://beauty.demobay.info/wp-content/uploads/2014/12/41-xPAFe-4L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("145", "1", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "<p>JAPONESQUE® Nail Nippers are a stylish must-have for professional manicured results. These expert nippers are handcrafted to trim even the most hard-to-reach nail areas. Designed with an innovative brushed nickel-plate finish, the hardened steel blades and fine-point tip provide precision and control, while the power barrel spring and locking clip keep the cutting surface safe and sharp</p>\n", "JAPONESQUE Nail Nippers", "", "publish", "closed", "closed", "", "japonesque-nail-nippers", "", "", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "", "0", "http://beauty.demobay.info/2014/12/18/japonesque-nail-nippers/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "", "21qMy1BBR7L", "", "inherit", "closed", "closed", "", "21qmy1bbr7l", "", "", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "", "145", "http://beauty.demobay.info/wp-content/uploads/2014/12/21qMy1BBR7L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "<p>The set contains: nail scissors, nail clippers, cuticle pusher, nail file, tweezers, nail cleaner, toe nail clippers, and cuticle trimmers.<br /> With this kit,you won\'t need to buy single product when you want clip your nails<br /> Single space for each tool,zipper closure and with a clear view of all the tool you need<br /> Easy to storage and carry<br /> Looks exquisite and fits into your travel luggage and handbags easily,handy for use</p>\n<p> Kindly note:<br /> Please keep away from children because both of the clipper and pusher are extremely sharp.<br /> Color:show as picture</p>\n<p>What you get:<br /> 1 * FOONEE Luxury Nail Care Personal Manicure Pedicure Nail Clipper Set with Square Leather Case</p>\n<p>FOONEE is a famous worldwide brand of beauty and healthy products. </p>\n", "FOONEE Luxury Nail Care Personal Manicure Pedicure Nail Clipper Set with Square Leather Case", "", "publish", "closed", "closed", "", "foonee-luxury-nail-care-personal-manicure-pedicure-nail-clipper-set-with-square-leather-case", "", "", "2014-12-18 23:17:22", "2014-12-18 23:17:22", "", "0", "http://beauty.demobay.info/2014/12/18/foonee-luxury-nail-care-personal-manicure-pedicure-nail-clipper-set-with-square-leather-case/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("148", "1", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "", "51oXEolVfCL", "", "inherit", "closed", "closed", "", "51oxeolvfcl", "", "", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "", "147", "http://beauty.demobay.info/wp-content/uploads/2014/12/51oXEolVfCL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("149", "1", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "\n<p>Warning: Your Family & Friends May Try To Steal Your CLYPPI!</p>\n<p>Why?</p>\n<p>It is probably because of the the way your CLYPPI:</p>\n<p>• is designed to look modern and stylish, an ultra cool precision tool<br />• fits comfortably in your hand and feels luxuriously smooth but reliably sturdy<br />• cuts clean every time without cracking, splitting or tearing your toenails</p>\n<p>Beware! Leave your CLYPPI unattended at your peril!</p>\n<p>Your friends and family may not be able to keep their hands off. Remember, THEIR nail clipper probably looks cheap and nasty. It probably has chrome plating which is chipping off - or will soon start to. The thumb lever on THEIR nail clippers has probably become loose and wobbly. Even worse than all of this, THEIR clipper does a really bad job cutting their nails!</p>\n<p>YOUR CLYPPI will look good for ever...</p>\n<p>...thanks to the fact that it is made of high quality Stainless Steel with a matte, brushed steel finish. Nothing has been added which could peel or fall off. A handy nail file is integrated into the lever. This High Tech Nail Clipper is ergonomically designed to be a pleasure to use. It will effortlessly and consistently cut your fingernails cleanly and precisely - resulting in perfectly manicured nails you can be proud of. After all, it is the little things that give a lasting first impression.</p>\n<p>Your CLYPPI comes with a full LIFETIME GUARANTEE. </p>\n<p>There is really nothing to lose and everything to gain!</p>\n<p>To order your very own CLYPPI simply click the Add to Cart button above.</p>\n<p>And once it is YOURS, remember to keep it safe ;)</p></p>\n", "Clyppi: BEST Toenail Clippers | Perfect XMAS GIFTS For Men & Women | Superior Large Easy Grip Nail Clipper | Extra Sharp Toenail Clippers For Thick Toenails | Professional Stainless Steel Toe Nail Clippers", "", "publish", "closed", "closed", "", "clyppi-best-toenail-clippers-perfect-xmas-gifts-for-men-women-superior-large-easy-grip-nail-clipper-extra-sharp-toenail-clippers-for-thick-toenails-professional-stainless-steel-toe-nail-cli", "", "", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "", "0", "http://beauty.demobay.info/2014/12/18/clyppi-best-toenail-clippers-perfect-xmas-gifts-for-men-women-superior-large-easy-grip-nail-clipper-extra-sharp-toenail-clippers-for-thick-toenails-professional-stainless-steel-toe-nail-cli/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("150", "1", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "", "41qQTbUhyCL", "", "inherit", "closed", "closed", "", "41qqtbuhycl", "", "", "2014-12-18 23:17:23", "2014-12-18 23:17:23", "", "149", "http://beauty.demobay.info/wp-content/uploads/2014/12/41qQTbUhyCL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("151", "1", "2014-12-18 23:18:11", "2014-12-18 23:18:11", "<p>This ultra-hydrating, Vitamin C & Anti-Oxidant rich emollient formula combats the visible effects of stress, fatigue, smoking & other dehydrating environmental factors.</p>\n", "Image Skin Care Vital C Hydrating Repair Creme 2 oz", "", "trash", "closed", "closed", "", "image-skin-care-vital-c-hydrating-repair-creme-2-oz", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=151", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("152", "1", "2014-12-18 23:18:11", "2014-12-18 23:18:11", "", "41Qzt8wABML", "", "inherit", "closed", "closed", "", "41qzt8wabml", "", "", "2014-12-18 23:18:11", "2014-12-18 23:18:11", "", "151", "http://beauty.demobay.info/wp-content/uploads/2014/12/41Qzt8wABML.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("153", "1", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "<p>Image Skin Care Exfoliating Body Scrub is a dual exfoliating system with walnut skin-resurfacing beads. This high-performance body exfoliator intensively polishes skin and almond oil hydrating beads with encapsulated vitamin E soothe and hydrate the skin. This body scrub removes dull, dry surface cells without disturbing the skin\'s natural pH<br />\nbalance while improving natural cell turnover, leaving the skin looking luminous.</p>\n", "Image Skin Care Exfoliating Body Scrub 4 oz", "", "trash", "closed", "closed", "", "image-skin-care-exfoliating-body-scrub-4-oz", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=153", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("154", "1", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "", "11sqGqEDjhL", "", "inherit", "closed", "closed", "", "11sqgqedjhl", "", "", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "", "153", "http://beauty.demobay.info/wp-content/uploads/2014/12/11sqGqEDjhL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("155", "1", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "<p>Put your best face forward with our Skin 123 kit.  Cleanse, tone and hydrate your skin daily with a trio of products designed to balance and control excess oil production without drying facial skin. The foundation to good skin care in three easy steps. A $57 value.</p>\n", "Baxter of California Skin 1.2.3 Kit", "", "trash", "closed", "closed", "", "baxter-of-california-skin-1-2-3-kit", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=155", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("156", "1", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "", "41a4LipSN-L", "", "inherit", "closed", "closed", "", "41a4lipsn-l", "", "", "2014-12-18 23:18:12", "2014-12-18 23:18:12", "", "155", "http://beauty.demobay.info/wp-content/uploads/2014/12/41a4LipSN-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("157", "1", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "<p>\n<p>The Luxury Rose Set by REN is the brand\'s most luxurious Moroccan Rose Otto gift set yet. It features award-winning products that indulge your skin and your senses.</p>\n<p>Set includes:</p>\n<p>- Moroccan Rose Otto Body Wash (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Body Lotion (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Sugar Body Polish (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Bath Oil (0.34 oz.)</p>\n<p>By REN; made in the United Kingdom.</p>\n", "Ren Luxury Rose Gift", "", "trash", "closed", "closed", "", "ren-luxury-rose-gift", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=157", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("158", "1", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "", "41G92WlnyQL", "", "inherit", "closed", "closed", "", "41g92wlnyql", "", "", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "", "157", "http://beauty.demobay.info/wp-content/uploads/2014/12/41G92WlnyQL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("159", "1", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "<p>DESCRIPTIONrnA daily, super hydrating UVA/UVB broad spectrum moisturizer for the hands. Diminishes age spots with a blend of natural skin lightening agents, protects against harmful effects of the sun and builds up collagen to restore youthful skin. Contains coenzyme Q10 and other antioxidants to fight against free radicals and environmental damage. rnDIRECTIONSrnApply daily for maximum protection and moisture. Reapply throughout the day and while exposed to the sun.</p>\n", "Image Skin care Ageless Total Rejuvenating Hand Creme SPF 15 2 oz", "", "trash", "closed", "closed", "", "image-skin-care-ageless-total-rejuvenating-hand-creme-spf-15-2-oz", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=159", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "", "21GtgiaqS-L", "", "inherit", "closed", "closed", "", "21gtgiaqs-l", "", "", "2014-12-18 23:18:13", "2014-12-18 23:18:13", "", "159", "http://beauty.demobay.info/wp-content/uploads/2014/12/21GtgiaqS-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("161", "1", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "<p>Benefits of Anti-aging Cream<br />\n<br /> - Diminish the appearance of deep wrinkles<br />\n<br /> - improved elasticity and firmness of skin<br />\n<br /> - Minimize appearance of pores<br />\n<br /> This anti-aging cream is formulated with advanced ingredients that penetrate deep into your skin\'s surface to help re-energize</p>\n", "Anti Aging Cream - The Best Hyaluronic Acid + Vitamin C + Collagen + Resveratrol Moisturizing Formula. Luxury Anti Aging Eye Cream with Retinol also targets Hands, Face, and Neck. Premium Anti Wrinkle Skin Care for Women and Men. Nourish, Hydrate, and Brighten Skin. Reduce Fine Lines, Blemishes and Skin Damage. Rejuvenate and Restore Radiance. 100% Satisfaction Guarantee From Cleopatra Beauty Care.", "", "trash", "closed", "closed", "", "anti-aging-cream-the-best-hyaluronic-acid-vitamin-c-collagen-resveratrol-moisturizing-formula-luxury-anti-aging-eye-cream-with-retinol-also-targets-hands-face-and-neck-premium-anti-wrinkle", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=161", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("162", "1", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "", "51O1sP0ciJL", "", "inherit", "closed", "closed", "", "51o1sp0cijl", "", "", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "", "161", "http://beauty.demobay.info/wp-content/uploads/2014/12/51O1sP0ciJL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("163", "1", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "<p>Daily facial cleansers are not enough to get rid of pimples, blackheads & clog. Even if you try your hardest with a scrub it just won\'t do the trick! You need the Beauty Facial Extreme-Clay Mint Healing Mask! Contains natural ingredients such as sulfur, bentonite, kaolin, and jojoba oil. Facials and chemical peels with an aesthetician to treat breakouts or hormonal acne, can be time consuming sitting under the steamer, but why take time out of your busy day when you can have an at home treatment that clears those pores and makes your skin glow. Use the Clay Mint Healing Mask two to three times weekly to give your skin a deep cleansing treat to minimize your pores and to draw out excess oils and impurities from deep within the layers of the skin. Acne treatment facial mask formulated to purify, deep clean, and minimize your pore size, for cleaner and clearer skin. Some skin care products and masks claim to work better than others for your face and body, but don\'t be misled! Get what celebrities use! Exfoliates while removing impurities and helps stimulate collagen and elasticity. Better than Pure & Essential Minerals, Dead Sea Mud facial Mask, Aztec Secrets Indian Healing Clay, and GlamGlow Super Mud. Order Now! 30 Day Money Back Guarantee. No Questions Ask.</p>\n", "Facial Mask - Clay Mint Healing Mask and body muds are treatments to heal acne, acne scars, pimples, blackheads, eczema, psoriasis & clearing acne for the face, neck & decollete. Leaves your skin clear. Take care of your skin and look your best day and night!", "", "trash", "closed", "closed", "", "facial-mask-clay-mint-healing-mask-and-body-muds-are-treatments-to-heal-acne-acne-scars-pimples-blackheads-eczema-psoriasis-clearing-acne-for-the-face-neck-decollete-leaves-your-skin-clea", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=163", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("164", "1", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "", "51UOmVhk4IL", "", "inherit", "closed", "closed", "", "51uomvhk4il", "", "", "2014-12-18 23:18:14", "2014-12-18 23:18:14", "", "163", "http://beauty.demobay.info/wp-content/uploads/2014/12/51UOmVhk4IL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("165", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "<p>The herbal medicines, which is good for the skin, goes deep into the skin and regenerate you skin. As the secrets of royal cour for Fuman, it helps the balance of the skin, adds clean and clear vitality by filling the energy. This is Whoo Luxury Herbal BB cream, which expresses the natural and smooth skin by safe and soft usage on a damaged skin and is applied smoothly along the texture of the skin like the nutrition cream. Direction : After applying makeup base or finishing basic skincare, gently and evenly apply the Luxury BB by sponge or finger.</p>\n", "The History of Whoo Gongjinhyang:Mi Luxury BB 45ml", "", "trash", "closed", "closed", "", "the-history-of-whoo-gongjinhyangmi-luxury-bb-45ml", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=165", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("166", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "31K2joGFRFL", "", "inherit", "closed", "closed", "", "31k2jogfrfl", "", "", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "165", "http://beauty.demobay.info/wp-content/uploads/2014/12/31K2joGFRFL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("167", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "<p>WHAT IS YOUR REFLECTION IN THE MIRROR TELLING YOU?</p>\n<p>SIGNS OF AGING?</p>\n<p> - Crows Feet, Laugh Lines, Wrinkles?<br />\n<br />- Dry Flaky Skin?<br />\n<br />- Large Pores?<br />\n<br />- Oily Skin?<br />\n<br />- Uneven Skin Tone?<br />\n<br />- Dull Complexion?<br />\n<br />- Rough Texture?<br />\n<br />- Poor Skin Structure? </p>\n<p>Some benefits you will enjoy when you purchase our Serum:</p>\n<p> - Hyaluronic Acid, natures moisture magnet, helps raise skin moisture levels to fill in & plump up tissue, fine lines & wrinkles<br />\n<br />- Absorbs quickly & deeply into your skin leaving it feeling smooth & silky with no oily residue or clogging of pores<br />\n<br />- Gentle on sensitive & acne prone skin<br />\n<br />- Smaller pores improve texture & skin clarity<br />\n<br />- Fades acne scars, age & sun spots<br />\n<br />- No fumbling with a dropper or spilling the contents<br />\n<br />- One pump gives you right amount, every time - saves you money!<br />\n<br />- A consistency thicker than water, more runny than gel<br />\n<br />- A sealed, shrink wrapped bottle to prevent leakage & tampering<br />\n<br />- Paraben free </p>\n<p>Hyaluronic Acid is the key to keeping your skin hydrated & youthful </p>\n<p>Vitamin C stimulates collagen production which improves skin tone, elasticity & complexion </p>\n<p>An airless frosted pump dispenser prevents oxidation of ingredients </p>\n<p>Certified in the USA, FDA registered, top quality ingredients & stringent manufacturing quality standards </p>\n<p>Anti-aging is not about vanity, it\'s about aging beautifully </p>\n<p>Get two, one for you & one for a friend </p>\n<p>When you order, you are protected by our 45 day, 100% customer satisfaction money back guarantee</p>\n<p>Buy while stocks last - Click the \'Add to Cart\' Button, NOW!</p>\n", "Hyaluronic Acid Serum with Vitamin C+E - 1 fluid Oz - Best Anti-aging Skin Care Products for Men & Women - Removes Acne Scars, Age & Sun Spots, Fine Lines & Wrinkles, Shrinks Pores - Daily Moisturizer for Face, Neck & Decollete", "", "trash", "closed", "closed", "", "hyaluronic-acid-serum-with-vitamin-ce-1-fluid-oz-best-anti-aging-skin-care-products-for-men-women-removes-acne-scars-age-sun-spots-fine-lines-wrinkles-shrinks-pores-daily-moisturizer", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=167", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("168", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "31tKYXP7sOL", "", "inherit", "closed", "closed", "", "31tkyxp7sol", "", "", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "167", "http://beauty.demobay.info/wp-content/uploads/2014/12/31tKYXP7sOL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("169", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "<p>Super C Serum - A True Anti-Aging Breakthrough</p>\n<p>Once in a while you come upon a product that\'s a cut above; one extraordinary serum that earns the right to be called \"Super C\".</p>\n<p>\"What\'s so super about it?\" Answer: \"Everything.\"</p>\n<p>More than a typical vitamin C serum, more than a facial beauty bath, COUI\'s Super C is a true anti-aging symphony. Revolutionary, transformative, exquisite.</p>\n<p>And the grand conductor, the secret weapon, found in no other vitamin C serums, is Epidermal Growth Factor. </p>\n<p>EGF synthesizes new collagen while conducting this powerful orchestra of ingredients for maximum anti-aging synergy.</p>\n<p>Vitamin C + Hydrolyzed Collagen + Marine Kelp + Hyaluronic Acid + EGF + Antioxidants = The skin of your dreams.</p>\n<p>In just weeks you experience the magic of:</p>\n<p> - Diminished fine lines and wrinkles</p>\n<p> - Diminished age spots and acne scars</p>\n<p> - A more youthful appearance</p>\n<p> - Skin that is radiant, glowing and luminous</p>\n<p>Will your friends be jealous? You bet. COUI has this perfect formulation, and yes, you deserve it. </p>\n<p>A powerhouse of proven, luxurious ingredients that are usually only available in skincare products that cost hundreds of dollars is now at your fingertips for a fraction of the price. </p>\n<p>COUI Skin Care - A LUXURY YOU CAN AFFORD!</p>\n<p>We invite you to experience the wonder of the Super C Serum for yourself. And with COUI\'s 100% lifetime money back guarantee, you can try it with total confidence. <br />Extraordinary skin is just one click away--Order the Super C today!</p>\n", "Super C Serum - Best Collagen Skin Care for Face and Eyes a Breakthrough in Anti Aging - With Vitamin C + EGF + Marine Kelp + Hyaluronic Acid - Effective Wrinkle and Acne Scar Treatment Remove Age Spots", "", "trash", "closed", "closed", "", "super-c-serum-best-collagen-skin-care-for-face-and-eyes-a-breakthrough-in-anti-aging-with-vitamin-c-egf-marine-kelp-hyaluronic-acid-effective-wrinkle-and-acne-scar-treatment-remove-age-spo", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "0", "http://beauty.demobay.info/?p=169", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("170", "1", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "41bhu8atpAL", "", "inherit", "closed", "closed", "", "41bhu8atpal", "", "", "2014-12-18 23:18:15", "2014-12-18 23:18:15", "", "169", "http://beauty.demobay.info/wp-content/uploads/2014/12/41bhu8atpAL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("171", "1", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "<p>Why We\'re Different:</p>\n<p>\n-YOUTHFUL GLOW & FIRMING. Our proprietary formula supports natural collagen<br />\nwhile brightening, revitalizing, firming and improving the appearance of uneven skin tone.</p>\n<p>\n-AMAZING FEEL. Upon initial application, you\'ll notice the difference right away with Alina. A soft, silky feel that penetrates quickly and leaves your skin feeling soft and alive!</p>\n<p>\n-HYDRATE & REPAIR. We\'ve added hyaluronic acid, vitamin E and aloe to ensure your skin maintains proper moisture and hydration.</p>\n<p>\n-THE BEST FORM OF VITAMIN C. Most vitamin C serums contain a form of ascorbic acid that actually has very limited penetration into the skin. Alina Vitamin C Serum penetrates the skin 3x more than ascorbic acid.</p>\n<p>\n-ADDED HYALURONIC ACID to increase the absorption of vitamin C while hydrating the skin to maintain moisture and vitality.</p>\n<p>\n-ANTIOXIDANT SUPPORT. Vitamin C is a well known anti-oxidant but we\'ve also added green and white tea extracts to further boost antioxidant support.</p>\n<p>\nVitamin C Serum is on the Rise:\n<p>\nVitamin C is a water-soluble antioxidant that plays an important role in protecting your body from free radicals and preventing damage to cell structure, both inside and outside cells.</p>\n<p>\n-VITAMIN C HAS GAINED TREMENDOUS POPULARITY because of it\'s effect on skin tone & radiance, and its ability to deliver anti-oxidant benefit to skin cells.</p>\n<p>\n-HIGHER % OF VITAMIN C DOESN\'T MEAN BETTER. Some forms of vitamin c require higher concentration levels in order to be effective because they are inherently less stable and don\'t penetrate the skin as well as other forms. Unfortunately, products that contain higher concentration levels of vitamin C can also increase the risk of skin irritation.  Alina Vitamin C Serum uses a form of vitamin C that is extremely stable and,<br />\nwhen combined with rich moisturizers, gentle on your skin.</p>\n", "Alina Skin Care Enhanced Vitamin C Serum with Hyaluronic Acid & Green and White Tea Extracts", "", "trash", "closed", "closed", "", "alina-skin-care-enhanced-vitamin-c-serum-with-hyaluronic-acid-green-and-white-tea-extracts", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "0", "http://beauty.demobay.info/?p=171", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("172", "1", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "", "41mVJ3uG9lL", "", "inherit", "closed", "closed", "", "41mvj3ug9ll", "", "", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "", "171", "http://beauty.demobay.info/wp-content/uploads/2014/12/41mVJ3uG9lL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "<p>All natural, body scrub by SW Basics.  Perfect scrub for face and body.  Gently exfoliates and moisturizes.   Made from all natural and organic ingredients... and no animal products!  Smells wonderful.</p>\n", "Vegan Vegetarian Skin Care Moisturizing Body Scrub by SW Basics - All Natural Skincare - Organic Ingredients", "", "trash", "closed", "closed", "", "vegan-vegetarian-skin-care-moisturizing-body-scrub-by-sw-basics-all-natural-skincare-organic-ingredients", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "0", "http://beauty.demobay.info/?p=173", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("174", "1", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "", "51gs3bTkg4L", "", "inherit", "closed", "closed", "", "51gs3btkg4l", "", "", "2014-12-18 23:18:16", "2014-12-18 23:18:16", "", "173", "http://beauty.demobay.info/wp-content/uploads/2014/12/51gs3bTkg4L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("175", "1", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "<p>Vitamin C 20% Serum - Unleash Your Timeless Beauty </p>\n<p>Do you ever look in the mirror and wonder what\'s holding you back? What\'s keeping your true beauty from shining through? </p>\n<p>If you\'re like most women, it\'s uneven complexion, age spots, wrinkles, and a buildup of dead skin cells that leave your complexion dull and weary. Years of free radical damage has sapped the very life, vitality and structure from your skin. </p>\n<p>It\'s time to fight back. </p>\n<p>You already know most of the benefits of a vitamin C serum, like the anti-aging, collagen restoring qualities, or the natural exfoliation it provides. <br />We imagine you\'ve heard of its antioxidant power punch, how it protects the skin against environmental damage and, in short, helps you shed years from your face. </p>\n<p>The mighty Vitamin C has already proven herself. Now, why COUI? </p>\n<p>COUI Skincare\'s Vitamin C Serum offers the highest concentration of pure Vitamin C, <br />scientifically formulated for extraordinary results you can see and feel: </p>\n<p>- Creation of new collagen, restoring structure and elasticity to the skin <br />- Deep exfoliation for enhanced glow and youthful radiance <br />- Aggressive healing and repair at the cellular level <br />- Powerful antioxidant protection against environmental factors that cause aging <br />- Skin that is refreshed, revitalized and rejuvenated </p>\n<p>And best of all, this is luxury you can afford. In the world of anti-aging skincare products \"improvement\" isn\'t enough. With COUI, you experience full-scale transformation. </p>\n<p>Stop depriving your skin of the radiance and vitality it deserves. A more youthful, glowing complexion is just one click away. And with COUI\'s 100% lifetime money back guarantee, you can try it with total confidence. </p>\n<p>Order COUI\'s Vitamin C 20% today and let the real you shine through.</p>\n", "Natural Vitamin C Serum 20% - Professional Anti Aging Skin Care for Face - Hyaluronic Acid + Ferulic Acid + Vitamin E + Powerful Antioxidants", "", "trash", "closed", "closed", "", "natural-vitamin-c-serum-20-professional-anti-aging-skin-care-for-face-hyaluronic-acid-ferulic-acid-vitamin-e-powerful-antioxidants", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "0", "http://beauty.demobay.info/?p=175", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("176", "1", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "", "41m5INuEUJL", "", "inherit", "closed", "closed", "", "41m5inueujl", "", "", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "", "175", "http://beauty.demobay.info/wp-content/uploads/2014/12/41m5INuEUJL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("177", "1", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "<p>A Little TLC </p>\n<p>When your skin gets painfully dry, Sisley Confort Extreme Day offers a little TLC. This super rich cream—made with solanum, linden blossom, and shea butter—stimulates and strengthens the skin’s barrier function, while soothing and softening damaged skin. Skin is left feeling extra comforted, soft and loved.</p>\n<p> A nourishing day cream designed to hydrate very dry, fragile skin Nourishes and revitalizes the skin Comforts and softens skin, eliminating any tight feeling\n<p> Especially Suited For:  Dry and sensitive skin</p>\n<p> Essential Elements:  Extracts of solanum, mallow, linden blossom, shea butter and phytosqualane all work in synergy to help stimulate the production of lipids, strengthen the skin barrier, and soothe and comfort skin.</p>\n<p>For Best Effect: Apply Confort Extreme Day Skin Care in the morning to perfectly cleansed skin.</p>\n", "Sisley Botanical Confort Extreme Day Skin Care, 1.6-Ounce Jar", "", "trash", "closed", "closed", "", "sisley-botanical-confort-extreme-day-skin-care-1-6-ounce-jar", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "0", "http://beauty.demobay.info/?p=177", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("178", "1", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "", "21X-C6tKWuL", "", "inherit", "closed", "closed", "", "21x-c6tkwul", "", "", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "", "177", "http://beauty.demobay.info/wp-content/uploads/2014/12/21X-C6tKWuL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("179", "1", "2014-12-18 23:18:17", "2014-12-18 23:18:17", "<p>Eminence OrganicsCoconut Age Corrective Moisturizer(2 oz/60 ml)Benefits For normal to dry skin types, especially mature Improves skin tone and firmness Protects from environmental damageMaintains skin moisture levelsSkin instantly feels firmer and tighterFeatures Coconut Oil moisturizes and heals the skin Coconut Water balances the pH, tones and strengthens Shea Butter repairs and hydrates the skin Carrot supplies potent Vitamin A to the skin Eminence Organics is a highly effective, entirely organic skin care line. With all naturally organic ingredients these hand-made products are effective and extremely healing. Rich in vitamins, active ingredients and nutrients, Eminence products will give you immediate results that you will see and feel.</p>\n", "Eminence Organics Coconut Age Corrective Moisturizer 2 oz", "", "trash", "closed", "closed", "", "eminence-organics-coconut-age-corrective-moisturizer-2-oz", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "0", "http://beauty.demobay.info/?p=179", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("180", "1", "2014-12-18 23:18:18", "2014-12-18 23:18:18", "", "4112TcD6q-L", "", "inherit", "closed", "closed", "", "4112tcd6q-l", "", "", "2014-12-18 23:18:18", "2014-12-18 23:18:18", "", "179", "http://beauty.demobay.info/wp-content/uploads/2014/12/4112TcD6q-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "<p>Eminence OrganicsCoconut Age Corrective Moisturizer(2 oz/60 ml)Benefits For normal to dry skin types, especially mature Improves skin tone and firmness Protects from environmental damageMaintains skin moisture levelsSkin instantly feels firmer and tighterFeatures Coconut Oil moisturizes and heals the skin Coconut Water balances the pH, tones and strengthens Shea Butter repairs and hydrates the skin Carrot supplies potent Vitamin A to the skin Eminence Organics is a highly effective, entirely organic skin care line. With all naturally organic ingredients these hand-made products are effective and extremely healing. Rich in vitamins, active ingredients and nutrients, Eminence products will give you immediate results that you will see and feel.</p>\n", "Eminence Organics Coconut Age Corrective Moisturizer 2 oz", "", "inherit", "closed", "closed", "", "179-revision-v1", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "179", "http://beauty.demobay.info/2014/12/18/179-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("182", "1", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "<p>A Little TLC </p>\n<p>When your skin gets painfully dry, Sisley Confort Extreme Day offers a little TLC. This super rich cream—made with solanum, linden blossom, and shea butter—stimulates and strengthens the skin’s barrier function, while soothing and softening damaged skin. Skin is left feeling extra comforted, soft and loved.</p>\n<p> A nourishing day cream designed to hydrate very dry, fragile skin Nourishes and revitalizes the skin Comforts and softens skin, eliminating any tight feeling\n<p> Especially Suited For:  Dry and sensitive skin</p>\n<p> Essential Elements:  Extracts of solanum, mallow, linden blossom, shea butter and phytosqualane all work in synergy to help stimulate the production of lipids, strengthen the skin barrier, and soothe and comfort skin.</p>\n<p>For Best Effect: Apply Confort Extreme Day Skin Care in the morning to perfectly cleansed skin.</p>\n", "Sisley Botanical Confort Extreme Day Skin Care, 1.6-Ounce Jar", "", "inherit", "closed", "closed", "", "177-revision-v1", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "177", "http://beauty.demobay.info/2014/12/18/177-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("183", "1", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "<p>Vitamin C 20% Serum - Unleash Your Timeless Beauty </p>\n<p>Do you ever look in the mirror and wonder what\'s holding you back? What\'s keeping your true beauty from shining through? </p>\n<p>If you\'re like most women, it\'s uneven complexion, age spots, wrinkles, and a buildup of dead skin cells that leave your complexion dull and weary. Years of free radical damage has sapped the very life, vitality and structure from your skin. </p>\n<p>It\'s time to fight back. </p>\n<p>You already know most of the benefits of a vitamin C serum, like the anti-aging, collagen restoring qualities, or the natural exfoliation it provides. <br />We imagine you\'ve heard of its antioxidant power punch, how it protects the skin against environmental damage and, in short, helps you shed years from your face. </p>\n<p>The mighty Vitamin C has already proven herself. Now, why COUI? </p>\n<p>COUI Skincare\'s Vitamin C Serum offers the highest concentration of pure Vitamin C, <br />scientifically formulated for extraordinary results you can see and feel: </p>\n<p>- Creation of new collagen, restoring structure and elasticity to the skin <br />- Deep exfoliation for enhanced glow and youthful radiance <br />- Aggressive healing and repair at the cellular level <br />- Powerful antioxidant protection against environmental factors that cause aging <br />- Skin that is refreshed, revitalized and rejuvenated </p>\n<p>And best of all, this is luxury you can afford. In the world of anti-aging skincare products \"improvement\" isn\'t enough. With COUI, you experience full-scale transformation. </p>\n<p>Stop depriving your skin of the radiance and vitality it deserves. A more youthful, glowing complexion is just one click away. And with COUI\'s 100% lifetime money back guarantee, you can try it with total confidence. </p>\n<p>Order COUI\'s Vitamin C 20% today and let the real you shine through.</p>\n", "Natural Vitamin C Serum 20% - Professional Anti Aging Skin Care for Face - Hyaluronic Acid + Ferulic Acid + Vitamin E + Powerful Antioxidants", "", "inherit", "closed", "closed", "", "175-revision-v1", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "175", "http://beauty.demobay.info/2014/12/18/175-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("184", "1", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "<p>All natural, body scrub by SW Basics.  Perfect scrub for face and body.  Gently exfoliates and moisturizes.   Made from all natural and organic ingredients... and no animal products!  Smells wonderful.</p>\n", "Vegan Vegetarian Skin Care Moisturizing Body Scrub by SW Basics - All Natural Skincare - Organic Ingredients", "", "inherit", "closed", "closed", "", "173-revision-v1", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "173", "http://beauty.demobay.info/2014/12/18/173-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("185", "1", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "<p>Why We\'re Different:</p>\n<p>\n-YOUTHFUL GLOW & FIRMING. Our proprietary formula supports natural collagen<br />\nwhile brightening, revitalizing, firming and improving the appearance of uneven skin tone.</p>\n<p>\n-AMAZING FEEL. Upon initial application, you\'ll notice the difference right away with Alina. A soft, silky feel that penetrates quickly and leaves your skin feeling soft and alive!</p>\n<p>\n-HYDRATE & REPAIR. We\'ve added hyaluronic acid, vitamin E and aloe to ensure your skin maintains proper moisture and hydration.</p>\n<p>\n-THE BEST FORM OF VITAMIN C. Most vitamin C serums contain a form of ascorbic acid that actually has very limited penetration into the skin. Alina Vitamin C Serum penetrates the skin 3x more than ascorbic acid.</p>\n<p>\n-ADDED HYALURONIC ACID to increase the absorption of vitamin C while hydrating the skin to maintain moisture and vitality.</p>\n<p>\n-ANTIOXIDANT SUPPORT. Vitamin C is a well known anti-oxidant but we\'ve also added green and white tea extracts to further boost antioxidant support.</p>\n<p>\nVitamin C Serum is on the Rise:\n<p>\nVitamin C is a water-soluble antioxidant that plays an important role in protecting your body from free radicals and preventing damage to cell structure, both inside and outside cells.</p>\n<p>\n-VITAMIN C HAS GAINED TREMENDOUS POPULARITY because of it\'s effect on skin tone & radiance, and its ability to deliver anti-oxidant benefit to skin cells.</p>\n<p>\n-HIGHER % OF VITAMIN C DOESN\'T MEAN BETTER. Some forms of vitamin c require higher concentration levels in order to be effective because they are inherently less stable and don\'t penetrate the skin as well as other forms. Unfortunately, products that contain higher concentration levels of vitamin C can also increase the risk of skin irritation.  Alina Vitamin C Serum uses a form of vitamin C that is extremely stable and,<br />\nwhen combined with rich moisturizers, gentle on your skin.</p>\n", "Alina Skin Care Enhanced Vitamin C Serum with Hyaluronic Acid & Green and White Tea Extracts", "", "inherit", "closed", "closed", "", "171-revision-v1", "", "", "2014-12-18 23:18:37", "2014-12-18 23:18:37", "", "171", "http://beauty.demobay.info/2014/12/18/171-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("186", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>Super C Serum - A True Anti-Aging Breakthrough</p>\n<p>Once in a while you come upon a product that\'s a cut above; one extraordinary serum that earns the right to be called \"Super C\".</p>\n<p>\"What\'s so super about it?\" Answer: \"Everything.\"</p>\n<p>More than a typical vitamin C serum, more than a facial beauty bath, COUI\'s Super C is a true anti-aging symphony. Revolutionary, transformative, exquisite.</p>\n<p>And the grand conductor, the secret weapon, found in no other vitamin C serums, is Epidermal Growth Factor. </p>\n<p>EGF synthesizes new collagen while conducting this powerful orchestra of ingredients for maximum anti-aging synergy.</p>\n<p>Vitamin C + Hydrolyzed Collagen + Marine Kelp + Hyaluronic Acid + EGF + Antioxidants = The skin of your dreams.</p>\n<p>In just weeks you experience the magic of:</p>\n<p> - Diminished fine lines and wrinkles</p>\n<p> - Diminished age spots and acne scars</p>\n<p> - A more youthful appearance</p>\n<p> - Skin that is radiant, glowing and luminous</p>\n<p>Will your friends be jealous? You bet. COUI has this perfect formulation, and yes, you deserve it. </p>\n<p>A powerhouse of proven, luxurious ingredients that are usually only available in skincare products that cost hundreds of dollars is now at your fingertips for a fraction of the price. </p>\n<p>COUI Skin Care - A LUXURY YOU CAN AFFORD!</p>\n<p>We invite you to experience the wonder of the Super C Serum for yourself. And with COUI\'s 100% lifetime money back guarantee, you can try it with total confidence. <br />Extraordinary skin is just one click away--Order the Super C today!</p>\n", "Super C Serum - Best Collagen Skin Care for Face and Eyes a Breakthrough in Anti Aging - With Vitamin C + EGF + Marine Kelp + Hyaluronic Acid - Effective Wrinkle and Acne Scar Treatment Remove Age Spots", "", "inherit", "closed", "closed", "", "169-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "169", "http://beauty.demobay.info/2014/12/18/169-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("187", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>WHAT IS YOUR REFLECTION IN THE MIRROR TELLING YOU?</p>\n<p>SIGNS OF AGING?</p>\n<p> - Crows Feet, Laugh Lines, Wrinkles?<br />\n<br />- Dry Flaky Skin?<br />\n<br />- Large Pores?<br />\n<br />- Oily Skin?<br />\n<br />- Uneven Skin Tone?<br />\n<br />- Dull Complexion?<br />\n<br />- Rough Texture?<br />\n<br />- Poor Skin Structure? </p>\n<p>Some benefits you will enjoy when you purchase our Serum:</p>\n<p> - Hyaluronic Acid, natures moisture magnet, helps raise skin moisture levels to fill in & plump up tissue, fine lines & wrinkles<br />\n<br />- Absorbs quickly & deeply into your skin leaving it feeling smooth & silky with no oily residue or clogging of pores<br />\n<br />- Gentle on sensitive & acne prone skin<br />\n<br />- Smaller pores improve texture & skin clarity<br />\n<br />- Fades acne scars, age & sun spots<br />\n<br />- No fumbling with a dropper or spilling the contents<br />\n<br />- One pump gives you right amount, every time - saves you money!<br />\n<br />- A consistency thicker than water, more runny than gel<br />\n<br />- A sealed, shrink wrapped bottle to prevent leakage & tampering<br />\n<br />- Paraben free </p>\n<p>Hyaluronic Acid is the key to keeping your skin hydrated & youthful </p>\n<p>Vitamin C stimulates collagen production which improves skin tone, elasticity & complexion </p>\n<p>An airless frosted pump dispenser prevents oxidation of ingredients </p>\n<p>Certified in the USA, FDA registered, top quality ingredients & stringent manufacturing quality standards </p>\n<p>Anti-aging is not about vanity, it\'s about aging beautifully </p>\n<p>Get two, one for you & one for a friend </p>\n<p>When you order, you are protected by our 45 day, 100% customer satisfaction money back guarantee</p>\n<p>Buy while stocks last - Click the \'Add to Cart\' Button, NOW!</p>\n", "Hyaluronic Acid Serum with Vitamin C+E - 1 fluid Oz - Best Anti-aging Skin Care Products for Men & Women - Removes Acne Scars, Age & Sun Spots, Fine Lines & Wrinkles, Shrinks Pores - Daily Moisturizer for Face, Neck & Decollete", "", "inherit", "closed", "closed", "", "167-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "167", "http://beauty.demobay.info/2014/12/18/167-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("188", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>The herbal medicines, which is good for the skin, goes deep into the skin and regenerate you skin. As the secrets of royal cour for Fuman, it helps the balance of the skin, adds clean and clear vitality by filling the energy. This is Whoo Luxury Herbal BB cream, which expresses the natural and smooth skin by safe and soft usage on a damaged skin and is applied smoothly along the texture of the skin like the nutrition cream. Direction : After applying makeup base or finishing basic skincare, gently and evenly apply the Luxury BB by sponge or finger.</p>\n", "The History of Whoo Gongjinhyang:Mi Luxury BB 45ml", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "165", "http://beauty.demobay.info/2014/12/18/165-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("189", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>Daily facial cleansers are not enough to get rid of pimples, blackheads & clog. Even if you try your hardest with a scrub it just won\'t do the trick! You need the Beauty Facial Extreme-Clay Mint Healing Mask! Contains natural ingredients such as sulfur, bentonite, kaolin, and jojoba oil. Facials and chemical peels with an aesthetician to treat breakouts or hormonal acne, can be time consuming sitting under the steamer, but why take time out of your busy day when you can have an at home treatment that clears those pores and makes your skin glow. Use the Clay Mint Healing Mask two to three times weekly to give your skin a deep cleansing treat to minimize your pores and to draw out excess oils and impurities from deep within the layers of the skin. Acne treatment facial mask formulated to purify, deep clean, and minimize your pore size, for cleaner and clearer skin. Some skin care products and masks claim to work better than others for your face and body, but don\'t be misled! Get what celebrities use! Exfoliates while removing impurities and helps stimulate collagen and elasticity. Better than Pure & Essential Minerals, Dead Sea Mud facial Mask, Aztec Secrets Indian Healing Clay, and GlamGlow Super Mud. Order Now! 30 Day Money Back Guarantee. No Questions Ask.</p>\n", "Facial Mask - Clay Mint Healing Mask and body muds are treatments to heal acne, acne scars, pimples, blackheads, eczema, psoriasis & clearing acne for the face, neck & decollete. Leaves your skin clear. Take care of your skin and look your best day and night!", "", "inherit", "closed", "closed", "", "163-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "163", "http://beauty.demobay.info/2014/12/18/163-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("190", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>Benefits of Anti-aging Cream<br />\n<br /> - Diminish the appearance of deep wrinkles<br />\n<br /> - improved elasticity and firmness of skin<br />\n<br /> - Minimize appearance of pores<br />\n<br /> This anti-aging cream is formulated with advanced ingredients that penetrate deep into your skin\'s surface to help re-energize</p>\n", "Anti Aging Cream - The Best Hyaluronic Acid + Vitamin C + Collagen + Resveratrol Moisturizing Formula. Luxury Anti Aging Eye Cream with Retinol also targets Hands, Face, and Neck. Premium Anti Wrinkle Skin Care for Women and Men. Nourish, Hydrate, and Brighten Skin. Reduce Fine Lines, Blemishes and Skin Damage. Rejuvenate and Restore Radiance. 100% Satisfaction Guarantee From Cleopatra Beauty Care.", "", "inherit", "closed", "closed", "", "161-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "161", "http://beauty.demobay.info/2014/12/18/161-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("191", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>DESCRIPTIONrnA daily, super hydrating UVA/UVB broad spectrum moisturizer for the hands. Diminishes age spots with a blend of natural skin lightening agents, protects against harmful effects of the sun and builds up collagen to restore youthful skin. Contains coenzyme Q10 and other antioxidants to fight against free radicals and environmental damage. rnDIRECTIONSrnApply daily for maximum protection and moisture. Reapply throughout the day and while exposed to the sun.</p>\n", "Image Skin care Ageless Total Rejuvenating Hand Creme SPF 15 2 oz", "", "inherit", "closed", "closed", "", "159-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "159", "http://beauty.demobay.info/2014/12/18/159-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("192", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>\n<p>The Luxury Rose Set by REN is the brand\'s most luxurious Moroccan Rose Otto gift set yet. It features award-winning products that indulge your skin and your senses.</p>\n<p>Set includes:</p>\n<p>- Moroccan Rose Otto Body Wash (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Body Lotion (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Sugar Body Polish (6.8 oz.)</p>\n<p>- Moroccan Rose Otto Bath Oil (0.34 oz.)</p>\n<p>By REN; made in the United Kingdom.</p>\n", "Ren Luxury Rose Gift", "", "inherit", "closed", "closed", "", "157-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "157", "http://beauty.demobay.info/2014/12/18/157-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("193", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>Put your best face forward with our Skin 123 kit.  Cleanse, tone and hydrate your skin daily with a trio of products designed to balance and control excess oil production without drying facial skin. The foundation to good skin care in three easy steps. A $57 value.</p>\n", "Baxter of California Skin 1.2.3 Kit", "", "inherit", "closed", "closed", "", "155-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "155", "http://beauty.demobay.info/2014/12/18/155-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("194", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>Image Skin Care Exfoliating Body Scrub is a dual exfoliating system with walnut skin-resurfacing beads. This high-performance body exfoliator intensively polishes skin and almond oil hydrating beads with encapsulated vitamin E soothe and hydrate the skin. This body scrub removes dull, dry surface cells without disturbing the skin\'s natural pH<br />\nbalance while improving natural cell turnover, leaving the skin looking luminous.</p>\n", "Image Skin Care Exfoliating Body Scrub 4 oz", "", "inherit", "closed", "closed", "", "153-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "153", "http://beauty.demobay.info/2014/12/18/153-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("195", "1", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "<p>This ultra-hydrating, Vitamin C & Anti-Oxidant rich emollient formula combats the visible effects of stress, fatigue, smoking & other dehydrating environmental factors.</p>\n", "Image Skin Care Vital C Hydrating Repair Creme 2 oz", "", "inherit", "closed", "closed", "", "151-revision-v1", "", "", "2014-12-18 23:18:38", "2014-12-18 23:18:38", "", "151", "http://beauty.demobay.info/2014/12/18/151-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("196", "1", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "<p>This rich, non-greasy formula helps heal and soothe dry, chapped, cracked hands. Road-tested by golfers, carpenters and chefs, this hard-working hand cream repairs tough, calloused skin and cuticles, providing lasting relief. Especially effective for those who wash their hands a lot or spend time outdoors in rugged temperatures; because the palms and back of your hands have the fewest and smallest oil glands, they tend to get the driest.</p>\n", "Jack Black Industrial Strength Hand Healer, 3 fl. oz.", "", "publish", "closed", "closed", "", "jack-black-industrial-strength-hand-healer-3-fl-oz", "", "", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "", "0", "http://beauty.demobay.info/2014/12/18/jack-black-industrial-strength-hand-healer-3-fl-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("197", "1", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "", "41WghEFDhSL", "", "inherit", "closed", "closed", "", "41wghefdhsl", "", "", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "", "196", "http://beauty.demobay.info/wp-content/uploads/2014/12/41WghEFDhSL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("198", "1", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "<p>This smooth Cream-gel combines the balancing and matifying properties of herbal extracts with a moisturizing action to ensure proper hydration to the skin. </p>\n<p>It is the ideal product to normalize the skin\'s pH level, control sebum production and maintain a fresh, mat complexion. </p>\n<p>HOW TO USE: after cleansing and toning with Purifying Cleansing Gel and Astringent Toning Water, apply from the centre of the face towards the sides until completely absorbed. </p>\n<p>An excellent make up base. </p>\n<p>Skin-friendly pH value</p>\n", "Helan Oily Skin Care Kaoline Clay Cream-gel - OIL Free, Balancing, and Matyifing - With Lemon Essential Oil, Burdock, Cinnamon, Lapacho and Ginger, Vitamin E", "", "publish", "closed", "closed", "", "helan-oily-skin-care-kaoline-clay-cream-gel-oil-free-balancing-and-matyifing-with-lemon-essential-oil-burdock-cinnamon-lapacho-and-ginger-vitamin-e", "", "", "2014-12-18 23:19:14", "2014-12-18 23:19:14", "", "0", "http://beauty.demobay.info/2014/12/18/helan-oily-skin-care-kaoline-clay-cream-gel-oil-free-balancing-and-matyifing-with-lemon-essential-oil-burdock-cinnamon-lapacho-and-ginger-vitamin-e/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("199", "1", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "21b5tlWRVSL", "", "inherit", "closed", "closed", "", "21b5tlwrvsl", "", "", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "198", "http://beauty.demobay.info/wp-content/uploads/2014/12/21b5tlWRVSL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("200", "1", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "<p>Acne treatment facial pads formulated to purify, deep clean, exfoliate, minimize pore size, and reduce inflammation for cleaner and clearer skin. Forget all the other home remedies, natural cures, gel, & acne soap. Cure signs of acne with the latest popular anti acne &lmp comedone extractor treatment product. Some skin care & beauty products claim to work better than others for your face, body, zits, & pimples, but dont be misled! Why get expensive salicylic acid, glycolic acid, and lactic acid chemical peels at a dermatology office? Just use the best at home medical grade acne treatment pad! Supplies powerful ingredients to help fight acne skins for women, men, girls, and teens. Get what celebrities use as a zit zapper that exfoliates while removing impurities. Wipes away pore-clogging oils, blackheads, whiteheads, and hormonal acne. Say goodbye to acne cream solutions, medication, and pills! Prevent those embarrassing acne scars before they ruin your skin! Stop wasting money on concealer, derma roller, cetaphil, neutrogena, and proactiv! Order Now 30 Day Money Back Guarantee.<br />\nBest Acne Treatment.</p>\n", "Best New Acne Treatment - Works better than other facial cleansing care products and exfoliators. Contains alpha beta, glycolic, salicylic, and lactic acids. No need for expensive dermatology chemical peels. Ease away, give relief with aid to a pimple with inflammation & redness. Stay Acnefree.", "", "publish", "closed", "closed", "", "best-new-acne-treatment-works-better-than-other-facial-cleansing-care-products-and-exfoliators-contains-alpha-beta-glycolic-salicylic-and-lactic-acids-no-need-for-expensive-dermatology-chemical", "", "", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "0", "http://beauty.demobay.info/2014/12/18/best-new-acne-treatment-works-better-than-other-facial-cleansing-care-products-and-exfoliators-contains-alpha-beta-glycolic-salicylic-and-lactic-acids-no-need-for-expensive-dermatology-chemical/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("201", "1", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "51f0c3lD2kL", "", "inherit", "closed", "closed", "", "51f0c3ld2kl", "", "", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "200", "http://beauty.demobay.info/wp-content/uploads/2014/12/51f0c3lD2kL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("202", "1", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "<p>Luxury Argan-Oil Skin Care Gift Collection - The hardest part of receiving this to give as a gift is that when you see it, you may want it for yourself. Want to see what is inside? This is what your giftee will see... Open the Kraft box and take a look. • In between the tissue paper and rosebuds lies the elegant gold bag, filled with indulgent goodies. • Open each of the smaller containers and sniff. The light, pure scents of honeysuckle, lavender and brown sugar-fig will delight your senses. • Open the Lumineux Luxe and rub a bit of the thick, triple-rich cream into your skin. Feel the silky richness as it absorbs. • Try one of the lip balms. Notice how the argan oil makes the balm glide on silky smooth. • Take a sniff - but maybe save the sugar scrub for your next bath - then you can luxuriate as you exfoliate. Did you buy one for yourself? Don\'t you deserve a gift, too? Don\'t forget there is no risk involved in purchasing from us. Our Absolute Risk Free Guarantee: If you are not happy with the purchase, we will refund your money, no questions asked. So buy right now and this gorgeous gift collection will be on its way to you for giving almost immediately. We thank you for your purchase.</p>\n", "Luxe Lumineux Argan Oil-Infused Gift Set for Her - Perfect Gifts for Women - Every Woman Will Love This Luxury Gift Collection", "", "publish", "closed", "closed", "", "luxe-lumineux-argan-oil-infused-gift-set-for-her-perfect-gifts-for-women-every-woman-will-love-this-luxury-gift-collection", "", "", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "0", "http://beauty.demobay.info/2014/12/18/luxe-lumineux-argan-oil-infused-gift-set-for-her-perfect-gifts-for-women-every-woman-will-love-this-luxury-gift-collection/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("203", "1", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "51s5pbptkDL", "", "inherit", "closed", "closed", "", "51s5pbptkdl", "", "", "2014-12-18 23:19:15", "2014-12-18 23:19:15", "", "202", "http://beauty.demobay.info/wp-content/uploads/2014/12/51s5pbptkDL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("204", "1", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "<p>Sisley Botanical Confort Extreme Night Skin Care--/1.7OZ Design House: Sisley</p>\n", "Sisley Botanical Confort Extreme Night Skin Care, 1.6-Ounce Jar", "", "publish", "closed", "closed", "", "sisley-botanical-confort-extreme-night-skin-care-1-6-ounce-jar", "", "", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "0", "http://beauty.demobay.info/2014/12/18/sisley-botanical-confort-extreme-night-skin-care-1-6-ounce-jar/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("205", "1", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "31cW7Hc6tkL", "", "inherit", "closed", "closed", "", "31cw7hc6tkl", "", "", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "204", "http://beauty.demobay.info/wp-content/uploads/2014/12/31cW7Hc6tkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("206", "1", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "<p>Atomy Skin Care 6 System includes:<br />\nSkin Lotion, Milk Lotion, Nutritional Cream, Eye Cream, Essence, and BB Cream.</p>\n<p>Luxury cosmetics produced by a combination of 3 major advanced technologies. Popularized luxury product minus the price bubble.</p>\n", "Atomy Skin Care 6 System", "", "publish", "closed", "closed", "", "atomy-skin-care-6-system", "", "", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "0", "http://beauty.demobay.info/2014/12/18/atomy-skin-care-6-system/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("207", "1", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "21FtTJ-ghDL", "", "inherit", "closed", "closed", "", "21fttj-ghdl", "", "", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "206", "http://beauty.demobay.info/wp-content/uploads/2014/12/21FtTJ-ghDL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("208", "1", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "<p>★ Natural Argan Treatment for Dry Itchy Skin Intense Argan Body Kit ★ </p>\n<p>Ever struggled to calm and revive dry itchy or cracked skin?<br />Do you battle with sensitive or irritated skin?</p>\n<p>If you have a regular to dry skin type, then you need to give this body kit a try...</p>\n<p>The light Argan body lotion is easily absorbed and designed to gradually revive dry itchy skin<br />The Argan body oil is easily absorbed and helps in protecting the skin from dryness, leaving it smooth, silky and soft</p>\n<p>Why Customers Worldwide LOVE This Body KIT?</p>\n<p>• Amazon \'ONE OF A KIND\' Argan Kit Body Oil and Lotion Treatment<br />• Nourishes, Hydrates, Calms, Rebuilds, Renews, Softens the Skin and Promotes Skin Shine Glow<br />• Preserves Crucial Fatty Acids and High Concentrations of Vitamins Essential to the Skin<br />• Relieves Problematic Dry Skin as in the Case of Psoriasis, Eczema and Dermatitis<br />• Based on an exclusive UNIQUE High Quality Herbal Complex to Enrich the Skin Texture</p>\n<p>Customer Satisfaction Guaranteed:</p>\n<p>Vitamins\' Argan Oil based products are already manufactured for more than 20 years and with great success</p>\n<p>We GUARANTEE that Your Skin will Look and Feel Better than Before or We will Give You 100% of Your Money... Contact Us for the FREE DIY eBook!</p>\n<p>Don\'t Miss Our Limited Time Offer!<br />➨ Click the Orange \'Add to Cart\' Button to Ensure Your Argan Body Kit Set Discount Deal...</p>\n", "Dry Itchy Skin Body Kit - CHRISTMAS HOLIDAYS SALE! - Natural Moroccan Argan Oil Body Lotion + Argan Body Serum Treatment Skin Set Products - Ultimate Sensitive Body Creme Care Moisturizer & Skin Oil to Revive, Repair and Calm Dryness & Cracked or Irritated Skin - Fancy Gift Box - (8.5 oz / 250 ml) + (3.4 oz / 100 ml) - 100% Customer Satisfaction GUARANTEED Body Kit!", "", "publish", "closed", "closed", "", "dry-itchy-skin-body-kit-christmas-holidays-sale-natural-moroccan-argan-oil-body-lotion-argan-body-serum-treatment-skin-set-products-ultimate-sensitive-body-creme-care-moisturizer-skin-oil-t", "", "", "2014-12-18 23:19:16", "2014-12-18 23:19:16", "", "0", "http://beauty.demobay.info/2014/12/18/dry-itchy-skin-body-kit-christmas-holidays-sale-natural-moroccan-argan-oil-body-lotion-argan-body-serum-treatment-skin-set-products-ultimate-sensitive-body-creme-care-moisturizer-skin-oil-t/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("209", "1", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "51lMGC89qfL", "", "inherit", "closed", "closed", "", "51lmgc89qfl", "", "", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "208", "http://beauty.demobay.info/wp-content/uploads/2014/12/51lMGC89qfL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("210", "1", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "<p>Image Skin Care Body Spa Cell U Lift Firming Body Creme is a new, revolutionary body cream that is designed to fight the skin\'s laxity on a cellular level. EPP helps minimize the volume of lipid cells and underlying tissue while strengthening collagen fibers. Plastic surgeons\' clinical studies showed firmer and tighter looking skin with a hydrated, smooth surface. It helps minimize the appearance of irregularities on the skin.</p>\n", "Image Skin Care Body Spa Cell U Lift Firming Body Creme 5.00 oz", "", "publish", "closed", "closed", "", "image-skin-care-body-spa-cell-u-lift-firming-body-creme-5-00-oz", "", "", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "0", "http://beauty.demobay.info/2014/12/18/image-skin-care-body-spa-cell-u-lift-firming-body-creme-5-00-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("211", "1", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "219-JTkm24L", "", "inherit", "closed", "closed", "", "219-jtkm24l", "", "", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "210", "http://beauty.demobay.info/wp-content/uploads/2014/12/219-JTkm24L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("212", "1", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "<p>For the first time, two of the most powerful anti-aging actives, NIA-114 and Retinol, unite in one powerhouse treatment kit. For Retinol (vitamin A) to achieve age-fighting potency, it needs vitamin B3 to convert to its active form. AR Night fights all the major signs of aging - reduces the look of deep-set wrinkles and fine lines, hydrates and deeply nourishes skin nightly, plumps skin to restore its bounce and youthful contour, evens tone and leaves complexion radiant, refines and smoothes skin texture - the unsurpassed performance of retinol without the irritation. AR Day reduces the look of deep-set wrinkles and fine lines, hydrates and deeply nourishes skin, plumps skin to restore its bounce and youthful contour, evens tone and leaves complexion radiant, refines and smoothes skin texture, protects against damaging UVA/UVB rays. AR Eye Cream fights the major signs of aging - firms the eye area, minimizes the look of dark circles, puffiness and redness, instantly hydrates, smoothes and refines texture.</p>\n", "StriVectin-AR Advanced Retinol Trio Skin Care Kit", "", "publish", "closed", "closed", "", "strivectin-ar-advanced-retinol-trio-skin-care-kit", "", "", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "0", "http://beauty.demobay.info/2014/12/18/strivectin-ar-advanced-retinol-trio-skin-care-kit/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("213", "1", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "41zOauIuGhL", "", "inherit", "closed", "closed", "", "41zoauiughl", "", "", "2014-12-18 23:19:17", "2014-12-18 23:19:17", "", "212", "http://beauty.demobay.info/wp-content/uploads/2014/12/41zOauIuGhL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "<p>A Total Transformation 360º Around The Eyes.</p>\n<p>Creme LuXury Eye is clinically tested to deliver a 94% instant surge in moisture and a 100% improvement in moisture in just two weeks. After four weeks, women who tried Creme Luxury Eye agreed that skin looks firmer - there is a visible reduction in the appearance of wrinkles, and a visual improvement in skin roughness. </p>\n<p>Creme LuXury Eye uses CellEffect Technology to help turn back the clock on the signs of aging. CellEffect Technology is a powerful complex driven by Cardiolipin - the most rare and precious ingredient ever used in any ARTISTRY® product. CellEffect Technology re-energizes skin cells and boosts their natural ability to repair visible signs of damage and aging, for skin that looks healthier and acts younger.</p>\n", "Artistry Luxury Creme Luxury Eye", "", "publish", "closed", "closed", "", "artistry-luxury-creme-luxury-eye", "", "", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "0", "http://beauty.demobay.info/2014/12/18/artistry-luxury-creme-luxury-eye/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("215", "1", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "21Hb30mcV-L", "", "inherit", "closed", "closed", "", "21hb30mcv-l", "", "", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "214", "http://beauty.demobay.info/wp-content/uploads/2014/12/21Hb30mcV-L.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("216", "1", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "Dermatouch Exfoliating Wrinkle Reducer & Acne Treatment 2-item Bundle: Natural Skin Care Anti-aging Oxygen Serum + MED Serum for Problem Skin", "", "publish", "closed", "closed", "", "dermatouch-exfoliating-wrinkle-reducer-acne-treatment-2-item-bundle-natural-skin-care-anti-aging-oxygen-serum-med-serum-for-problem-skin", "", "", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "0", "http://beauty.demobay.info/2014/12/18/dermatouch-exfoliating-wrinkle-reducer-acne-treatment-2-item-bundle-natural-skin-care-anti-aging-oxygen-serum-med-serum-for-problem-skin/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("217", "1", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "41TYonWKRkL", "", "inherit", "closed", "closed", "", "41tyonwkrkl", "", "", "2014-12-18 23:19:18", "2014-12-18 23:19:18", "", "216", "http://beauty.demobay.info/wp-content/uploads/2014/12/41TYonWKRkL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "<p>Men line control cream dry skin was launched by the design house of Clarins. It is recommended for daily use. Please store in a cool dry place. Men line control cream dry skin by Clarins for men 1.7 ounce cream.</p>\n", "Clarins Men Line-Control Cream Dry Skin Care, 1.7 Ounce", "", "publish", "closed", "closed", "", "clarins-men-line-control-cream-dry-skin-care-1-7-ounce", "", "", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "", "0", "http://beauty.demobay.info/2014/12/18/clarins-men-line-control-cream-dry-skin-care-1-7-ounce/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("219", "1", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "", "41weCvz1FFL", "", "inherit", "closed", "closed", "", "41wecvz1ffl", "", "", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "", "218", "http://beauty.demobay.info/wp-content/uploads/2014/12/41weCvz1FFL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("220", "1", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "", "Clark\'s Botanicals Skin Clearing Face & Body Wash, 7.4 fl. oz.", "", "publish", "closed", "closed", "", "clarks-botanicals-skin-clearing-face-body-wash-7-4-fl-oz", "", "", "2014-12-18 23:19:19", "2014-12-18 23:19:19", "", "0", "http://beauty.demobay.info/2014/12/18/clarks-botanicals-skin-clearing-face-body-wash-7-4-fl-oz/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("221", "1", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "41maHeF8DgL", "", "inherit", "closed", "closed", "", "41mahef8dgl", "", "", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "220", "http://beauty.demobay.info/wp-content/uploads/2014/12/41maHeF8DgL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("222", "1", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "<p>Containing bestsellers, Beard Lube Conditioning Shave for the ultimate close shave, Double-Duty Face Moisturizer SPF 20 to keep skin smooth and protected, Eye Balm Age Minimizing Gel to revive the travel-tired eye-area, Intense Therapy Lip Balm Natural Mint & Shea Butter to soften lips and freshen breath, and All-Over Wash to cleanse hair, face and body. This convenient set offers everything you need, in generous travel sizes, to keep you looking good while you\'re on the fly.</p>\n", "Jack Black First Class Five Travel Pack", "", "publish", "closed", "closed", "", "jack-black-first-class-five-travel-pack", "", "", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "0", "http://beauty.demobay.info/2014/12/18/jack-black-first-class-five-travel-pack/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("223", "1", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "51ig2icKvcL", "", "inherit", "closed", "closed", "", "51ig2ickvcl", "", "", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "222", "http://beauty.demobay.info/wp-content/uploads/2014/12/51ig2icKvcL.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("224", "1", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "<p>Looking for younger, more healthy, radiant skin?</p>\n<p>Our new 20% Natural Vitamin C facial serum enhances collagen, is a powerful antioxidant, and improves your skin\'s moisture levels, making it look younger, smoother and more radiant!</p>\n<p>Our 20% Natural Vitamin C Facial Serum is clinically designed to invigorate and revitalize facial skin. It repairs and maintains by stimulating collagen production.</p>\n<p>Vitamin C is critical for our bodies and plays an important role in maintaining healthy, resilient skin. While younger skin is full of Vitamin C, aging skin looses this nutrient over time. Other factors such as exposure to UV light and pollution compound the decline of Vitamin C, contributing to signs of aging.</p>\n<p>The good news is that you can fight back by replenishing your skin\'s Vitamin C levels to help fight time\'s effect on your face! One of the most effective and powerful functions of Vitamin C is its role in the production of collagen, a protein that gives your skin its elasticity. As you age, your skin\'s collagen breaks down, and wrinkles begin to form. Stabilizing your skin\'s level of Vitamin C can help to counteract wrinkles.</p>\n<p>Taking Vitamin C trough a supplement, or food is beneficial to your health. But to target signs of aging on your face, topical Vitamin C is best. In fact, applying Vitamin C to the skin can be 20 times more effective than taking it orally!</p>\n<p>Limited time, quantity and sale price.</p>\n<p>Go up to the Buy Now button, and you\'ll receive this product to your front door in just a few days!</p>\n<p>Marquee Skin Care - Luxury for your face - at affordable prices.</p>\n", "20% Natural Vitamin C Facial Serum - Collagen Production for Younger Looking Skin - Anti Oxidant, Anti Aging, Anti Wrinkle - Beauty and Luxury for Your Face By Marquee Skin Care", "", "publish", "closed", "closed", "", "20-natural-vitamin-c-facial-serum-collagen-production-for-younger-looking-skin-anti-oxidant-anti-aging-anti-wrinkle-beauty-and-luxury-for-your-face-by-marquee-skin-care", "", "", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "0", "http://beauty.demobay.info/2014/12/18/20-natural-vitamin-c-facial-serum-collagen-production-for-younger-looking-skin-anti-oxidant-anti-aging-anti-wrinkle-beauty-and-luxury-for-your-face-by-marquee-skin-care/", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("225", "1", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "31hTXcZDLRL", "", "inherit", "closed", "closed", "", "31htxczdlrl", "", "", "2014-12-18 23:19:20", "2014-12-18 23:19:20", "", "224", "http://beauty.demobay.info/wp-content/uploads/2014/12/31hTXcZDLRL.jpg", "0", "attachment", "image/jpeg", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("36", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("38", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("40", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("42", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("44", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("46", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("48", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("50", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("52", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("54", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("56", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("60", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("62", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("64", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("66", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("68", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("70", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("72", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("74", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("76", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("78", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("80", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("82", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("84", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("86", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("88", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("90", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("92", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("94", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("96", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("98", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("100", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("102", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("104", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("106", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("108", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("110", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("112", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("114", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("116", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("118", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("120", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("122", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("124", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("126", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("127", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("128", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("129", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("130", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("131", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("133", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("135", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("137", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("139", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("141", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("143", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("145", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("147", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("149", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("151", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("153", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("155", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("157", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("159", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("161", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("163", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("165", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("167", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("169", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("171", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("173", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("175", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("177", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("179", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("196", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("198", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("200", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("202", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("204", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("206", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("208", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("210", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("212", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("214", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("216", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("218", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("220", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("222", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("224", "2", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "30");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "category", "", "0", "15");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "17");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "10");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "", "0", "10");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "nav_menu", "", "0", "5");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Luxury Makeup", "luxury-makeup", "0");
INSERT INTO `wp_terms` VALUES("2", "Luxury Skin Care", "luxury-skin-care", "0");
INSERT INTO `wp_terms` VALUES("3", "Luxury Fragrance", "luxury-fragrance", "0");
INSERT INTO `wp_terms` VALUES("4", "Luxury Nails", "luxury-nails", "0");
INSERT INTO `wp_terms` VALUES("5", "Luxury Hair Care", "luxury-hair-care", "0");
INSERT INTO `wp_terms` VALUES("6", "men", "men", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "f");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "l");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "wp350_media,wp360_revisions,wp360_locks,wp390_widgets,aioseop_menu_220");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_dashboard_quick_press_last_post_id", "6");
INSERT INTO `wp_usermeta` VALUES("19", "1", "session_tokens", "a:1:{s:64:\"b1e6b2b04c25629aa2aad84f1b45cc48ffe96dc2cafc83062e88143327ed39ed\";i:1420117190;}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "wp_user-settings", "libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("21", "1", "wp_user-settings-time", "1418909084");
INSERT INTO `wp_usermeta` VALUES("22", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("23", "1", "metaboxhidden_nav-menus", "a:2:{i:0;s:8:\"add-post\";i:1;s:12:\"add-post_tag\";}");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "admin", "$P$B9n2urjV7VWR2U7ZwmIUQFNWi0kB...", "admin", "mail@yourmail.com", "", "0000-00-00 00:00:00", "", "0", "admin");

SET FOREIGN_KEY_CHECKS = 1;